// -----------------------------------------------------------------------------
// Altair 8800 Simulator
//
// This file contains copies of a number of BASIC examples found in various
// places on the net, created by various authors.
//
// While the Altair 8800 simulator code itself is released under GPLv3, 
// the contents of this file are excluded from that license for obvious reasons.
// -----------------------------------------------------------------------------

// [this gets included from prog_examples.cpp]

// short example list: quicker upload => easier for debugging
//#define USE_SHORT_EXAMPLE_LIST

#include "config.h"


const char basic_23_match[] =
  "20 PRINT TAB(31);\"23 MATCHES\"\r"
  "30 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "40 PRINT:PRINT:PRINT\r"
  "80 PRINT \" THIS IS A GAME CALLED '23 MATCHES'.\"\r"
  "90 PRINT\r"
  "100 PRINT \"WHEN IT IS YOUR TURN, YOU MAY TAKE ONE, TWO, OR THREE\"\r"
  "110 PRINT \"MATCHES. THE OBJECT OF THE GAME IS NOT TO HAVE TO TAKE\"\r"
  "120 PRINT \"THE LAST MATCH.\"\r"
  "130 PRINT\r"
  "140 PRINT \"LET'S FLIP A COIN TO SEE WHO GOES FIRST.\"\r"
  "150 PRINT \"IF IT COMES UP HEADS, I WILL WIN THE TOSS.\"\r"
  "155 PRINT\r"
  "160 REM\r"
  "165 N = 23\r"
  "170 Q = INT(2*RND(5))\r"
  "180 IF Q = 1 THEN 210\r"
  "190 PRINT \"TAILS! YOU GO FIRST. \"\r"
  "195 PRINT\r"
  "200 GOTO 300\r"
  "210 PRINT \"HEADS! I WIN! HA! HA!\"\r"
  "220 PRINT \"PREPARE TO LOSE, MEATBALL-NOSE!!\"\r"
  "230 PRINT\r"
  "250 PRINT \"I TAKE 2 MATCHES\"\r"
  "260 N = N -2\r"
  "270 PRINT \"THE NUMBER OF MATCHES IS NOW\" N\r"
  "280 PRINT\r"
  "290 PRINT \"YOUR TURN -- YOU MAY TAKE 1, 2 OR 3 MATCHES.\"\r"
  "300 PRINT \"HOW MANY DO YOU WISH TO REMOVE\",\r"
  "310 INPUT K\r"
  "320 IF K > 3 THEN 430\r"
  "330 IF K <= 0 THEN 430\r"
  "340 N = N - K\r"
  "350 PRINT \"THERE ARE NOW\";N;\"MATCHES REMAINING.\"\r"
  "351 IF N = 4 THEN 381\r"
  "352 IF N = 3 THEN 383\r"
  "353 IF N = 2 THEN 385\r"
  "360 IF N <= 1 THEN  530\r"
  "370 Z = 4 - K\r"
  "372 GOTO 390\r"
  "380 PRINT\r"
  "381 Z = 3\r"
  "382 GOTO 390\r"
  "383 Z = 2\r"
  "384 GOTO 390\r"
  "385 Z = 1\r"
  "390 PRINT \"MY TURN ! I REMOVE\" Z \"MATCHES\"\r"
  "400 N = N - Z\r"
  "410 IF N <= 1 THEN 470\r"
  "420 GOTO 270\r"
  "430 PRINT \"VERY FUNNY! DUMMY!\"\r"
  "440 PRINT \"DO YOU WANT TO PLAY OR GOOF AROUND?\"\r"
  "450 PRINT \"NOW, HOW MANY MATCHES DO YOU WANT\",\r"
  "460 GOTO 310\r"
  "470 PRINT\r"
  "480 PRINT\"YOU POOR BOOB! YOU TOOK THE LAST MATCH! I GOTCHA!!\"\r"
  "490 PRINT \"HA ! HA ! I BEAT YOU !!!\"\r"
  "500 PRINT\r"
  "510 PRINT \"GOOD BYE LOSER!\"\r"
  "520 GOTO 560\r"
  "530 PRINT \"YOU WON, FLOPPY EARS !\"\r"
  "540 PRINT \"THINK YOU'RE PRETTY SMART !\"\r"
  "550 PRINT \"LETS PLAY AGAIN AND I'LL BLOW YOUR SHOES OFF !!\"\r"
  "560 STOP\r"
  "570 END\r"
  "";

const char basic_amazing[] =
  "10 PRINT TAB(28);\"AMAZING PROGRAM\"\r"
  "20 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "30 PRINT:PRINT:PRINT:PRINT\r"
  "100 INPUT \"WHAT ARE YOUR WIDTH AND LENGTH\";H,V\r"
  "102 IF H<>1 AND V<>1 THEN 110\r"
  "104 PRINT \"MEANINGLESS DIMENSIONS.  TRY AGAIN.\":GOTO 100\r"
  "110 DIM W(H,V),V(H,V)\r"
  "120 PRINT\r"
  "130 PRINT\r"
  "140 PRINT\r"
  "150 PRINT\r"
  "160 Q=0:Z=0:X=INT(RND(1)*H+1)\r"
  "165 FOR I=1 TO H\r"
  "170 IF I=X THEN 173\r"
  "171 PRINT \".--\";:GOTO 180\r"
  "173 PRINT \".  \";\r"
  "180 NEXT I\r"
  "190 PRINT \".\"\r"
  "195 C=1:W(X,1)=C:C=C+1\r"
  "200 R=X:S=1:GOTO 260\r"
  "210 IF R<>H THEN 240\r"
  "215 IF S<>V THEN 230\r"
  "220 R=1:S=1:GOTO 250\r"
  "230 R=1:S=S+1:GOTO 250\r"
  "240 R=R+1\r"
  "250 IF W(R,S)=0 THEN 210\r"
  "260 IF R-1=0 THEN 530\r"
  "265 IF W(R-1,S)<>0 THEN 530\r"
  "270 IF S-1=0 THEN 390\r"
  "280 IF W(R,S-1)<>0 THEN 390\r"
  "290 IF R=H THEN 330\r"
  "300 IF W(R+1,S)<>0 THEN 330\r"
  "310 X=INT(RND(1)*3+1)\r"
  "320 ON X GOTO 790,820,860\r"
  "330 IF S<>V THEN 340\r"
  "334 IF Z=1 THEN 370\r"
  "338 Q=1:GOTO 350\r"
  "340 IF W(R,S+1)<>0 THEN 370\r"
  "350 X=INT(RND(1)*3+1)\r"
  "360 ON X GOTO 790,820,910\r"
  "370 X=INT(RND(1)*2+1)\r"
  "380 ON X GOTO 790,820\r"
  "390 IF R=H THEN 470\r"
  "400 IF W(R+1,S)<>0 THEN 470\r"
  "405 IF S<>V THEN 420\r"
  "410 IF Z=1 THEN 450\r"
  "415 Q=1:GOTO 430\r"
  "420 IF W(R,S+1)<>0 THEN 450\r"
  "430 X=INT(RND(1)*3+1)\r"
  "440 ON X GOTO 790,860,910\r"
  "450 X=INT(RND(1)*2+1)\r"
  "460 ON X GOTO 790,860\r"
  "470 IF S<>V THEN 490\r"
  "480 IF Z=1 THEN 520\r"
  "485 Q=1:GOTO 500\r"
  "490 IF W(R,S+1)<>0 THEN 520\r"
  "500 X=INT(RND(1)*2+1)\r"
  "510 ON X GOTO 790,910\r"
  "520 GOTO 790\r"
  "530 IF S-1=0 THEN 670\r"
  "540 IF W(R,S-1)<>0 THEN 670\r"
  "545 IF R=H THEN 610\r"
  "547 IF W(R+1,S)<>0 THEN 610\r"
  "550 IF S<>V THEN 560\r"
  "552 IF Z=1 THEN 590\r"
  "554 Q=1:GOTO 570\r"
  "560 IF W(R,S+1)<>0 THEN 590\r"
  "570 X=INT(RND(1)*3+1)\r"
  "580 ON X GOTO 820,860,910\r"
  "590 X=INT(RND(1)*2+1)\r"
  "600 ON X GOTO 820,860\r"
  "610 IF S<>V THEN 630\r"
  "620 IF Z=1 THEN 660\r"
  "625 Q=1:GOTO 640\r"
  "630 IF W(R,S+1)<>0 THEN 660\r"
  "640 X=INT(RND(1)*2+1)\r"
  "650 ON X GOTO 820,910\r"
  "660 GOTO 820\r"
  "670 IF R=H THEN 740\r"
  "680 IF W(R+1,S)<>0 THEN 740\r"
  "685 IF S<>V THEN 700\r"
  "690 IF Z=1 THEN 730\r"
  "695 Q=1:GOTO 830\r"
  "700 IF W(R,S+1)<>0 THEN 730\r"
  "710 X=INT(RND(1)*2+1)\r"
  "720 ON X GOTO 860,910\r"
  "730 GOTO 860\r"
  "740 IF S<>V THEN 760\r"
  "750 IF Z=1 THEN 780\r"
  "755 Q=1:GOTO 770\r"
  "760 IF W(R,S+1)<>0 THEN 780\r"
  "770 GOTO 910\r"
  "780 GOTO 1000\r"
  "790 W(R-1,S)=C\r"
  "800 C=C+1:V(R-1,S)=2:R=R-1\r"
  "810 IF C=H*V+1 THEN 1010\r"
  "815 Q=0:GOTO 260\r"
  "820 W(R,S-1)=C\r"
  "830 C=C+1\r"
  "840 V(R,S-1)=1:S=S-1:IF C=H*V+1 THEN 1010\r"
  "850 Q=0:GOTO 260\r"
  "860 W(R+1,S)=C\r"
  "870 C=C+1:IF V(R,S)=0 THEN 880\r"
  "875 V(R,S)=3:GOTO 890\r"
  "880 V(R,S)=2\r"
  "890 R=R+1\r"
  "900 IF C=H*V+1 THEN 1010\r"
  "905 GOTO 530\r"
  "910 IF Q=1 THEN 960\r"
  "920 W(R,S+1)=C:C=C+1:IF V(R,S)=0 THEN 940\r"
  "930 V(R,S)=3:GOTO 950\r"
  "940 V(R,S)=1\r"
  "950 S=S+1:IF C=H*V+1 THEN 1010\r"
  "955 GOTO 260\r"
  "960 Z=1\r"
  "970 IF V(R,S)=0 THEN 980\r"
  "975 V(R,S)=3:Q=0:GOTO 1000\r"
  "980 V(R,S)=1:Q=0:R=1:S=1:GOTO 250\r"
  "1000 GOTO 210\r"
  "1010 FOR J=1 TO V\r"
  "1011 PRINT \"I\";\r"
  "1012 FOR I=1 TO H\r"
  "1013 IF V(I,J)<2 THEN 1030\r"
  "1020 PRINT \"   \";\r"
  "1021 GOTO 1040\r"
  "1030 PRINT \"  I\";\r"
  "1040 NEXT I\r"
  "1041 PRINT\r"
  "1043 FOR I=1 TO H\r"
  "1045 IF V(I,J)=0 THEN 1060\r"
  "1050 IF V(I,J)=2 THEN 1060\r"
  "1051 PRINT \":  \";\r"
  "1052 GOTO 1070\r"
  "1060 PRINT \":--\";\r"
  "1070 NEXT I\r"
  "1071 PRINT \".\"\r"
  "1072 NEXT J\r"
  "1073 END\r"
  "";

const char basic_baccarat[] =
  "100 REM (SOURCE UNKNOWN) EDITED SLIGHTLY BY D. KURLAND 11/6/75\r"
  "110 PRINT \"WELCOME TO CASINO UNIVAC 1108\" \r"
  "120 PRINT \"THE GAME IS BACCARAT\"  \r"
  "130 H=0   \r"
  "140 GOSUB 1400\r"
  "150 DIM A(10),C(10)   \r"
  "160 PRINT \"ARE YOU READY\";   \r"
  "170 INPUT X$ \r"
  "180 IF X$=\"NO\" OR X$=\"N\" THEN 1390\r"
  "190 PRINT \"WAGER\";   \r"
  "200 D=0  \r"
  "210 E=0  \r"
  "220 INPUT G  \r"
  "230 IF G>100000! THEN 1370 \r"
  "240 IF G>0 THEN 270   \r"
  "250 PRINT \"HA!HA!, VERY FUNNY!!\" \r"
  "260 GOTO 190 \r"
  "270 B=1  \r"
  "280 GOTO 740\r"
  "290 A(B)=INT(RND(1)*52)+1\r"
  "300 C(B)=A(B)-13*INT(A(B)/13)   \r"
  "310 IF C(B)=0 THEN 600  \r"
  "320 ON C(B)GOTO330,350,370,390,410,430,450,470,490,510,540,570  \r"
  "330 PRINT \"ACE  \";  \r"
  "340 GOTO 620   \r"
  "350 PRINT \"DEUCE  \";\r"
  "360 GOTO 620   \r"
  "370 PRINT \"THREE  \";\r"
  "380 GOTO 620   \r"
  "390 PRINT \"FOUR  \"; \r"
  "400 GOTO 620   \r"
  "410 PRINT \"FIVE  \"; \r"
  "420 GOTO 620   \r"
  "430 PRINT \"SIX  \";  \r"
  "440 GOTO 620   \r"
  "450 PRINT \"SEVEN  \";\r"
  "460 GOTO 620   \r"
  "470 PRINT \"EIGHT  \";\r"
  "480 GOTO 620   \r"
  "490 PRINT \"NINE  \"; \r"
  "500 GOTO 620   \r"
  "510 PRINT \"TEN  \";  \r"
  "520 C(B)=0  \r"
  "530 GOTO 620   \r"
  "540 PRINT \"JACK  \"; \r"
  "550 C(B)=0  \r"
  "560 GOTO 620   \r"
  "570 PRINT \"QUEEN  \";\r"
  "580 C(B)=0  \r"
  "590 GOTO 620   \r"
  "600 PRINT \"KING  \"; \r"
  "610 C(B)=0  \r"
  "620 IF INT(A(B)/13)<>A(B)/13 THEN 640   \r"
  "630 ON A(B)/13 GOTO 660,680,700,720 \r"
  "640 IF INT(A(B)/13)=0 THEN 660  \r"
  "650 ON INT(A(B)/13)GOTO 680,700,720 \r"
  "660 PRINT \"OF CLUBS\"\r"
  "670 RETURN  \r"
  "680 PRINT \"OF DIAMONDS\" \r"
  "690 RETURN  \r"
  "700 PRINT \"OF SPADES\"   \r"
  "710 RETURN  \r"
  "720 PRINT \"OF HEARTS\"   \r"
  "730 RETURN  \r"
  "740 PRINT \"YOUR FIRST CARD IS A \";  \r"
  "750 GOSUB 290\r"
  "760 GOSUB 1310   \r"
  "770 PRINT \"YOUR NEXT CARD IS A \";   \r"
  "780 GOSUB 290\r"
  "790 GOSUB 1310   \r"
  "800 PRINT \"DO YOU WANT A CARD\"; \r"
  "810 INPUT J$\r"
  "820 IF J$=\"YES\" OR J$=\"Y\" THEN 870  \r"
  "830 C(3)=0  \r"
  "840 D=D+C(B)\r"
  "850 B=B+1   \r"
  "860 GOTO 900   \r"
  "870 PRINT \"THE CARD IS A \"; \r"
  "880 GOSUB290 \r"
  "890 GOSUB 1310   \r"
  "900 PRINT \"MY FIRST CARD IS A \";\r"
  "910 GOSUB 290\r"
  "920 GOSUB 1340   \r"
  "930 PRINT \"MY NEXT CARD IS A \"; \r"
  "940 GOSUB 290\r"
  "950 GOSUB 1340   \r"
  "960 IF E<10 THEN 990\r"
  "970 E=E-10  \r"
  "980 GOTO 960   \r"
  "990 IF E<6 THEN 1030 \r"
  "1000 PRINT \"I DO NOT WANT A CARD\"\r"
  "1010 C(6)=0  \r"
  "1020 GOTO 1060   \r"
  "1030 PRINT \"I TAKE CARD\" \r"
  "1040 PRINT \"THE CARD IS A \"; \r"
  "1050 GOSUB 290\r"
  "1060 E=E+C(6)\r"
  "1070 IF D<10 THEN 1100\r"
  "1080 D=D-10  \r"
  "1090 GOTO 1070   \r"
  "1100 PRINT \"YOUR TOTAL IS\";D \r"
  "1110 IF E<10 THEN 1140\r"
  "1120 E=E-10  \r"
  "1130 GOTO 1110   \r"
  "1140 PRINT \"MY TOTAL IS  \";E \r"
  "1150 IF D=E THEN 1590\r"
  "1160 IF D>E THEN 1200 \r"
  "1170 PRINT \"I WIN  $\"G   \r"
  "1180 G=-G\r"
  "1190 GOTO 1210   \r"
  "1200 PRINT \"YOU WIN $\";G \r"
  "1210 H=H+G   \r"
  "1220 IF H>0 THEN 1290 \r"
  "1230 IF H=0 THEN 1610\r"
  "1240 PRINT \"YOU OWE ME  $\";-H\r"
  "1250 PRINT \"DO YOU WANT TO TRY AGAIN\";   \r"
  "1260 INPUT K$\r"
  "1270 IF K$=\"NO\" OR K$=\"N\" THEN 1390   \r"
  "1280 GOTO 190\r"
  "1290 PRINT \"I.O.U. $\";H  \r"
  "1300 GOTO 1250   \r"
  "1310 D=D+C(B)\r"
  "1320 B=B+1   \r"
  "1330 RETURN  \r"
  "1340 E=E+C(B)\r"
  "1350 B=B+1   \r"
  "1360 RETURN  \r"
  "1370 PRINT \"HOUSE LIMIT IS $100000\"  \r"
  "1380 GOTO190  \r"
  "1390 STOP\r"
  "1400 PRINT \"DO YOU WANT THE RULES OF THE GAME\"; \r"
  "1410 INPUT I$   \r"
  "1420 IF I$=\"NO\" OR I$=\"N\" THEN RETURN   \r"
  "1430 PRINT \"* OFFICIAL RULES FOR THE GAME OF BACCARAT *\"\r"
  "1440 PRINT \"THE COMPUTER IS SHUFFLING SIX DECKS OF CARDS\"   \r"
  "1450 PRINT \"TOGETHER. THE RULES ARE AS FOLLOWS: THE OBJECT\" \r"
  "1460 PRINT \"IS TO BE AS CLOSE TO POSSIBLE TO NINE IN TWO\"   \r"
  "1470 PRINT \"OR THREE CARDS, FACE CARDS AND TENS COUNT ZERO\" \r"
  "1480 PRINT \"ACES COUNT AS ONE EACH,ALL OTHER CARDS COUNT\"   \r"
  "1490 PRINT \"THEIR INDEX VALUE.  WHEN THE TOTAL IS OVER TEN\" \r"
  "1500 PRINT \"THE TENS UNIT IS DROPPED.  EXAMPLE: A SEVEN AND\"\r"
  "1510 PRINT \"A SIX TOTALING THIRTEEN COUNT AS THREE.  THE\"   \r"
  "1520 PRINT \"PLAYER WITH THE HIGHER TOTAL WINS.  IN CASE OF\" \r"
  "1530 PRINT \"A TIE THE COMPUTER WINS. \"  \r"
  "1540 PRINT \"DO YOU UNDERSTAND THE RULES\";   \r"
  "1550 INPUT O$   \r"
  "1560 IF O$=\"YES\" OR O$=\"Y\" THEN RETURN  \r"
  "1570 PRINT \"TOUGH LUCK\" \r"
  "1580 RETURN \r"
  "1590 PRINT \"IT IS A TIE. THE COMPUTER WINS!\"\r"
  "1600 GOTO 1170  \r"
  "1610 PRINT \"YOU ARE EVEN-UP !!\" \r"
  "1620 GOTO1250\r"
  "1630 END\r"
  "";

const char basic_baseball[] =
  "100 REM BASEBALL SIMULATION PROGRAM\r"
  "110 REM WRITTEN BY JOEL LIND & KEN BIRKMAN - NYU - JULY 1973\r"
  "120 REM STOLEN AND ENHANCED DECEMBER 1973 BY R. D. KURLAND - NYU\r"
  "130 DIM B(7),P$(9),W$(7),J$(8),K$(4)\r"
  "140 FOR I=1 TO 7: B(I)=0:NEXT\r"
  "150 B=0:T9=0:R9=0:S=0:O=0:B1=0:B2=0:T=0\r"
  "160 Z1=1:Z2=1\r"
  "170 PRINT \"WELCOME TO EBBETT'S FIELD\"\r"
  "180 PRINT \"WHAT DO YOU WANT TO CALL YOUR TEAM\";\r"
  "190 INPUT A$\r"
  "200 FOR I=1 TO 7:READ W$(I):NEXT\r"
  "210 FOR I=1 TO 9:READ P$(I):NEXT\r"
  "220 FOR I=1 TO 4:READ K$(I):NEXT\r"
  "230 FOR I=1 TO 8:READ J$(I):NEXT\r"
  "240 PRINT \"FINE. THE \";A$;\" NEED A MANAGER.  WHAT'S YOUR NAME\";\r"
  "250 INPUT B$\r"
  "260 PRINT \"WHAT DO YOU WANT TO CALL MY TEAM, \";B$;\r"
  "270 INPUT C$\r"
  "280 PRINT\r"
  "290 PRINT \"OPENING DAY, THE \";A$;\" VERSUS THE \";C$\r"
  "300 PRINT\r"
  "310 PRINT \"LET'S FLIP A COIN. THE WINNER IS THE HOME TEAM.\"\r"
  "320 PRINT \"HEADS OR TAILS\";\r"
  "330 INPUT D$\r"
  "340 IF D$<>\"HEADS\" AND D$<>\"TAILS\" THEN 320\r"
  "350 FOR I=1 TO TYM\r"
  "360 Y=RND(1)\r"
  "370 NEXT I\r"
  "380 H=1\r"
  "390 Y=RND(1)\r"
  "400 Y$=\"HEADS\"\r"
  "410 IF Y>.5 THEN Y$=\"TAILS\"\r"
  "420 IF D$=Y$ THEN 490\r"
  "430 H=0\r"
  "440 PRINT \"YOU LOST THE TOSS.  THE \";A$;\" ARE UP FIRST.\"\r"
  "450 PRINT\r"
  "460 PRINT\r"
  "470 A=0\r"
  "480 GOTO 610\r"
  "490 PRINT \"YOU WIN THE TOSS. \";A$;\" TAKE THE FIELD, AND \";\r"
  "500 PRINT C$;\" ARE AT BAT.\"\r"
  "510 A=1\r"
  "520 R9=0\r"
  "530 T=T+1\r"
  "540 IF T<3 THEN GOSUB 5140\r"
  "550 IF T<18 THEN 710\r"
  "560 IF T>18 THEN 590\r"
  "570 GOSUB 3500\r"
  "580 GOTO 710\r"
  "590 GOSUB 3290\r"
  "600 GOTO 710\r"
  "610 REM START AN INNING - WE ARE OUT ON THE FIELD\r"
  "620 T=T+1\r"
  "630 R9=0\r"
  "640 IF T<18 THEN 690\r"
  "650 IF T>18 THEN 680\r"
  "660 GOSUB 3500\r"
  "670 GOTO 690\r"
  "680 GOSUB 3290\r"
  "690 IF T>2 THEN 710\r"
  "700 GOSUB 5070\r"
  "710 S=0:B=0\r"
  "720 PRINT\r"
  "730 IF O=0 THEN PRINT \"NO OUTS\"\r"
  "740 IF O=1 THEN PRINT \"THERE IS 1 OUT\"\r"
  "750 IF O>1 THEN PRINT \"THERE ARE\";O;\"OUTS\"\r"
  "760 P=B(1)+B(2)+B(3)\r"
  "770 IF P<>3 THEN 800\r"
  "780 PRINT \"BASES LOADED\"\r"
  "790 GOTO 900\r"
  "800 IF P=0 THEN 900\r"
  "810 Y$=\"RUNNER ON \"\r"
  "820 IF P>1 THEN Y$=\"RUNNERS ON \"\r"
  "830 PRINT Y$;\r"
  "840 IF B(1)=0 THEN 870\r"
  "850 PRINT \"FIRST\";\r"
  "860 IF P>1 THEN PRINT \" AND \";\r"
  "870 IF B(2)=1 THEN PRINT \"SECOND\";\r"
  "880 IF P>1 AND B(1)=0 THEN PRINT \" AND \";\r"
  "890 IF B(3)=1 THEN PRINT \"THIRD\" ELSE PRINT \" \"\r"
  "900 IF A=0 THEN 920\r"
  "910 GOTO 3030\r"
  "920 PRINT \"BATTER UP\"\r"
  "930 IF B<>3 OR S<>2 THEN 960\r"
  "940 PRINT \"FULL COUNT\"\r"
  "950 GOTO 970\r"
  "960 IF B>0 OR S>0 THEN PRINT \"THE COUNT IS\";B;\"AND\";S\r"
  "970 PRINT\r"
  "980 IF A=1 THEN 3030\r"
  "990 PRINT \"WHAT WILL YOUR BATTER DO, \";B$;\r"
  "1000 INPUT C\r"
  "1010 IF C>0 AND C<5 THEN 1050\r"
  "1020 PRINT \"HUH?  \";\r"
  "1030 GOSUB 5070\r"
  "1040 GOTO 990\r"
  "1050 Y2=RND(1)\r"
  "1060 IF Y2<.56 OR Y2>.5625 THEN 1120\r"
  "1070 PRINT \"WILD PITCH!\"\r"
  "1080 N=1\r"
  "1090 GOSUB 3540\r"
  "1100 B(1)=0\r"
  "1110 GOTO 1210\r"
  "1120 IF Y2>.772 AND Y2<.775 THEN 4880\r"
  "1130 ON C GOTO 1140,1450,2600,4450,5500\r"
  "1140 C=1\r"
  "1150 GOSUB 5240\r"
  "1160 IF A=0 THEN Z1=Z1+1\r"
  "1170 Y=RND(1)\r"
  "1180 IF B<>3 OR S<>0 THEN 1200\r"
  "1190 IF Y<.7 THEN 1310 ELSE 1210\r"
  "1200 IF Y<.5 THEN 1310\r"
  "1210 B=B+1\r"
  "1220 Y=INT(RND(1)*8+1)\r"
  "1230 IF Y=9 THEN 1220\r"
  "1240 PRINT J$(Y);\" - BALL\";B\r"
  "1250 IF B<>4 THEN 930\r"
  "1260 PRINT \"WALK\"\r"
  "1270 GOSUB 4950\r"
  "1280 Y=RND(1)\r"
  "1290 GOTO 710\r"
  "1300 PRINT \"HIGH POP - FOUL DOWN THE \";Y$;\" FIELD LINE\"\r"
  "1310 S=S+1\r"
  "1320 IF C=2 OR C=5 THEN 1370\r"
  "1330 Y=INT(RND(1)*4+1)\r"
  "1340 IF Y=5 THEN 1330\r"
  "1350 PRINT K$(Y);\", CALLED STRIKE\";S\r"
  "1360 GOTO 1380\r"
  "1370 PRINT \"SWINGING STRIKE\";S\r"
  "1380 IF C=5 AND S<>3 THEN 4450\r"
  "1390 IF S<>3 THEN 930\r"
  "1400 PRINT \"STRUCK OUT\"\r"
  "1410 O=O+1\r"
  "1420 IF O=3 THEN 2850\r"
  "1430 IF C=5 THEN 4450\r"
  "1440 GOTO 710\r"
  "1450 C=2\r"
  "1460 Y=INT(RND(1)*10+1)\r"
  "1470 IF Y=10 THEN 1450\r"
  "1480 IF A=0 THEN Z2=Z2+1\r"
  "1490 IF C<>5 THEN GOSUB 5240\r"
  "1500 IF S<>2 AND Z2/Z1>7 AND A=0 THEN 1520\r"
  "1510 IF S<>2 OR Z2/Z1<25 THEN 1590\r"
  "1520 Y=INT(RND(1)*20+1)\r"
  "1530 IF Y>7 THEN 1550\r"
  "1540 ON Y GOTO 1610,1310,1310,1310,1310,1680,1610\r"
  "1550 IF Y>13 THEN 1570\r"
  "1560 ON Y-7 GOTO 1680,1310,1740,1850,1740,1850\r"
  "1570 IF Y>18 THEN 1600\r"
  "1580 ON Y-13 GOTO 1980,1980,2040,2570,1640,2570\r"
  "1590 IF Y<3 THEN 1310\r"
  "1600 ON Y-2 GOTO 1610,1680,1740,1850,1980,2040,2570\r"
  "1610 PRINT \"FOULED INTO THE STANDS-OUT OF PLAY\"\r"
  "1620 IF S<>2 THEN S=S+1\r"
  "1630 GOTO 930\r"
  "1640 Y=RND(1)\r"
  "1650 Y$=\"RIGHT\"\r"
  "1660 IF Y<.5 THEN Y$=\"LEFT\"\r"
  "1670 GOTO 1620\r"
  "1680 Y=INT(RND(1)*20+1)\r"
  "1690 IF Y>18 THEN 1720\r"
  "1700 PRINT \"FOULED BACK INTO THE STANDS\"\r"
  "1710 GOTO 1620\r"
  "1720 PRINT \"POPPED IT UP - CAUGHT BY CATCHER\"\r"
  "1730 GOTO 1410\r"
  "1740 PRINT \"INFIELD GROUNDER\"\r"
  "1750 E2=RND(1)\r"
  "1760 IF E2<.37 OR E2>.41 THEN 1820\r"
  "1770 PRINT \"1 BASE ERROR!!\"\r"
  "1780 N=1\r"
  "1790 C=4\r"
  "1800 GOSUB 3540\r"
  "1810 GOTO 710\r"
  "1820 GOSUB 4100\r"
  "1830 IF O=3 THEN 2850\r"
  "1840 GOTO 710\r"
  "1850 PRINT \"GROUNDER - COULD BE TROUBLE\"\r"
  "1860 Y=RND(1)\r"
  "1870 IF Y>.75 THEN 1950\r"
  "1880 Y$=\"UP THE MIDDLE\"\r"
  "1890 IF Y<.5 THEN Y$=\"THROUGH THE HOLE INTO RIGHT FIELD\"\r"
  "1900 IF Y<.25 THEN Y$=\"THROUGH THE HOLE INTO LEFT FIELD\"\r"
  "1910 PRINT \"A SINGLE \";Y$;\"!\"\r"
  "1920 N=1\r"
  "1930 GOSUB 3540\r"
  "1940 GOTO 710\r"
  "1950 PRINT \"INFIELDER UP WITH IT!\"\r"
  "1960 GOSUB 4800\r"
  "1970 IF O=3 THEN 2850 ELSE 710\r"
  "1980 Y=RND(1)\r"
  "1990 Y$=\"LEFT\"\r"
  "2000 IF Y<.6 THEN Y$=\"CENTER\"\r"
  "2010 IF Y<.3 THEN Y$=\"RIGHT\"\r"
  "2020 PRINT \"FLY-OUT TO \";Y$;\" FIELD\"\r"
  "2030 GOTO 1410\r"
  "2040 Z=RND(1)\r"
  "2050 Y$=\"CENTER\"\r"
  "2060 IF Z<.6 THEN Y$=\"RIGHT\"\r"
  "2070 IF Z<.3 THEN Y$=\"LEFT\"\r"
  "2080 PRINT \"LONG FLY TO DEEP \";Y$;\" FIELD - LOOKS GOOD!\"\r"
  "2090 Z=RND(1)\r"
  "2100 IF Z<.9 THEN 2130\r"
  "2110 PRINT Y$;\"FIELDER CAUGHT IT AT THE WALL!\"\r"
  "2120 GOTO 2180\r"
  "2130 IF Z<.8 THEN 2160\r"
  "2140 PRINT \"A DIVING CATCH!\"\r"
  "2150 GOTO 2180\r"
  "2160 IF Z<.7 THEN 2290\r"
  "2170 PRINT Y$;\"FIELDER CAUGHT IT ON THE WARNING TRACK!\"\r"
  "2180 O=O+1\r"
  "2190 IF O=3 THEN 2850\r"
  "2200 FOR I=3 TO 1 STEP -1\r"
  "2210 IF B(I)=1 THEN 2240\r"
  "2220 NEXT I\r"
  "2230 GOTO 710\r"
  "2240 B(I+1)=B(I)\r"
  "2250 B(I)=0\r"
  "2260 PRINT \"LEAD RUNNER TAGS UP - AND ADVANCES 1 BASE!\"\r"
  "2270 GOSUB 3830\r"
  "2280 GOTO 710\r"
  "2290 IF Z<.5 THEN 2360\r"
  "2300 PRINT \"BATTER HOLDS WITH A SINGLE.\"\r"
  "2310 N=2\r"
  "2320 GOSUB 3540\r"
  "2330 B(2)=0\r"
  "2340 B(1)=1\r"
  "2350 GOTO 710\r"
  "2360 IF Z<.15 THEN 2480\r"
  "2370 PRINT \"DOUBLE!\"\r"
  "2380 Y=RND(1)\r"
  "2390 IF Y>.5 THEN 2430\r"
  "2400 N=2\r"
  "2410 GOSUB 3540\r"
  "2420 GOTO 710\r"
  "2430 N=3\r"
  "2440 GOSUB 3540\r"
  "2450 B(3)=0\r"
  "2460 B(2)=1\r"
  "2470 GOTO 710\r"
  "2480 IF Z<.1 THEN 2530\r"
  "2490 PRINT \"TRIPLE!\"\r"
  "2500 N=3\r"
  "2510 GOSUB 3540\r"
  "2520 GOTO 710\r"
  "2530 PRINT \"IT'S OVER THE WALL -- A H*O*M*E R*U*N!!!\"\r"
  "2540 N=4\r"
  "2550 GOSUB 3540\r"
  "2560 GOTO 710\r"
  "2570 Y=INT(RND(1)*7+1)\r"
  "2580 PRINT \"LINED OUT TO \";P$(Y)\r"
  "2590 GOTO 1410\r"
  "2600 GOSUB 5240\r"
  "2610 PRINT \"BATTER BUNTS...\"\r"
  "2620 Y=RND(1)\r"
  "2630 IF Y<.6 THEN 2750\r"
  "2640 IF B(3)=0 THEN 2660\r"
  "2650 IF Y<.8 THEN 2830\r"
  "2660 PRINT \"THROWN OUT AT FIRST.\"\r"
  "2670 O=O+1\r"
  "2680 IF O=3 THEN 2850\r"
  "2690 IF B(1)+B(2)+B(3)=0 THEN 710\r"
  "2700 PRINT \"SACRIFICE - \";\r"
  "2710 N=1\r"
  "2720 GOSUB 3540\r"
  "2730 B(1)=0\r"
  "2740 GOTO 710\r"
  "2750 IF Y<.2 THEN 2830\r"
  "2760 IF Y<.4 THEN 2790\r"
  "2770 PRINT \"BATTER MISSES PITCH\"\r"
  "2780 GOTO 1310\r"
  "2790 PRINT \"BEATS IT OUT! SINGLE!\"\r"
  "2800 N=1\r"
  "2810 GOSUB 3540\r"
  "2820 GOTO 710\r"
  "2830 GOSUB 4100\r"
  "2840 IF O<>3 THEN 710\r"
  "2850 PRINT \"3 OUTS. THE SIDE IS RETIRED\";\r"
  "2860 I=B(1)+B(2)+B(3)\r"
  "2870 IF I=0 THEN PRINT \".\"\r"
  "2880 IF I=1 THEN PRINT \", LEAVING 1 MAN ON BASE\"\r"
  "2890 IF I>1 THEN PRINT \", LEAVING\";I;\"MEN ON BASE\"\r"
  "2900 PRINT\r"
  "2910 PRINT\r"
  "2920 PRINT \"*************\"\r"
  "2930 D=T/2-INT(T/2)\r"
  "2940 PRINT \"AFTER\";\r"
  "2950 IF T>1 THEN PRINT INT(T/2);\r"
  "2960 IF D>.3 THEN PRINT \" 1/2 \";\r"
  "2970 Y$=\"INNINGS\"\r"
  "2980 IF T<3 THEN Y$=\"INNING\"\r"
  "2990 PRINT Y$;\" OF PLAY, THE SCORE IS\"\r"
  "3000 GOSUB 3960\r"
  "3010 O=0:B(1)=0:B(2)=0:B(3)=0\r"
  "3020 IF A=0 THEN 510 ELSE 470\r"
  "3030 REM MY TEAM IS AT BAT\r"
  "3040 Y=RND(1)\r"
  "3050 IF B(1)+B(2)+B(3)=0 THEN 3140\r"
  "3060 REM IF O=2 AND S=2 AND B=3 THEN 4850\r"
  "3070 IF B(3)=1 THEN 3110\r"
  "3080 IF B(2)=0 THEN 3100\r"
  "3090 IF .45<Y AND .46>Y THEN 4450\r"
  "3100 IF .45<Y AND .47>Y THEN 4450\r"
  "3110 IF O=2 THEN 3140\r"
  "3120 IF O<2 AND Y<.333 AND B(3)=1 THEN 2600\r"
  "3130 IF .45<Y AND .55>Y THEN 2600\r"
  "3140 IF S=0 THEN 3240\r"
  "3150 IF B<>3 THEN 3180\r"
  "3160 IF Y<.6 THEN 1450\r"
  "3170 GOTO 1140\r"
  "3180 IF Y>.3 THEN 1450\r"
  "3190 IF S<>2 THEN 1140\r"
  "3200 IF B=0 AND Y<.1 THEN 1140\r"
  "3210 IF B=0 THEN 1450\r"
  "3220 IF Y<.2 THEN 1140\r"
  "3230 GOTO 1450\r"
  "3240 IF B=3 THEN 3270\r"
  "3250 IF Y<.6 THEN 1140\r"
  "3260 GOTO 1450\r"
  "3270 IF Y<.9 THEN 1140\r"
  "3280 GOTO 1450\r"
  "3290 IF T<>19 THEN 3330\r"
  "3300 IF R1<>R2 THEN 3340\r"
  "3310 PRINT\r"
  "3320 PRINT \"*** GOING INTO EXTRA INNINGS ***\"\r"
  "3330 IF R1=R2 THEN RETURN\r"
  "3340 IF (T-1)/2<>INT(T-1)/2 THEN RETURN\r"
  "3350 PRINT \"THE BALLGAME IS OVER.\"\r"
  "3360 PRINT \"*************\"\r"
  "3370 PRINT \"FINAL SCORE:\"\r"
  "3380 T9=1\r"
  "3390 GOSUB 3960\r"
  "3400 IF R1>R2 THEN 3470\r"
  "3410 PRINT \"NICE TRY, \";B$\r"
  "3420 PRINT \"YOU SHOULD KNOW BETTER THAN TO TRY TO\"\r"
  "3430 PRINT \"OUT-MANAGE A COMPUTER.  MAYBE BASEBALL\"\r"
  "3440 PRINT \"JUST ISN'T YOUR SPORT...WHY DON'T YOU TRY GOLF?\"\r"
  "3450 REM CHAIN GOLF\r"
  "3460 STOP\r"
  "3470 PRINT \"CONGRATULATIONS, \";B$\r"
  "3480 PRINT \"YOU'VE BEATEN ME, BUT I WILL HAVE MY REVENGE.\"\r"
  "3490 STOP\r"
  "3500 REM 9TH INNING\r"
  "3510 IF A=0 THEN 3530\r"
  "3520 IF R2>R1 THEN 3350 ELSE RETURN\r"
  "3530 IF R1>R2 THEN 3350 ELSE RETURN\r"
  "3540 REM ADVANCE N BASES (SET N BEFORE GOSUB)\r"
  "3550 N2=B(1)+B(2)+B(3)\r"
  "3560 IF C=5 THEN N=N+1\r"
  "3570 N3=N\r"
  "3580 IF N2=0 THEN 3650\r"
  "3590 REM FIND LAST RUNNER: MAKE SURE HE ISN\"T TRYING TO ADVANCE\r"
  "3600 REM PAST HOME PLATE.\r"
  "3610 FOR I=1 TO 3\r"
  "3620 IF B(I)=1 THEN 3640\r"
  "3630 NEXT I\r"
  "3640 IF 4-I<N THEN N3=4-I\r"
  "3650 FOR I=3+N TO N+1 STEP -1\r"
  "3660 B(I)=B(I-N)\r"
  "3670 NEXT I\r"
  "3680 B(N)=1\r"
  "3690 IF N=1 THEN 3740\r"
  "3700 FOR P=1 TO 3\r"
  "3710 IF (N-P)>1 THEN B(N-P)=0\r"
  "3720 IF (N-P)<=1 THEN B(1)=0\r"
  "3730 NEXT P\r"
  "3740 FOR P=1 TO 7\r"
  "3750 IF P=N THEN 3780\r"
  "3760 NEXT P\r"
  "3770 GOTO 3830\r"
  "3780 IF C=4 OR N2=0 THEN 3830\r"
  "3790 Y$=\"RUNNERS ADVANCE\"\r"
  "3800 IF N2=1 THEN Y$=\"RUNNER ADVANCES\"\r"
  "3810 PRINT Y$;N3;\r"
  "3820 IF N3=1 THEN PRINT \"BASE\" ELSE PRINT \"BASES\"\r"
  "3830 IF B(4)+B(5)+B(6)+B(7)=0 THEN RETURN\r"
  "3840 REM AT LEAST 1 RUN HAS SCORED.\r"
  "3850 N2=B(4)+B(5)+B(6)+B(7)\r"
  "3860 IF A=0 THEN 3890\r"
  "3870 R2=R2+N2\r"
  "3880 GOTO 3900\r"
  "3890 R1=R1+N2\r"
  "3900 B(4)=0:B(5)=0:B(6)=0:B(7)=0\r"
  "3910 IF N2=1 THEN PRINT \"** 1 RUN SCORED\"\r"
  "3920 IF N2>1 THEN PRINT \"**\";N2;\"RUNS SCORED\"\r"
  "3930 PRINT\r"
  "3940 PRINT\r"
  "3950 PRINT \"********NEW SCORE:\"\r"
  "3960 IF H=1 THEN 4000\r"
  "3970 IF LEN(A$)>LEN(C$) THEN PRINT A$;TAB(LEN(A$)+3);R1\r"
  "3980 IF LEN(A$)<=LEN(C$) THEN PRINT A$;TAB(LEN(C$)+3);R1\r"
  "3990 IF H=1 THEN 4030\r"
  "4000 IF LEN(A$)>LEN(C$) THEN PRINT C$;TAB(LEN(A$)+3);R2\r"
  "4010 IF LEN(A$)<=LEN(C$) THEN PRINT C$;TAB(LEN(C$)+3);R2\r"
  "4020 IF H=1 THEN 3970\r"
  "4030 PRINT \"*************\"\r"
  "4040 PRINT\r"
  "4050 PRINT\r"
  "4060 IF T9=1 THEN 4090\r"
  "4070 IF A=1 AND T>17 AND INT(T/2)=T/2 AND R2>R1 THEN 3350\r"
  "4080 IF A=0 AND T>17 AND INT(T/2)=T/2 AND R1>R2 THEN 3350\r"
  "4090 RETURN\r"
  "4100 REM LEAD RUNNER OUT (FIELDER\"S CHOICE THEN ONE BASE ADVANCE)\r"
  "4110 N=1\r"
  "4120 I=4\r"
  "4130 IF B(4)=0 AND B(3)=1 AND B(2)=1 AND B(1)=1 THEN 4220\r"
  "4140 I=3\r"
  "4150 IF B(3)=0 AND B(2)=1 AND B(1)=1 THEN 4220\r"
  "4160 I=2\r"
  "4170 IF B(2)=0 AND B(1)=1 THEN 4220\r"
  "4180 REM NO ONE FORCED\r"
  "4190 O=O+1\r"
  "4200 PRINT \"BATTER THROWN OUT\"\r"
  "4210 RETURN\r"
  "4220 B(I-1)=0\r"
  "4230 F=RND(1)\r"
  "4240 IF O=2 OR F>.3 THEN 4290\r"
  "4250 O=O+2\r"
  "4260 PRINT \"DOUBLE PLAY!\"\r"
  "4270 IF O=3 THEN RETURN\r"
  "4280 GOTO 4910\r"
  "4290 O=O+1\r"
  "4300 PRINT \"RUNNER ON BASE\";I-1;\"IS OUT ON FIELDER'S CHOICE\"\r"
  "4310 IF O=3 THEN RETURN\r"
  "4320 GOSUB 3540\r"
  "4330 RETURN\r"
  "4340 REM FORCED RUNNERS ADVANCE 1 BASE, OTHERS HOLD\r"
  "4350 FOR I=1 TO 3\r"
  "4360 IF B(I)=0 THEN 4400\r"
  "4370 NEXT I\r"
  "4380 N=1\r"
  "4390 GOTO 3540\r"
  "4400 REM NO ONE ON BASE I\r"
  "4410 FOR I2=I TO 1 STEP -1\r"
  "4420 B(I2)=1\r"
  "4430 NEXT I2\r"
  "4440 RETURN\r"
  "4450 REM LEAD RUNNER STEALS\r"
  "4460 FOR I=3 TO 1 STEP -1\r"
  "4470 IF B(I)=1 THEN 4510\r"
  "4480 NEXT I\r"
  "4490 PRINT \"NO ONE ON BASE, DUMMY!\"\r"
  "4500 GOTO 990\r"
  "4510 REM I IS LEAD RUNNER\"S BASE\r"
  "4520 IF C<>5 THEN GOSUB 5240\r"
  "4530 IF RND(1)/I<.3 THEN 4680\r"
  "4540 IF B(1)+B(2)+B(3)>1 THEN 4570\r"
  "4550 PRINT \"RUNNER STEALS A BASE\"\r"
  "4560 GOTO 4580\r"
  "4570 PRINT \"RUNNERS STEAL A BASE\"\r"
  "4580 N=1\r"
  "4590 C2=C\r"
  "4600 C=4\r"
  "4610 GOSUB 3540\r"
  "4620 C=C2\r"
  "4630 B(1)=0\r"
  "4640 IF C=5 AND S<>3 THEN 930\r"
  "4650 IF C=5 THEN 710\r"
  "4660 Y=RND(1)\r"
  "4670 IF Y>.5 THEN 1210 ELSE 1310\r"
  "4680 PRINT \"RUNNER THROWN OUT STEALING\"\r"
  "4690 O=O+1\r"
  "4700 B(I)=0\r"
  "4710 IF O=3 THEN 2850\r"
  "4720 N=1\r"
  "4730 GOSUB 3540\r"
  "4740 B(1)=0\r"
  "4750 IF C=5 AND S<>3 THEN 930\r"
  "4760 IF C=5 THEN 710\r"
  "4770 Y=RND(1)\r"
  "4780 IF B=3 THEN 1310\r"
  "4790 IF Y>.5 THEN 1210 ELSE 1310\r"
  "4800 REM RUNNERS ADVANCE ONE BASE, BATTER THROWN OUT\r"
  "4810 N=1\r"
  "4820 IF O=2 THEN 4850\r"
  "4830 GOSUB 3540\r"
  "4840 B(1)=0\r"
  "4850 O=O+1\r"
  "4860 PRINT \"BATTER THROWN OUT\"\r"
  "4870 RETURN\r"
  "4880 PRINT \"HIT BATSMAN (OUCH!)\"\r"
  "4890 GOSUB 4950\r"
  "4900 GOTO 710\r"
  "4910 N=1\r"
  "4920 GOSUB 3540\r"
  "4930 B(1)=0\r"
  "4940 RETURN\r"
  "4950 REM BATTER WALKED\r"
  "4960 FOR I=1 TO 3\r"
  "4970 IF B(I)=0 THEN 5010\r"
  "4980 NEXT I\r"
  "4990 N=1\r"
  "5000 GOTO 3540\r"
  "5010 IF I=1 THEN 5050\r"
  "5020 FOR I0=I TO 2 STEP -1\r"
  "5030 B(I0)=B(I0-1)\r"
  "5040 NEXT I0\r"
  "5050 B(1)=1\r"
  "5060 RETURN\r"
  "5070 PRINT \"WHEN YOUR'RE UP:\"\r"
  "5080 PRINT \"1-BATTER TAKES PITCH\"\r"
  "5090 PRINT \"2-BATTER SWINGS AWAY\"\r"
  "5100 PRINT \"3-BATTER BUNTS\"\r"
  "5110 PRINT \"4-LEAD RUNNER STEALS\"\r"
  "5120 REM PRINT \"5-HIT AND RUN\"\r"
  "5130 RETURN\r"
  "5140 REM PITCHING ROUTINE\r"
  "5150 PRINT \"YOUR PITCHER MAY THROW:\"\r"
  "5160 PRINT \"1-FAST BALL\"\r"
  "5170 PRINT \"2-CURVE\"\r"
  "5180 PRINT \"3-SLIDER\"\r"
  "5190 PRINT \"4-SINKER\"\r"
  "5200 PRINT \"5-CHANGE-UP\"\r"
  "5210 PRINT \"6-KNUCKLEBALL\"\r"
  "5220 PRINT \"7-SCREWBALL\"\r"
  "5230 RETURN\r"
  "5240 IF A=0 THEN 5370\r"
  "5250 IF R9=1 THEN 5300\r"
  "5260 PRINT \"WHAT WILL YOUR PITCHER THROW\";\r"
  "5270 INPUT W\r"
  "5280 IF W<0 THEN R9=1\r"
  "5290 IF R9=0 THEN 5320 ELSE PRINT \"RANDOM PITCHES FOR REST OF INNING\"\r"
  "5300 W=INT(RND(1)*8+1)\r"
  "5310 IF W=8 THEN 5300\r"
  "5320 IF W>0 AND W<8 THEN 5470\r"
  "5330 PRINT \"UH-UH, \";B$;\".  \";\r"
  "5340 GOSUB 5150\r"
  "5350 PRINT\r"
  "5360 GOTO 5260\r"
  "5370 REM I MUST SELECT A PITCH\r"
  "5380 W1=RND(1)\r"
  "5390 W=1\r"
  "5400 IF W1<.75 THEN W=2\r"
  "5410 IF W1<.55 THEN W=3\r"
  "5420 IF W1<.45 THEN W=4\r"
  "5430 IF W1<.35 THEN W=5\r"
  "5440 IF W1<.15 THEN W=6\r"
  "5450 IF W1<.08 THEN W=7\r"
  "5460 GOTO 5470\r"
  "5470 PRINT W$(W);\r"
  "5480 PRINT \"...\";\r"
  "5490 RETURN\r"
  "5500 REM HIT-AND-RUN\r"
  "5510 IF B(1)+B(2)+B(3)=0 THEN 4490\r"
  "5520 GOSUB 5240\r"
  "5530 PRINT \"HIT AND RUN!\"\r"
  "5540 C=5\r"
  "5550 GOTO 1460\r"
  "5560 DATA FAST BALL,CURVE BALL,SLIDER,SINKER,CHANGE-UP,KNUCKLEBALL\r"
  "5570 DATA SCREWBALL\r"
  "5580 DATA RIGHT,LEFT,CENTER,FIRST,SECOND,THIRD,SHORTSTOP,PITCHER,CATCHER\r"
  "5590 DATA RIGHT OVER THE PLATE,CAUGHT THE OUTSIDE CORNER\r"
  "5600 DATA OVER THE INSIDE CORNER,OVER AT THE KNEES\r"
  "5610 DATA HIGH,LOW,INSIDE,OUTSIDE,HIGH AND TIGHT,LOW AND OUTSIDE\r"
  "5620 DATA LOW AND INSIDE,HIGH AND OUTSIDE\r"
  "5630 END\r"
  "";

const char basic_basketbl[] =
  "5 PRINT TAB(31);\"BASKETBALL\"\r"
  "7 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "8 PRINT:PRINT:PRINT\r"
  "10 PRINT \"THIS IS DARTMOUTH COLLEGE BASKETBALL.  YOU WILL BE DARTMOUTH\"\r"
  "20 PRINT \" CAPTAIN AND PLAYMAKER.  CALL SHOTS AS FOLLOWS:  1. LONG\"\r"
  "30 PRINT \" (30 FT.) JUMP SHOT; 2. SHORT (15 FT.) JUMP SHOT; 3. LAY\"\r"
  "40 PRINT \" UP; 4. SET SHOT.\"\r"
  "60 PRINT \"BOTH TEAMS WILL USE THE SAME DEFENSE.  CALL DEFENSE AS\"\r"
  "70 PRINT \"FOLLOWS:  6. PRESS; 6.5 MAN-TO MAN; 7. ZONE; 7.5 NONE.\"\r"
  "72 PRINT \"TO CHANGE DEFENSE, JUST TYPE 0 AS YOUR NEXT SHOT.\"\r"
  "76 INPUT \"YOUR STARTING DEFENSE WILL BE\";D:IF D<6 THEN 2010\r"
  "79 PRINT\r"
  "80 INPUT \"CHOOSE YOUR OPPONENT\";O$\r"
  "370 PRINT \"CENTER JUMP\"\r"
  "390 IF RND(1)> 3/5 THEN 420\r"
  "400 PRINT O$;\" CONTROLS THE TAP.\"\r"
  "410 GOTO 3000\r"
  "420 PRINT \"DARTMOUTH CONTROLS THE TAP.\"\r"
  "425 PRINT\r"
  "430 INPUT \"YOUR SHOT\";Z\r"
  "440 P=0\r"
  "445 IF Z<>INT(Z) THEN 455\r"
  "446 IF Z<0 OR Z>4 THEN 455\r"
  "447 GOTO 460\r"
  "455 PRINT \"INCORRECT ANSWER.  RETYPE IT. \";:GOTO 430\r"
  "460 IF RND(1)<.5 THEN 1000\r"
  "480 IF T<100 THEN 1000\r"
  "490 PRINT\r"
  "491 IF S(1)<>S(0) THEN 510\r"
  "492 PRINT:PRINT \"   ***** END OF SECOND HALF *****\":PRINT\r"
  "493 PRINT \"SCORE AT END OF REGULATION TIME:\"\r"
  "494 PRINT \"        DARTMOUTH:\";S(1);\"  \";O$;\":\";S(0)\r"
  "495 PRINT\r"
  "496 PRINT \"BEGIN TWO MINUTE OVERTIME PERIOD\"\r"
  "499 T=93\r"
  "500 GOTO 370\r"
  "510 PRINT \"   ***** END OF GAME *****\"\r"
  "515 PRINT \"FINAL SCORE: DARTMOUTH:\";S(1);\"  \";O$;\":\";S(0)\r"
  "520 STOP\r"
  "600 PRINT\r"
  "610 PRINT \"   *** TWO MINUTES LEFT IN THE GAME ***\"\r"
  "620 PRINT\r"
  "630 RETURN\r"
  "1000 ON Z GOTO 1040,1040\r"
  "1030 GOTO 1300\r"
  "1040 T=T+1\r"
  "1041 IF T=50 THEN 8000\r"
  "1042 IF T=92 THEN 1046\r"
  "1043 GOTO 1050\r"
  "1046 GOSUB 600\r"
  "1050 PRINT \"JUMP SHOT\"\r"
  "1060 IF RND(1)>.341*D/8 THEN 1090\r"
  "1070 PRINT \"SHOT IS GOOD.\"\r"
  "1075 GOSUB 7000\r"
  "1085 GOTO 3000\r"
  "1090 IF RND(1)>.682*D/8 THEN 1200\r"
  "1100 PRINT \"SHOT IS OFF TARGET.\"\r"
  "1105 IF D/6*RND(1)>.45 THEN 1130\r"
  "1110 PRINT \"DARTMOUTH CONTROLS THE REBOUND.\"\r"
  "1120 GOTO 1145\r"
  "1130 PRINT \"REBOUND TO \";O$\r"
  "1140 GOTO 3000\r"
  "1145 IF RND(1)>.4 THEN 1158\r"
  "1150 GOTO 1300\r"
  "1158 IF D=6 THEN 5100\r"
  "1160 PRINT \"BALL PASSED BACK TO YOU. \";\r"
  "1170 GOTO 430\r"
  "1180 IF RND(1)>.9 THEN 1190\r"
  "1185 PRINT \"PLAYER FOULED, TWO SHOTS.\"\r"
  "1187 GOSUB 4000\r"
  "1188 GOTO 3000\r"
  "1190 PRINT \"BALL STOLEN. \";O$;\"'S BALL.\"\r"
  "1195 GOTO 3000\r"
  "1200 IF RND(1)>.782*D/8 THEN 1250\r"
  "1210 PRINT \"SHOT IS BLOCKED.  BALL CONTROLLED BY \";\r"
  "1230 IF RND(1)>.5 THEN 1242\r"
  "1235 PRINT \"DARTMOUTH.\"\r"
  "1240 GOTO 430\r"
  "1242 PRINT O$;\".\"\r"
  "1245 GOTO 3000\r"
  "1250 IF RND(1)>.843*D/8 THEN 1270\r"
  "1255 PRINT \"SHOOTER IS FOULED.  TWO SHOTS.\"\r"
  "1260 GOSUB 4000\r"
  "1265 GOTO 3000\r"
  "1270 PRINT \"CHARGING FOUL.  DARTMOUTH LOSES BALL.\"\r"
  "1280 GOTO 3000\r"
  "1300 T=T+1\r"
  "1301 IF T=50 THEN 8000\r"
  "1302 IF T=92 THEN 1304\r"
  "1303 GOTO 1305\r"
  "1304 GOSUB 600\r"
  "1305 IF Z=0 THEN 2010\r"
  "1310 IF Z>3 THEN 1700\r"
  "1320 PRINT \"LAY UP.\"\r"
  "1330 IF 7/D*RND(1)>.4 THEN 1360\r"
  "1340 PRINT \"SHOT IS GOOD.  TWO POINTS.\"\r"
  "1345 GOSUB 7000\r"
  "1355 GOTO 3000\r"
  "1360 IF 7/D*RND(1)>.7 THEN 1500\r"
  "1370 PRINT \"SHOT IS OFF THE RIM.\"\r"
  "1380 IF RND(1)>2/3 THEN 1415\r"
  "1390 PRINT O$;\" CONTROLS THE REBOUND.\"\r"
  "1400 GOTO 3000\r"
  "1415 PRINT \"DARTMOUTH CONTROLS THE REBOUND.\"\r"
  "1420 IF RND(1)>.4 THEN 1440\r"
  "1430 GOTO 1300\r"
  "1440 PRINT \"BALL PASSED BACK TO YOU.\";\r"
  "1450 GOTO 430\r"
  "1500 IF 7/D*RND(1)>.875 THEN 1600\r"
  "1510 PRINT \"SHOOTER FOULED.  TWO SHOTS.\"\r"
  "1520 GOSUB 4000\r"
  "1530 GOTO 3000\r"
  "1600 IF 7/D*RND(1)>.925 THEN 1630\r"
  "1610 PRINT \"SHOT BLOCKED. \";O$;\"'S BALL.\"\r"
  "1620 GOTO 3000\r"
  "1630 PRINT \"CHARGING FOUL.  DARTMOUTH LOSES THE BALL.\"\r"
  "1640 GOTO 3000\r"
  "1700 PRINT \"SET SHOT.\"\r"
  "1710 GOTO 1330\r"
  "2010 INPUT \"YOUR NEW DEFENSIVE ALLIGNMENT IS\";D\r"
  "2030 IF D<6 THEN 2010\r"
  "2040 GOTO 425\r"
  "3000 P=1\r"
  "3005 T=T+1\r"
  "3008 IF T=50 THEN 8000\r"
  "3012 GOTO 3018\r"
  "3015 GOSUB 600\r"
  "3018 PRINT\r"
  "3020 Z1=10/4*RND(1)+1\r"
  "3030 IF Z1>2 THEN 3500\r"
  "3040 PRINT \"JUMP SHOT.\"\r"
  "3050 IF 8/D*RND(1)>.35 THEN 3100\r"
  "3060 PRINT \"SHOT IS GOOD.\"\r"
  "3080 GOSUB 6000\r"
  "3090 GOTO 425\r"
  "3100 IF 8/D*RND(1)>.75 THEN 3200\r"
  "3105 PRINT \"SHOT IS OFF RIM.\"\r"
  "3110 IF D/6*RND(1)>.5 THEN 3150\r"
  "3120 PRINT \"DARTMOUTH CONTROLS THE REBOUND.\"\r"
  "3130 GOTO 425\r"
  "3150 PRINT O$;\" CONTROLS THE REBOUND.\"\r"
  "3160 IF D=6 THEN 5000\r"
  "3165 IF RND(1)>.5 THEN 3175\r"
  "3168 PRINT \"PASS BACK TO \";O$;\" GUARD.\"\r"
  "3170 GOTO 3000\r"
  "3175 GOTO 3500\r"
  "3200 IF 8/D*RND(1)>.9 THEN 3310\r"
  "3210 PRINT \"PLAYER FOULED.  TWO SHOTS.\"\r"
  "3220 GOSUB 4000\r"
  "3230 GOTO 425\r"
  "3310 PRINT \"OFFENSIVE FOUL.  DARTMOUTH'S BALL.\"\r"
  "3320 GOTO 425\r"
  "3500 IF Z1>3 THEN 3800\r"
  "3510 PRINT \"LAY UP.\"\r"
  "3520 IF 7/D*RND(1)>.413 THEN 3600\r"
  "3530 PRINT \"SHOT IS GOOD.\"\r"
  "3540 GOSUB 6000\r"
  "3550 GOTO 425\r"
  "3600 PRINT \"SHOT IS MISSED.\"\r"
  "3610 GOTO 3110\r"
  "3800 PRINT \"SET SHOT.\"\r"
  "3810 GOTO 3520\r"
  "4000 REM FOUL SHOOTING\r"
  "4010 IF RND(1)>.49 THEN 4050\r"
  "4020 PRINT \"SHOOTER MAKES BOTH SHOTS.\"\r"
  "4030 S(1-P)=S(1-P)+2\r"
  "4040 GOSUB 6010\r"
  "4041 RETURN\r"
  "4050 IF RND(1)>.75 THEN 4100\r"
  "4060 PRINT \"SHOOTER MAKES ONE SHOT AND MISSES ONE.\"\r"
  "4070 S(1-P)=S(1-P)+1\r"
  "4080 GOTO 4040\r"
  "4100 PRINT \"BOTH SHOTS MISSED.\"\r"
  "4110 GOTO 4040\r"
  "5000 IF RND(1)>.75 THEN 5010\r"
  "5005 GOTO 3165\r"
  "5010 PRINT \"BALL STOLEN.  EASY LAY UP FOR DARTMOUTH.\"\r"
  "5015 GOSUB 7000\r"
  "5030 GOTO 3000\r"
  "5100 IF RND(1)>.6 THEN 5120\r"
  "5110 GOTO 1160\r"
  "5120 PRINT \"PASS STOLEN BY \";O$;\" EASY LAYUP.\"\r"
  "5130 GOSUB 6000\r"
  "5140 GOTO 425\r"
  "6000 S(0)=S(0)+2\r"
  "6010 PRINT \"SCORE: \";S(1);\"TO\";S(0)\r"
  "6020 RETURN\r"
  "7000 S(1)=S(1)+2\r"
  "7010 GOSUB 6010\r"
  "7020 RETURN\r"
  "8000 PRINT:PRINT \"   ***** END OF FIRST HALF *****\":PRINT\r"
  "8010 PRINT \"SCORE: DARTMOUTH:\";S(1);\"  \";O$;\":\";S(0)\r"
  "8015 PRINT\r"
  "8016 PRINT\r"
  "8020 GOTO 370\r"
  "9999 END\r"
  "";

const char basic_battle[] =
  "5 PRINT TAB(33);\"BATTLE\"\r"
  "7 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "10 REM -- BATTLE WRITTEN BY RAY WESTERGARD  10/70\r"
  "20 REM COPYRIGHT 1971 BY THE REGENTS OF THE UNIV. OF CALIF.\r"
  "30 REM PRODUCED AT THE LAWRENCE HALL OF SCIENCE, BERKELEY\r"
  "40 REM DIM F(6,6),H(6,6),A(4)<B(4),C(6),L(3)\r"
  "50 FOR X=1 TO 6\r"
  "51 FOR Y=1 TO 6\r"
  "52 F(X,Y)=0\r"
  "53 NEXT Y\r"
  "54 NEXT X\r"
  "60 FOR I=1 TO 3\r"
  "70 N=4-I\r"
  "80 FOR J=1 TO 2\r"
  "90 A=INT(6*RND(1)+1)\r"
  "100 B=INT(6*RND(1)+1)\r"
  "110 D=INT(4*RND(1)+1)\r"
  "120 IF F(A,B)>0 THEN 90\r"
  "130 M=0\r"
  "140 ON D GOTO 150,340,550,740\r"
  "150 B(1)=B\r"
  "160 B(2)=7:B(3)=7\r"
  "170 FOR K=1 TO N\r"
  "180 IF M>1 THEN 240\r"
  "190 IF B(K)=6 THEN 230\r"
  "200 IF F(A,B(K)+1)>0 THEN 230\r"
  "210 B(K+1)=B(K)+1\r"
  "220 GOTO 280\r"
  "230 M=2\r"
  "240 IF B(1)<B(2) AND B(1)<B(3) THEN Z=B(1)\r"
  "242 IF B(2)<B(1) AND B(2)<B(3) THEN Z=B(2)\r"
  "244 IF B(3)<B(1) AND B(3)<B(2) THEN Z=B(3)\r"
  "250 IF Z=1 THEN 90\r"
  "260 IF F(A,Z-1)>0 THEN 90\r"
  "270 B(K+1)=Z-1\r"
  "280 NEXT K\r"
  "290 F(A,B)=9-2*I-J\r"
  "300 FOR K=1 TO N\r"
  "310 F(A,B(K+1))=F(A,B)\r"
  "320 NEXT K\r"
  "330 GOTO 990\r"
  "340 A(1)=A\r"
  "350 B(1)=B\r"
  "360 A(2)=0:A(3)=0:B(2)=0:B(3)=0\r"
  "370 FOR K=1 TO N\r"
  "380 IF M>1 THEN 460\r"
  "390 IF A(K)=1 OR B(K)=1 THEN 450\r"
  "400 IF F(A(K)-1,B(K)-1)>0 THEN 450\r"
  "410 IF F(A(K)-1,B(K))>0 AND F(A(K)-1,B(K))=F(A(K),B(K)-1) THEN 450\r"
  "420 A(K+1)=A(K)-1\r"
  "430 B(K+1)=B(K)-1\r"
  "440 GOTO 530\r"
  "450 M=2\r"
  "460 IF A(1)>A(2) AND A(1)>A(3) THEN Z1=A(1)\r"
  "462 IF A(2)>A(1) AND A(2)>A(3) THEN Z1=A(2)\r"
  "464 IF A(3)>A(1) AND A(3)>A(2) THEN Z1=A(3)\r"
  "470 IF B(1)>B(2) AND B(1)>B(3) THEN Z2=B(1)\r"
  "474 IF B(2)>B(1) AND B(2)>B(3) THEN Z2=B(2)\r"
  "476 IF B(3)>B(1) AND B(3)>B(2) THEN Z2=B(3)\r"
  "480 IF Z1=6 OR Z2=6 THEN 90\r"
  "490 IF F(Z1+1,Z2+1)>0 THEN 90\r"
  "500 IF F(Z1,Z2+1)>0 AND F(Z1,Z2+1)=F(Z1+1,Z2) THEN 90\r"
  "510 A(K+1)=Z1+1\r"
  "520 B(K+1)=Z2+1\r"
  "530 NEXT K\r"
  "540 GOTO 950\r"
  "550 A(1)=A\r"
  "560 A(2)=7:A(3)=7\r"
  "570 FOR K=1 TO N\r"
  "580 IF M>1 THEN 640\r"
  "590 IF A(K)=6 THEN 630\r"
  "600 IF F(A(K)+1,B)>0 THEN 630\r"
  "610 A(K+1)=A(K)+1\r"
  "620 GOTO 680\r"
  "630 M=2\r"
  "640 IF A(1)<A(2) AND A(1)<A(3) THEN Z=A(1)\r"
  "642 IF A(2)<A(1) AND A(2)<A(3) THEN Z=A(2)\r"
  "644 IF A(3)<A(1) AND A(3)<A(2) THEN Z=A(3)\r"
  "650 IF Z=1 THEN 90\r"
  "660 IF F(Z-1,B)>0 THEN 90\r"
  "670 A(K+1)=Z-1\r"
  "680 NEXT K\r"
  "690 F(A,B)=9-2*I-J\r"
  "700 FOR K=1 TO N\r"
  "710 F(A(K+1),B)=F(A,B)\r"
  "720 NEXT K\r"
  "730 GOTO 990\r"
  "740 A(1)=A\r"
  "750 B(1)=B\r"
  "760 A(2)=7:A(3)=7\r"
  "770 B(2)=0:B(3)=0\r"
  "780 FOR K=1 TO N\r"
  "790 IF M>1 THEN 870\r"
  "800 IF A(K)=6 OR B(K)=1 THEN 860\r"
  "810 IF F(A(K)+1,B(K)-1)>0 THEN 860\r"
  "820 IF F(A(K)+1,B(K))>0 AND F(A(K)+1,B(K))=F(A(K),B(K)-1) THEN 860\r"
  "830 A(K+1)=A(K)+1\r"
  "840 B(K+1)=B(K)-1\r"
  "850 GOTO 940\r"
  "860 M=2\r"
  "870 IF A(1)<A(2) AND A(1)<A(3) THEN Z1=A(1)\r"
  "872 IF A(2)<A(1) AND A(2)<A(3) THEN Z1=A(2)\r"
  "874 IF A(3)<A(1) AND A(3)<A(2) THEN Z1=A(3)\r"
  "880 IF B(1)>B(2) AND B(1)>B(3) THEN Z2=B(1)\r"
  "882 IF B(2)>B(1) AND B(2)>B(3) THEN Z2=B(2)\r"
  "884 IF B(3)>B(1) AND B(3)>B(2) THEN Z2=B(3)\r"
  "890 IF Z1=1 OR Z2=6 THEN 90\r"
  "900 IF F(Z1-1,Z2+1)>0 THEN 90\r"
  "910 IF F(Z1,Z2+1)>0 AND F(Z1,Z2+1)=F(Z1-1,Z2) THEN 90\r"
  "920 A(K+1)=Z1-1\r"
  "930 B(K+1)=Z2+1\r"
  "940 NEXT K\r"
  "950 F(A,B)=9-2*I-J\r"
  "960 FOR K=1 TO N\r"
  "970 F(A(K+1),B(K+1))=F(A,B)\r"
  "980 NEXT K\r"
  "990 NEXT J\r"
  "1000 NEXT I\r"
  "1010 PRINT\r"
  "1020 PRINT \"THE FOLLOWING CODE OF THE BAD GUYS' FLEET DISPOSITION\"\r"
  "1030 PRINT \"HAS BEEN CAPTURED BUT NOT DECODED:\"\r"
  "1040 PRINT\r"
  "1050 FOR I=1 TO 6\r"
  "1051 FOR J=1 TO 6\r"
  "1052 H(I,J)=F(J,I)\r"
  "1053 NEXT J\r"
  "1054 NEXT I\r"
  "1060 FOR I=1 TO 6\r"
  "1061 FOR J=1 TO 6\r"
  "1062 PRINT H(I,J);\r"
  "1063 NEXT J\r"
  "1064 PRINT\r"
  "1065 NEXT I\r"
  "1070 PRINT\r"
  "1080 PRINT \"DE-CODE IT AND USE IT IF YOU CAN\"\r"
  "1090 PRINT \"BUT KEEP THE DE-CODING METHOD A SECRET.\"\r"
  "1100 PRINT\r"
  "1110 FOR I=1 TO 6\r"
  "1111 FOR J=1 TO 6\r"
  "1112 H(I,J)=0\r"
  "1113 NEXT J\r"
  "1114 NEXT I\r"
  "1120 FOR I=1 TO 3\r"
  "1121 L(I)=0\r"
  "1122 NEXT I\r"
  "1130 C(1)=2:C(2)=2\r"
  "1140 C(3)=1:C(4)=1\r"
  "1150 C(5)=0:C(6)=0\r"
  "1160 S=0:H=0\r"
  "1170 PRINT \"START GAME\"\r"
  "1180 INPUT X,Y\r"
  "1190 IF X<1 OR X>6 OR INT(X)<>ABS(X) THEN 1210\r"
  "1200 IF Y>0 AND Y<7 AND INT(Y)=ABS(Y) THEN 1230\r"
  "1210 PRINT \"INVALID INPUT.  TRY AGAIN.\"\r"
  "1220 GOTO 1180\r"
  "1230 R=7-Y\r"
  "1240 C=X\r"
  "1250 IF F(R,C)>0 THEN 1290\r"
  "1260 S=S+1\r"
  "1270 PRINT \"SPLASH!  TRY AGAIN.\"\r"
  "1280 GOTO 1180\r"
  "1290 IF C(F(R,C))<4 THEN 1340\r"
  "1300 PRINT \"THERE USED TO BE A SHIP AT THAT POINT, BUT YOU SUNK IT.\"\r"
  "1310 PRINT \"SPLASH!  TRY AGAIN.\"\r"
  "1320 S=S+1\r"
  "1330 GOTO 1180\r"
  "1340 IF H(R,C)>0 THEN 1420\r"
  "1350 H=H+1\r"
  "1360 H(R,C)=F(R,C)\r"
  "1370 PRINT \"A DIRECT HIT ON SHIP NUMBER\";F(R,C)\r"
  "1380 C(F(R,C))=C(F(R,C))+1\r"
  "1390 IF C(F(R,C))>=4 THEN 1470\r"
  "1400 PRINT \"TRY AGAIN.\"\r"
  "1410 GOTO 1180\r"
  "1420 PRINT \"YOU ALREADY PUT A HOLE IN SHIP NUMBER\";F(R,C);\r"
  "1430 PRINT \"AT THAT POINT.\"\r"
  "1440 PRINT \"SPLASH!  TRY AGAIN.\"\r"
  "1450 S=S+1\r"
  "1460 GOTO 1180\r"
  "1470 L((INT(F(R,C)-1)/2)+1)=L((INT(F(R,C)-1)/2)+1)+1\r"
  "1480 PRINT \"AND YOU SUNK IT.  HURRAH FOR THE GOOD GUYS.\"\r"
  "1490 PRINT \"SO FAR, THE BAD GUYS HAVE LOST\"\r"
  "1500 PRINT L(1);\"DESTROYER(S),\";L(2);\"CRUISER(S), AND\";\r"
  "1510 PRINT L(3);\"AIRCRAFT CARRIER(S).\"\r"
  "1520 PRINT \"YOUR CURRENT SPLASH/HIT RATIO IS\";S/H\r"
  "1530 IF (L(1)+L(2)+L(3))<6 THEN 1180\r"
  "1540 PRINT\r"
  "1550 PRINT \"YOU HAVE TOTALLY WIPED OUT THE BAD GUYS' FLEET\"\r"
  "1560 PRINT \"WITH A FINAL SPLASH/HIT RATIO OF\";S/H\r"
  "1570 IF S/H>0 THEN 1590\r"
  "1580 PRINT \"CONGRATULATIONS -- A DIRECT HIT EVERY TIME.\"\r"
  "1590 PRINT\r"
  "1600 PRINT \"****************************\"\r"
  "1610 PRINT\r"
  "1620 GOTO 50\r"
  "1630 END\r"
  "";

const char basic_birthday[] =
  "100 REM BIRTHDAY UPDATED 5-5-77 TO \"MITS\" BY D. NIXON \r"
  "110   DIM Z$(12),L(12),N(60),Y$(7)   \r"
  "120   DIM G$(12),H$(32)  \r"
  "130 FOR I=1 TO 12:READ Z$(I):NEXT\r"
  "140 FOR I=1 TO 12:READ L(I):NEXT \r"
  "150 FOR I=1 TO 7:READ Y$(I): NEXT\r"
  "160 FOR I=1 TO 12:READ G$(I):NEXT\r"
  "170 FOR I=1 TO 32:READ H$(I):NEXT\r"
  "180 DATA JANUARY,FEBRUARY,MARCH,APRIL,MAY,JUNE,JULY,AUGUST:  \r"
  "190 DATA SEPTEMBER,OCTOBER,NOVEMBER,DECEMBER:\r"
  "200 DATA 31,28,31,30,31,30,31,31,30,31,30,31:\r"
  "210 DATA THURS,FRI,SATUR,SUN,MON,TUES,WEDNES:\r"
  "220 DATA THE MOON,THE SUN,THE EARTH,THE PLANET MERCURY,VENUS,MARS:   \r"
  "230 DATA JUPITER,SATURN,THE PLANET URANUS,THE PLANET NEPTUNE:\r"
  "240 DATA THE PLANET PLUTO,PEANUT BUTTER: \r"
  "250 DATA JUXTAROTATION,CONTRAPOSITION,CONTRASTING PHASES,TRANSPOSITION:  \r"
  "260 DATA SATISFIED,HAPPY,INTERESTING,TOLERANT:   \r"
  "270 DATA OFTEN,OCCASIONALLY,SOMETIMES:   \r"
  "280 DATA TEND TO BE,ARE,ARE INCLINED TO BE:  \r"
  "290 DATA SHORT OF PATIENCE,UNEASY,AT ODDS:   \r"
  "300 DATA OTHERS.,CLOSE FRIENDS.,YOUNGER PEOPLE.,THOSE IN AUTHORITY.: \r"
  "310 DATA \": BEWARE OF \",\"  AVOID \"   \r"
  "320 DATA APPLE PIE,BEING ALONE,DARK PLACES,STRANGERS,UNUSUAL SITUATIONS: \r"
  "330   DATA BE TAKING A TRIP YOU HAVE NOT MADE BEFORE.\r"
  "340   DATA BE MEETING SOMEONE YOU WILL KNOW FOR THE REST OF YOUR LIFE.   \r"
  "350   DATA MAKE SEVERAL IMPORTANT DECISIONS INVOLVING OTHERS.\r"
  "360   DATA BECOME ILL IF YOU DO NOT LESSEN YOUR UNUSUAL ACTIVITIES.  \r"
  "370  PRINT \"TYPE IN TODAY'S DATE NUMERICALLY: MO,DAY,YEAR\"; \r"
  "380  INPUT X1,Y1,Z1 \r"
  "390  IF Z1>99 GOTO 410 \r"
  "400  Z1=Z1+1900 \r"
  "410 XF=X1:YF=Y1:ZF=Z1:GOSUB 1220:U=ND\r"
  "420  PRINT \"TODAY IS \";Y$(U-7*INT(U/7)+1);\"DAY   (I HOPE)\"  \r"
  "430  PRINT  \r"
  "440  PRINT \"HI, I'M A MICROPROCESSOR.\"  \r"
  "450  PRINT \"TELL ME YOUR NAME\"; \r"
  "460  INPUT N$   \r"
  "470 I=INSTR(N$,\" \")-1   \r"
  "480 IF I<0 THEN 580 \r"
  "490 K$=LEFT$(N$,I)  \r"
  "500  PRINT \"ARE YOU USUALLY CALLED \";K$;\r"
  "510  INPUT A$   \r"
  "520 GOSUB 1140   \r"
  "530  ON NA GOTO 540,560,510\r"
  "540  PRINT \"WHAT DO YOU LIKE TO BE CALLED\"; \r"
  "550  INPUT K$   \r"
  "560  PRINT \"SO YOUR FULL NAME IS \";N$;\", BUT YOU\"   \r"
  "570  PRINT \"LIKE TO BE CALLED \";K$;\".\"  \r"
  "580  PRINT \"HOW OLD ARE YOU, \";K$;  \r"
  "590  INPUT A\r"
  "600  A=INT(A)   \r"
  "610  IF INT((A-5)/95)=0  GOTO 640  \r"
  "620  PRINT \"COME ON, \";K$;\", YOU'RE PULLING MY LEG.\"\r"
  "630  GOTO 580  \r"
  "640  PRINT \"SO YOU ARE\";A;\"YEARS OLD.\"  \r"
  "650  PRINT \"DO YOU KNOW, OFF HAND, HOW MANY DAYS OLD YOU ARE\";  \r"
  "660  INPUT A$   \r"
  "670 GOSUB 1140   \r"
  "680  ON NA GOTO 720,690,660\r"
  "690  PRINT \"OK, SMARTY, HOW MANY?\"  \r"
  "700  PRINT \"SORRY, \";K$;\", YOU'LL HAVE TO BE FASTER THAN THAT!\" \r"
  "710  GOTO 1600 \r"
  "720  PRINT \"OK, I'LL TELL YOU.\" \r"
  "730  PRINT \"IN WHAT MONTH WERE YOU BORN\";   \r"
  "740  INPUT M$   \r"
  "750  FOR X=1 TO 12  \r"
  "760  IF M$=Z$(X) GOTO 800  \r"
  "770  NEXT X \r"
  "780  PRINT K$;\", YOU MAY BE NICE BUT YOU CAN'T SPELL.\"  \r"
  "790  GOTO 730  \r"
  "800  PRINT \"ON WHAT DAY\";   \r"
  "810  INPUT Y\r"
  "820  Z=Z1-A \r"
  "830  IF INT((Y-1)/L(X))=0 GOTO 870 \r"
  "840  IF (X-1)*(Y-28)*(Z-4*INT(Z/4)+1)=1 GOTO 870   \r"
  "850  PRINT \"COME ON, \";N$;\", YOU'RE GIVING ME A HARD TIME.\" \r"
  "860  GOTO 800  \r"
  "870  REM\r"
  "880 XF=X1:YF=Y1:ZF=Z:GOSUB 1220:W=ND \r"
  "890 XF=X:YF=Y:ZF=Z:GOSUB 1220:V=ND   \r"
  "900 IF W=> V GOTO 920  \r"
  "910  Z=Z-1  \r"
  "920  IF ABS(W-V)>30 GOTO 990   \r"
  "930  ON SGN(W-V)+2 GOTO 940,980,960\r"
  "940  PRINT \"YOU HAVE A BIRTHDAY COMING UP IN ONLY\";V-W;\"DAYS!\"  \r"
  "950 GOTO 990\r"
  "960  PRINT \"YOUR BIRTHDAY WAS ONLY\";W-V;\"DAYS AGO. CONGRATULATIONS!\"\r"
  "970  GOTO 990  \r"
  "980  PRINT \"HAPPY BIRTHDAY, DEAR \";K$;\", HAPPY BIRTHDAY TO YOU.\"\r"
  "990 XF=X:YF=Y:ZF=Z:GOSUB 1220:V=ND   \r"
  "1000  PRINT \"YOU WERE BORN ON \";Y$(V-7*INT(V/7)+1);\"DAY, \";Z$(X);Y;\",\";Z \r"
  "1010  PRINT \"WHICH MAKES YOU\";U-V;\"DAYS OLD.\"\r"
  "1020  PRINT \"YOU WERE BORN ON THE DAY\";V;\"AD, AND ON JAN. 1, 2000\"   \r"
  "1030  PRINT \"YOU WILL BE\";730480!-V;\"DAYS OLD.\"   \r"
  "1040  PRINT \"HOW ABOUT THAT!!!\"  \r"
  "1050  PRINT  \r"
  "1060  GOSUB 1350 \r"
  "1070  PRINT \"WELL, \";N$; \r"
  "1080  IF N$=K$ GOTO 1100 \r"
  "1090  PRINT \" (ALIAS \";K$;\")\"\r"
  "1100  PRINT \" IT HAS BEEN NICE CHATTING WITH YOU. DO COME AGAIN.\"\r"
  "1110  PRINT \"GOOD BYE\"   \r"
  "1120  GOTO 1600 \r"
  "1130 REM SUBROUTINE FOR YES NO REQUEST   \r"
  "1140 NA=1\r"
  "1150 IF A$=\"NO\" GOTO 1210\r"
  "1160 IF A$=\"N0\" GOTO 1210\r"
  "1170 NA=2\r"
  "1180 IF A$=\"YES\" GOTO 1210   \r"
  "1190 NA=3\r"
  "1200 PRINT \"A SIMPLE YES OR NO WILL DO! \"\r"
  "1210 RETURN  \r"
  "1220 REM SUBROUTINE TO SOLVE FOR NUMBER OF DAYS  \r"
  "1230 ND=YF-1 \r"
  "1240  FOR I1=1 TO XF-1   \r"
  "1250 ND=ND+L(I1) \r"
  "1260 NEXT I1 \r"
  "1270 I1=INT(ZF/100)  \r"
  "1280 IF ZF<>4*INT(ZF/4) GOTO 1330\r"
  "1290 IF  ZF/100=I1 GOTO 1330 \r"
  "1300 IF  ND>59 GOTO 1330 \r"
  "1310 IF XF=3 GOTO 1330   \r"
  "1320 ND=ND-1 \r"
  "1330  ND=ND+36524!*I1+INT(365.25*(ZF-100*I1)) \r"
  "1340 RETURN  \r"
  "1350 REM GENERATE RANDOM HOROSCOPE  \r"
  "1360 R1=INT(12*RND(1))+1\r"
  "1370 R2 = INT(12*RND(1))+1  \r"
  "1380  IF R1=R2 GOTO 1370   \r"
  "1390 R=1\r"
  "1400 X=4:GOSUB 1570 \r"
  "1410 PRINT \"YOU WERE BORN UNDER THE \";H$(NR);\" OF \";G$(R1)  \r"
  "1420 X=4:GOSUB 1570 \r"
  "1430 PRINT \"AND \";G$(R2);\".  YOU ARE A BASICALLY \";H$(NR)   \r"
  "1440 X=3:GOSUB 1570 \r"
  "1450 PRINT \"PERSON BUT \";H$(NR);\r"
  "1460 GOSUB 1570 \r"
  "1470 PRINT \" YOU \";H$(NR)   \r"
  "1480 GOSUB 1570:N1=NR:X=4:GOSUB 1570:N2=NR:X=2:GOSUB 1570   \r"
  "1490 PRINT H$(N1);\" WITH \";H$(N2);H$(NR)\r"
  "1500 X=5:GOSUB 1570 \r"
  "1510 PRINT H$(NR);\" FOR THE NEXT WEEK. I PREDICT YOU WILL SOON\" \r"
  "1520 X=4:GOSUB 1570 \r"
  "1530 PRINT H$(NR)   \r"
  "1540 PRINT  \r"
  "1550 RETURN \r"
  "1560 REM SUBROUTINE TO SELECT RANDOM WORDS  \r"
  "1570 NR=INT(X*RND(1))+R \r"
  "1580 R=R+X  \r"
  "1590 RETURN \r"
  "1600 END\r"
  "";

const char basic_blackjack[] =
  "100 REM *** B L A C K J A C K ***\r"
  "101 WIDTH 80\r"
  "110 DIM D(208),H(16),O(16),P(16,11),Q(11),S(16),X(16)\r"
  "120 PRINT:PRINT\"WELCOME TO THE CASINO\"\r"
  "130 PRINT \"WE PLAY VEGAS STYLE BLACKJACK\"\r"
  "140 PRINT:INPUT\"INSTRUCTIONS? (YES-NO) \";M$: IF M$=\"NO\" THEN GOTO 160\r"
  "150 IF M$=\"YES\" THEN GOSUB 1640:GOTO 160 ELSE GOTO 140\r"
  "160 R=16:PRINT\"HOW MANY DECKS (1-4)\";\r"
  "170 INPUTN:IFN<1ORN>4THENPRINT\"1 TO 4 DECKS ONLY. REENTER\";:GOTO170\r"
  "180 E=N*52:GOSUB870:B=1:GOSUB890:A=1\r"
  "190 PRINT:G=1\r"
  "200 INPUT\"BET PLEASE\";U:IF U>0 THENGOTO220 ELSE IF U=0 THEN GOTO1600\r"
  "210 B=1:GOSUB 890:GOTO 200\r"
  "220 IF U<=500 THEN GOTO240 ELSEPRINT\"SORRY, THE HOUSE LIMIT IS $500!\"\r"
  "230 GOTO 200\r"
  "240 GOSUB930:H(1)=U:N=Q(2):PRINT:PRINT\"MY UP CARD\";:GOSUB1050:N=P(R,1)\r"
  "250 PRINT : PRINT\"YOUR 1ST CARD\";:GOSUB1050:PRINT\"YOUR 2ND CARD\";:N=P(R,2)\r"
  "260 GOSUB 1050\r"
  "270 GOSUB1170:IFM<>11THEN GOTO 280 ELSE GOSUB 1550\r"
  "280 IF W<>21 THEN GOTO 320 ELSE PRINT : PRINT\"I HAVE BLACKJACK, \";\r"
  "290 IF X(1)<>21 THEN GOTO 310 ELSE PRINT\"SO DO YOU, WE PUSH\"\r"
  "300 GOSUB 1510:GOTO 190\r"
  "310 PRINT\"YOU LOSE\":V=V-U:GOTO300\r"
  "320 IF X(1)<>21 THEN GOTO340 ELSE PRINT\"YOU HAVE BLACKJACK, YOU WIN!\"\r"
  "330 V=V+3*U/2:GOTO300\r"
  "340 PRINT:PRINT\"PLAY \";:IF R=1 THEN GOTO 350 ELSE PRINT\"FOR HAND\";G;\r"
  "350 PRINT:PRINT\"YOUR TOTAL IS\";X(G);:INPUT F:IF F>-1 THEN GOTO 370\r"
  "360 PRINT\"ONLY 0-3 IS VALID, REENTER\";:GOTO350\r"
  "370 IF F>3 THEN GOTO 360 ELSE IF F<>1 THEN GOTO 550\r"
  "380 REM ******** PLAYER HIT ROUTINE *************\r"
  "390 IF A<=E THEN GOTO 400 ELSE GOSUB 1220\r"
  "400 M=S(G):M=M+1:S(G)=M:N=D(A):P(G,M)=N:PRINT\"YOUR CARD IS\";:GOSUB 1050\r"
  "410 GOSUB 1010:A=A+1:IF N<>11 THEN GOTO 420 ELSE O(G)=O(G)+1\r"
  "420 X(G)=X(G)+N\r"
  "430 IF X(G)<22 THEN GOTO 340 ELSE IF O(G)=0 THEN 450\r"
  "440 O(G)=O(G)-1:X(G)=X(G)-10:GOTO 430\r"
  "450 PRINT:PRINT\"YOU BUSTED WITH\";X(G):X(G)=0:Y=Y-1:PRINT\r"
  "460 REM ********* CHECK FOR END OF PLAY ************\r"
  "470 IF G<R GOTO 500\r"
  "480 GOSUB 1250\r"
  "490 GOTO190\r"
  "500 G=G+1\r"
  "510 N=P(G,1)\r"
  "520 PRINT \"YOUR 1ST CARD FOR HAND \";G;\" WAS\";\r"
  "530 GOSUB 1050\r"
  "540 GOTO 340\r"
  "550 IF F<>0 GOTO 620\r"
  "560 REM *********PLAYER STAND ALONE ROUTINE ************\r"
  "570 IF X(G)<22 GOTO 470\r"
  "580 IF O(G)=0 GOTO 450\r"
  "590 X(G)=X(G)-10\r"
  "600 O(G)=O(G)-1\r"
  "610 G=G+1\r"
  "620 IF F<>2 GOTO 730\r"
  "630 IF S(G)=2 GOTO 670\r"
  "640 PRINT \"DOUBLE ON 1ST 2 CARDS ONLY\"\r"
  "650 GOTO 340\r"
  "660 REM ***** DOUBLE DOWN ROUTINE **********\r"
  "670 IF A<=E THEN GOTO 680 ELSE 1220\r"
  "680 H(G)=2*U:N=D(A):P(G,3)=N:A=A+1:PRINT \"YOU DRAW THE\";:GOSUB 1050\r"
  "690 GOSUB 1010:IF N=11 THEN O(G)=O(G)+1\r"
  "700 X(G)=X(G)+N\r"
  "710 IF X(G)<22 THEN GOTO 470\r"
  "720 IF O(G)=0 THEN GOTO 450 ELSE O(G)=O(G)-1:X(G)=X(G)-10:GOTO1350\r"
  "730 N=P(G,1):Y=Y+1:GOSUB 1010:M=N:N=P(G,2):GOSUB1010:IFM=NTHENGOTO760\r"
  "740 PRINT \"YOU MAY ONLY SPLIT PAIRS\": GOTO 340\r"
  "750 REM *********PAIR SPLIT ROUTINE **********\r"
  "760 R=R+1:Y=Y+1:P(R,1)=P(G,2):S(G)=1:S(R)=1:X(G)=X(G)/2:X(R)=X(G)\r"
  "770 H(R)=U:IF N<>11 THEN GOTO 340\r"
  "780 REM **********ACES WERE SPLIT - 1 CARD EACH *********\r"
  "790 IF A>E THEN GOSUB 1220\r"
  "800 N=D(A):P(G,2)=N:PRINT \"1ST ACE GETS A\";:GOSUB 1050: GOSUB 1010\r"
  "810 IF N=11 THEN N=1\r"
  "820 X(G)=X(G)+N:A=A+1:IF A>E THEN GOSUB 1220\r"
  "830 N=D(A):P(R,2)=N:PRINT \"2ND ACE GETS A\";:GOSUB 1050:GOSUB 1010\r"
  "840 IF N=11 THEN N=1\r"
  "850 X(R)=X(R)+N:A=A+1:GOTO480\r"
  "860 REM ************ BUILD 1 TO 4 DECKS ************\r"
  "870 FOR I=1 TO N: J=(I-1)*52: FOR K =1 TO 52: D(J+K)=K:NEXT K,I:RETURN\r"
  "880 REM *********SHUFFLE THE CARDS ***********\r"
  "890 PRINTCHR$(26):PRINT \"I'M SHUFFLING.... \":FOR I=B TO E\r"
  "900 C=RND(1)*E:IF C<B GOTO 900 ELSE L=D(I):D(I)=D(C):D(C)=L:NEXTI\r"
  "910 A=B:RETURN\r"
  "920 REM ******** DEAL THE CARDS ***********\r"
  "930 FOR I=1 TO 11:Q(I)=0:FOR J=1 TO R: P(J,I)=0:NEXT J,I:R=1:Y=1\r"
  "940 IF A+4>E THEN B=1:GOSUB 890\r"
  "950 PRINT \"DEALING\":P(R,1)=D(A):Q(1)=D(A+1):P(R,2)=D(A+2):Q(2)=D(A+3)\r"
  "960 A=A+4:T=2:S(1)=2:GOSUB980:M=N:RETURN\r"
  "970 REM ********** COMPUTE THE VALUE OF THE DEALERS HAND *********\r"
  "980 Z=0:W=0:FOR I=1 TO 2:N=Q(I):GOSUB 1010:IF N=11 THEN Z=Z+1\r"
  "990 W=W+N:NEXT I :RETURN\r"
  "1000 REM **********COMPUTE THE VALUE OF A CARD **********:\r"
  "1010 IF N<14 THEN GOTO 1020 ELSE N=N-13:GOTO 1010\r"
  "1020 IF N=1 THEN N=11:RETURN ELSE GOTO 1030\r"
  "1030 IF N<11 THEN RETURN ELSE N=10:RETURN\r"
  "1040 **********PRINT A CARD **********\r"
  "1050 I=0\r"
  "1060 IF N>=14 THEN N=N-13:I=I+1:GOTO1060\r"
  "1070 IF N=1 THEN PRINT TAB(17);\"ACE \";:GOTO1130\r"
  "1080 IF N<10 THEN PRINT TAB(18);N;:GOTO1130\r"
  "1090 IF N<11 THEN PRINT TAB(17);N;:GOTO 1130\r"
  "1100 IF N<12 THEN PRINT TAB(16);\"JACK \";:GOTO1130\r"
  "1110 IF N<13 THEN PRINT TAB(15);\"QUEEN \";:GOTO 1130\r"
  "1120 PRINT TAB(16);\"KING \";\r"
  "1130 PRINT \"OF \";:IF I=0 THEN PRINT \"SPADES\":RETURN\r"
  "1140 IF I=1 THEN PRINT \"HEARTS\":RETURN\r"
  "1150 IF I=2 THEN PRINT \"DIAMONDS\":RETURN ELSE PRINT \"CLUBS\":RETURN\r"
  "1160 REM ********* COMPUTE VALUE OF PLAYERS HAND *********:\r"
  "1170 O(G)=0:X(G)=0:FOR I =1 TO 2: N=P(G,I):GOSUB 1010:X(G)=X(G)+N\r"
  "1180 IF N<>11 THEN GOTO 1200\r"
  "1190 O(G)=O(G)+1\r"
  "1200 NEXT I:RETURN\r"
  "1210 REM *********SAVE THE CARDS THAT ARE ALREADY DEALT AND SHUFFLE**\r"
  "1220 K=T:FOR I=1 TO R:K=K+S(I):NEXT I\r"
  "1230 FOR I=1TOK:A=A-1:J=D(I):D(I)=D(A):D(A)=J:NEXTI:B=K+1:GOSUB890:RETURN\r"
  "1240 REM *******DEALERS LOGIC **********:\r"
  "1250 N=Q(1):PRINT \"MY HOLE CARD\";:GOSUB 1050:IF Y=0 THEN GOTO 1390\r"
  "1260 IF W<17 THEN GOTO 1300\r"
  "1270 IF W>17 THEN GOTO 1340\r"
  "1280 IF Z=0 THEN GOTO 1380\r"
  "1290 W=W-10:Z=Z-1\r"
  "1300 IF A>E THEN GOSUB 1220\r"
  "1310 N=D(A):T=T+1:A=A+1:PRINT:PRINT \"I DRAW THE\";:GOSUB1050:GOSUB1010\r"
  "1320 IF N=11 THEN Z=Z+1\r"
  "1330 W=W+N:GOTO 1260\r"
  "1340 IF W<22 THEN GOTO 1380\r"
  "1350 IF Z=0 THEN GOTO 1370\r"
  "1360 Z=Z-1:W=W-10:GOTO1260\r"
  "1370 PRINT \"I BUSTED \";\r"
  "1380 PRINT \"MY TOTAL IS \";W\r"
  "1390 FOR I =1 TO R:PRINT \"YOU \";:IF X(I)<>0 THEN GOTO 1410\r"
  "1400 PRINT \"LOST \";:V=V-H(I):GOTO 1460\r"
  "1410 IF W<22 THEN GOTO 1430\r"
  "1420 PRINT \"WON \";:V=V+H(I):GOTO 1460\r"
  "1430 IF W<>X(I) THEN GOTO 1450\r"
  "1440 PRINT \"PUSHED ON \";:GOTO1460\r"
  "1450 IF W<X(I) THEN GOTO 1420 ELSE GOTO 1400\r"
  "1460 IF R<>1 THEN GOTO 1470 ELSE PRINT \"THE HAND\":GOTO 1480\r"
  "1470 PRINT \"HAND \";I\r"
  "1480 NEXT I\r"
  "1490 REM ********* PRINT THE PLAYERS WON/LOST STANDING *******\r"
  "1500 PRINT\r"
  "1510 PRINT \"YOU'RE \";:IF V=0 THEN PRINT \"EVEN\":RETURN\r"
  "1520 IF V<0 THEN PRINT \"BEHIND $\"V:RETURN ELSE PRINT \"AHEAD $\";V:RETURN\r"
  "1530 PRINT \"AHEAD $\";V\r"
  "1540 REM ********INSURANCE ROUTINE ************\r"
  "1550 INPUT \"INSURANCE (YES-NO)\";M$:IF M$=\"NO\" THEN RETURN\r"
  "1560 IF M$<>\"YES\" THEN GOTO 1550\r"
  "1570 PRINT \"YOUR INSURANCE BET \";:IF W=21 THEN PRINT \"WINS\":V=V+U:RETURN\r"
  "1580 PRINT \"LOSES\":V=V-U/2:RETURN\r"
  "1590 REM ******END OF GAME WRAP UP **************\r"
  "1600 PRINT \"THANKS FOR PLAYING\":PRINT \"HOPE YOU ENJOYED YOURSELF\"\r"
  "1610 PRINT \"HERE'S YOUR FINAL STANDING!\":GOSUB 1510\r"
  "1620 IFV>0THENPRINT\"NOW, JUST YOU TRY TO COLLECT !!\":END\r"
  "1630 IF V=0THENPRINT\"BIG DEAL......\":END ELSEPRINT\"PAY UP, OR ELSE\":END\r"
  "1640 REM ******** INSTRUCTIONS ***********\r"
  "1650 PRINT:PRINT\"THE DEALER STANDS ON 17 OR MORE\"\r"
  "1660 PRINT\"BUT WILL HIT A SOFT 17.\"\r"
  "1670 PRINT\"YOU MAY SPLIT ANY PAIR.\":PRINT\"YOU MAY DOUBLE THE 1ST 2 CARDS\"\r"
  "1680 PRINT\"AND GET ONLY 1 MORE CARD.\":PRINT:PRINT\"PLAY CODES:\"\r"
  "1690 PRINT \"  0 - STAND\":PRINT \"  1 - HIT\":PRINT \"  2 - DOUBLE DOWN\"\r"
  "1700 PRINT \"  3 - SPLIT A PAIR\":PRINT:PRINT \"A ZERO BET ENDS THE GAME\"\r"
  "1710 PRINT \"A NEGATIVE BET FORCES A SHUFFLE\"\r"
  "1720 PRINT \"GOOD LUCK - LET'S START\":RETURN\r"
  "";

const char basic_bombard[] =
  "10 PRINT TAB(33);\"BOMBARDMENT\"\r"
  "20 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "30 PRINT:PRINT:PRINT\r"
  "100 PRINT \"YOU ARE ON A BATTLEFIELD WITH 4 PLATOONS AND YOU\"\r"
  "110 PRINT \"HAVE 25 OUTPOSTS AVAILABLE WHERE THEY MAY BE PLACED.\"\r"
  "120 PRINT \"YOU CAN ONLY PLACE ONE PLATOON AT ANY ONE OUTPOST.\"\r"
  "130 PRINT \"THE COMPUTER DOES THE SAME WITH ITS FOUR PLATOONS.\"\r"
  "135 PRINT\r"
  "140 PRINT \"THE OBJECT OF THE GAME IS TO FIRE MISSLES AT THE\"\r"
  "150 PRINT \"OUTPOSTS OF THE COMPUTER.  IT WILL DO THE SAME TO YOU.\"\r"
  "160 PRINT \"THE ONE WHO DESTROYS ALL FOUR OF THE ENEMY'S PLATOONS\"\r"
  "170 PRINT \"FIRST IS THE WINNER.\"\r"
  "180 PRINT\r"
  "190 PRINT \"GOOD LUCK... AND TELL US WHERE YOU WANT THE BODIES SENT!\"\r"
  "200 PRINT\r"
  "210 PRINT \"TEAR OFF MATRIX AND USE IT TO CHECK OFF THE NUMBERS.\"\r"
  "220 FOR R=1 TO 5: PRINT: NEXT R\r"
  "260 DIM M(100)\r"
  "270 FOR R=1 TO 5\r"
  "280 I=(R-1)*5+1\r"
  "290 PRINT I,I+1,I+2,I+3,I+4\r"
  "300 NEXT R\r"
  "350 FOR R=1 TO 10: PRINT: NEXT R\r"
  "380 C=INT(RND(1)*25)+1\r"
  "390 D=INT(RND(1)*25)+1\r"
  "400 E=INT(RND(1)*25)+1\r"
  "410 F=INT(RND(1)*25)+1\r"
  "420 IF C=D THEN 390\r"
  "430 IF C=E THEN 400\r"
  "440 IF C=F THEN 410\r"
  "450 IF D=E THEN 400\r"
  "460 IF D=F THEN 410\r"
  "470 IF E=F THEN 410\r"
  "480 PRINT \"WHAT ARE YOUR FOUR POSITIONS\";\r"
  "490 INPUT G,H,K,L\r"
  "495 PRINT\r"
  "500 PRINT \"WHERE DO YOU WISH TO FIRE YOUR MISSLE\";\r"
  "510 INPUT Y\r"
  "520 IF Y=C THEN 710\r"
  "530 IF Y=D THEN 710\r"
  "540 IF Y=E THEN 710\r"
  "550 IF Y=F THEN 710\r"
  "560 GOTO 630\r"
  "570 M=INT(RND(1)*25)+1\r"
  "575 GOTO 1160\r"
  "580 IF X=G THEN 920\r"
  "590 IF X=H THEN 920\r"
  "600 IF X=L THEN 920\r"
  "610 IF X=K THEN 920\r"
  "620 GOTO 670\r"
  "630 PRINT \"HA, HA YOU MISSED. MY TURN NOW:\"\r"
  "640 PRINT: PRINT: GOTO 570\r"
  "670 PRINT \"I MISSED YOU, YOU DIRTY RAT. I PICKED\";M\". YOUR TURN:\"\r"
  "680 PRINT: PRINT: GOTO 500\r"
  "710 Q=Q+1\r"
  "720 IF Q=4 THEN 890\r"
  "730 PRINT \"YOU GOT ONE OF MY OUTPOSTS!\"\r"
  "740 IF Q=1 THEN 770\r"
  "750 IF Q=2 THEN 810\r"
  "760 IF Q=3 THEN 850\r"
  "770 PRINT \"ONE DOWN, THREE TO GO.\"\r"
  "780 PRINT: PRINT: GOTO 570\r"
  "810 PRINT \"TWO DOWN, TWO TO GO.\"\r"
  "820 PRINT: PRINT: GOTO 570\r"
  "850 PRINT \"THREE DOWN, ONE TO GO.\"\r"
  "860 PRINT: PRINT: GOTO 570\r"
  "890 PRINT \"YOU GOT ME, I'M GOING FAST. BUT I'LL GET YOU WHEN\"\r"
  "900 PRINT \"MY TRANSISTO&S RECUP%RA*E!\"\r"
  "910 GOTO 1235\r"
  "920 Z=Z+1\r"
  "930 IF Z=4 THEN 1110\r"
  "940 PRINT \"I GOT YOU. IT WON'T BE LONG NOW. POST\";X;\"WAS HIT.\"\r"
  "950 IF Z=1 THEN 990\r"
  "960 IF Z=2 THEN 1030\r"
  "970 IF Z=3 THEN 1070\r"
  "990 PRINT \"YOU HAVE ONLY THREE OUTPOSTS LEFT.\"\r"
  "1000 PRINT: PRINT: GOTO 500\r"
  "1030 PRINT \"YOU HAVE ONLY TWO OUTPOSTS LEFT.\"\r"
  "1040 PRINT: PRINT: GOTO 500\r"
  "1070 PRINT \"YOU HAVE ONLY ONE OUTPOST LEFT.\"\r"
  "1080 PRINT: PRINT: GOTO 500\r"
  "1110 PRINT \"YOU'RE DEAD. YOUR LAST OUTPOST WAS AT\";X;\". HA, HA, HA.\"\r"
  "1120 PRINT \"BETTER LUCK NEXT TIME.\"\r"
  "1150 GOTO 1235\r"
  "1160 P=P+1\r"
  "1170 N=P-1\r"
  "1180 FOR T=1 TO N\r"
  "1190 IF M=M(T) THEN 570\r"
  "1200 NEXT T\r"
  "1210 X=M\r"
  "1220 M(P)=M\r"
  "1230 GOTO 580\r"
  "1235 END\r"
  "";

const char basic_budget[] =
  "100 REM TYPED BY CONNIE FOSTER ,CORRECTED BY C.FOSTER ,PROG BY O.E.DIAL\r"
  "110 REM ALL REM STATEMENTS CAN BE CHANGED TO ALLOW USE OF TWO TERMINALS\r"
  "120 REM SEE ARTICLE IN PERSONAL COMPUTING MAY/JUNE 77\r"
  "130 Q=27:V$=\"###.#\":W$=\"$$#####,\":U$=\"###\"\r"
  "140 DIMD(18),E$(Q),V(Q),F(Q)\r"
  "150 PRINTTAB(19)\"RECURSIVE BUDGETING MODEL\":PRINT:PRINTTAB(28)\"* * *\"\r"
  "160 DATASALARY/WAGES,OTHER INCOME,FED INC TAX,STATE & LOCAL TAX\r"
  "170 DATASOCIAL SECURITY,UNEMPLOYMENT INS,HEALTH INS\r"
  "180 DATALIFE INS,CONTRIBUTIONS,OTHER DEDUCTIONS\r"
  "190 DATARENT/MORTGAGE,LIFE INS,HEALTH INS,HOUSE INS\r"
  "200 DATAAUTO INS,CAR PAYMENTS,LOAN PAYMENTS,TRASH REMOVAL\r"
  "210 DATAOTHER FIXED EXP\r"
  "220 DATAFOOD/BEVERAGES,CLOTHING,DRY CLEANING,BARBER/BEAUTY\r"
  "230 DATAHOME MAINT,HOME HEAT'G FUEL,WATER,ELECTRICITY, TELEPHONE\r"
  "240 DATAGAS/OIL,AUTO MAINT,FARES/TOLLS/PARKING,DENTIST\r"
  "250 DATAPHYSICIAN,DRUGS/SUNDRIES,SCHOOL EXPENSE,FAMILY ALLOWANCE\r"
  "260 DATACLUBS/LODGES,THEATER/SPORTS,RESTAURANTS\r"
  "270 DATAOTHER ENT'MENT,MAG'S/BOOKS/PAPERS,SITTERS,CHILD CARE\r"
  "280 DATAVACATION SAVING,OTHER SAVINGS,CONTRIBUTIONS,OTHER EXPENSES\r"
  "290 PRINT:PRINT\"SELECT YOUR BUDGETING PERIOD BY NUMBER. LATER ON IT WILL\"\r"
  "300 PRINT\"BE EXTENDED TO ONE YEAR.\":PRINT\r"
  "310 PRINTTAB(3)\"1-WEEKLY\"TAB(15)\"2-BIWEEKLY\"TAB(30)\"3-SEMIMONTHLY\";\r"
  "320 PRINTTAB(45)\"4-MONTHLY\":PRINT\r"
  "330 INPUTP:IFP>4THENPRINT\"TRY AGAIN\":GOTO290\r"
  "340 IFP=1THENP=52ELSEIFP=2THENP=26ELSEIFP=3THENP=24ELSEIFP=4THENP=12\r"
  "350 PRINT:PRINT\"ALRIGHT,FIRST LET'S LOOK AT INCOME FOR THE PERIOD.\":PRINT\r"
  "360 READA$:PRINTA$;\" $\";:INPUTD(0):READA$:PRINTA$;\" $\";:INPUTD(1)\r"
  "370 TI=D(0)+D(1):PRINT\r"
  "380 PRINT:PRINT\"OK,NOW LET'S LOOK AT PAYCHECK DEDUCTIONS.\":PRINT\r"
  "390 FORJ=2TO9:READA$:PRINTA$;:INPUT\" $\";D(J):TD=TD+D(J):NEXTJ:PRINT \r"
  "400 PRINT\"OK,NOW LET'S LOOK AT FIXED EXPENSES.\":PRINT\r"
  "410 FORJ=10TO18:READA$:PRINTA$;:INPUT\" $\";D(J):TF=TF+D(J):NEXTJ\r"
  "420 DF=TD+TF:SI=TI-DF:S=64\r"
  "430 PRINT:PRINT\"OK,AT THIS TIME OUR TABLE LOOKS LIKE THIS:\":PRINT\r"
  "440 REM\r"
  "450 GOSUB1900:PRINT:PRINTTAB(19);\r"
  "460 PRINT\"RECURSIVE BUDGETING MODEL\":PRINT:PRINTTAB(27)\"* * *\":PRINT\r"
  "470 GOSUB1900\r"
  "480 PRINT:PRINTTAB(20)\"SPENDABLE INCOME SUMMARY\":PRINT\r"
  "490 GOSUB1890:PRINTTAB(3)\"ACCOUNT\"TAB(42)\"PERIOD\"TAB(57)\"ANNUAL\"\r"
  "500 GOSUB1890:PRINT\"TOTAL INCOME\" TAB(40);:PRINTUSINGW$;TI;:PRINTTAB(55)\r"
  "510 PRINTUSINGW$;TI*P:PRINT:PRINTTAB(3)\"PAYCHECK DEDUCTIONS\"TAB(25);\r"
  "520 PRINTUSINGW$;TD*(-1):PRINT\r"
  "530 PRINTTAB(3)\"FIXED EXPENSES\"TAB(25);:PRINTUSINGW$;TF*(-1);\r"
  "540 PRINTTAB(40);:PRINTUSINGW$;DF*(-1);:PRINTTAB(55);\r"
  "550 PRINTUSINGW$;DF*(-1)*P\r"
  "560 PRINTTAB(41)\"-------\"TAB(55)\"--------\":PRINT\"SPENDABLE INCOME\";\r"
  "570 PRINTTAB(40);:PRINTUSINGW$;SI;:PRINTTAB(55);:PRINTUSINGW$;SI*P\r"
  "580 PRINTTAB(41)\"=======\"TAB(55)\"========\":PRINT:\r"
  "590 GOSUB1900:PRINT: PRINT\r"
  "600 REM\r"
  "610 GOSUB1910:RO=0\r"
  "620 PRINT:PRINT \"OK,NOW FOR THE FIRST ROUND OF VARIABLE EXPENSE. DON'T\"\r"
  "630 PRINT\"PINCH YOURSELF IN YOUR ESTIMATES (WITHIN REASON). LET THE\"\r"
  "640 PRINT\"COMPUTER HELP YOU REFINE YOUR BUDGET LATER ON.\":PRINT\r"
  "650 FORJ=0TOQ:READE$(J) :PRINTE$(J);:INPUT\" $\";V(J):VT=VT+V(J):NEXTJ\r"
  "660 RESTORE:PRINT:PRINT\r"
  "670 PRINT\"YOUR BUDGET FOR THE FIRST ROUND TOTALLED $\"VT\". THIS\"\r"
  "680 PRINT\"COMPARES TO SPENDABLE INCOME OF $\"SI\". WE HAVE\"\r"
  "690 PRINT\"PRORATED THE DIFFERENCE, $\"SI-VT\",OVER ALL VARIABLE EXPENSE\"\r"
  "700 PRINT\"ACCOUNTS.\":PRINT\r"
  "710 GOSUB1910:FORJ=0TOQ:V(J)=INT(V(J)/VT*SI):NEXTJ:VT=SI:PRINT\r"
  "720 PRINT\"NOW WE BEGIN THE BUDGET REFINEMENT PHASE. MAKE AS MANY\"\r"
  "730 PRINT\"PASSES AS YOU LIKE. AS YOU REVIEW EACH ACCOUNT,DECIDE\"\r"
  "740 PRINT\"WHETHER TO FREEZE IT OR TO LEAVE IT FOR ANOTHER PASS.\":PRINT\r"
  "750 PRINT\"HINT: DON'T BE IN A HURRY TO FREEZE AN ACCOUNT.\":PRINT\r"
  "760 PRINT\"YOUR TASK IS FINISHED WHEN ALL ACCOUNTS ARE FROZEN.\":PRINT\r"
  "770 GOSUB1910\r"
  "780 FORJ=0TOQ:PRINT:IFV(J)=0THEN980\r"
  "790 PRINTE$(J);\" $\";V(J):INPUT\"CHANGE ('Y' OR 'N')\";A$\r"
  "800 IFA$=\"N\"THEN840ELSEIFA$=\"Y\"THEN820ELSEIFA$<>\"Y\"THEN790\r"
  "810 GOTO790\r"
  "820 INPUT\"REVISED AMOUNT $\";A:IFA<V(J)THEN840\r"
  "830 GOSUB1930\r"
  "840 INPUT\"FREEZE ('Y' OR 'N')\";B$:PRINT\r"
  "850 IFA$=\"Y\"ANDB$=\"Y\"THEN900\r"
  "860 IFA$=\"Y\"ANDB$=\"N\"THEN940\r"
  "870 IFA$=\"N\"ANDB$=\"N\"THEN980\r"
  "880 VT=VT-V(J):FT=FT+V(J):SWAPF(J),V(J):V(J)=0:PRINT\r"
  "890 PRINT\"OK,THE ACCOUNT HAS BEEN FROZEN AT $\"F(J)\".\":GOTO980\r"
  "900 VT=VT-A:FT=FT+A:SWAPA,F(J):V(J)=0\r"
  "910 FORK=OTOQ:V(K)=INT(V(K)*(SI-FT)/VT):NEXTK:VT=SI-FT\r"
  "920 PRINT\"OK,THE ACCOUNT HAS BEEN FROZEN AT $\"F(J)\",AND THE DIFFERENCE\"\r"
  "930 PRINT\"PRORATED OVER REMAINING ACCOUNTS.\":PRINT:GOTO980\r"
  "940 VT=VT-V(J)+A:V(J)=A\r"
  "950 FORK=0TOQ:V(K)=INT(V(K)*(SI-FT)/VT):NEXTK:VT=SI-FT\r"
  "960 PRINT\"OK,THE VALUE HAS BEEN CHANGED TO $\"A\", AND THE DIFFERENCE\"\r"
  "970 PRINT\"PRORATED OVER REMAINING ACCOUNTS.\":PRINT\r"
  "980 NEXTJ:PRINT:R=0:FORJ=0TOQ:IFV(J)=0THENR=R+1:NEXTJ\r"
  "990 IFR<=QTHEN1010\r"
  "1000 FORJ=OTOQ:F(J)=INT(F(J)/FT*SI):VT=0:FT=SI:GOTO1380\r"
  "1010 PRINT\"NOW LET'S RECAP VARIABLE EXPENSES BEFORE GOING ON TO THE\"\r"
  "1020 PRINT\"NEXT ROUND.\":PRINT:RO=RO+1:V1=0:F1=0\r"
  "1030 FORJ=0TOQ:V(J)=INT(V(J)/VT*(SI-FT)):NEXTJ:VT=SI-FT\r"
  "1040 REM\r"
  "1050 PRINTTAB(7)\"INTERIM SUMMARY OF VARIABLE EXPENSES\";\r"
  "1060 PRINT\":   NO.\"RO\r"
  "1070 GOSUB1890:PRINTTAB(3)\"ACCOUNTS\"TAB(28)\"NUMBER\"TAB(37)\"PERCENT\";\r"
  "1080 PRINTTAB(48)\"AMOUNT\"TAB(56)\"PERCENT\"\r"
  "1090 GOSUB1890:FORJ=0TOQ:IFV(J)+F(J)=0THEN1110\r"
  "1100 IFV(J)THENV1=V1+1ELSEF1=F1+1\r"
  "1110 NEXTJ\r"
  "1120 PRINT\"VARIABLE EXPENSES\"TAB(29);:PRINTUSINGU$;V1;:PRINTTAB(39);\r"
  "1130 PRINTUSINGV$;V1/(V1+F1)*100;:PRINTTAB(46);:PRINTUSINGW$;VT;\r"
  "1140 PRINTTAB(58);:PRINTUSINGV$;VT/TI*100:PRINT\r"
  "1150 PRINT\"FROZEN EXPENSES\"TAB(29);:PRINTUSINGU$;F1;:PRINTTAB(39);\r"
  "1160 PRINTUSINGV$;F1/(V1+F1)*100;:PRINTTAB(46);\r"
  "1170 PRINTUSINGW$;FT;:PRINTTAB(58);:PRINTUSINGV$;FT/TI*100\r"
  "1180 PRINTTAB(28)\"-------\"TAB(48)\"--------\"\r"
  "1190 PRINTTAB(3)\"TOTALS\"TAB(29);:PRINTUSINGU$;F1+V1;:PRINTTAB(46);\r"
  "1200 PRINTUSINGW$;VT+FT:PRINTTAB(28)\"=======\"TAB(48)\"========\":PRINT\r"
  "1210 GOSUB1900:PRINT:PRINT\r"
  "1220 GOSUB1230:GOTO1270\r"
  "1230 PRINTTAB(8)\"INTERIM STATUS OF VARIABLE EXPENSES  NO.\"RO\r"
  "1240 GOSUB1890:PRINTTAB(3)\"ACCOUNT\"TAB(30)\"VARIABLE\"TAB(43)\"FROZEN\";\r"
  "1250 PRINTTAB(54)\"PERCENT\"\r"
  "1260 GOSUB1890:PRINT\r"
  "1270 FORJ=0TOQ:IFV(J)+F(J)=0THEN1330ELSEPRINTE$(J);:R2=R2+1\r"
  "1280 IFF(J)THEN1300ELSEPRINTTAB(29):PRINTUSINGW$;V(J);:PRINTTAB(55);\r"
  "1290 PRINTUSINGV$;V(J)/TI*100:GOTO1320\r"
  "1300 PRINTTAB(40);:PRINTUSINGW$;F(J);:PRINTTAB(55);\r"
  "1310 PRINTUSINGV$;F(J)/TI*100\r"
  "1320 IFINT(R2/5)=R2/5THENPRINT\r"
  "1330 NEXTJ:PRINT:R2=0\r"
  "1340 GOSUB1900:PRINT\r"
  "1350 REM\r"
  "1360 PRINT:PRINT \"NOW WE MAKE ANOTHER PASS THROUGH VARIABLE EXPENSES.\":PRINT\r"
  "1370 GOTO770\r"
  "1380 PRINT\"PLEASE INPUT THE REQUESTED INFORMATION BEFORE WE PROVIDE A\"\r"
  "1390 PRINT\"FINAL DETAIL OF YOUR BUDGET.\":PRINT\r"
  "1400 PRINTTAB(18)\"* USE NO COMMAS NOR COLONS *\":PRINT\r"
  "1410 INPUT\"NAME\";A$:INPUT\"BUDGET YEAR\";A\r"
  "1420 B=LEN(A$):B=16-B/2\r"
  "1430 REM\r"
  "1440 GOSUB1920\r"
  "1450 GOSUB1900:PRINT\r"
  "1460 PRINTTAB(B)\"* THE \"A$\" FAMILY BUDGET FOR\"A\"*\":PRINT\r"
  "1470 GOSUB1900:PRINT\r"
  "1480 PRINTTAB(6)\"ACCOUNT\"TAB(20)\"\"TAB(26)\"INCOME\"TAB(38)\":\";\r"
  "1490 PRINTTAB(44)\"EXPENSE\"TAB(56)\":PERCENT\"\r"
  "1500 PRINTTAB(20)\":-----------------:-----------------: TOTAL\"\r"
  "1510 PRINTTAB(20)\": PERIOD : ANNUAL : PERIOD : ANNUAL : INCOME\"\r"
  "1520 PRINT\"--------------------:--------:--------:--------:--------:------\"\r"
  "1530 X$=\":$$#####,:$$#####,:        :        : ###.#\"\r"
  "1540 Y$=\":        :        :$$#####,:$$#####,: ###.#\"\r"
  "1550 GOTO1570\r"
  "1560 PRINT\":        :        :        :        :\":RETURN\r"
  "1570 PRINT\"INCOME\"TAB(20);:PRINTUSINGX$;TI;TI*P;TI/TI*100\r"
  "1580 PRINT\"------\"TAB(20);\r"
  "1590 GOSUB1560\r"
  "1600 READA$:PRINTA$TAB(20);:PRINTUSINGX$;D(0);D(0)*P;D(0)/TI*100\r"
  "1610 READA$:PRINTA$TAB(20);:PRINTUSINGX$;D(1);D(1)*P;D(1)/TI*100\r"
  "1620 PRINTTAB(20);\r"
  "1630 GOSUB1560\r"
  "1640 PRINT\"PAYCHECK DEDUCT'S\"TAB(20);\r"
  "1650 PRINTUSINGY$;TD;TD*P;TD/TI*100\r"
  "1660 PRINT\"-----------------\"TAB(20);\r"
  "1670 GOSUB1560\r"
  "1680 FORJ=2TO9:READA$:IFD(J)=0THEN1700ELSEPRINTA$TAB(20);\r"
  "1690 PRINTUSINGY$;D(J);D(J)*P;D(J)/TI*100\r"
  "1700 NEXTJ:PRINTTAB(20);\r"
  "1710 GOSUB1560\r"
  "1720 PRINT\"FIXED EXPENSES\"TAB(20);\r"
  "1730 PRINTUSINGY$;TF;TF*P;TF/TI*100\r"
  "1740 PRINT\"--------------\"TAB(20);\r"
  "1750 GOSUB1560\r"
  "1760 FORJ=10TO18:READA$:IFD(J)=0THEN1780ELSEPRINTA$TAB(20);\r"
  "1770 PRINTUSINGY$;D(J);D(J)*P;D(J)/TI*100\r"
  "1780 NEXTJ:PRINTTAB(20);\r"
  "1790 GOSUB1560\r"
  "1800 PRINT\"VARIABLE EXPENSE\"TAB(20);\r"
  "1810 PRINTUSINGY$;FT;FT*P;FT/TI*100\r"
  "1820 PRINT\"----------------\"TAB(20);\r"
  "1830 GOSUB1560\r"
  "1840 FORJ=0TOQ:IFF(J)=0THEN1860ELSEPRINTE$(J)TAB(20);\r"
  "1850 PRINTUSINGY$;F(J);F(J)*P;F(J)/TI*100\r"
  "1860 NEXTJ:PRINT\r"
  "1870 GOSUB1900:PRINT\r"
  "1880 GOSUB1900:PRINT:GOTO1980\r"
  "1890 FORL=1TOS:PRINT\"-\";:NEXTL:PRINT:RETURN\r"
  "1900 FORL=1TOS:PRINT\"=\";:NEXTL:PRINT:RETURN\r"
  "1910 PRINT\"PRESS 'Y' TO CONTINUE\":PRINT:INPUTA$:PRINT:RETURN\r"
  "1920 FORL=1TO10:PRINT;:NEXTL:RETURN\r"
  "1930 IFA<=V(J)THEN1970\r"
  "1940 IFA<=VTTHEN1970\r"
  "1950 PRINT\"* YOU HAVE EXCEEDED YOUR BALANCE OF SPENDABLE INCOME BY $\"A-SI;\r"
  "1960 PRINT\" *\":INPUT\"REVISED AMOUNT $\";A:PRINT\r"
  "1970 RETURN\r"
  "1980 RESTORE:READA$:READA$:PRINT:PRINT:S=95\r"
  "1990 PRINTTAB(21)\"* EXPENSE BAR CHART *\"\r"
  "2000 PRINTTAB(20)\"PERCENT OF TATAL INCOME\":PRINT\r"
  "2010 GOSUB1890:PRINT\r"
  "2020 GOSUB2140:PRINT\r"
  "2030 FORJ=2TO18:READA$:IFD(J)=0THEN2060\r"
  "2040 A=INT(D(J)/TI*300):PRINTA$;\r"
  "2050 GOSUB2170\r"
  "2060 NEXTJ\r"
  "2070 FORJ=0TOQ:IFF(J)=0THEN2100\r"
  "2080 A=INT(F(J)/TI*300):PRINTE$(J);\r"
  "2090 GOSUB2170\r"
  "2100 NEXTJ:PRINT\r"
  "2110 GOSUB2140:PRINT:PRINT\r"
  "2120 GOSUB1900:PRINT:PRINT:STOP\r"
  "2130 REM\r"
  "2140 PRINTTAB(20)\"  -  -  -  -  5  -  -  -  - 10  -  -  -  - 15  -  -  -  \";\r"
  "2150 PRINT\"- 20  -  -  -  - 25\":RETURN\r"
  "2160 RETURN\r"
  "2170 IFA<1THENPRINTTAB(20)\"]\":GOTO2200\r"
  "2180 IFA<2THENPRINTTAB(20)\"]]\":GOTO2200\r"
  "2190 PRINTTAB(20);:FORK=1TOA:PRINT\"]\";:NEXTK:PRINT\r"
  "2200 RETURN\r"
  "2210 REM\r"
  "2220 REM\r"
  "2230 STOP\r"
  "2240 REM\r"
  "2250 REM\r"
  "";

const char basic_chase[] =
  "100 PRINT \"THIS IS THE GAME OF CHASE\"\r"
  "110 PRINT \"WANT INSTRUCTIONS\";\r"
  "120 INPUT C$\r"
  "130 IF LEFT$(C$,1)=\"N\" THEN 230\r"
  "140 IF LEFT$(C$,1)<>\"Y\" THEN 110\r"
  "150 PRINT \"YOU ARE '*' IN A HIGH VOLTAGE MAZE WITH 5\"\r"
  "160 PRINT \"SECURITY MACHINES '+' TRYING TO DESTROY YOU\"\r"
  "170 PRINT \"YOU MUST MANEUVER THE SECURITY MACHINES INTO\"\r"
  "180 PRINT \"THE MAZE 'X' TO SURVIVE.  GOOD LUCK !!!\"\r"
  "190 PRINT \"MOVES ARE 7,8,9\"\r"
  "200 PRINT \"          4,5,6\"\r"
  "210 PRINT \"          1,2,3   0 TO END THE GAME\"\r"
  "220 PRINT\r"
  "230 DIM A(10,20),E(21),F(21)\r"
  "240 LET G=0\r"
  "250 FOR B=1 TO 10\r"
  "260 FOR C=1 TO 20\r"
  "270 LET A(B,C)=0\r"
  "280 IF B=1 THEN 330\r"
  "290 IF B=10 THEN 330\r"
  "300 IF C=1 THEN 330\r"
  "310 IF C=20 THEN 330\r"
  "320 GOTO 340\r"
  "330 LET A(B,C)=1\r"
  "340 NEXT C\r"
  "350 NEXT B\r"
  "360 FOR D=1 TO 21\r"
  "370 LET B=INT(RND(1)*8)+2\r"
  "380 LET C=INT(RND(1)*18)+2\r"
  "390 IF A(B,C)<>0 THEN 370\r"
  "400 LET A(B,C)=1\r"
  "410 IF D<6 THEN 430\r"
  "420 GOTO 440\r"
  "430 LET A(B,C)=2\r"
  "440 IF D=6 THEN 460\r"
  "450 GOTO 470\r"
  "460 LET A(B,C)=3\r"
  "470 LET E(D)=B\r"
  "480 LET F(D)=C\r"
  "490 NEXT D\r"
  "500 FOR B=1 TO 10\r"
  "510 FOR C=1 TO 20\r"
  "520 IF A(B,C)<>0 THEN 550\r"
  "530 PRINT \" \";\r"
  "540 GOTO 630\r"
  "550 IF A(B,C)<>1 THEN 580\r"
  "560 PRINT \"X\";\r"
  "570 GOTO 630\r"
  "580 IF A(B,C)<>2 THEN 610\r"
  "590 PRINT \"+\";\r"
  "600 GOTO 630\r"
  "610 IF A(B,C)<>3 THEN 630\r"
  "620 PRINT \"*\";\r"
  "630 NEXT C\r"
  "640 PRINT\r"
  "650 NEXT B\r"
  "660 LET B=E(6)\r"
  "670 LET C=F(6)\r"
  "680 LET A(B,C)=0\r"
  "690 INPUT Y\r"
  "700 ON Y+1 GOTO 1040,730,730,730,740,780,740,710,710,710\r"
  "710 LET B=B-1\r"
  "720 GOTO 740\r"
  "730 LET B=B+1\r"
  "740 ON Y GOTO 750,780,770,750,780,770,750,780,770\r"
  "750 LET C=C-1\r"
  "760 GOTO 780\r"
  "770 LET C=C+1\r"
  "780 IF A(B,C)=1 THEN 1060\r"
  "790 IF A(B,C)=2 THEN 1080\r"
  "800 LET A(B,C)=3\r"
  "810 LET E(6)=B\r"
  "820 LET F(6)=C\r"
  "830 FOR D=1 TO 5\r"
  "840 IF A(E(D),F(D))<>2 THEN 1020\r"
  "850 LET A(E(D),F(D))=0\r"
  "860 IF E(D)>=B THEN 890\r"
  "870 LET E(D)=E(D)+1\r"
  "880 GOTO 910\r"
  "890 IF E(D)=B THEN 910\r"
  "900 LET E(D)=E(D)-1\r"
  "910 IF F(D)>=C THEN 940\r"
  "920 LET F(D)=F(D)+1\r"
  "930 GOTO 960\r"
  "940 IF F(D)=C THEN 960\r"
  "950 LET F(D)=F(D)-1\r"
  "960 IF A(E(D),F(D))=3 THEN 1080\r"
  "970 IF A(E(D),F(D))=0 THEN 1000\r"
  "980 LET G=G+1\r"
  "990 GOTO 1010\r"
  "1000 LET A(E(D),F(D))=2\r"
  "1010 IF G=5 THEN 1100\r"
  "1020 NEXT D\r"
  "1030 GOTO 500\r"
  "1040 PRINT \"SORRY TO SEE YOU QUIT\"\r"
  "1050 GOTO 1110\r"
  "1060 PRINT \"ZAP!!! YOU TOUCHED THE FENCE !!!!!\"\r"
  "1070 GOTO 1110\r"
  "1080 PRINT \"** YOU HAVE BEEN DESTROYED BY A LUCKY COMPUTER **\"\r"
  "1090 GOTO 1110\r"
  "1100 PRINT \"YOU ARE LUCKY **YOU DESTROYED ALL THE ENEMY**\"\r"
  "1110 PRINT \"WANT TO PLAY AGAIN\";\r"
  "1120 INPUT C$\r"
  "1130 IF LEFT$(C$,1)=\"Y\" THEN 240\r"
  "1140 IF LEFT$(C$,1)<>\"N\" THEN 1110\r"
  "1150 PRINT \"HOPE YOU DON'T FEEL FENCED IN.\"\r"
  "1160 PRINT \"TRY AGAIN SOMETIME\"\r"
  "1170 END\r"
  "";

const char basic_checkers[] =
  "5 PRINT TAB(32);\"CHECKERS\"\r"
  "10 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "15 PRINT:PRINT:PRINT\r"
  "20 PRINT \"THIS IS THE GAME OF CHECKERS.  THE COMPUTER IS X,\"\r"
  "25 PRINT \"AND YOU ARE O.  THE COMPUTER WILL MOVE FIRST.\"\r"
  "30 PRINT \"SQUARES ARE REFERRED TO BY A COORDINATE SYSTEM.\"\r"
  "35 PRINT \"(0,0) IS THE LOWER LEFT CORNER\"\r"
  "40 PRINT \"(0,7) IS THE UPPER LEFT CORNER\"\r"
  "45 PRINT \"(7,0) IS THE LOWER RIGHT CORNER\"\r"
  "50 PRINT \"(7,7) IS THE UPPER RIGHT CORNER\"\r"
  "55 PRINT \"THE COMPUTER WILL TYPE '+TO' WHEN YOU HAVE ANOTHER\"\r"
  "60 PRINT \"JUMP.  TYPE TWO NEGATIVE NUMBERS IF YOU CANNOT JUMP.\"\r"
  "65 PRINT:PRINT:PRINT\r"
  "80 DIM R(4),S(7,7):G=-1:R(0)=-99\r"
  "90 DATA 1,0,1,0,0,0,-1,0,0,1,0,0,0,-1,0,-1,15\r"
  "120 FOR X=0 TO 7:FOR Y=0 TO 7:READ J:IF J=15 THEN 180\r"
  "160 S(X,Y)=J:GOTO 200\r"
  "180 RESTORE:READ S(X,Y)\r"
  "200 NEXT Y,X\r"
  "230 FOR X=0 TO 7:FOR Y=0 TO 7:IF S(X,Y)>-1 THEN 350\r"
  "310 IF S(X,Y)=-1 THEN FOR A=-1 TO 1 STEP 2:B=G:GOSUB 650:NEXT A\r"
  "330 IF S(X,Y)=-2 THEN FOR A=-1 TO 1 STEP 2:FOR B=-1 TO 1 STEP 2:GOSUB 650:NEXT B,A\r"
  "350 NEXT Y,X:GOTO 1140\r"
  "650 U=X+A:V=Y+B:IF U<0 OR U>7 OR V<0 OR V>7 THEN 870\r"
  "740 IF S(U,V)=0 THEN GOSUB 910:GOTO 870\r"
  "770 IF S(U,V)<0 THEN 870\r"
  "790 U=U+A:V=V+B:IF U<0 OR V<0 OR U>7 OR V>7 THEN 870\r"
  "850 IF S(U,V)=0 THEN GOSUB 910\r"
  "870 RETURN\r"
  "910 IF V=0 AND S(X,Y)=-1 THEN Q=Q+2\r"
  "920 IF ABS(Y-V)=2 THEN Q=Q+5\r"
  "960 IF Y=7 THEN Q=Q-2\r"
  "980 IF U=0 OR U=7 THEN Q=Q+1\r"
  "1030 FOR C=-1 TO 1 STEP 2:IF U+C<0 OR U+C>7 OR V+G<0 THEN 1080\r"
  "1035 IF S(U+C,V+G)<0 THEN Q=Q+1:GOTO 1080\r"
  "1040 IF U-C<0 OR U-C>7 OR V-G>7 THEN 1080\r"
  "1045 IF S(U+C,V+G)>0 AND(S(U-C,V-G)=0 OR(U-C=X AND V-G=Y))THEN Q=Q-2\r"
  "1080 NEXT C:IF Q>R(0)THEN R(0)=Q:R(1)=X:R(2)=Y:R(3)=U:R(4)=V\r"
  "1100 Q=0:RETURN\r"
  "1140 IF R(0)=-99 THEN 1880\r"
  "1230 PRINT CHR$(26)\"FROM\"R(1);R(2)\"TO\"R(3);R(4);:R(0)=-99\r"
  "1240 IF R(4)=0 THEN S(R(3),R(4))=-2:GOTO 1420\r"
  "1250 S(R(3),R(4))=S(R(1),R(2))\r"
  "1310 S(R(1),R(2))=0:IF ABS(R(1)-R(3))<>2 THEN 1420\r"
  "1330 S((R(1)+R(3))/2,(R(2)+R(4))/2)=0\r"
  "1340 X=R(3):Y=R(4):IF S(X,Y)=-1 THEN B=-2:FOR A=-2 TO 2 STEP 4:GOSUB 1370\r"
  "1350 IF S(X,Y)=-2 THEN FOR A=-2 TO 2 STEP 4:FOR B=-2 TO 2 STEP 4:GOSUB 1370:NEXT B\r"
  "1360 NEXT A:IF R(0)<>-99 THEN PRINT\"TO\"R(3);R(4);:R(0)=-99:GOTO 1240\r"
  "1365 GOTO 1420\r"
  "1370 U=X+A:V=Y+B:IF U<0 OR U>7 OR V<0 OR V>7 THEN 1400\r"
  "1380 IF S(U,V)=0 AND S(X+A/2,Y+B/2)>0 THEN GOSUB 910\r"
  "1400 RETURN\r"
  "1420 PRINT:PRINT:PRINT:FOR Y=7 TO 0 STEP-1:FOR X=0 TO 7:I=5*X:PRINT TAB(I);\r"
  "1430 IF S(X,Y)=0 THEN PRINT\".\";\r"
  "1470 IF S(X,Y)=1 THEN PRINT\"O\";\r"
  "1490 IF S(X,Y)=-1 THEN PRINT\"X\";\r"
  "1510 IF S(X,Y)=-2 THEN PRINT\"X*\";\r"
  "1530 IF S(X,Y)=2 THEN PRINT\"O*\";\r"
  "1550 NEXT X:PRINT\" \":PRINT:NEXT Y:PRINT\r"
  "1552 FOR L=0 TO 7\r"
  "1554 FOR M=0 TO 7\r"
  "1556 IF S(L,M)=1 OR S(L,M)=2 THEN Z=1\r"
  "1558 IF S(L,M)=-1 OR S(L,M)=-2 THEN T=1\r"
  "1560 NEXT M\r"
  "1562 NEXT L\r"
  "1564 IF Z<>1 THEN 1885\r"
  "1566 IF T<>1 THEN 1880\r"
  "1570 Z=0: T=0\r"
  "1590 INPUT \"FROM\";E,H:X=E:Y=H:IF S(X,Y)<=0 THEN 1590\r"
  "1670 INPUT \"TO\";A,B:X=A:Y=B\r"
  "1680 IF S(X,Y)=0 AND ABS(A-E)<=2 AND ABS(A-E)=ABS(B-H)THEN 1700\r"
  "1690 PRINT CHR$(7)CHR$(11);:GOTO 1670\r"
  "1700 I=46\r"
  "1750 S(A,B)=S(E,H):S(E,H)=0:IF ABS(E-A)<>2 THEN 1810\r"
  "1800 S((E+A)/2,(H+B)/2)=0\r"
  "1802 INPUT \"+TO\";A1,B1:IF A1<0 THEN 1810\r"
  "1804 IF S(A1,B1)<>0 OR ABS(A1-A)<>2 OR ABS(B1-B)<>2 THEN 1802\r"
  "1806 E=A:H=B:A=A1:B=B1:I=I+15:GOTO 1750\r"
  "1810 IF B=7 THEN S(A,B)=2\r"
  "1830 GOTO 230\r"
  "1880 PRINT: PRINT \"YOU WIN.\": END\r"
  "1885 PRINT: PRINT \"I WIN.\": END\r"
  "";

const char basic_chess[] =
  "100 REM--CHESS BY RANDY MILLER, JAN, 1976\r"
  "110 DEFINT A-Z:DEFSNG E:DEFSNG M:DEFSNG P\r"
  "120 DIM PS(70,3),MV(35,2),V(32)\r"
  "130 DIM B(8,8),TM(8,8)\r"
  "140 DEF FNL(X)=X\\10\r"
  "150 DEF FNM(X)=X MOD(10)\r"
  "160 TM(1,1)=0\r"
  "170 FOR X=1 TO 32\r"
  "180 READ V(X)\r"
  "190 NEXT\r"
  "200 FOR Y=1 TO 8\r"
  "210 FOR X=1 TO 8\r"
  "220 READ B(X,Y)\r"
  "230 NEXT X:NEXT Y\r"
  "240 DATA -2,1,-1,2,1,2,2,1,2,-1,1,-2,-1,-2,-2,-1\r"
  "250 DATA 8,12,19,21,-8,-12,-19,-21\r"
  "260 DATA 1,9,10,11,-1,-9,-10,-11\r"
  "270 DATA 4,2,3,6,5,3,2,4,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0\r"
  "280 DATA 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-1,-1,-1,-1\r"
  "290 DATA -1,-1,-1,-1,-4,-2,-3,-6,-5,-3,-2,-4\r"
  "300 CB=3:CW=3\r"
  "310 PRINT:PRINT:PRINT:PRINT TAB(10);\"**** CHESS ****\"\r"
  "320 INPUT \"DO YOU WANT TO BE WHITE OR BLACK\";C$\r"
  "330 IF LEFT$(C$,1)=\"B\" THEN 370\r"
  "340 B(4,1)=5:B(4,8)=-5\r"
  "350 B(5,1)=6:B(5,8)=-6\r"
  "360 GOTO 380\r"
  "370 PRINT \"THANK YOU, THAT MEANS I GET TO GO FIRST\":PRINT\r"
  "380 FOR Y=1 TO 8\r"
  "390 FOR X=1 TO 8\r"
  "400 TM(X,Y)=B(X,Y)\r"
  "410 NEXT X:NEXT Y\r"
  "420 IF LEFT$(C$,1)<>\"B\" THEN 840\r"
  "430 NB=1\r"
  "440 REM -- COMPILE LIST OF POSSIBLE MOVES --\r"
  "450 FOR X=1 TO 8\r"
  "460 FOR Y=1 TO 8\r"
  "470 IF SGN(B(X,Y))<>1 THEN 550\r"
  "480 GOSUB 1870\r"
  "490 FOR D=1 TO N\r"
  "500 IF MV(D,1)=0 THEN 540\r"
  "510 PS(NB,1)=MV(D,1)\r"
  "520 PS(NB,2)=MV(D,2)\r"
  "530 NB=NB+1\r"
  "540 NEXT D\r"
  "550 NEXT Y\r"
  "560 NEXT X\r"
  "570 PRINT:PRINT \"NUMBER OF POSSIBLE MOVES FOR COMPUTER\";NB-1:PRINT\r"
  "580 IF NB>1 THEN PRINT \"FROM TO  BOARD VALUE\":GOTO 620\r"
  "590 PRINT \"I DON'T BELIEVE IT! - YOU WON!!!\"\r"
  "600 END\r"
  "610 REM -- EVALUATE EACH POSSIBLE MOVE --\r"
  "620 FOR D=1 TO NB-1\r"
  "630 D1=FNL(PS(D,1))\r"
  "640 D2=FNM(PS(D,1))\r"
  "650 D3=FNL(PS(D,2))\r"
  "660 D4=FNM(PS(D,2))\r"
  "670 D5=B(D3,D4)\r"
  "680 TM(D3,D4)=TM(D1,D2)\r"
  "690 TM(D1,D2)=0\r"
  "700 GOSUB 1530\r"
  "710 PS(D,3)=EV\r"
  "720 TM(D1,D2)=TM(D3,D4)\r"
  "730 TM(D3,D4)=D5\r"
  "740 PRINT PS(D,1);PS(D,2);TAB(12);PS(D,3)\r"
  "750 NEXT D\r"
  "760 REM\r"
  "770 MZ=PS(1,3):MX=1\r"
  "780 IF NB=2 THEN 830\r"
  "790 FOR D=2 TO NB-1\r"
  "800 IF PS(D,3)<=MZ THEN 820\r"
  "810 MX=D:MZ=PS(D,3)\r"
  "820 NEXT D\r"
  "830 GOSUB 1290\r"
  "840 GOSUB 870\r"
  "850 PRINT\r"
  "860 GOTO 430\r"
  "870 REM -- INPUT ROUTINE --\r"
  "880 GOTO 910\r"
  "890 INPUT \"YOUR MOVE\";M,N\r"
  "900 IF M<>0 THEN 930\r"
  "910 FOR P=1 TO 8:FOR P1=1 TO 8:PRINT B(P1,P);:NEXT P1:PRINT:NEXT P\r"
  "920 GOTO 890\r"
  "930 X1=FNL(M):Y1=FNM(M):X2=FNL(N):Y2=FNM(N)\r"
  "940 IF X1>8 OR X1<1 OR Y1>8 OR Y1<1 THEN 970\r"
  "950 IF X2>8 OR X2<1 OR Y2>8 OR Y2<1 THEN 970\r"
  "960 IF SGN(B(X1,Y1))=-1 THEN 990\r"
  "970 PRINT \"YOU CAN'T DO THAT.\"\r"
  "980 GOTO 890\r"
  "990 REM\r"
  "1000 FOR P=1 TO 8\r"
  "1010 FOR P1=1 TO 8\r"
  "1020 TM(P,P1)=B(P,P1)\r"
  "1030 NEXT P1\r"
  "1040 NEXT P\r"
  "1050 GOSUB 3690\r"
  "1060 IF LG=0 THEN 970\r"
  "1070 TM(X2,Y2)=TM(X1,Y1)\r"
  "1080 TM(X1,Y1)=0\r"
  "1090 B(X2,Y2)=B(X1,Y1)\r"
  "1100 B(X1,Y1)=0\r"
  "1110 PRINT \"ACCEPTED.\"\r"
  "1120 IF Y2<>1 OR B(X2,Y2)<>-1 THEN 1180\r"
  "1130 PRINT \"TO PROMOTE YOUR PAWN TO A KNIGHT, TYPE 2; FOR A BISHOP,\"\r"
  "1140 PRINT \"TYPE 3;  FOR A ROOK, TYPE 4; FOR A QUEEN, TYPE 5\";\r"
  "1150 INPUT P\r"
  "1160 IF P>5 OR P<2 THEN 1130\r"
  "1170 B(X2,Y2)=-P:TM(X2,Y2)=-P\r"
  "1180 IF B(X2,Y2)<>-6 OR ABS(X1-X2)<>2 THEN 1240\r"
  "1190 IF X1-X2=2 THEN 1250\r"
  "1200 B(8,8)=0:TM(8,8)=0\r"
  "1210 B(X2-1,8)=-4:TM(X2-1,8)=-4\r"
  "1220 CB=(CB AND -3)\r"
  "1230 PRINT \"IT'S ABOUT TIME YOU CASTLED!\":PRINT\r"
  "1240 RETURN\r"
  "1250 B(1,8)=0:TM(1,8)=0\r"
  "1260 B(X2+1,8)=-4:TM(X2+1,8)=-4\r"
  "1270 CB=(CB AND -3)\r"
  "1280 GOTO 1230\r"
  "1290 REM -- OUTPUT ROUTINE --\r"
  "1300 IF PS(MX,3)<200 THEN 1350\r"
  "1310 PRINT \"HA - LET'S SEE YOU GET OUT OF THIS -\"\r"
  "1320 PRINT \"I MOVE\";PS(MX,1);\"TO\";PS(MX,2)\r"
  "1330 PRINT \"THANKS FOR THE GOOD GAME...\"\r"
  "1340 END\r"
  "1350 ON INT(RND(1)*4)+1 GOTO 1360,1370,1380,1390\r"
  "1360 PRINT \"I RECKON I'LL MOVE \";:GOTO 1400\r"
  "1370 PRINT \"I GUESS I'LL TAKE\";:GOTO 1400\r"
  "1380 PRINT \"MY MOVE IS\";:GOTO 1400\r"
  "1390 PRINT \"I LIKE\";\r"
  "1400 PRINT PS(MX,1);\"TO\";PS(MX,2):PRINT\r"
  "1410 D1=FNL(PS(MX,1))\r"
  "1420 D2=FNM(PS(MX,1))\r"
  "1430 D3=FNL(PS(MX,2))\r"
  "1440 D4=FNM(PS(MX,2))\r"
  "1450 B(D3,D4)=B(D1,D2)\r"
  "1460 B(D1,D2)=0\r"
  "1470 IF D4<>8 OR B(D3,D4)<>1 THEN 1500\r"
  "1480 PRINT \"I PROMOTE MY PAWN TO A QUEEN!\"\r"
  "1490 B(D3,D4)=5\r"
  "1500 RETURN\r"
  "1510 REM\r"
  "1520 EV=RND(1):RETURN\r"
  "1530 EV=RND(1)/2:US=0\r"
  "1540 EV=EV+D4/7\r"
  "1550 FOR PJ=1 TO 8\r"
  "1560 IF TM(PJ,8)<>1 THEN 1590\r"
  "1570 TM(PJ,8)=5\r"
  "1580 GOTO 1610\r"
  "1590 NEXT PJ\r"
  "1600 IF SGN(D5)=-1 THEN EV=EV-D5\r"
  "1610 FOR X=1 TO 8\r"
  "1620 FOR Y=1 TO 8\r"
  "1630 CX=TM(X,Y):CS=SGN(CX)\r"
  "1640 IF CS<>-1 THEN 1750\r"
  "1650 EV=EV+CX\r"
  "1660 GOSUB 1840\r"
  "1670 IF N=0 THEN 1750\r"
  "1680 US=US+N:EV=EV-.166666\r"
  "1690 FOR UX=1 TO N\r"
  "1700 U1=MV(UX,1):U2=MV(UX,2)\r"
  "1710 IF SGN(TM(FNL(U2),FNM(U2)))<>1 THEN 1740\r"
  "1720 IF SGN(TM(FNL(U1),FNM(U1)))<>-1 THEN 1740\r"
  "1730 EV=EV-2*TM(FNL(U2),FNM(U2))\r"
  "1740 NEXT UX\r"
  "1750 NEXT Y\r"
  "1760 NEXT X\r"
  "1770 IF US>0 THEN 1800\r"
  "1780 EV=EV+1000\r"
  "1790 GOTO 1810\r"
  "1800 FOR X=3 TO 6:FOR Y=3 TO 6:EV=EV+TM(X,Y)/3:NEXTY:NEXTX\r"
  "1810 IF PJ>8 THEN 1830\r"
  "1820 TM(PJ,8)=1\r"
  "1830 RETURN\r"
  "1840 REM\r"
  "1850 R=0\r"
  "1860 GOTO 1880\r"
  "1870 R=1\r"
  "1880 MV(1,1)=0\r"
  "1890 S1=SGN(TM(X,Y))\r"
  "1900 AA=X*10+Y\r"
  "1910 N=1\r"
  "1920 ON ABS(TM(X,Y)) GOSUB 2330,2770,2880,3140,3400,3440\r"
  "1930 IF N=1 THEN 1950\r"
  "1940 IF R=1 THEN 1970\r"
  "1950 N=N-1\r"
  "1960 RETURN\r"
  "1970 REM -- IF RESTRICTED --\r"
  "1980 N1=N-1\r"
  "1990 N=N1\r"
  "2000 FOR K=1 TO N1\r"
  "2010 C1=FNL(MV(K,1))\r"
  "2020 C2=FNM(MV(K,1))\r"
  "2030 C3=FNL(MV(K,2))\r"
  "2040 C4=FNM(MV(K,2))\r"
  "2050 IF ABS(TM(C3,C4))=6 THEN 2070\r"
  "2060 IF SGN(TM(C3,C4))<>S1 THEN 2080\r"
  "2070 MV(K,1)=0:MV(K,2)=0:GOTO 2290\r"
  "2080 C5=TM(C3,C4)\r"
  "2090 TM(C3,C4)=TM(C1,C2)\r"
  "2100 TM(C1,C2)=0\r"
  "2110 REM -- FIND KING --\r"
  "2120 FOR Y2=1 TO 8\r"
  "2130 FOR X2=1 TO 8\r"
  "2140 IF TM(X2,Y2)=6*S1 THEN 2170\r"
  "2150 NEXT X2\r"
  "2160 NEXT Y2\r"
  "2170 REM\r"
  "2180 FOR Y1=1 TO 8\r"
  "2190 FOR X1=1 TO 8\r"
  "2200 IF SGN(TM(X1,Y1))<>-S1 THEN 2250\r"
  "2210 IF TM(X1,Y1)<>-S1 THEN 2230\r"
  "2220 IF X1=X2 AND ABS(Y2-Y1)>2 THEN 2250\r"
  "2230 GOSUB 3660\r"
  "2240 IF LG=1 THEN 2310\r"
  "2250 NEXT X1\r"
  "2260 NEXT Y1\r"
  "2270 TM(C1,C2)=TM(C3,C4)\r"
  "2280 TM(C3,C4)=C5\r"
  "2290 NEXT K\r"
  "2300 RETURN\r"
  "2310 MV(K,1)=0:MV(K,2)=0\r"
  "2320 GOTO 2250\r"
  "2330 REM -- RAW PAWN MOVE --\r"
  "2340 IF S1=-1 THEN 2560\r"
  "2350 IF Y+1>8 THEN 2550\r"
  "2360 IF TM(X,Y+1)<>0 THEN 2450\r"
  "2370 MV(N,1)=AA\r"
  "2380 MV(N,2)=X*10+Y+1\r"
  "2390 N=N+1\r"
  "2400 IF Y>2 THEN 2450\r"
  "2410 IF TM(X,Y+2)<>0 THEN 2450\r"
  "2420 MV(N,1)=AA\r"
  "2430 MV(N,2)=X*10+Y+2\r"
  "2440 N=N+1\r"
  "2450 IF X=1 THEN 2500\r"
  "2460 IF SGN(TM(X-1,Y+1))<>-S1 THEN 2500\r"
  "2470 MV(N,1)=AA\r"
  "2480 MV(N,2)=(X-1)*10+Y+1\r"
  "2490 N=N+1\r"
  "2500 IF X=8 THEN 2550\r"
  "2510 IF SGN(TM(X+1,Y+1))<>-S1 THEN 2550\r"
  "2520 MV(N,1)=AA\r"
  "2530 MV(N,2)=(X+1)*10+Y+1\r"
  "2540 N=N+1\r"
  "2550 RETURN\r"
  "2560 IF Y-1<1 THEN 2760\r"
  "2570 IF TM(X,Y-1)<>0 THEN 2660\r"
  "2580 MV(N,1)=AA\r"
  "2590 MV(N,2)=X*10+Y-1\r"
  "2600 N=N+1\r"
  "2610 IF Y<7 THEN 2660\r"
  "2620 IF TM(X,Y-2)<>0 THEN 2660\r"
  "2630 MV(N,1)=AA\r"
  "2640 MV(N,2)=X*10+Y-2\r"
  "2650 N=N+1\r"
  "2660 IF X=1 THEN 2710\r"
  "2670 IF SGN(TM(X-1,Y-1))<>-S1 THEN 2710\r"
  "2680 MV(N,1)=AA\r"
  "2690 MV(N,2)=(X-1)*10+Y-1\r"
  "2700 N=N+1\r"
  "2710 IF X=8 THEN 2760\r"
  "2720 IF SGN(TM(X+1,Y-1))<>-S1 THEN 2760\r"
  "2730 MV(N,1)=AA\r"
  "2740 MV(N,2)=(X+1)*10+Y-1\r"
  "2750 N=N+1\r"
  "2760 RETURN\r"
  "2770 REM -- RAW KNIGHT MOVE --\r"
  "2780 FOR C6=1 TO 15 STEP 2\r"
  "2790 KL=V(C6):KM=V(C6+1)\r"
  "2800 XT=X+KL\r"
  "2810 YT=Y+KM\r"
  "2820 IF XT>8 OR XT<1 OR YT>8 OR YT<1 THEN 2860\r"
  "2830 MV(N,1)=AA\r"
  "2840 MV(N,2)=XT*10+YT\r"
  "2850 N=N+1\r"
  "2860 NEXT C6\r"
  "2870 RETURN\r"
  "2880 REM -- RAW BISHOP MOVE --\r"
  "2890 EL=(8-Y)*-(8-Y<=8-X)+(8-X)*-(8-X < 8-Y)\r"
  "2900 IF EL=0 THEN 2930\r"
  "2910 C6=11\r"
  "2920 GOSUB 3060\r"
  "2930 EL=(8-Y)*-(8-Y <= X-1)+(X-1)*-(X-1 < 8-Y)\r"
  "2940 IF EL=0 THEN 2970\r"
  "2950 C6=-9\r"
  "2960 GOSUB 3060\r"
  "2970 EL=(8-X)*-(8-X <= Y-1)+(Y-1)*-(Y-1 < 8-X)\r"
  "2980 IF EL=0 THEN 3010\r"
  "2990 C6=9\r"
  "3000 GOSUB 3060\r"
  "3010 EL=(Y-1)*-(Y-1 <= X-1)+(X-1)*-(X-1 < Y-1)\r"
  "3020 IF EL=0 THEN 3050\r"
  "3030 C6=-11\r"
  "3040 GOSUB 3060\r"
  "3050 RETURN\r"
  "3060 FOR E=1 TO EL\r"
  "3070 F=C6*E\r"
  "3080 MV(N,1)=AA\r"
  "3090 MV(N,2)=AA+F\r"
  "3100 N=N+1\r"
  "3110 IF TM(FNL(AA+F),FNM(AA+F))<>0 THEN 3130\r"
  "3120 NEXT E\r"
  "3130 RETURN\r"
  "3140 REM -- RAW ROOK MOVE --\r"
  "3150 EL=8-Y\r"
  "3160 IF EL=0 THEN 3190\r"
  "3170 C6=1\r"
  "3180 GOSUB 3320\r"
  "3190 EL=Y-1\r"
  "3200 IF EL=0 THEN 3230\r"
  "3210 C6=-1\r"
  "3220 GOSUB 3320\r"
  "3230 EL=8-X\r"
  "3240 IF EL=0 THEN 3270\r"
  "3250 C6=10\r"
  "3260 GOSUB 3320\r"
  "3270 EL=X-1\r"
  "3280 IF EL=0 THEN 3310\r"
  "3290 C6=-10\r"
  "3300 GOSUB 3320\r"
  "3310 RETURN\r"
  "3320 FOR E=1 TO EL\r"
  "3330 F=C6*E\r"
  "3340 MV(N,1)=AA\r"
  "3350 MV(N,2)=AA+F\r"
  "3360 N=N+1\r"
  "3370 IF TM(FNL(AA+F),FNM(AA+F))<>0 THEN 3390\r"
  "3380 NEXT E\r"
  "3390 RETURN\r"
  "3400 REM -- RAW QUEEN MOVE --\r"
  "3410 GOSUB 2880\r"
  "3420 GOSUB 3140\r"
  "3430 RETURN\r"
  "3440 REM -- RAW KING MOVE --\r"
  "3450 IF X=8 THEN 3510\r"
  "3460 C6=10:GOSUB 3620\r"
  "3470 IF Y=1 THEN 3500\r"
  "3480 C6=9:GOSUB 3620\r"
  "3490 IF Y=8 THEN 3520\r"
  "3500 C6=11:GOSUB 3620\r"
  "3510 IF X=1 THEN 3570\r"
  "3520 C6=-10:GOSUB 3620\r"
  "3530 IF Y=8 THEN 3570\r"
  "3540 C6=-9:GOSUB 3620\r"
  "3550 IF Y=1 THEN 3570\r"
  "3560 C6=-11:GOSUB 3620\r"
  "3570 IF Y=1 THEN 3590\r"
  "3580 C6=-1:GOSUB 3620\r"
  "3590 IF Y=8 THEN 3610\r"
  "3600 C6=1:GOSUB 3620\r"
  "3610 RETURN\r"
  "3620 MV(N,1)=AA\r"
  "3630 MV(N,2)=AA+C6\r"
  "3640 N=N+1\r"
  "3650 RETURN\r"
  "3660 REM\r"
  "3670 RR=0\r"
  "3680 GOTO 3700\r"
  "3690 RR=1\r"
  "3700 IF TM(X1,Y1)<>0 THEN 3720\r"
  "3710 LG=0:RETURN\r"
  "3720 S=SGN(TM(X1,Y1))\r"
  "3730 A=X1*10+Y1\r"
  "3740 B=X2*10+Y2\r"
  "3750 ON ABS(TM(X1,Y1)) GOSUB 4070,4270,4340,4510,4630,4680\r"
  "3760 IF LG=0 THEN RETURN\r"
  "3770 IF RR=1 THEN 3790\r"
  "3780 LG=1:RETURN\r"
  "3790 REM -- IF RESTRICTED --\r"
  "3800 IF S=SGN(TM(X2,Y2)) THEN 3710\r"
  "3810 T1=X1:T2=Y1:T3=X2:T4=Y2:T=TM(X2,Y2)\r"
  "3820 TM(X2,Y2)=TM(X1,Y1):TM(X1,Y1)=0\r"
  "3830 SV=S\r"
  "3840 REM -- FIND KING --\r"
  "3850 FOR Y2=1 TO 8\r"
  "3860 FOR X2=1 TO 8\r"
  "3870 IF TM(X2,Y2)=6*S THEN 3910\r"
  "3880 NEXT X2\r"
  "3890 NEXT Y2\r"
  "3900 END\r"
  "3910 REM\r"
  "3920 FOR Y1=1 TO 8\r"
  "3930 FOR X1=1 TO 8\r"
  "3940 P=TM(X1,Y1):IF SGN(P)=S OR P=0 OR ABS(P)=6 THEN 3980\r"
  "3950 GOSUB 3660\r"
  "3960 S=SV\r"
  "3970 IF LG=1 THEN 4050\r"
  "3980 NEXT X1\r"
  "3990 NEXT Y1\r"
  "4000 LG=1\r"
  "4010 TM(T1,T2)=TM(T3,T4)\r"
  "4020 TM(T3,T4)=T\r"
  "4030 X1=T1:Y1=T2:X2=T3:Y2=T4\r"
  "4040 RETURN\r"
  "4050 LG=0\r"
  "4060 GOTO 4010\r"
  "4070 REM -- RAW PAWN MOVE --\r"
  "4080 IF SGN(Y2-Y1)=S THEN 4110\r"
  "4090 LG=0:RETURN\r"
  "4100 LG=1:RETURN\r"
  "4110 IF S=-1 THEN 4190\r"
  "4120 IF B-A=1 OR B-A=2 THEN 4160\r"
  "4130 IF TM(X2,Y2)=0 THEN 4090\r"
  "4140 IF B-A=-9 OR B-A=11 THEN 4100\r"
  "4150 GOTO 4090\r"
  "4160 IF Y2=2 THEN 4100\r"
  "4170 IF B-A=1 THEN 4100\r"
  "4180 GOTO 4090\r"
  "4190 IF A-B=1 OR A-B=2 THEN 4230\r"
  "4200 IF TM(X2,Y2)=0 THEN 4090\r"
  "4210 IF A-B=-9 OR A-B=11 THEN 4100\r"
  "4220 GOTO 4090\r"
  "4230 IF Y2=7 THEN 4100\r"
  "4240 IF A-B=1 THEN 4100\r"
  "4250 IF Y1=7 AND A-B=2 THEN 4100\r"
  "4260 GOTO 4090\r"
  "4270 REM -- RAW KNIGHT MOVE --\r"
  "4280 FOR P=17 TO 24\r"
  "4290 P1=V(P)\r"
  "4300 IF A+P1<>B THEN 4320\r"
  "4310 LG=1:RETURN\r"
  "4320 NEXT P\r"
  "4330 LG=0:RETURN\r"
  "4340 REM -- RAW BISHOP MOVE --\r"
  "4350 IF Y2=Y1 OR X2=X1 THEN 4420\r"
  "4360 SP=-9\r"
  "4370 IF X2<X1 THEN 4470\r"
  "4380 IF Y1<Y2 THEN 4430\r"
  "4390 SP=9\r"
  "4400 P=INT(ABS(A-B)/9)\r"
  "4410 IF ABS(A-B)/9=P THEN 4490\r"
  "4420 LG=0:RETURN\r"
  "4430 SP=11\r"
  "4440 P=INT(ABS(A-B)/11)\r"
  "4450 IF ABS(A-B)/11<>P THEN 4420\r"
  "4460 GOTO 4490\r"
  "4470 IF Y1<Y2 THEN 4400\r"
  "4480 SP=-11:GOTO 4440\r"
  "4490 GOSUB 4950\r"
  "4500 RETURN\r"
  "4510 REM -- RAW ROOK MOVES --\r"
  "4520 IF Y2=Y1 THEN 4590\r"
  "4530 IF X1=X2 THEN 4550\r"
  "4540 LG=0:RETURN\r"
  "4550 P=ABS(B-A)\r"
  "4560 SP=SGN(B-A)\r"
  "4570 GOSUB 4950\r"
  "4580 RETURN\r"
  "4590 P=ABS(INT((B-A)/10))\r"
  "4600 SP=SGN(B-A)*10\r"
  "4610 GOSUB 4950\r"
  "4620 RETURN\r"
  "4630 REM -- RAW QUEEN MOVE --\r"
  "4640 GOSUB 4340\r"
  "4650 IF LG=1 THEN RETURN\r"
  "4660 GOSUB 4510\r"
  "4670 RETURN\r"
  "4680 REM -- KING MOVE --\r"
  "4690 IF ABS(A-B)<>20 THEN 4890\r"
  "4700 IF A-B=20 THEN 4730\r"
  "4710 IF CB<>1 AND CB<>3 THEN 4880\r"
  "4720 GOTO 4740\r"
  "4730 IF CB=0 OR CB=1 THEN 4880\r"
  "4740 PS=SGN(A-B):FORP2=28+50*((PS=-1)*-1)TOA+10-20*((PS=-1)+1)STEP10*P\r"
  "4750 IF TM(FNL(P2),FNM(P2))<>0 THEN 4880\r"
  "4760 NEXT P2:T1=X1:T2=Y1:T3=X2:T4=Y2\r"
  "4770 FOR P2=A TO 18+70*((PS=-1)*-1) STEP 10*-PS\r"
  "4780 X2=FNL(P2):Y2=FNM(P2)\r"
  "4790 FOR X1=1 TO 8\r"
  "4800 FOR Y1=1 TO 8\r"
  "4810 IF SGN(TM(X1,Y1))<>1 THEN 4840\r"
  "4820 GOSUB 3690\r"
  "4830 IF LG=1 THEN 4880\r"
  "4840 NEXT Y1:NEXT X1:NEXT P2\r"
  "4850 LG=1\r"
  "4860 X1=T1:Y1=T2:X2=T3:Y2=T4\r"
  "4870 RETURN\r"
  "4880 LG=0:GOTO 4860\r"
  "4890 FOR P=25 TO 32\r"
  "4900 P1=V(P)\r"
  "4910 IF B=A+P1 THEN 4940\r"
  "4920 NEXT P\r"
  "4930 LG=0:RETURN\r"
  "4940 LG=1:RETURN\r"
  "4950 REM\r"
  "4960 LG=0\r"
  "4970 IF P=0 THEN STOP\r"
  "4980 IF P>1 THEN 5000\r"
  "4990 LG=1:RETURN\r"
  "5000 FOR P1=1 TO P-1\r"
  "5010 P2=A+SP*P1\r"
  "5020 IF TM(FNL(P2),FNM(P2))<>0 THEN RETURN\r"
  "5030 NEXT P1\r"
  "5040 LG=1:RETURN\r"
  "5050 END\r"
  "";

const char basic_climates[] =
  "100 REM--E.A.GALLETTA,PATCHOGUE-H.S.,4/22/69 EARTH SIENCE (BIICAC)\r"
  "110 REM--PROGRAM ON CLIMATES  \r"
  "120 REM--REWRITTEN--7/28/69--BASIC--<ROD> \r"
  "130 REM REVISED BY TONY PEREZ, WALT WHITMAN HS, 8-69 \r"
  "140 REM RE-REVISED BY C.LOSIK 8-26-70\r"
  "150 DIML(56)  \r"
  "160 READN,L(N) \r"
  "170 IFN<>56THEN 160\r"
  "180 T=0 \r"
  "190 PRINT\"O.K., HERE ARE SOME VALUES FOR THE PRECIPIATION (P) AND FOR\r"
  "200 PRINT\"THE POTENTIAL EVAPOTRANSPIRATION (PE) OF AN AREA:\"  \r"
  "210 PRINT \r"
  "220 PRINT\" \",\"MONTH\",\" P\",\" PE\" \r"
  "230 PRINT\" \",\"=====\",\"=====\",\"======\" \r"
  "240 P=INT(10*RND(1))\r"
  "250 IFP>6THEN240  \r"
  "260 IFP<1THEN240  \r"
  "270 E=INT(10*RND(1))\r"
  "280 IFE>4THEN270  \r"
  "290 IFE<1THEN270  \r"
  "300 Z=5*E+6*P  \r"
  "310 IF (Z-21)*(Z-22)*(Z-17)*(Z-38)=0 THEN 240 \r"
  "320 FORI=1TO12 \r"
  "330 PRINT\" \",I,\r"
  "340 IFP>1THEN360  \r"
  "350 P1=12*COS(.261*I)^2+2*RND(1)\r"
  "360 IFP<>2THEN380 \r"
  "370 P1=12*SIN(.261*I)+2*RND(1) \r"
  "380 IFP<>3THEN400 \r"
  "390 P1=2+3*RND(1)  \r"
  "400 IFP<>4THEN420 \r"
  "410 P1=2*RND(1) \r"
  "420 IFP<>5THEN440 \r"
  "430 P1=7+10*RND(1) \r"
  "440 IFP<>6THEN460 \r"
  "450 P1=3*COS(.5+.15*I)^2\r"
  "460 PRINTINT(P1), \r"
  "470 IFE>1THEN490  \r"
  "480 E1=10*SIN(.261*I)^2 \r"
  "490 IFE<>2THEN510 \r"
  "500 E1=12*SIN(.261*I)^2 \r"
  "510 IFE<>3THEN530 \r"
  "520 E1=2*SIN(.5+.15*I)^2\r"
  "530 IFE<>4THEN550 \r"
  "540 E1=8+4*RND(1)  \r"
  "550 T=T+INT(P1) \r"
  "560 PRINTINT(E1+(E1/10)*2) \r"
  "570 NEXTI \r"
  "580 PRINT \r"
  "590 PRINT\"TOTAL PRECIPITATION =\";T;\"INCHES\"\r"
  "600 PRINT \r"
  "610 PRINT\"O.K., PLOT YOUR GRAPH ON THE PAPER PROVIDE YOU\" \r"
  "620 PRINT\"AND WHEN YOU ARE READY TO CONTINUE.... MEREY TYPE\" \r"
  "630 PRINT\"ANY NUMBER AND THE RETURN KEY.      \"; \r"
  "640 INPUTQ \r"
  "650 PRINT \r"
  "660 PRINT\"READY? GOOD, NOW TELL ME . . . DOES YOUR GRAPH SHOW THAT\"  \r"
  "670 PRINT\"THE CLIMATE HAS DEFINITE WET AND DRY SEASONS (1=YES, 0=NO) \"\r"
  "680 INPUT S\r"
  "690 PRINT \r"
  "700 IFS=0THEN880  \r"
  "710 IF S<>1 THEN 660  \r"
  "720 IFP<3THEN990  \r"
  "730 B=0\r"
  "740 GOSUB 1960\r"
  "750 PRINT\"TELL ME, IS THE CLIMATE [1] WET, [2] DRY, R [3] MODERATE ALL\"  \r"
  "760 PRINT\"YEAR\";  \r"
  "770 INPUT S\r"
  "780 PRINT \r"
  "790 IFS=1THEN920  \r"
  "800 IFS=3THEN960  \r"
  "810 IF S<>2 THEN 750  \r"
  "820 IFT<13THEN1130 \r"
  "830 IFT>80THEN860 \r"
  "840 GOSUB1950 \r"
  "850 GOTO1140\r"
  "860 GOSUB1910 \r"
  "870 GOTO1140\r"
  "880 IFP>2THEN750  \r"
  "890 IFP=2THEN820  \r"
  "900 GOSUB1910 \r"
  "910 GOTO990\r"
  "920 IFT>80THEN1130 \r"
  "930 IFT>=13THEN840 \r"
  "940 GOSUB1930 \r"
  "950 GOTO1140\r"
  "960 IF(T-13)*(80-T)>=0THEN1130 \r"
  "970 IFT<13THEN940 \r"
  "980 IFT>80THEN860 \r"
  "990 PRINT\"TELL ME, WHICH IS THE WET SEASON, [1] THE WINTER OR [2] THE\" \r"
  "1000 PRINT\"SUMMER\"; \r"
  "1010 PRINT \r"
  "1020 INPUT S\r"
  "1030 PRINT \r"
  "1040 IFS=1THEN1090  \r"
  "1050 IF S<>2 THEN 990  \r"
  "1060 IFP=2THEN1130  \r"
  "1070 GOSUB1910 \r"
  "1080 GOTO1140\r"
  "1090 IFP=1THEN1130  \r"
  "1100 GOSUB1910 \r"
  "1110 GOTO1140\r"
  "1120 PRINT \r"
  "1130 PRINT\"NICE GOING, SMARTY PANTS. KEEP UP THE GOODWORK.\"  \r"
  "1140 PRINT\"BY CHECKING THE PE CURVE ON YOUR GRAPH, WOUD YOU SAY THAT THE\" \r"
  "1150 PRINT\"SUMMERS ARE [1] HOT, [2] WARM, OR [3] COOL\" \r"
  "1160 INPUT S\r"
  "1170 PRINT \r"
  "1180 IFS=2THEN1260  \r"
  "1190 IFS=3THEN1300  \r"
  "1200 IF S<>1 THEN 1130  \r"
  "1210 IFE=2THEN1320  \r"
  "1220 IFE=4THEN1320  \r"
  "1230 IF E=1 THEN 1320\r"
  "1240 GOSUB1910 \r"
  "1250 GOTO1330\r"
  "1260 IFE=1THEN1320  \r"
  "1270 IFE<>3THEN1240 \r"
  "1280 GOSUB1950 \r"
  "1290 GOTO1330\r"
  "1300 IFE=3THEN1320  \r"
  "1310 IFE<>3THEN1240 \r"
  "1320 PRINT\"YOU HAVE RESTORED MY FAITH IN TEENAGERS.\"\r"
  "1330 PRINT\"FROM THE SAME INFORMATION (PE GRAPH), WOULD YOU SAY THAT THE\"\r"
  "1340 PRINT\"WINTERS ARE [1] COLD, [2] MILD, OR [3] WARM\";\r"
  "1350 INPUT S\r"
  "1360 PRINT \r"
  "1370 IFS=2THEN1450  \r"
  "1380 IFS=3THEN1490  \r"
  "1390 IF S<>1 THEN 1330  \r"
  "1400 IFE<3THEN1520  \r"
  "1410 GOSUB1930 \r"
  "1420 GOTO1530\r"
  "1430 GOSUB1950 \r"
  "1440 GOTO1530\r"
  "1450 IFE=3THEN1520  \r"
  "1460 IFE=4THEN1430  \r"
  "1470 GOSUB1910 \r"
  "1480 GOTO1530\r"
  "1490 IFE=3THEN1410  \r"
  "1500 IFE=4THEN1530  \r"
  "1510 GOTO1470\r"
  "1520 PRINT\"IT WARMS MY HEART TO HEAR YOU SAY THAT. GOOD GOING.\"\r"
  "1530 PRINT \r"
  "1540 PRINT\"WELL, BY NOW YOU MUST HAVE AN INKLING AS TO THE TYPE OF\" \r"
  "1550 PRINT\"CLIMATE WE HAVE HERE. BELOW IS A COMPLETE LISTING OF ALL THE  \r"
  "1560 PRINT\"CLIMATES IN THE WORLD. REFER TO THEM BY THEIR NUMBER ONLY.\" \r"
  "1570 PRINT \r"
  "1580 PRINT \r"
  "1590 PRINT\"NUMBER\",\"NAME OF CLIMATE\"\r"
  "1600 PRINT\"======\",\"===============\"\r"
  "1610 PRINT\"1\",\"TROPICAL RAINFOREST\" \r"
  "1620 PRINT\"2\",\"TROPICAL EAST COAST\" \r"
  "1630 PRINT\"3\",\"TROPICAL MONSOON\"\r"
  "1640 PRINT\"4\",\"TROPICAL SAVANNA\"\r"
  "1650 PRINT\"5\",\"TROPICAL DESERT\" \r"
  "1660 PRINT\"6\",\"MEDITERRANEAN\"  \r"
  "1670 PRINT\"7\",\"MARINE WEST COAST\"  \r"
  "1680 PRINT\"8\",\"HUMID CONTINENTAL\"  \r"
  "1690 PRINT\"9\",\"HUMID SUBTROPICAL\"  \r"
  "1700 PRINT\"10\",\"MIDDLE LATITUDE GRASSLANDS\" \r"
  "1710 PRINT\"11\",\"MIDDLE LATITUDE DESERT\" \r"
  "1720 PRINT\"12\",\"SUBARTIC CLIMATES\" \r"
  "1730 PRINT\"13 OR 14\",\"HIGHLAND CLIMATES\"\r"
  "1740 PRINT\" \",\"(TROPICAL OR MIDDLE LATITUDES)\" \r"
  "1750 PRINT\"15\",\"POLAR TUNDRA\"  \r"
  "1760 PRINT\"16\",\"POLAR ICECAP\"  \r"
  "1770 PRINT \r"
  "1780 PRINT\"WHAT IS THE NUMBER OF THE CLIMATE WE HAVE (WE'LL ACCEPT THE\" \r"
  "1790 PRINT \"FACT THAT THEY MAY OVERLAP)\";  \r"
  "1800 INPUTS \r"
  "1810 PRINT \r"
  "1820 PRINT \r"
  "1830 PRINT \r"
  "1840 IFS=L(Z)THEN1880  \r"
  "1850 PRINT\"MY SUGGESTION - STICK TO LANGUAGES OR SOCIAL STUDIES.\"  \r"
  "1860 PRINT\"YOU SHOULD HAVE SAID\";L(Z);\". GOOD DAY TO YOU.\" \r"
  "1870 STOP  \r"
  "1880 PRINT\"YOUR FORTUNE AS A METEOROLOGIST IS BUDDING. IT WAS\" \r"
  "1890 PRINT\"VERY NICE TO WORK WITH YOU. SO LONG.\"  \r"
  "1900 STOP  \r"
  "1910 B=1 \r"
  "1920 GOTO1960  \r"
  "1930 B=2 \r"
  "1940 GOTO1960  \r"
  "1950 B=3 \r"
  "1960 PRINT\"AW C'MON, YOU COULDN'T POSSIBLY MEAN THAT...\"  \r"
  "1970 PRINT\"YOU SHOULD HAVE SAID\";B \r"
  "1980 PRINT \r"
  "1990 RETURN \r"
  "2000 DATA11,6,16,7,23,10,26,3,27,15 \r"
  "2010 DATA28,8,29,11,32,3,33,13,34,11\r"
  "2020 DATA 35,9,39,16,40,8,41,13,44,5\r"
  "2030 DATA46,10,45,16,50,1,51,12,56,4\r"
  "2040 DATA39,4,44,5,35,9,40,8,45,1,41,15,46,12,51,5,56,16\r"
  "2050 DATA0,0\r"
  "2060 END\r"
  "";

const char basic_cloud_9[] =
  "10 REM--A.C.CAGGIANO+E.A.GALLETTA, PATCHOGUE H.S., 11-20-68 \r"
  "11 REM--REVISED BY CHARLES LOSIK AND TONY PEREZ 7/18/69 \r"
  "12 REM RE-REVISED BY C.LOSIK 8-26-70\r"
  "20 REM--THIS PROGRAM IS ASSOCIATED WITH CLOUD FORMATION \r"
  "25 REM PHASE I OF PROGRAM BEGINS HERE. STUDENTS WILL BE GIVEN\r"
  "26 REM INTRODUCTORY INFORMATION AND BE ALLOWED TO ASK AND ANSWER \r"
  "27 REM ANY NUMBER OF PROBLEMS. WHEN THEY INPUT NO. 2 (LINES 554-556) \r"
  "28 REM PROGRAM SENDS THEM TO PHASE II (LINE 561 AND FOLLOWING). \r"
  "30 PRINT\" \",\"CLOUD NINE\" \r"
  "40 PRINT\" \",\"===== ====\" \r"
  "45 DIM B(2), T(4), Q(3), A(3), C(3) \r"
  "50 PRINT \r"
  "60 PRINT\" STRONG CONVECTION CURRENTS ARE CAUSING ADIABATIC\" \r"
  "70 PRINT\"COOLING OF AIR WHERE YOU ARE AND ARE RESPONSIBLE FOR THE\"\r"
  "80 PRINT\"FORMATION OF A CLOUD. BOTH THE DRY AND THE MOIST ADIABATIC\" \r"
  "90 PRINT\"(AS WELL AS THE NORMAL LAPSE RATES) ARE CONSIDERED IN THIS\" \r"
  "91 PRINT\"PROGRAM.\"\r"
  "100 PRINT \r"
  "105 PRINT \r"
  "110 PRINT\" \",\"LEGEND\" \r"
  "120 PRINT\" \",\"======\" \r"
  "140 PRINT\"1=\"; \r"
  "150 GOSUB1000 \r"
  "160 PRINT\"2=\"; \r"
  "170 GOSUB1010 \r"
  "180 PRINT\"3=\"; \r"
  "190 GOSUB1020 \r"
  "200 PRINT\"4=\"; \r"
  "210 GOSUB1030 \r"
  "220 PRINT \r"
  "225 PRINT \r"
  "230 PRINT\"CHOOSE ANY TWO OF THE ABOVE VARIABLES AND SELECT VALUES FOR\" \r"
  "231 PRINT\"THEM. TYPE THEM IN AS:\" \r"
  "232 PRINT\"VARIABLE CODE ,VALUE, VARIABLE CODE ,VALUE...(E.G. 1,50,2,30)\" \r"
  "233 PRINT \r"
  "240 X=0\r"
  "242 Y=0\r"
  "245 A=0\r"
  "246 B=0\r"
  "247 B(1)=0 \r"
  "248 B(2)=0 \r"
  "250 INPUTB(1),A,B(2),B \r"
  "290 PRINT \r"
  "300 FORI=1TO4 \r"
  "310 IFB(1)=ITHEN330\r"
  "320 NEXTI \r"
  "330 T(I)=A \r"
  "340 FORJ=1TO4 \r"
  "350 IFB(2)=JTHEN370\r"
  "360 NEXTJ \r"
  "370 T(J)=B \r"
  "380 IFI<>JTHEN405 \r"
  "390 PRINT\"YOU CAN'T USE THE SAME VALUES TWICE.\"\r"
  "395 GOTO250\r"
  "405 PRINT\"OKAY, TYPE IN YOUR CALCULATED VALUE FOR\";\r"
  "406 PRINT \r"
  "410 IFJ*I<>2THEN425\r"
  "411 T=(T(1)-T(2))/4.5 \r"
  "412 T(4)=1000*T \r"
  "413 T(3)=T(2)-T \r"
  "414 GOSUB1020 \r"
  "415 GOSUB1050 \r"
  "416 GOSUB1030 \r"
  "417 INPUTX,Y \r"
  "418 IFABS(X-T(3))>=.6THEN500 \r"
  "419 IFABS(Y-T(4))>=.6THEN500 \r"
  "420 GOTO550\r"
  "425 IFJ*I<>3THEN440\r"
  "426 T=(T(1)-T(3))/5.5 \r"
  "427 T(4)=1000*T \r"
  "428 T(2)=T+T(3) \r"
  "429 GOSUB1010 \r"
  "430 GOSUB1050 \r"
  "431 GOSUB1030 \r"
  "432 INPUTX,Y \r"
  "433 IFABS(X-T(2))>=.6THEN500 \r"
  "434 IFABS(Y-T(4))>=.6THEN500 \r"
  "435 GOTO550\r"
  "440 IFJ*I<>4THEN455\r"
  "441 T=T(4)/1000 \r"
  "442 T(2)=T(1)-4.5*T \r"
  "443 T(3)=T(2)-T \r"
  "444 GOSUB1010 \r"
  "445 GOSUB1050 \r"
  "446 GOSUB1020 \r"
  "447 INPUTX,Y \r"
  "448 IFABS(X-T(2))>=.6THEN500 \r"
  "449 IFABS(Y-T(3))>=.6THEN500 \r"
  "450 PRINT\"OKAY, TYPE IN YOUR CALCULATED VALUE FOR\" \r"
  "455 IFJ*I<>6THEN470\r"
  "456 T=T(2)-T(3) \r"
  "457 T(4)=1000*T \r"
  "458 T(1)=T(3)+5.5*T \r"
  "459 GOSUB1000 \r"
  "460 GOSUB1050 \r"
  "461 GOSUB1030 \r"
  "462 INPUTX,Y \r"
  "463 IFABS(X-T(1))>=.6THEN500 \r"
  "464 IFABS(Y-T(4))>=.6THEN500 \r"
  "465 GOTO550\r"
  "470 IFJ*I<>8THEN485\r"
  "471 T=T(4)/1000 \r"
  "472 T(3)=T(2)+T \r"
  "473 T(1)=T(2)+6.5*T \r"
  "474 GOSUB1010 \r"
  "475 GOSUB1050 \r"
  "476 GOSUB1020 \r"
  "477 INPUTX,Y \r"
  "478 IFABS(X-T(1))>=.6THEN500 \r"
  "479 IFABS(Y-T(3))>=.6THEN500 \r"
  "480 GOTO550\r"
  "481 IFABS(X-T(3))>=.6THEN500 \r"
  "485 IFJ*I<>12THEN390 \r"
  "486 T=T(4)/1000 \r"
  "487 T(1)=T(3)+5.5*T \r"
  "488 T(2)=T(3)+T \r"
  "489 GOSUB1000 \r"
  "490 GOSUB1050 \r"
  "491 GOSUB1010 \r"
  "492 INPUTX,Y \r"
  "493 IFABS(X-T(1))>=.6THEN500 \r"
  "494 IFABS(Y-T(2))>=.6THEN500 \r"
  "495 GOTO550\r"
  "500 PRINT \r"
  "502 PRINT\"IT LOOKS LIKE WE GOOFED SOME PLACE.\" \r"
  "505 PRINT\"LET'S SEE WHAT THE CORRECT VALUES ARE.\" \r"
  "507 PRINT \r"
  "510 PRINT T(1);\"DEGREES - \"; \r"
  "512 GO SUB 1000\r"
  "515 PRINT T(2);\"DEGREES - \"; \r"
  "517 GO SUB 1010\r"
  "520 PRINT T(3);\"DEGREES - \"; \r"
  "522 GO SUB 1020\r"
  "525 PRINT T(4);\"FEET - \"; \r"
  "527 GO SUB 1030\r"
  "530 PRINT \r"
  "535 GOTO554\r"
  "550 PRINT \r"
  "552 PRINT\"VERY GOOD. VERY, VERY GOOD.\"\r"
  "553 PRINT \r"
  "554 PRINT\"DO YOU HAVE ANY OTHER PROBLEMS YOU WOULD LIKE TO TRY?\" \r"
  "555 PRINT \"(1=YES, 0=NO) : \"; \r"
  "556 INPUT P\r"
  "557 IFP<1THEN561 \r"
  "558 PRINT \r"
  "559 PRINT\"USING THE SAME LEGEND AS BEFORE...\" \r"
  "560 GOTO230\r"
  "561 H=(T(1)-T(3))*2000-7*T(4) \r"
  "562 REM LINE 561 CALCULATES ALTITUDE FOR TOP OF CLOUD AND BEGINS \r"
  "563 REM PHASE II OF PROGRAM. PROBLEM NO.2 IN THIS PART (CALCULATION \r"
  "564 REM OF TEMP. ABOVE CLOUD TOP) INVOLVES USE OF THE NORMAL LAPSE RATE. \r"
  "565 PRINT \r"
  "567 PRINT\"WELL, BEFORE YOU LEAVE, I HAVE A FEW I'D LIKE YOU TO TRY...\" \r"
  "570 PRINT\"BASED ON YOUR VALUES, THE HEIGHT OF THE CLOUD\" \r"
  "580 PRINT\"(MEASURED FROM THE CLOUD BASE) IS \";H;\"FT. CAN YOU TELL ME:\"\r"
  "600 Q(1)=.7*T(4)\r"
  "601 Q(2)=T(4)+1.5*H \r"
  "602 Q(3)=T(4)+.5*H \r"
  "610 A(1)=T(1)-T(4)*3.85E-03 \r"
  "611 A(2)=T(1)-(T(4)+1.5*H)*3.5E-03 \r"
  "612 A(3)=T(3)-1.5E-03*H \r"
  "614 PRINT \r"
  "615 PRINT\"WHAT IS THE TEMPERATURE AT EACH OF THESE ALTITUDES:\" \r"
  "620 FORN=1TO3 \r"
  "625 PRINT\" \",N;INT(Q(N)+.5);\"FT\" \r"
  "627 NEXT N \r"
  "628 PRINT \r"
  "629 FORN=1TO3 \r"
  "630 PRINT\"THE TEMPERATURE AT \";INT(Q(N)+.5);\" FT. IS \";\r"
  "631 INPUTC(N) \r"
  "635 IFABS(C(N)-A(N))>1.1THEN750\r"
  "640 NEXTN \r"
  "699 PRINT \r"
  "700 PRINT\"WOW, YOU MUST BE A BRAIN. AND YOU PROBALLY KNOW\"\r"
  "710 PRINT\"A LOT ABOUT CLOUDS AND THINGS LIKE THAT. IT WAS VERY\" \r"
  "720 PRINT\"NICE TO WORK WITH SOMEONE WHO UNDERSTANDS ME.\" \r"
  "730 PRINT\" \",\"THANK YOU AND . . . . PEACE AND LONG LIFE\" \r"
  "740 STOP \r"
  "750 PRINT \r"
  "755 PRINT\"SORRY. YOU WERE DOING GREAT THERE FOR A WHILE.\" \r"
  "760 PRINT\"WELL, BACK TO THE BOOKS. THE VALUES YOU SHOULD HAVE ARE:\" \r"
  "765 PRINT \r"
  "770 FORN=1TO3 \r"
  "774 PRINTN;\r"
  "780 PRINT\"THE TEMPERATURE AT\";INT(Q(N)+.5);\"FEET IS \";A(N);\"DEGREES\" \r"
  "790 NEXTN \r"
  "830 STOP \r"
  "1000 PRINT\"THE TEMPERATURE ON THE GROUND\" \r"
  "1005 RETURN \r"
  "1010 PRINT\"THE DEW POINT TEMPERATURE ON THE GROUND\" \r"
  "1015 RETURN \r"
  "1020 PRINT\"THE TEMPERATURE AT THE BASE OF THE CLOUD\"\r"
  "1025 RETURN \r"
  "1030 PRINT\"THE ELEVATION, IN FEET, OF THE CLOUD BASE\" \r"
  "1035 RETURN \r"
  "1050 PRINT\"FOLLOWED BY A COMMA, AND THEN TYPE IN YOUR VALUE FOR \" \r"
  "1055 RETURN \r"
  "2000 END\r"
  "";

const char basic_craps[] =
  "100 REM  NAME--CRAPS\r"
  "110 REM\r"
  "120 REM  DESCRIPTIONS--A SESSION AT THE CRAPS TABLE.\r"
  "130 REM\r"
  "140 REM  SOURCE--UNKNOWN\r"
  "150 REM\r"
  "160 REM  INSTRUCTIONS--TYPE \"RUN\" AND FOLLOW INSTRUCTIONS.\r"
  "170 REM\r"
  "180 REM\r"
  "190 REM  *  *  *  *  *  *   MAIN PROGRAM  *  *  *  *  *  *  *  *  *  *\r"
  "200 REM\r"
  "210 REM  RANDOMIZE - COMMAND NOT IN 4K BASIC\r"
  "220 PRINT\r"
  "230 PRINT \"WELCOME TO THE DIGITAL CRAPS TABLE.\"\r"
  "240 PRINT \"DO YOU WANT INSTRUCTIONS (0=NO  1=YES) \";\r"
  "250 INPUT Z0\r"
  "260 IF Z0=0 THEN 350\r"
  "270 IF Z0=1 THEN 300\r"
  "280 PRINT \"INCORRECT ANSWER.  PLEASE TYPE '1' OR '0'\";\r"
  "290 GOTO 250\r"
  "300  PRINT \" ON THE FIRST THROW 2'S,3'S AND 12'S LOSE, 7'S AND 11'S\"\r"
  "310  PRINT \" WIN.  ON LATER THROWS 7'S AND 11'S LOSE, THE ORIGINAL\"\r"
  "320  PRINT \" NUMBER WINS, AND ANY OTHER RESULT CAUSES ANOTHER THROW.\"\r"
  "330  PRINT \" BETS MAY RANGE FROM .01 TO 10000, TYPE '-1' TO FIND THE\"\r"
  "340  PRINT \" STATE OF YOUR WINNINGS OR LOSSES, AND A '0' TO QUIT.\"\r"
  "350  PRINT\r"
  "360  PRINT\r"
  "370 PRINT\r"
  "380 PRINT \" HOW MUCH DO YOU BET\";\r"
  "390 INPUT B1\r"
  "400 IF B1<0 THEN 840\r"
  "410 IF B1=0 THEN 960\r"
  "420 IF B1<5 THEN 940\r"
  "430 IF B1>10000 THEN 820\r"
  "440 LET T7=0\r"
  "450 LET D1=INT(6*RND(1))+1\r"
  "460 LET D2=INT(6*RND(1))+1\r"
  "470 PRINT D1;D2;\r"
  "480 LET T=D1+D2\r"
  "490 IF T7>0 THEN 520\r"
  "500 IF T=12 THEN 750\r"
  "510 IF T=2 THEN 770\r"
  "520 IF T=8 THEN 560\r"
  "530 IF T=11 THEN 560\r"
  "540 PRINT \" A\";T;\r"
  "550 GOTO 570\r"
  "560 PRINT \" AN\";T;\r"
  "570 IF T7>0 THEN 630\r"
  "580 IF T=3 THEN 780\r"
  "590 IF T=7 THEN 710\r"
  "600 IF T=11 THEN 710\r"
  "610 LET D9=T\r"
  "620 GOTO 680\r"
  "630 IF T=7 THEN 780\r"
  "640 IF T=11 THEN 780\r"
  "650 IF T=D9 THEN 710\r"
  "660 PRINT\r"
  "670 GOTO 450\r"
  "680 PRINT \" YOUR NUMBER IS \" T\r"
  "690 LET T7=1\r"
  "700 GOTO 450\r"
  "710 PRINT \" YOU WIN\"\r"
  "720 LET W=W+B1\r"
  "730 PRINT \" YOU WIN\" B1;\"DOLLARS\"\r"
  "740 GOTO 370\r"
  "750 PRINT \" BOXCARS.....\";\r"
  "760 GOTO 780\r"
  "770 PRINT \" SNAKES EYES.....\";\r"
  "780 LET W=W-B1\r"
  "790 PRINT \" YOU LOSE\"\r"
  "800 PRINT \" YOU LOSE\" B1; \"DOLLARS\"\r"
  "810 GOTO 370\r"
  "820 PRINT \" ARE YOU KIDDING ME? TRY A LITTLE LESS\"\r"
  "830 GOTO 370\r"
  "840 PRINT\r"
  "850 IF W>=0 THEN 920\r"
  "860 PRINT\" YOU ARE BEHIND\";-W;\"DOLLARS--TRY SOME MORE (1=YES  0=NO) \";\r"
  "870 INPUT H0\r"
  "880 IF H0=0 THEN 960\r"
  "890 IF H0=1 THEN 370\r"
  "900 PRINT\"INCORRECT ANSWER. PLEASE TYPE '1' OR '0'\";\r"
  "910 GOTO 870\r"
  "920 PRINT \" YOU ARE AHEAD\"W;\" DOLLARS--HOW ABOUT A LITTLE MORE\";\r"
  "930 GOTO 870\r"
  "940 PRINT \" YOU ARE A CHEAPSKATE--BUT I'LL PLAY\"\r"
  "950 GOTO 440\r"
  "960 PRINT\r"
  "970 PRINT\r"
  "980 PRINT\r"
  "990 PRINT\r"
  "1000 IF W>=0 THEN 1040\r"
  "1010 PRINT\"  YOU LOST\";-W;\"DOLLARS./. TOUGH LIFE\"\r"
  "1020 PRINT \" LET THIS BE A LESSON\"\r"
  "1030 STOP\r"
  "1040 PRINT \" YOU WON \" W; \"DOLLARS...WILL SEND CHECK IMMEDIATELY\"\r"
  "1050 END\r"
  "";

const char basic_crazy_8[] =
  "100  REM SOURCE UNKNOWN:  REVISED BY D. KURLAND  11/16/75 \r"
  "110 PRINT \"THIS IS THE GAME OF CRAZY EIGHTS\" \r"
  "120 DIM A(52),D(52),G(52),H(52) \r"
  "130 DIM T(52),S(52),V(52)   \r"
  "140 DIM Z(52),U$(4),C$(13)  \r"
  "150 READ U$(1),U$(2),U$(3),U$(4)\r"
  "160 FOR I=1 TO 13   \r"
  "170 READ C$(I)  \r"
  "180 NEXT I  \r"
  "190 FOR I=1 TO 52   \r"
  "200 READ Z(I)   \r"
  "210 NEXT I  \r"
  "220 DATA CLUBS,DIAMONDS,HEARTS,SPADES   \r"
  "230 DATA \"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",JACK,QUEEN,KING,ACE   \r"
  "240 DATA 2,3,4,5,6,7,50,9,10,10,10,10,1 \r"
  "250 DATA 2,3,4,5,6,7,50,9,10,10,10,10,1 \r"
  "260 DATA 2,3,4,5,6,7,50,9,10,10,10,10,1 \r"
  "270 DATA 2,3,4,5,6,7,50,9,10,10,10,10,1 \r"
  "280 PRINT \"DO YOU KNOW HOW TO PLAY\";\r"
  "290 INPUT A$\r"
  "300 IF A$=\"YES\" OR A$=\"Y\" THEN 400  \r"
  "310 PRINT \"WHEN ASKED WHICH CARD YOU WISH TO PLAY, YOUR ANSWER SHOULD\"  \r"
  "320 PRINT \"OF THE FORM:  CARD,SUIT  .  ANY EIGHT MAY BE\"\r"
  "330 PRINT \"PLAYED AT ANY TIME REGARDLESS OF SUIT TO CHANGE THE SUIT.\"   \r"
  "340 PRINT \"IF YOU ARE UNABLE OR UNWILLING TO PLAY, YOU WILL BE GIVEN\"   \r"
  "350 PRINT \"ANOTHER CARD FROM THE DRAW STACK.  IF ALL CARDS HAVE BEEN\"   \r"
  "360 PRINT \"DRAWN, ANY PERSON WHO IS ABLE TO PLAY MUST DO SO.\"   \r"
  "370 PRINT \"AT THE END OF THE GAME, THE PERSON HOLDING CARDS HAS POINTS\" \r"
  "380 PRINT \"SCORED AGAINST HIM AS FOLLOWS:  EIGHTS=50, ACE=1, FACE\"  \r"
  "390 PRINT \"CARD=10, INDEX VALUE FOR EACH OTHER CARD.\"   \r"
  "400 PRINT : PRINT \"GAME WILL START SHORTLY...\"\r"
  "410 L=0 : FOR I=1 TO 4\r"
  "420 FOR J=1 TO 13   \r"
  "430 L=L+1   \r"
  "440 S(L)=I  \r"
  "450 V(L)=J  \r"
  "460 NEXT J  \r"
  "470 NEXT I  \r"
  "480 N1=0\r"
  "490 N2=0\r"
  "500 N3=0\r"
  "510 S1=0\r"
  "520 S2=0\r"
  "530 FOR I=1 TO 52   \r"
  "540 G(I)=0  \r"
  "550 H(I)=0  \r"
  "560 A(I)=RND(1) \r"
  "570 NEXT I  \r"
  "580 W1=0\r"
  "590 B1=0\r"
  "600 P1=1\r"
  "610 P2=1\r"
  "620 J=0 \r"
  "630 M1=99999!\r"
  "640 FOR I=1 TO 52   \r"
  "650 IF A(I)>=M1 THEN 680\r"
  "660 M1=A(I) \r"
  "670 I1=I\r"
  "680 NEXT I  \r"
  "690 J=J+1   \r"
  "700 D(J)=I1 \r"
  "710 A(I1)=99999! \r"
  "720 IF J<52 THEN 630\r"
  "730 FOR I=1 TO 7\r"
  "740 G(D(52-2*I+2))=1\r"
  "750 H(D(52-2*I+1))=1\r"
  "760 NEXT I  \r"
  "770 T(1)=D(38)  \r"
  "780 T1=1\r"
  "790 P=S(T(1))   \r"
  "800 H1=7\r"
  "810 H2=7\r"
  "820 D1=37   \r"
  "830 GOSUB 1390  \r"
  "840 GOSUB 1510  \r"
  "850 IF W1=1 THEN 910\r"
  "860 IF B1=1 THEN 910\r"
  "870 GOSUB 2020  \r"
  "880 IF W1=1 THEN 910\r"
  "890 IF B1=1 THEN 910\r"
  "900 GOTO 830\r"
  "910 GOSUB 1140  \r"
  "920 PRINT \"YOUR SCORE IS\";C1\r"
  "930 PRINT \"MY SCORE IS\";C2  \r"
  "940 IF C2>=C1 THEN 980  \r"
  "950 PRINT \"YOU WON THAT HAND.\"  \r"
  "960 N1=N1+1 \r"
  "970 GOTO 1000\r"
  "980 PRINT \"I WON THAT HAND.\"\r"
  "990 N2=N2+1 \r"
  "1000 PRINT   \r"
  "1010 N3=N3+1 \r"
  "1020 PRINT \"DO YOU WISH TO PLAY AGAIN\";  \r"
  "1030 INPUT A$\r"
  "1040 IF A$=\"YES\" OR A$=\"Y\" THEN 530  \r"
  "1050 PRINT   \r"
  "1060 PRINT \"OUT OF\";N3;\"HANDS YOU WON\";N1\r"
  "1070 PRINT \"YOUR TOTAL SCORE IS\";S1;\": MINE IS\";S2;\".\"   \r"
  "1080 IF S1<=S2 THEN1110   \r"
  "1090 PRINT \"LOOKS LIKE YOU'RE HIGH SCORER.\"  \r"
  "1100 GOTO 1120\r"
  "1110 PRINT \"LOOKS LIKE I AM THE HIGH SCORER.\"\r"
  "1120 PRINT \"BYE.\"\r"
  "1130 STOP   \r"
  "1140 C1=0   \r"
  "1150 C2=0   \r"
  "1160 IF H2=0 THEN 1240  \r"
  "1170 PRINT  \r"
  "1180 PRINT \"CARDS LEFT IN MY HAND\"  \r"
  "1190 FOR I=1 TO 52  \r"
  "1200 IF H(I)=0 THEN 1230\r"
  "1210 PRINT C$(V(I));TAB(6);\"OF \";U$(S(I))   \r"
  "1220 C1=C1+Z(I) \r"
  "1230 NEXT I \r"
  "1240 IF H1=0 THEN 1360  \r"
  "1250 FOR I=1 TO 52  \r"
  "1260 IF G(I)=0 THEN 1280\r"
  "1270 C2=C2+Z(I) \r"
  "1280 NEXT I \r"
  "1290 IF C1=0 THEN 1360  \r"
  "1300 IF C1>=C2 THEN 1340\r"
  "1310 C2=C2-C1   \r"
  "1320 C1=0   \r"
  "1330 GOTO 1360  \r"
  "1340 C1=C1-C2   \r"
  "1350 C2=0   \r"
  "1360 S1=S1+C1   \r"
  "1370 S2=S2+C2   \r"
  "1380 RETURN \r"
  "1390 PRINT  \r"
  "1400 PRINT \"YOUR HAND IS\"   \r"
  "1410 FOR I=1 TO 52  \r"
  "1420 IF G(I)=0 THEN 1440\r"
  "1430 PRINT C$(V(I));TAB(6);\"OF \";U$(S(I))   \r"
  "1440 NEXT I \r"
  "1450 PRINT  \r"
  "1460 PRINT \"THE LAST CARD PLAYED WAS THE \"; \r"
  "1470 PRINT C$(V(T(T1)));\" OF \";U$(S(T(T1))) \r"
  "1480 IF V(T(T1))<>7 THEN 1500   \r"
  "1490 PRINT \"THE SUIT CALLED FOR IS \";U$(P)  \r"
  "1500 RETURN \r"
  "1510 PRINT \"DO YOU WISH TO PLAY A CARD\";\r"
  "1520 INPUT A$   \r"
  "1530 AZ$=LEFT$(A$,1)\r"
  "1531 IF AZ$<>\"Y\" AND AZ$<>\"N\" THEN PRINT \"(Y OR N) PLEASE ! \"; : GOTO 1520\r"
  "1540 IF D1<>0 THEN 1570 \r"
  "1550 PRINT \"ALL THE CARDS HAVE BEEN DEALT---YOU ARE BLOCKED\"\r"
  "1560 GOTO 1980  \r"
  "1570 I=D(D1)\r"
  "1580 D1=D1-1\r"
  "1590 H1=H1+1\r"
  "1600 G(I)=1 \r"
  "1610 PRINT \"YOUR NEW CARD IS THE \";C$(V(I));\" OF \";U$(S(I)) \r"
  "1620 GOTO 1510  \r"
  "1630 PRINT \"WHICH OF YOUR CARDS DO YOU WISH TO PLAY\";   \r"
  "1640 INPUT X$,Y$\r"
  "1650 GOSUB 2610 \r"
  "1660 IF V9>0 THEN 1680 ELSE PRINT \"UNKNOWN CARD, TRY AGAIN\";\r"
  "1670 GOTO 1640 \r"
  "1680 GOSUB 2500 \r"
  "1690 IF S9>0 THEN 1710 ELSE PRINT \"UNKNOWN SUIT, TRY AGAIN\";\r"
  "1700 GOTO 1640 \r"
  "1710 IF V9=7 THEN 1760  \r"
  "1720 IF S9=P THEN 1760  \r"
  "1730 IF V9=V(T(T1)) THEN 1760   \r"
  "1740 PRINT \"THAT IS NOT A LEGAL PLAY.\"  \r"
  "1750 GOTO 1510  \r"
  "1760 FOR I=1 TO 52  \r"
  "1770 IF G(I)=0 THEN 1800\r"
  "1780 IF V(I)<>V9 THEN 1800  \r"
  "1790 IF S(I)=S9 THEN 1830   \r"
  "1800 NEXT I \r"
  "1810 PRINT \"YOU DO NOT HAVE THAT CARD.\" \r"
  "1820 GOTO 1510  \r"
  "1830 G(I)=0 \r"
  "1840 H1=H1-1\r"
  "1850 T1=T1+1\r"
  "1860 T(T1)=I\r"
  "1870 IF V9<>7 THEN 1930 \r"
  "1880 PRINT \"WHAT SUIT DO YOU WISH\"; \r"
  "1890 INPUT Y$   \r"
  "1900 GOSUB 2500 \r"
  "1910 IF S9>0 THEN 1930 ELSE PRINT \"UNKNOWN SUIT, TRY AGAIN\";\r"
  "1920 GOTO 1890 \r"
  "1930 P=S9   \r"
  "1940 P1=1   \r"
  "1950 IF H1<>0 THEN 1970 \r"
  "1960 W1=1   \r"
  "1970 RETURN \r"
  "1980 IF P2<>0 THEN 2000 \r"
  "1990 B1=1   \r"
  "2000 P1=0   \r"
  "2010 RETURN \r"
  "2020 I=53   \r"
  "2030 I=I-1  \r"
  "2040 IF H(I)=0 THEN 2080\r"
  "2050 IF V(I)=7 THEN 2080\r"
  "2060 IF S(I)=P THEN 2220\r"
  "2070 IF V(I)=V(T(T1)) THEN 2220 \r"
  "2080 IF I>1 THEN 2030   \r"
  "2090 FOR I=1 TO 52  \r"
  "2100 IF V(I)<>7 THEN 2120   \r"
  "2110 IF H(I)<>0 THEN 2220   \r"
  "2120 NEXT I \r"
  "2130 IF D1=0 THEN 2460  \r"
  "2140 I=D(D1)\r"
  "2150 D1=D1-1\r"
  "2160 IF V(I)=7 THEN 2240\r"
  "2170 IF S(I)=P THEN 2240\r"
  "2180 IF V(I)=V(T(T1)) THEN 2240 \r"
  "2190  H2=H2+1   \r"
  "2200 H(I)=1 \r"
  "2210 GOTO 2130  \r"
  "2220 H(I)=0 \r"
  "2230 H2=H2-1\r"
  "2240 T1=T1+1\r"
  "2250 T(T1)=I\r"
  "2260 P=S(I) \r"
  "2270 IF V(I)<>7 THEN 2420   \r"
  "2280 FOR J=1 TO 4   \r"
  "2290 Y(J)=0 \r"
  "2300 K1=13*(J-1)+1  \r"
  "2310 K2=13*J\r"
  "2320 FOR K=K1 TO K2 \r"
  "2330 IF H(I)=0 THEN 2350\r"
  "2340 Y(J)=Y(J)+1\r"
  "2350 NEXT K \r"
  "2360 NEXT J \r"
  "2370 P=1\r"
  "2380 FOR J=2 TO 4   \r"
  "2390 IF Y(J)<=Y(P) THEN 2410\r"
  "2400 P=J\r"
  "2410 NEXT J \r"
  "2420 P2=1   \r"
  "2430 IF H2<>0 THEN 2450 \r"
  "2440 W1=1   \r"
  "2450 RETURN \r"
  "2460 IF P1<>0 THEN 2480 \r"
  "2470 B1=1   \r"
  "2480 P2=0   \r"
  "2490 RETURN \r"
  "2500 FOR I0 = 1 TO 4\r"
  "2510 IF Y$=U$(I0) THEN 2590 \r"
  "2520 NEXT I0\r"
  "2530 S9 = 0 \r"
  "2540 IF Y$=\"C\" THEN S9=1\r"
  "2550 IF Y$=\"D\" THEN S9=2\r"
  "2560 IF Y$=\"H\" THEN S9=3\r"
  "2570 IF Y$=\"S\" THEN S9=4\r"
  "2580 RETURN \r"
  "2590 S9 = I0\r"
  "2600 RETURN \r"
  "2610 FOR I0 = 1 TO 13   \r"
  "2620 IF X$=C$(I0) THEN 2700 \r"
  "2630 NEXT I0\r"
  "2640 V9 = 0 \r"
  "2650 IF X$=\"J\" THEN V9=10   \r"
  "2660 IF X$=\"Q\" THEN V9=11   \r"
  "2670 IF X$=\"K\" THEN V9=12   \r"
  "2680 IF X$=\"A\" THEN V9=13   \r"
  "2690 RETURN \r"
  "2700 V9 = I0\r"
  "2710 RETURN \r"
  "2720 END\r"
  "";

const char basic_cube[] =
  "10 PRINT TAB(34);\"CUBE\"\r"
  "20 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "30 PRINT : PRINT : PRINT\r"
  "100 PRINT \"DO YOU WANT TO SEE THE INSTRUCTIONS? (YES--1,NO--0)\"\r"
  "110 INPUT B7\r"
  "120 IF B7=0 THEN 370\r"
  "130 PRINT\"THIS IS A GAME IN WHICH YOU WILL BE PLAYING AGAINST THE\"\r"
  "140 PRINT\"RANDOM DECISION OF THE COMPUTER. THE FIELD OF PLAY IS A\"\r"
  "150 PRINT\"CUBE OF SIDE 3. ANY OF THE 27 LOCATIONS CAN BE DESIGNATED\"\r"
  "160 PRINT\"BY INPUTING THREE NUMBERS SUCH AS 2,3,1. AT THE START,\"\r"
  "170 PRINT\"YOU ARE AUTOMATICALLY AT LOCATION 1,1,1. THE OBJECT OF\"\r"
  "180 PRINT\"THE GAME IS TO GET TO LOCATION 3,3,3. ONE MINOR DETAIL:\"\r"
  "190 PRINT\"THE COMPUTER WILL PICK, AT RANDOM, 5 LOCATIONS AT WHICH\"\r"
  "200 PRINT\"IT WILL PLANT LAND MINES. IF YOU HIT ONE OF THESE LOCATIONS\"\r"
  "210 PRINT\"YOU LOSE. ONE OTHER DETAIL: YOU MAY MOVE ONLY ONE SPACE \"\r"
  "220 PRINT\"IN ONE DIRECTION EACH MOVE. FOR  EXAMPLE: FROM 1,1,2 YOU\"\r"
  "230 PRINT\"MAY MOVE TO 2,1,2 OR 1,1,3. YOU MAY NOT CHANGE\"\r"
  "240 PRINT\"TWO OF THE NUMBERS ON THE SAME MOVE. IF YOU MAKE AN ILLEGAL\"\r"
  "250 PRINT\"MOVE, YOU LOSE AND THE COMPUTER TAKES THE MONEY YOU MAY\"\r"
  "260 PRINT\"HAVE BET ON THAT ROUND.\"\r"
  "270 PRINT\r"
  "280 PRINT\r"
  "290 PRINT\"ALL YES OR NO QUESTIONS WILL BE ANSWERED BY A 1 FOR YES\"\r"
  "300 PRINT\"OR A 0 (ZERO) FOR NO.\"\r"
  "310 PRINT\r"
  "320 PRINT\"WHEN STATING THE AMOUNT OF A WAGER, PRINT ONLY THE NUMBER\"\r"
  "330 PRINT\"OF DOLLARS (EXAMPLE: 250)  YOU ARE AUTOMATICALLY STARTED WITH\"\r"
  "340 PRINT\"500 DOLLARS IN YOUR ACCOUNT.\"\r"
  "350 PRINT\r"
  "360 PRINT \"GOOD LUCK!\"\r"
  "370 LET A1=500\r"
  "380 LET A=INT(3*(RND(X)))\r"
  "390 IF A<>0 THEN 410\r"
  "400 LET A=3\r"
  "410 LET B=INT(3*(RND(X)))\r"
  "420 IF B<>0 THEN 440\r"
  "430 LET B=2\r"
  "440 LET C=INT(3*(RND(X)))\r"
  "450 IF C<>0 THEN 470\r"
  "460 LET C=3\r"
  "470 LET D=INT(3*(RND(X)))\r"
  "480 IF D<>0 THEN 500\r"
  "490 LET D=1\r"
  "500 LET E=INT(3*(RND(X)))\r"
  "510 IF E<>0 THEN 530\r"
  "520 LET E=3\r"
  "530 LET F=INT(3*(RND(X)))\r"
  "540 IF F<>0 THEN 560\r"
  "550 LET F=3\r"
  "560 LET G=INT(3*(RND(X)))\r"
  "570 IF G<>0 THEN 590\r"
  "580 LET G=3\r"
  "590 LET H=INT(3*(RND(X)))\r"
  "600 IF H<>0 THEN 620\r"
  "610 LET H=3\r"
  "620 LET I=INT(3*(RND(X)))\r"
  "630 IF I<>0 THEN 650\r"
  "640 LET I=2\r"
  "650 LET J=INT(3*(RND(X)))\r"
  "660 IF J<>0 THEN 680\r"
  "670 LET J=3\r"
  "680 LET K=INT(3*(RND(X)))\r"
  "690 IF K<>0 THEN 710\r"
  "700 LET K=2\r"
  "710 LET L=INT(3*(RND(X)))\r"
  "720 IF L<>0 THEN 740\r"
  "730 LET L=3\r"
  "740 LET M=INT(3*(RND(X)))\r"
  "750 IF M<>0 THEN 770\r"
  "760 LET M=3\r"
  "770 LET N=INT(3*(RND(X)))\r"
  "780 IF N<>0 THEN 800\r"
  "790 LET N=1\r"
  "800 LET O=INT (3*(RND(X)))\r"
  "810 IF O <>0 THEN 830\r"
  "820 LET O=3\r"
  "830 PRINT \"WANT TO MAKE A WAGER?\"\r"
  "840 INPUT Z\r"
  "850 IF Z=0 THEN 920\r"
  "860 PRINT \"HOW MUCH \";\r"
  "870 INPUT Z1\r"
  "876 IF A1<Z1 THEN 1522\r"
  "880 LET W=1\r"
  "890 LET X=1\r"
  "900 LET Y=1\r"
  "910 PRINT\r"
  "920 PRINT \"IT'S YOUR MOVE:  \";\r"
  "930 INPUT P,Q,R\r"
  "940 IF P>W+1 THEN 1030\r"
  "950 IF P=W+1 THEN 1000\r"
  "960 IF Q>X+1 THEN 1030\r"
  "970 IF Q=(X+1) THEN 1010\r"
  "980 IF R >(Y+1)  THEN 1030\r"
  "990 GOTO 1050\r"
  "1000 IF Q>= X+1 THEN 1030\r"
  "1010 IF R>=Y+1 THEN 1030\r"
  "1020 GOTO 1050\r"
  "1030 PRINT:PRINT \"ILLEGAL MOVE. YOU LOSE.\"\r"
  "1040 GOTO 1440\r"
  "1050 LET W=P\r"
  "1060 LET X=Q\r"
  "1070 LET Y=R\r"
  "1080 IF P=3 THEN 1100\r"
  "1090 GOTO 1130\r"
  "1100 IF  Q=3 THEN 1120\r"
  "1110 GOTO 1130\r"
  "1120 IF R=3 THEN 1530\r"
  "1130 IF P=A THEN 1150\r"
  "1140 GOTO 1180\r"
  "1150 IF Q=B THEN 1170\r"
  "1160 GOTO 1180\r"
  "1170 IF R=C THEN 1400\r"
  "1180 IF P=D THEN 1200\r"
  "1190 GOTO 1230\r"
  "1200 IF Q=E THEN 1220\r"
  "1210 GOTO 1230\r"
  "1220 IF  R=F THEN 1400\r"
  "1230 IF P=G THEN 1250\r"
  "1240 GOTO 1280\r"
  "1250 IF Q=H THEN 1270\r"
  "1260 GOTO 1280\r"
  "1270 IF R=I THEN 1400\r"
  "1280 IF P=J THEN 1300\r"
  "1290 GOTO 1330\r"
  "1300 IF Q=K THEN 1320\r"
  "1310 GOTO 1330\r"
  "1320 IF R=L THEN 1440\r"
  "1330 IF P=M THEN 1350\r"
  "1340 GOTO 1380\r"
  "1350 IF Q=N THEN 1370\r"
  "1360 GOTO 1380\r"
  "1370 IF R=O THEN 1400\r"
  "1380 PRINT \"NEXT MOVE: \";\r"
  "1390 GOTO 930 \r"
  "1400 PRINT\"******BANG******\"\r"
  "1410 PRINT \"YOU LOSE!\"\r"
  "1420 PRINT\r"
  "1430 PRINT\r"
  "1440 IF   Z=0 THEN 1580\r"
  "1450 PRINT \r"
  "1460 LET Z2=A1-Z1\r"
  "1470 IF Z2>0 THEN 1500\r"
  "1480 PRINT \"YOU BUST.\"\r"
  "1490 GOTO 1610\r"
  "1500 PRINT \" YOU NOW HAVE\"; Z2; \"DOLLARS.\"\r"
  "1510 LET A1=Z2\r"
  "1520 GOTO 1580\r"
  "1522 PRINT\"TRIED TO FOOL ME; BET AGAIN\";\r"
  "1525 GOTO 870\r"
  "1530 PRINT\"CONGRATULATIONS!\"\r"
  "1540 IF Z=0 THEN 1580\r"
  "1550 LET Z2=A1+Z1\r"
  "1560 PRINT \"YOU NOW HAVE\"; Z2;\"DOLLARS.\"\r"
  "1570 LET A1=Z2\r"
  "1580 PRINT\"DO YOU WANT TO TRY AGAIN \";\r"
  "1590 INPUT S\r"
  "1600 IF S=1 THEN 380\r"
  "1610 PRINT \"TOUGH LUCK!\"\r"
  "1620 PRINT\r"
  "1630 PRINT \"GOODBYE.\"\r"
  "1640 END\r"
  "";

const char basic_evenwin[] =
  "1 PRINT TAB(31);\"EVEN WINS\"\r"
  "2 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "3 PRINT:PRINT\r"
  "4 Y1=0\r"
  "10 M1=0\r"
  "20 DIM M(20),Y(20)\r"
  "30 PRINT \"     THIS IS A TWO PERSON GAME CALLED 'EVEN WINS.'\"\r"
  "40 PRINT \"TO PLAY THE GAME, THE PLAYERS NEED 27 MARBLES OR\"\r"
  "50 PRINT \"OTHER OBJECTS ON A TABLE.\"\r"
  "60 PRINT\r"
  "70 PRINT \r"
  "80 PRINT \"     THE 2 PLAYERS ALTERNATE TURNS, WITH EACH PLAYER\"\r"
  "90 PRINT \"REMOVING FROM 1 TO 4 MARBLES ON EACH MOVE.  THE GAME\"\r"
  "100 PRINT \"ENDS WHEN THERE ARE NO MARBLES LEFT, AND THE WINNER\"\r"
  "110 PRINT \"IS THE ONE WITH AN EVEN NUMBER OF MARBLES.\"\r"
  "120 PRINT\r"
  "130 PRINT\r"
  "140 PRINT \"     THE ONLY RULES ARE THAT (1) YOU MUST ALTERNATE TURNS,\"\r"
  "150 PRINT \"(2) YOU MUST TAKE BETWEEN 1 AND 4 MARBLES EACH TURN,\"\r"
  "160 PRINT \"AND (3) YOU CANNOT SKIP A TURN.\"\r"
  "170 PRINT\r"
  "180 PRINT\r"
  "190 PRINT\r"
  "200 PRINT \"     TYPE A '1' IF YOU WANT TO GO FIRST, AND TYPE\"\r"
  "210 PRINT \"A '0' IF YOU WANT ME TO GO FIRST.\"\r"
  "220 INPUT C\r"
  "225 PRINT\r"
  "230 IF C=0 THEN 250\r"
  "240 GOTO 1060\r"
  "250 T=27\r"
  "260 M=2\r"
  "270 PRINT:PRINT \"TOTAL=\";T:PRINT\r"
  "280 M1=M1+M\r"
  "290 T=T-M\r"
  "300 PRINT \"I PICK UP\";M;\"MARBLES.\"\r"
  "310 IF T=0 THEN 880\r"
  "320 PRINT:PRINT \"TOTAL=\";T\r"
  "330 PRINT\r"
  "340 PRINT \"     AND WHAT IS YOUR NEXT MOVE, MY TOTAL IS\";M1\r"
  "350 INPUT Y\r"
  "360 PRINT\r"
  "370 IF Y<1 THEN 1160\r"
  "380 IF Y>4 THEN 1160\r"
  "390 IF Y<=T THEN 430\r"
  "400 PRINT \"     YOU HAVE TRIED TO TAKE MORE MARBLES THAN THERE ARE\"\r"
  "410 PRINT \"LEFT.  TRY AGAIN.\"\r"
  "420 GOTO 350\r"
  "430 Y1=Y1+Y\r"
  "440 T=T-Y\r"
  "450 IF T=0 THEN 880\r"
  "460 PRINT \"TOTAL=\";T\r"
  "470 PRINT\r"
  "480 PRINT \"YOUR TOTAL IS\";Y1\r"
  "490 IF T<.5 THEN 880\r"
  "500 R=T-6*INT(T/6)\r"
  "510 IF INT(Y1/2)=Y1/2 THEN 700\r"
  "520 IF T<4.2 THEN 580\r"
  "530 IF R>3.4 THEN 620\r"
  "540 M=R+1\r"
  "550 M1=M1+M\r"
  "560 T=T-M\r"
  "570 GOTO 300\r"
  "580 M=T\r"
  "590 T=T-M\r"
  "600 GOTO 830\r"
  "610 REM     250 IS WHERE I WIN.\r"
  "620 IF R<4.7 THEN 660\r"
  "630 IF R>3.5 THEN 660\r"
  "640 M=1\r"
  "650 GOTO 670\r"
  "660 M=4\r"
  "670 T=T-M\r"
  "680 M1=M1+M\r"
  "690 GOTO 300\r"
  "700 REM     I AM READY TO ENCODE THE STRAT FOR WHEN OPP TOT IS EVEN\r"
  "710 IF R<1.5 THEN 1020\r"
  "720 IF R>5.3 THEN 1020\r"
  "730 M=R-1\r"
  "740 M1=M1+M\r"
  "750 T=T-M\r"
  "760 IF T<.2 THEN 790\r"
  "770 REM     IS # ZERO HERE\r"
  "780 GOTO 300\r"
  "790 REM     IS = ZERO HERE\r"
  "800 PRINT \"I PICK UP\";M;\"MARBLES.\"\r"
  "810 PRINT\r"
  "820 GOTO 880\r"
  "830 REM    THIS IS WHERE I WIN\r"
  "840 PRINT \"I PICK UP\";M;\"MARBLES.\"\r"
  "850 PRINT\r"
  "860 PRINT \"TOTAL = 0\"\r"
  "870 M1=M1+M\r"
  "880 PRINT \"THAT IS ALL OF THE MARBLES.\"\r"
  "890 PRINT\r"
  "900 PRINT \" MY TOTAL IS\";M1;\", YOUR TOTAL IS\";Y1\r"
  "910 PRINT\r"
  "920 IF INT(M1/2)=M1/2 THEN 950\r"
  "930 PRINT \"     YOU WON.  DO YOU WANT TO PLAY\"\r"
  "940 GOTO 960\r"
  "950 PRINT \"     I WON.  DO YOU WANT TO PLAY\"\r"
  "960 PRINT \"AGAIN?  TYPE 1 FOR YES AND 0 FOR NO.\"\r"
  "970 INPUT A1\r"
  "980 IF A1=0 THEN 1030\r"
  "990 M1=0\r"
  "1000 Y1=0\r"
  "1010 GOTO 200\r"
  "1020 GOTO 640\r"
  "1030 PRINT\r"
  "1040 PRINT \"OK.  SEE YOU LATER.\"\r"
  "1050 GOTO 1230\r"
  "1060 T=27\r"
  "1070 PRINT\r"
  "1080 PRINT\r"
  "1090 PRINT\r"
  "1100 PRINT \"TOTAL=\";T\r"
  "1110 PRINT\r"
  "1120 PRINT\r"
  "1130 PRINT \"WHAT IS YOUR FIRST MOVE\";\r"
  "1140 INPUT Y\r"
  "1150 GOTO 360\r"
  "1160 PRINT\r"
  "1170 PRINT \"THE NUMBER OF MARBLES YOU TAKE MUST BE A POSITIVE\"\r"
  "1180 PRINT \"INTEGER BETWEEN 1 AND 4.\"\r"
  "1190 PRINT\r"
  "1200 PRINT \"     WHAT IS YOUR NEXT MOVE?\"\r"
  "1210 PRINT\r"
  "1220 GOTO 350\r"
  "1230 END\r"
  "";

const char basic_flipflop[] =
  "2 PRINT TAB(32);\"FLIPFLOP\"\r"
  "4 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "6 PRINT\r"
  "10 REM *** CREATED BY MICHAEL CASS\r"
  "15 DIM A$(20)\r"
  "20 PRINT \"THE OBJECT OF THIS PUZZLE IS TO CHANGE THIS:\"\r"
  "30 PRINT\r"
  "40 PRINT \"X X X X X X X X X X\"\r"
  "50 PRINT\r"
  "60 PRINT \"TO THIS:\"\r"
  "70 PRINT\r"
  "80 PRINT \"O O O O O O O O O O\"\r"
  "90 PRINT\r"
  "100 PRINT \"BY TYPING THE NUMBER CORRESPONDING TO THE POSITION OF THE\"\r"
  "110 PRINT \"LETTER ON SOME NUMBERS, ONE POSITION WILL CHANGE, ON\"\r"
  "120 PRINT \"OTHERS, TWO WILL CHANGE.  TO RESET LINE TO ALL X'S, TYPE 0\"\r"
  "130 PRINT \"(ZERO) AND TO START OVER IN THE MIDDLE OF A GAME, TYPE \"\r"
  "140 PRINT \"11 (ELEVEN).\"\r"
  "170 PRINT\r"
  "180 REM\r"
  "190 Q=RND(1)\r"
  "200 PRINT \"HERE IS THE STARTING LINE OF X'S.\"\r"
  "210 PRINT\r"
  "220 C=0\r"
  "230 PRINT \"1 2 3 4 5 6 7 8 9 10\"\r"
  "240 PRINT \"X X X X X X X X X X\"\r"
  "250 PRINT\r"
  "260 REM\r"
  "270 FOR X=1 TO 10\r"
  "280 A$(X)=\"X\"\r"
  "290 NEXT X\r"
  "300 GOTO 320\r"
  "310 PRINT \"ILLEGAL ENTRY--TRY AGAIN.\"\r"
  "320 PRINT \"INPUT THE NUMBER\";\r"
  "330 INPUT N\r"
  "340 IF N<>INT(N) THEN 310\r"
  "350 IF N=11 THEN 180\r"
  "360 IF N>11 THEN 310\r"
  "370 IF N=0 THEN 230\r"
  "380 IF M=N THEN 510\r"
  "390 M=N\r"
  "400 IF A$(N)=\"O\" THEN 480\r"
  "410 A$(N)=\"O\"\r"
  "420 R=TAN(Q+N/Q-N)-SIN(Q/N)+336*SIN(8*N)\r"
  "430 N=R-INT(R)\r"
  "440 N=INT(10*N)\r"
  "450 IF A$(N)=\"O\" THEN 480\r"
  "460 A$(N)=\"O\"\r"
  "470 GOTO 610\r"
  "480 A$(N)=\"X\"\r"
  "490 IF M=N THEN 420\r"
  "500 GOTO 610\r"
  "510 IF A$(N)=\"O\" THEN 590\r"
  "520 A$(N)=\"O\"\r"
  "530 R=.592*(1/TAN(Q/N+Q))/SIN(N*2+Q)-COS(N)\r"
  "540 N=R-INT(R)\r"
  "550 N=INT(10*N)\r"
  "560 IF A$(N)=\"O\" THEN 590\r"
  "570 A$(N)=\"O\"\r"
  "580 GOTO 610\r"
  "590 A$(N)=\"X\"\r"
  "600 IF M=N THEN 530\r"
  "610 PRINT \"1 2 3 4 5 6 7 8 9 10\"\r"
  "620 FOR Z=1 TO 10: PRINT A$(Z);\" \";: NEXT Z\r"
  "630 C=C+1\r"
  "640 PRINT\r"
  "650 FOR Z=1 TO 10\r"
  "660 IF A$(Z)<>\"O\" THEN 320\r"
  "670 NEXT Z\r"
  "680 IF C>12 THEN 710\r"
  "690 PRINT \"VERY GOOD.  YOU GUESSED IT IN ONLY\";C;\"GUESSES.\"\r"
  "700 GOTO 720\r"
  "710 PRINT \"TRY HARDER NEXT TIME.  IT TOOK YOU\";C;\"GUESSES.\"\r"
  "720 PRINT \"DO YOU WANT TO TRY ANOTHER PUZZLE\";\r"
  "730 INPUT X$\r"
  "740 IF LEFT$(X$,1)=\"N\" THEN 780\r"
  "760 PRINT\r"
  "770 GOTO 180\r"
  "780 END\r"
  "";

const char basic_football[] =
  "10 REM   THIS DEMONSTRATION IS CONVERTED FROM PDP-11 BASIC\r"
  "20 PRINT \"IF YOU NEED INSTRUCTIONS FOR PLAYING FOOTBALL, TYPE A 1\";\r"
  "30 INPUT I\r"
  "40 IF I<>1 THEN 340\r"
  "50 PRINT\r"
  "60 PRINT\r"
  "70 PRINT \"WHEN IT ASKS YOU A QUESTION TO BE ANSWERED YES OR\"\r"
  "80 PRINT \"NO, TYPE IN 0 FOR NO OR 1 FOR YES.\" \r"
  "90 PRINT\r"
  "100 GOSUB 4000\r"
  "300 PRINT \"TO CALL A PARTICULAR PLAY JUST TYPE ITS CODE NUMBER.\" \r"
  "310 PRINT \"ALSO, AT ANY TIME DURING PLAY YOU MAY CALL TIME OUT\"\r"
  "320 PRINT \"BY TYPING A '2'.  HOWEVER YOU ARE PERMITTED ONLY THREE\" \r"
  "330 PRINT \"TIMEOUTS PER HALF.  TYPING '3' WILL REPRINT THE CODES.\" \r"
  "340 PRINT\r"
  "350 PRINT\r"
  "370 DIM R(17)\r"
  "380 FOR I=0 TO 17\r"
  "390 READ R(I)\r"
  "400 NEXT I \r"
  "410 DATA 9,13,100,0,9,10,12,11,12,0,1,5,3,4,6,2,8,7\r"
  "420 REM RANDOMIZE - NOT IMPLEMENTED IN 4K BASIC\r"
  "430 LET F=0\r"
  "440 LET Z3=0\r"
  "450 LET O=0\r"
  "460 LET L=0\r"
  "470 REM DIM Z(5,3),P(2),D(2,5) \r"
  "471 DIM Z(24):DIM P(2):DIM D(18)\r"
  "480 FOR A=0 TO 5 \r"
  "490 FOR B=0 TO 2 \r"
  "500 READ Z(A+B*6),D(B+A*3) \r"
  "505 LET P(B)=0\r"
  "510 NEXT B \r"
  "520 READ Z(A+18)\r"
  "530 NEXT A \r"
  "540 PRINT \"DO YOU WANT TO RECEIVE\";\r"
  "550 LET X=1\r"
  "560 GOSUB 3610\r"
  "570 LET S=2-SGN(13-Q)\r"
  "580 LET K=S\r"
  "590 LET T1=120 \r"
  "600 LET U2=3 \r"
  "610 LET U=3\r"
  "620 LET C=900\r"
  "630 GOSUB 2250\r"
  "640 LET F1=50\r"
  "641 R1=1:R2=1\r"
  "642 FOR I=1 TO 7:R1=R1*RND(0):NEXT I\r"
  "643 FOR I=1 TO 3-Z2:R2=R2*RND(0):NEXT I\r"
  "650 LET B=INT(F1+O*20*RND(0)+(1-O)*29*(2-R1-R2))\r"
  "660 LET O=0\r"
  "670 LET Z9=8 \r"
  "680 GOSUB 1490\r"
  "690 LET L=0\r"
  "700 IF B<=99 THEN 2340\r"
  "710 PRINT \"A  TOUCHBACK\" \r"
  "720 LET B=20 \r"
  "730 LET L=0\r"
  "740 IF S=2 THEN 770\r"
  "750 PRINT \"MY \"; \r"
  "760 GOTO 780\r"
  "770 PRINT \"YOUR \"; \r"
  "780 GOSUB 3290\r"
  "790 GOSUB 2980\r"
  "800 LET D=1\r"
  "810 LET F2=.03 \r"
  "820 LET O=0\r"
  "830 IF C<=0 THEN 2770\r"
  "840 GOSUB 2530\r"
  "850 LET Z2=1 \r"
  "860 LET Z3=.3\r"
  "870 IF C<=F*T1 THEN 2920\r"
  "880 IF C<=0 THEN 2770\r"
  "890 IF L=0 THEN 910\r"
  "900 PRINT \"TIME TO GO--\";\r"
  "910 PRINT INT(C/60);\"MIN,\";C-60*INT(C/60);\"SEC.  \";\r"
  "920 PRINT \"YOUR PLAY\"; \r"
  "930 GOSUB 3610\r"
  "940 IF S=1 THEN 980\r"
  "950 IF Q>8 THEN 920\r"
  "960 LET M=Q\r"
  "970 GOTO 1000\r"
  "980 LET Y=Q-8\r"
  "990 IF (ABS(Q-10.5)*ABS(Q-10.5))>3 THEN 920\r"
  "1000 LET C=INT(C-L*(5+23*RND(X))) \r"
  "1010 LET L=1\r"
  "1020 IF M=7 THEN 1760\r"
  "1030 IF M=8 THEN 1920\r"
  "1040 LET Y1=Y-1 \r"
  "1050 IF RND(X)>Z(M-1+Y1*6) THEN 1240\r"
  "1060 LET A=2\r"
  "1070 GOSUB 3020\r"
  "1080 IF M<4 THEN 1110\r"
  "1090 PRINT \"PASS COMPLETE..\"; \r"
  "1100 LET L=SGN(INT(4*RND(0))) \r"
  "1110 IF RND(X)<F2 THEN 2510\r"
  "1120 IF G>0 THEN 1210\r"
  "1130 IF G=0 THEN 1170\r"
  "1140 IF G+B<1 THEN 2170\r"
  "1150 PRINT \"LOSS OF\";-G;\r"
  "1160 GOTO 1610\r"
  "1170 PRINT \"NO GAIN\"\r"
  "1180 LET Z9=2 \r"
  "1190 GOSUB 1490\r"
  "1200 GOTO 1670\r"
  "1210 IF B+G>99 THEN 1650\r"
  "1220 PRINT \"GAIN OF\";G; \r"
  "1230 GOTO 1610\r"
  "1240 IF M>3 THEN 1280\r"
  "1250 LET A=1\r"
  "1260 GOSUB 3020\r"
  "1270 GOTO 1120\r"
  "1280 IF RND(X)<.06*(2-SGN(Y-3)) THEN 1360\r"
  "1290 IF RND(0)<.05+INT(Y/3.5)/5 THEN 1510\r"
  "1300 LET Z9=6 \r"
  "1310 GOSUB 1490\r"
  "1320 PRINT \"PASS INCOMPLETE\"\r"
  "1330 LET L=0\r"
  "1340 LET G=0\r"
  "1350 GOTO 3120\r"
  "1360 PRINT \"PASS **INTERCEPTED**\";\r"
  "1370 LET A=1\r"
  "1380 GOSUB 3020\r"
  "1390 IF B<40 THEN 1410\r"
  "1400 LET G=20*(1+SGN(G))\r"
  "1410 LET B=100-B-G\r"
  "1420 LET S=3-S\r"
  "1430 LET Z9=9 \r"
  "1440 GOSUB 1490\r"
  "1450 IF B<1 THEN 710\r"
  "1460 IF B>99 THEN 1650\r"
  "1470 PRINT \"AT \"; \r"
  "1480 GOTO 2360\r"
  "1490 LET C=C-INT(4+Z9/2*(1+RND(0))) \r"
  "1500 RETURN \r"
  "1510 LET G=-(5+INT(10*RND(X)))\r"
  "1520 PRINT \"THE QUARTERBACK \";\r"
  "1530 IF RND(X)>.5 THEN 1560\r"
  "1540 PRINT \"IS THROWN FOR A \";\r"
  "1550 GOTO 1110\r"
  "1560 LET G=-(2*G+8) \r"
  "1570 LET M=5\r"
  "1580 LET A=1\r"
  "1590 PRINT \"SCRAMBLES FOR A \";\r"
  "1600 GOTO 1110\r"
  "1610 LET B=B+G\r"
  "1620 PRINT \"TO \"; \r"
  "1630 GOSUB 3300\r"
  "1640 IF B<=99 THEN 1670\r"
  "1650 GOSUB 1990\r"
  "1660 GOTO 630\r"
  "1670 IF B1>B THEN 3120\r"
  "1680 IF B1<B THEN 1730\r"
  "1690 IF RND(0)>.5 THEN 1730\r"
  "1700 PRINT \"**MEASUREMENT**\"\r"
  "1710 GOSUB 3520\r"
  "1720 IF RND(X)<.5 THEN 3120\r"
  "1730 GOSUB 2980\r"
  "1740 LET D=0\r"
  "1750 GOTO 3120\r"
  "1760 IF RND(X)<.06 THEN 1890\r"
  "1770 LET B=B+30+INT(15*(1-RND(X)*RND(X)*RND(X)))\r"
  "1780 LET Z9=2 \r"
  "1790 GOSUB 1490\r"
  "1800 IF B<=99 THEN 1850\r"
  "1810 LET P1=3 \r"
  "1820 GOSUB 2030\r"
  "1830 IF P1=0 THEN 710\r"
  "1840 GOTO 630\r"
  "1850 PRINT \"THE KICK IS \";\r"
  "1860 LET Z2=0 \r"
  "1870 LET S=3-S\r"
  "1880 GOTO 2340\r"
  "1890 PRINT \"**BLOCKED** RECOVERED..\"; \r"
  "1900 LET G=-INT(14*RND(X))\r"
  "1910 GOTO 1410\r"
  "1920 PRINT \"THE PUNT IS \";\r"
  "1930 IF RND(X)<.06 THEN 1890\r"
  "1940 LET F1=B \r"
  "1950 LET Z2=1 \r"
  "1960 LET S=3-S\r"
  "1970 LET Z3=.65 \r"
  "1980 GOTO 650\r"
  "1990 PRINT \"** TOUCHDOWN**\" \r"
  "2000 LET P1=1 \r"
  "2010 LET P(S)=P(S)+6\r"
  "2020 LET B=130\r"
  "2030 PRINT \"THE KICK IS \";\r"
  "2040 IF RND(X)<((B/132)*(B/132)*(B/132)*(B/132)) THEN 2070\r"
  "2050 LET P1=0 \r"
  "2060 PRINT \"NO \"; \r"
  "2070 PRINT \"GOOD\" \r"
  "2080 LET P(S)=P(S)+P1 \r"
  "2090 GOSUB 2120\r"
  "2100 LET S=3-S\r"
  "2110 RETURN \r"
  "2120 PRINT \"SCORE: ME\";P(1);\" YOU\";P(2) \r"
  "2130 LET L=0\r"
  "2140 IF X<5 THEN 2160\r"
  "2150 IF P(1)<>P(2) THEN 2770\r"
  "2160 RETURN \r"
  "2170 PRINT \"**SAFETY**\" \r"
  "2180 LET P(3-S)=P(3-S)+2\r"
  "2190 LET F1=30\r"
  "2200 LET S=3-S\r"
  "2210 GOSUB 2120\r"
  "2220 GOSUB 3440\r"
  "2230 PRINT \"FROM THE 20\"\r"
  "2240 GOTO 650\r"
  "2250 GOSUB 3440\r"
  "2260 IF S=2 THEN 2330\r"
  "2270 PRINT \"ON-SIDE\"; \r"
  "2280 GOSUB 3610\r"
  "2290 IF Q<>13 THEN 2330\r"
  "2300 LET F2=.15 \r"
  "2310 LET Z2=1 \r"
  "2320 LET O=1\r"
  "2330 RETURN \r"
  "2340 LET B=100-B\r"
  "2350 PRINT \"RECEIVED AT \";\r"
  "2360 GOSUB 3300\r"
  "2370 IF Z2*RND(X)>Z3 THEN 2490\r"
  "2380 IF RND(X)<F2 THEN 2500\r"
  "2390 LET G=5+INT(100*RND(0))\r"
  "2400 IF RND(0)<.15 THEN 2430\r"
  "2410 LET G=INT(24*(1-RND(X)*RND(X))) \r"
  "2420 IF G=0 THEN 2490\r"
  "2430 LET B=B+G\r"
  "2440 PRINT \" AND RUN BACK...\";\r"
  "2450 LET L=1\r"
  "2460 IF B>99 THEN 1650\r"
  "2470 PRINT \" TO \";\r"
  "2480 GOSUB 3300\r"
  "2490 IF RND(0)>F2 THEN 3260\r"
  "2500 LET G=0\r"
  "2510 PRINT \"**FUMBLE**\";\r"
  "2520 GOTO 1410\r"
  "2530 IF S=1 THEN 2560\r"
  "2540 LET Y=INT(1+3.5*RND(0))\r"
  "2550 RETURN \r"
  "2560 LET M=INT(55*RND(0)/10.5)+1\r"
  "2570 IF (B1-B)/(5-D)<3 THEN 2590\r"
  "2580 LET M=INT(6-4*RND(0)*RND(0))\r"
  "2590 IF L*F*60>=C THEN 2670\r"
  "2600 IF D<4 THEN 2550\r"
  "2610 PRINT \"I'LL \"; \r"
  "2620 IF B<55 THEN 2720\r"
  "2630 IF 0<4*RND(0)-B1+B THEN 2750\r"
  "2640 PRINT \"TRY FOR A FIELD GOAL\" \r"
  "2650 LET M=7\r"
  "2660 RETURN \r"
  "2670 IF P(2)*U2<=P(1)*U2 THEN 2600\r"
  "2680 PRINT \"TIME OUT\" \r"
  "2690 LET U2=U2-1\r"
  "2700 GOSUB 3520\r"
  "2710 GOTO 2600\r"
  "2720 PRINT \"PUNT\" \r"
  "2730 LET M=8\r"
  "2740 RETURN \r"
  "2750 PRINT \"GO FOR IT\"\r"
  "2760 RETURN \r"
  "2770 IF X<4 THEN 2830\r"
  "2780 IF P(1)=P(2) THEN 2830\r"
  "2790 PRINT \"THE GAME IS OVER\" \r"
  "2800 PRINT \"FINAL \";\r"
  "2810 GOSUB 2120\r"
  "2820 STOP \r"
  "2830 PRINT \"END OF PERIOD\";X\r"
  "2840 GOSUB 2120\r"
  "2850 LET F=1-F\r"
  "2860 GOSUB 3520\r"
  "2870 LET C=900\r"
  "2880 LET X=X+1\r"
  "2890 IF F<>0 THEN 810\r"
  "2900 LET S=3-K\r"
  "2910 GOTO 580\r"
  "2920 IF T1=0 THEN 2770\r"
  "2930 PRINT \"2 MINUTE WARNING\" \r"
  "2940 GOSUB 3520\r"
  "2950 LET T1=0 \r"
  "2960 LET C=120\r"
  "2970 GOTO 880\r"
  "2980 LET B1=B+10\r"
  "2990 IF B1<=100 THEN 3010\r"
  "3000 LET B1=100 \r"
  "3010 RETURN \r"
  "3020 LET Q=1.3*(A*RND(0)-1)-.06 \r"
  "3030 LET A=1\r"
  "3040 IF Q>=0 THEN 3070\r"
  "3050 LET A=0\r"
  "3060 LET Q=-Q \r"
  "3070 LET M1=M-1 \r"
  "3080 LET G=D(A+M1*3)+(SIN(Q)/SIN(Q+1.5708))*(D(2+M1*3)-D(A+M1*3))/3.5\r"
  "3090 LET G=G+INT(RND(0)+.02)*A*100*RND(0)\r"
  "3100 LET G=INT(G)\r"
  "3110 RETURN \r"
  "3120 LET D=D+1\r"
  "3130 IF D=5 THEN 3240\r"
  "3140 IF D<>  1 THEN 3160\r"
  "3150 PRINT \"1ST\"; \r"
  "3160 IF D<>2 THEN 3180\r"
  "3170 PRINT \"2ND\"; \r"
  "3180 IF D<>3 THEN 3200\r"
  "3190 PRINT \"3RD\"; \r"
  "3200 IF D<4 THEN 3220\r"
  "3210 PRINT \"4TH\"; \r"
  "3220 PRINT \" AND\";B1-B;\"   \"; \r"
  "3230 GOTO 810\r"
  "3240 LET S=3-S\r"
  "3250 LET B=100-B\r"
  "3260 IF S=2 THEN 770\r"
  "3270 PRINT \"MY \"; \r"
  "3280 GOTO 780\r"
  "3290 PRINT \"BALL ON \";\r"
  "3300 IF B=50 THEN 3400\r"
  "3310 LET V=50-ABS(B-50) \r"
  "3320 LET C=C-INT(7+3*RND(0))\r"
  "3330 IF S=1 THEN 3420\r"
  "3340 IF B<50 THEN 3370\r"
  "3350 PRINT \"MY \"; \r"
  "3360 GOTO 3380\r"
  "3370 PRINT \"YOUR \"; \r"
  "3380 PRINT V\r"
  "3390 RETURN \r"
  "3400 PRINT \"THE 50\" \r"
  "3410 RETURN \r"
  "3420 IF B<50 THEN 3350\r"
  "3430 GOTO 3370\r"
  "3440 IF S=2 THEN 3470\r"
  "3450 PRINT \"YOU\"; \r"
  "3460 GOTO 3480\r"
  "3470 PRINT \"I\"; \r"
  "3480 PRINT \" KICK OFF.\" \r"
  "3490 LET F2=.06 \r"
  "3500 LET Z2=0 \r"
  "3510 RETURN \r"
  "3520 LET L=0\r"
  "3530 PRINT \"TIMEOUT CALLED...\"\r"
  "3540 PRINT  \r"
  "3550 RETURN \r"
  "3560 IF U=0 THEN 3600\r"
  "3570 LET U=U-1\r"
  "3580 GOSUB 3520\r"
  "3590 GOTO 3610\r"
  "3600 GOSUB 4000:PRINT \"... TRY AGAIN\" \r"
  "3610 INPUT A\r"
  "3620 IF ABS(INT(A))>17 THEN 3600\r"
  "3630 LET Q=R(INT(ABS(A))) \r"
  "3640 IF Q=0 THEN 3600\r"
  "3650 IF Q=100 THEN 3560\r"
  "3660 RETURN \r"
  "3670 DATA .5,-2,.25,4,.5,13,.55 \r"
  "3680 DATA .4,-2,.3,7,.65,15,.75 \r"
  "3690 DATA .4,-2,.3,6,.6,15,.35\r"
  "3700 DATA .65,-2,.65,6,.6,17,.9 \r"
  "3710 DATA .4,2,.7,10,.4,27,.2 \r"
  "3720 DATA .1,19,.4,35,.2,100,.1 \r"
  "4000 REM   PRINT INSTRUCTIONS SUBROUTINE\r"
  "4100 PRINT \"ON OFFENSE YOU HAVE THE FOLLOWING PERMITTED PLAYS:\" \r"
  "4110 PRINT \"PLAY\",\"CODE\"\r"
  "4120 PRINT \"RUN\",\"10\" \r"
  "4130 PRINT \"PASS\",\"11\"\r"
  "4140 PRINT \"SWEEP\",\"12\" \r"
  "4150 PRINT \"SCREEN PASS\",\"13\" \r"
  "4160 PRINT \"LONG PASS\",\"14\" \r"
  "4170 PRINT \"DRAW PLAY\",\"15\" \r"
  "4180 PRINT \"PUNT\",\"16\"\r"
  "4190 PRINT \"FIELDGOAL\",\"17\" \r"
  "4200 PRINT\r"
  "4210 PRINT \"ON DEFENSE, YOU MAY TRY ONE OF THE FOLLOWING:\"\r"
  "4220 PRINT \"DEFENSE\",\"CODE\" \r"
  "4230 PRINT \"NORMAL\",\"4\",\"GOOD AGAINST SWEEP AND SCREEN\" \r"
  "4240 PRINT \"HOLD\",\"5\",\"GOOD AGAINST RUN, PASS AND DRAW\" \r"
  "4250 PRINT \"BLITZ\",\"6\",\"GOOD AGAINST PASS OR LONG PASS\" \r"
  "4260 PRINT \"INTERCEPT\",\"7\",\"INCREASES THE ODDS FOR AN INTERCEPTION\" \r"
  "4270 PRINT \"BLOCK\",\"8\",\"GIVES YOU A CHANCE TO BLOCK A KICK,\"\r"
  "4280 PRINT \" \",\" \",\"BUT DECREASES THE DISTANCE RUNBACK.\"\r"
  "4290 PRINT\r"
  "4300 RETURN\r"
  "9999 END\r"
  "";

const char basic_galaxy[] =
  "100 REM		<< GALAXY >>\r"
  "101 WIDTH 79\r"
  "102 DIM G$(15)\r"
  "103 FOR X=1 TO 15 : READ G$(X) : NEXT\r"
  "104 A$=\"*\":B$=\"+\":C$=\".\":D$=\"*\"\r"
  "105 FOR I=1 TO 40\r"
  "106 GOSUB 113\r"
  "107 PRINT TAB(A);A$; TAB(B);B$; TAB(C);C$\r"
  "108 NEXT\r"
  "109 Z1=INT(RND(1)*15)+1\r"
  "110 Z$=G$(Z1)\r"
  "111 PRINT TAB(20) Z$\r"
  "112 GOTO 105\r"
  "113 A=INT(RND(1)*28) : B=INT(RND(1)*25)+28 : C=INT(RND(1)*25)+55\r"
  "114 X=RND(1)\r"
  "115 IF X<.15 THEN SWAP A$,B$ : GOTO 121\r"
  "116 IF X<.3 THEN SWAP B$,C$ : GOTO 121\r"
  "117 IF X<.45 THEN SWAP A$,C$ : GOTO 121\r"
  "118 IF X<.6 THEN SWAP A$,D$ : GOTO 121\r"
  "119 IF X<.75 THEN SWAP B$,D$ : GOTO 121\r"
  "120 IF X<.9 THEN SWAP C$,D$\r"
  "121 RETURN\r"
  "122 DATA YOU ARE A TRAVELLER LOST IN SPACE\r"
  "123 DATA I AM BUT A TRAVELLER LOST IN SPACE\r"
  "124 DATA ALL MANKIND BUT EXPLORERS LOST IN SPACE\r"
  "125 DATA CAN WE FIND EACH OTHER IN SPACE ?\r"
  "126 DATA HOW DOES LIFE SEEM FROM UP THERE ?\r"
  "127 DATA I CAN SEE YOU CLEARLY NOW FROM HERE\r"
  "128 DATA THE YEARS SEEM TO PASS SO QUICKLY\r"
  "129 DATA WE'LL MEET HERE IN A MILLION YEARS\r"
  "130 DATA GREETINGS FROM WHERE THE RATS CRAWL\r"
  "131 DATA GREETINGS FROM THE CRACKS IN THE WALL\r"
  "132 DATA I SEE ALL THAT YOU EVER ARE DOING\r"
  "133 DATA THE SKY IS FALLING ON US ALL !!!\r"
  "134 DATA I'M AFRAID THAT THE END IS COMING\r"
  "135 DATA IN WHICH REMOTE PLACE CAN GOD BE MET ?\r"
  "136 DATA WE'LL MEET AGAIN DON'T KNOW WHERE OR WHEN\r"
  "137 DATA TIME RUNS QUITE SHORT FOR YOU AND ME\r"
  "138 DATA YOU GROW OLD AT THE SPEED OF LIGHT\r"
  "139 DATA HAVE YOU MADE PEACE WITH YOUR MAKER ?\r"
  "140 DATA HAVE YOU EXISTED AS A GIVER OR A TAKER ?\r"
  "141 DATA WILL YOU BE ABLE TO MEET ME OUT HERE ?\r"
  "142 DATA REMEMBER ALL THE GREAT TIMES WE HAD ?\r"
  "143 DATA WE SHALL NEVER LEAVE THIS PLACE TILL WE DIE\r"
  "144 DATA ETERNAL ENERGY BEYOND THE DREAMS OF MAN\r"
  "145 DATA SOME PEOPLE WILL ALWAYS BE FREE FOREVER\r"
  "146 DATA SOME PEOPLE WILL NEVER TASTE FREEDOM\r"
  "";

const char basic_hamurabi[] =
  "10 REM ORIGINAL HAMURABI IN IMSAI 4K BASIC\r"
  "20 REM FROM REVISION REWRITTEN 12/11/77\r"
  "310 PRINT \"HAMURABI - \";\r"
  "320 PRINT \"WHERE YOU GOVERN THE \";\r"
  "321 PRINT \"ANCIENT KINGDOM OF SUMERIA.\"\r"
  "330 PRINT \"THE OBJECT IS TO FIGURE \";\r"
  "331 PRINT \"OUT HOW THE GAME WORKS!!\"\r"
  "340 PRINT \"(IF YOU WANT TO QUIT, \";\r"
  "341 PRINT \"SELL ALL YOUR LAND.)\"\r"
  "400 LET A1 = 100\r"
  "410 LET A2 = 5\r"
  "420 LET A3 = 0\r"
  "430 LET B1 = 2800\r"
  "440 LET B2 = 200\r"
  "450 LET B3 = 3\r"
  "460 LET B4 = 3000\r"
  "470 LET C1 = 1000\r"
  "480 LET J = 1\r"
  "1010 PRINT\r"
  "1020 PRINT \"HAMURABI, I BEG TO REPORT \";\r"
  "1021 PRINT \"THAT LAST YEAR \"\r"
  "1040 PRINT A3;\"PEOPLE STARVED AND \";A2;\r"
  "1041 PRINT \"PEOPLE CAME TO THE CITY.\"\r"
  "1050 IF J > 0 THEN GOTO 1100\r"
  "1060 LET A1 = A1-INT(A1/2)\r"
  "1070 PRINT \"THE PLAGUE KILLED \";\r"
  "1071 PRINT \"HALF THE PEOPLE.\"\r"
  "1100 PRINT \"THE POPULATION IS NOW \";A1\r"
  "1120 PRINT \"WE HARVESTED \";B4;\"BUSHELS \";\r"
  "1121 PRINT \"AT \";B3;\"BUSHELS PER ACRE.\"\r"
  "1130 PRINT \"RATS DESTROYED \";\r"
  "1131 PRINT B2;\" BUSHELS LEAVING \";B1;\r"
  "1140 PRINT \"BUSHELS IN\"\r"
  "1141 PRINT \"THE STOREHOUSES.\"\r"
  "1160 PRINT \"THE CITY OWNS \";C1;\r"
  "1161 PRINT \"ACRES OF LAND.\"\r"
  "1170 LET C2 = 17+INT(6*RND(1))\r"
  "1180 PRINT \"LAND IS WORTH \";C2;\"BUSHELS \";\r"
  "1181 PRINT \"PER ACRE.\"\r"
  "1210 PRINT \"HAMURABI . . .\"\r"
  "1310 PRINT\r"
  "1320 PRINT \"BUY HOW MANY ACRES\";\r"
  "1330 INPUT I\r"
  "1335 PRINT\r"
  "1340 LET I = INT(ABS(I))\r"
  "1350 IF I = 0 THEN GOTO 1510\r"
  "1360 LET J = I*C2\r"
  "1370 IF J <= B1 THEN GOTO 1400\r"
  "1380 GOSUB 9000\r"
  "1390 GOTO 1310\r"
  "1400 LET B1 = B1-J\r"
  "1410 LET C1 = C1+I\r"
  "1510 PRINT \"SELL HOW MANY ACRES\";\r"
  "1520 INPUT I\r"
  "1525 PRINT\r"
  "1530 LET I = (ABS(I))\r"
  "1540 IF I = 0 THEN GOTO 1710\r"
  "1550 IF I < C1 THEN GOTO 1600\r"
  "1560 IF I = C1 THEN END\r"
  "1570 GOSUB 9000\r"
  "1580 GOTO 1510\r"
  "1600 LET C1 = C1-I\r"
  "1610 LET B1 = B1+C2*I\r"
  "1710 PRINT \"HOW MANY BUSHELS SHALL \";\r"
  "1711 PRINT \"WE DISTRIBUTE AS FOOD? \";\r"
  "1720 INPUT I\r"
  "1725 PRINT\r"
  "1730 LET I = INT(ABS(I))\r"
  "1740 IF I <= B1 THEN GOTO 1770\r"
  "1750 GOSUB 9000\r"
  "1760 GOTO 1710\r"
  "1770 LET B1 = B1-I\r"
  "1780 LET A3 = A1-INT(I/20)\r"
  "1790 LET A2 = 0\r"
  "1800 IF A3 >= 0 THEN GOTO 1910\r"
  "1810 LET A2 = -A3/2\r"
  "1820 LET A3 = 0\r"
  "1910 PRINT \"HOW MANY ACRES SHALL \";\r"
  "1911 PRINT \"WE PLANT? \";\r"
  "1920 INPUT I\r"
  "1925 PRINT\r"
  "1930 LET I = INT(ABS(I))\r"
  "1935 IF I > C1 THEN GOTO 1960\r"
  "1940 LET J = INT(I/2)\r"
  "1950 IF J <= B1 THEN GOTO 1980\r"
  "1960 GOSUB 9000\r"
  "1970 GOTO 1910\r"
  "1980 IF I > 10*A1 THEN GOTO 1960\r"
  "1990 LET B1 = B1-J\r"
  "2010 LET B3 = INT(5*RND(1))+1\r"
  "2020 LET B4 = B3*I\r"
  "2030 LET B2 = INT((B1+B4)*0.07*RND(1))\r"
  "2040 LET B1 = B1-B2+B4\r"
  "2050 LET J = INT(10*RND(1))\r"
  "2060 LET A2 = INT(A2+(5-B3)*B1/600+1)\r"
  "2070 IF A2 <= 50 THEN GOTO 2100\r"
  "2080 LET A2 = 50\r"
  "2100 LET A1 = A1+A2-A3\r"
  "2110 GOTO 1010\r"
  "9000 REM***ERROR ROUTINE\r"
  "9010 PRINT \"HAMURABI, THINK AGAIN - \";\r"
  "9011 PRINT \"YOU ONLY HAVE \"\r"
  "9020 PRINT A1;\"PEOPLE,\";C1;\"ACRES, AND \";\r"
  "9030 PRINT B1;\"BUSHELS IN STOREHOUSES.\"\r"
  "9040 RETURN\r"
  ""
  "";

const char basic_hangman[] =
  "10 PRINT TAB(32);\"HANGMAN\"\r"
  "20 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "25 PRINT:PRINT:PRINT\r"
  "30 DIM P$(12,12),L$(20),D$(20),N$(26),U(50)\r"
  "40 C=1: N=50\r"
  "50 FOR I=1 TO 20: D$(I)=\"-\": NEXT I: M=0\r"
  "60 FOR I=1 TO 26: N$(I)=\"\": NEXT I\r"
  "70 FOR I=1 TO 12: FOR J=1 TO 12: P$(I,J)=\" \": NEXT J: NEXT I\r"
  "80 FOR I=1 TO 12: P$(I,1)=\"X\": NEXT I\r"
  "90 FOR I=1 TO 7: P$(1,I)=\"X\": NEXT: P$(2,7)=\"X\"\r"
  "95 IF C<N THEN 100\r"
  "97 PRINT \"YOU DID ALL THE WORDS!!\": STOP\r"
  "100 Q=INT(N*RND(1))+1\r"
  "110 IF U(Q)=1 THEN 100\r"
  "115 U(Q)=1: C=C+1: RESTORE: T1=0\r"
  "150 FOR I=1 TO Q: READ A$: NEXT I\r"
  "160 L=LEN(A$): FOR I=1 TO LEN(A$): L$(I)=MID$(A$,I,1): NEXT I\r"
  "170 PRINT \"HERE ARE THE LETTERS YOU USED:\"\r"
  "180 FOR I=1 TO 26: PRINT N$(I);: IF N$(I+1)=\"\" THEN 200\r"
  "190 PRINT \",\";: NEXT I\r"
  "200 PRINT: PRINT: FOR I=1 TO L: PRINT D$(I);: NEXT I: PRINT: PRINT\r"
  "210 INPUT \"WHAT IS YOUR GUESS\";G$: R=0\r"
  "220 FOR I=1 TO 26: IF N$(I)=\"\" THEN 250\r"
  "230 IF G$=N$(I) THEN PRINT \"YOU GUESSED THAT LETTER BEFORE!\": GOTO 170\r"
  "240 NEXT I: PRINT \"PROGRAM ERROR.  RUN AGAIN.\": STOP\r"
  "250 N$(I)=G$: T1=T1+1\r"
  "260 FOR I=1 TO L: IF L$(I)=G$ THEN 280\r"
  "270 NEXT I: IF R=0 THEN 290\r"
  "275 GOTO 300\r"
  "280 D$(I)=G$: R=R+1: GOTO 270\r"
  "290 M=M+1: GOTO 400\r"
  "300 FOR I=1 TO L: IF D$(I)=\"-\" THEN 320\r"
  "310 NEXT I: GOTO 390\r"
  "320 PRINT: FOR I=1 TO L: PRINT D$(I);: NEXT I: PRINT: PRINT\r"
  "330 INPUT \"WHAT IS YOUR GUESS FOR THE WORD\";B$\r"
  "340 IF A$=B$ THEN 360\r"
  "350 PRINT \"WRONG.  TRY ANOTHER LETTER.\": PRINT: GOTO 170\r"
  "360 PRINT \"RIGHT!!  IT TOOK YOU\";T1;\"GUESSES!\"\r"
  "370 INPUT \"WANT ANOTHER WORD\";W$: IF W$=\"YES\" THEN 50\r"
  "380 PRINT: PRINT \"IT'S BEEN FUN!  BYE FOR NOW.\": GOTO 999\r"
  "390 PRINT \"YOU FOUND THE WORD!\": GOTO 370\r"
  "400 PRINT: PRINT: PRINT\"SORRY, THAT LETTER ISN'T IN THE WORD.\"\r"
  "410 ON M GOTO 415,420,425,430,435,440,445,450,455,460\r"
  "415 PRINT \"FIRST, WE DRAW A HEAD\": GOTO 470\r"
  "420 PRINT \"NOW WE DRAW A BODY.\": GOTO 470\r"
  "425 PRINT \"NEXT WE DRAW AN ARM.\": GOTO 470\r"
  "430 PRINT \"THIS TIME IT'S THE OTHER ARM.\": GOTO 470\r"
  "435 PRINT \"NOW, LET'S DRAW THE RIGHT LEG.\": GOTO 470\r"
  "440 PRINT \"THIS TIME WE DRAW THE LEFT LEG.\": GOTO 470\r"
  "445 PRINT \"NOW WE PUT UP A HAND.\": GOTO 470\r"
  "450 PRINT \"NEXT THE OTHER HAND.\": GOTO 470\r"
  "455 PRINT \"NOW WE DRAW ONE FOOT\": GOTO 470\r"
  "460 PRINT \"HERE'S THE OTHER FOOT -- YOU'RE HUNG!!\"\r"
  "470 ON M GOTO 480,490,500,510,520,530,540,550,560,570\r"
  "480 P$(3,6)=\"-\": P$(3,7)=\"-\": P$(3,8)=\"-\": P$(4,5)=\"(\": P$(4,6)=\".\"\r"
  "481 P$(4,8)=\".\":P$(4,9)=\")\":P$(5,6)=\"-\":P$(5,7)=\"-\":P$(5,8)=\"-\":GOTO 580\r"
  "490 FOR I=6 TO 9: P$(I,7)=\"X\": NEXT I: GOTO 580\r"
  "500 FOR I=4 TO 7: P$(I,I-1)=\"\\\": NEXT I: GOTO 580\r"
  "510 P$(4,11)=\"/\": P$(5,10)=\"/\": P$(6,9)=\"/\": P$(7,8)=\"/\": GOTO 580\r"
  "520 P$(10,6)=\"/\": P$(11,5)=\"/\": GOTO 580\r"
  "530 P$(10,8)=\"\\\": P$(11,9)=\"\\\": GOTO 580\r"
  "540 P$(3,11)=\"\\\": GOTO 580\r"
  "550 P$(3,3)=\"/\": GOTO 580\r"
  "560 P$(12,10)=\"\\\": P$(12,11)=\"-\": GOTO 580\r"
  "570 P$(12,3)=\"-\": P$(12,4)=\"/\"\r"
  "580 FOR I=1 TO 12: FOR J=1 TO 12: PRINT P$(I,J);: NEXT J\r"
  "590 PRINT: NEXT I: PRINT: PRINT: IF M<>10 THEN 170\r"
  "600 PRINT \"SORRY, YOU LOSE.  THE WORD WAS \";A$\r"
  "610 PRINT \"YOU MISSED THAT ONE.  DO YOU \";: GOTO 370\r"
  "620 INPUT \"TYPE YES OR NO\";Y$: IF LEFT$(Y$,1)=\"Y\" THEN 50\r"
  "700 DATA \"GUM\",\"SIN\",\"FOR\",\"CRY\",\"LUG\",\"BYE\",\"FLY\"\r"
  "710 DATA \"UGLY\",\"EACH\",\"FROM\",\"WORK\",\"TALK\",\"WITH\",\"SELF\"\r"
  "720 DATA \"PIZZA\",\"THING\",\"FEIGN\",\"FIEND\",\"ELBOW\",\"FAULT\",\"DIRTY\"\r"
  "730 DATA \"BUDGET\",\"SPIRIT\",\"QUAINT\",\"MAIDEN\",\"ESCORT\",\"PICKAX\"\r"
  "740 DATA \"EXAMPLE\",\"TENSION\",\"QUININE\",\"KIDNEY\",\"REPLICA\",\"SLEEPER\"\r"
  "750 DATA \"TRIANGLE\",\"KANGAROO\",\"MAHOGANY\",\"SERGEANT\",\"SEQUENCE\"\r"
  "760 DATA \"MOUSTACHE\",\"DANGEROUS\",\"SCIENTIST\",\"DIFFERENT\",\"QUIESCENT\"\r"
  "770 DATA \"MAGISTRATE\",\"ERRONEOUSLY\",\"LOUDSPEAKER\",\"PHYTOTOXIC\"\r"
  "780 DATA \"MATRIMONIAL\",\"PARASYMPATHOMIMETIC\",\"THIGMOTROPISM\"\r"
  "990 PRINT \"BYE NOW\"\r"
  "999 END\r"
  "";

const char basic_histogram[] =
  "100 REM  NAME--HISTGRAM\r"
  "110 REM\r"
  "120 REM  DESCRIPTION--PLOTS A HISTOGRAM OF SCORES ON A TEST.\r"
  "130 REM\r"
  "140 REM  SOURCE--RONALD FAGIN'67\r"
  "150 REM\r"
  "160 REM  INSTRUCTIONS--D IS THE INCREMENT BETWEEN SCORES. THUS\r"
  "170 REM  IF ALL SCORES ARE A MULTIPLE OF 5, D IS 5. IN A TYPICAL \r"
  "180 REM  TEST WHERE ANY INTEGRAL SCORE CAN BE ATTAINED, D IS 1. IT \r"
  "190 REM  IS ASSUMED IN THIS PROGRAM THAT NO MORE THAN 50 PEOPLE ATTAIN\r"
  "200 REM  ANY GIVEN SCORE. GIVE AS DATA STARTING IN LINE 1000 FIRST D,\r"
  "210 REM  THEN THE NUMBER OF PEOPLE WHO TOOK THE TEST, THEN\r"
  "220 REM  THE SCORES, ONE AT A TIME. \r"
  "230 REM\r"
  "240 REM\r"
  "250 REM  *  *  *  *  *  *  *  MAIN PROGRAM  *  *  *  *  *  *  *  *\r"
  "260 REM\r"
  "270 DIM A(1000)\r"
  "280 READ D,N\r"
  "290 FOR I=1 TO N:READ A(I):NEXT I\r"
  "300 LET L=A(1):LET R=A(1)\r"
  "310 FOR I=2 TO N\r"
  "320 IF A(I)>L THEN 340\r"
  "330 LET L=A(I)\r"
  "340 IF A(I)<R THEN 360\r"
  "350 LET R=A(I)\r"
  "360 NEXT I\r"
  "370 PRINT \"SCORE\",\"NUMBER OF PEOPLE\"\r"
  "380 PRINT\r"
  "390 FOR I=L TO R STEP D\r"
  "400 LET S=0\r"
  "410 PRINT I,\r"
  "420 FOR J=1 TO N\r"
  "430 IF A(J)<>I THEN 450\r"
  "440 LET S=S+1\r"
  "450 NEXT J\r"
  "460 FOR J=1 TO S\r"
  "470 PRINT \"*\";\r"
  "480 NEXT J\r"
  "490 PRINT\r"
  "500 NEXT I\r"
  "1000 DATA 2,10,  88,94,96,98,86,88,84,96,88,84\r"
  "2000 END\r";

const char basic_isprime[] =
  "100 PRINT \"Interface Age Prime-Number Benchmark Program\"\r"
  "110 FOR N=1 TO 1000\r"
  "120 FOR K=2 TO 500\r"
  "130 M=N/K\r"
  "140 L=INT(M)\r"
  "150 IF L=0 THEN 200\r"
  "160 IF L=1 THEN 190\r"
  "170 IF M>L THEN 190\r"
  "180 IF M=L THEN 210\r"
  "190 NEXT  K\r"
  "200 PRINT N\r"
  "210 NEXT  N\r"
  "220 PRINT\r"
  "230 PRINT\r"
  "240 PRINT \"Done\"\r"
  "250 END\r"
  "";

const char basic_king[] =
  "1 REM JIM STORER\r"
  "2 PRINT \"HOW MANY TIMES HAVE YOU PLAYED\";\r"
  "3 INPUT Z\r"
  "5 LET N5=8\r"
  "6 REM (RANDOMIZE)\r"
  "12 IF Z=500 THEN 47\r"
  "14 IF Z=1000 THEN 1960\r"
  "17 FOR Y1=1 TO 10\r"
  "18 PRINT\r"
  "19 NEXT Y1\r"
  "20 PRINT \"CONGRADULATIONS! YOU HAVE BEEN ELECTED PREMIER OF ETATS,\"\r"
  "22 PRINT \"A SMALL COMMUNIST ISLAND 30 BY 70 MILES LONG. YOUR JOB IS TO\"\r"
  "24 PRINT \"DECIDE UPON THE COUNTY'S BUDGET AND DISTIBUTE MONEY TO YOUR\"\r"
  "26 PRINT \"COUNTRYMEN FROM THE COMMUNAL TRASURY.\";\r"
  "27 IF Z<>0 THEN 47\r"
  "44 PRINT \"GOOD LUCK!\"\r"
  "47 FOR Y1=1 TO 4\r"
  "48 PRINT\r"
  "49 NEXT Y1\r"
  "50 LET A=INT(60000+(RND(1)*1000)-(RND(1)*1000))\r"
  "55 LET B=INT(500+(RND(1)*10)-(RND(1)*10))\r"
  "65 LET D=2000\r"
  "100 LET W=INT(RND(1)*10+95)\r"
  "101 FOR Y1=1 TO 8\r"
  "102 PRINT\r"
  "103 NEXT Y1\r"
  "105 PRINT \"YOU NOW HAVE\"A\"RALLODS IN THE TREASURY.\"\r"
  "110 PRINT INT(B)\"COUNTRYMEN,\";\r"
  "115 LET V9=INT(((RND(1)/2)*10+10))\r"
  "120 IF C=0 THEN 140\r"
  "130 PRINT INT(C)\"FOREIGN WORKERS,\";\r"
  "140 PRINT \" AND\"INT(D)\"SQ. MILES OF LAND.\"\r"
  "150 PRINT \"THIS YEAR INDUSTRY WILL BUY LAND FOR\"W\"RALLODS PER SQ. MILE.\r"
  "155 PRINT \"LAND CURRENTLY COSTS\"V9\"RALLODS PER SQ. MILE TO PLANT.\"\r"
  "160 FOR Y1=1 TO 3\r"
  "162 PRINT\r"
  "163 NEXT Y1\r"
  "200 PRINT \"HOW MANY SQ. MILES DO YOU WISH TO SELL TO INDUSTRY\"\r"
  "201 INPUT H\r"
  "215 IF H<0 THEN 200\r"
  "220 IF H<=D-1000 THEN 300\r"
  "230 PRINT \"...THINK AGAIN, YOU'VE ONLY\"D-1000\"SQ. MILES OF FARMLAND\"\r"
  "240 IF X<>0 THEN 200\r"
  "250 PRINT \"(FOREIGN INDUSTRY WILL ONLY BUY FARM LAND BECAUSE FOREST\"\r"
  "260 PRINT \"LAND IS UNECONOMICAL TO STRIP MINE DUE TO TREES, ETC.)\"\r"
  "280 LET X=1\r"
  "299 GOTO 200\r"
  "300 LET D=INT(D-H)\r"
  "310 LET A=INT(A+(H*W))\r"
  "320 PRINT \"HOW MANY RALLODS DO YOU WISH TO DISTRIBUTE?\"\r"
  "321 INPUT I\r"
  "342 IF I<0 THEN 320\r"
  "350 IF I<A THEN 400\r"
  "360 IF I=A THEN 380\r"
  "370 PRINT \"YOU ONLY HAVE\"A\"RALLODS IN THE TRASURY!\"\r"
  "375 GOTO 320\r"
  "380 LET J=0\r"
  "390 LET K=0\r"
  "395 LET A=0\r"
  "399 GOTO 1000\r"
  "400 LET A=INT(A-I)\r"
  "410 PRINT \"HOW MANY SQ. MILES DO YOU WISH TO PLANT\"\r"
  "411 INPUT J\r"
  "421 IF J<0 THEN 410\r"
  "422 IF J<=B*2 THEN 426\r"
  "423 PRINT \"SORRY, BUT EACH COUNTRYMAN CAN ONLY PLANT 2 SQ. MILES\"\r"
  "424 GOTO 410\r"
  "426 IF J<=D-1000 THEN 430\r"
  "427 PRINT \"SORRY, BUT YOU'VE ONLY\"D-1000\"SQ. MILES OF FARM LAND\"\r"
  "428 GOTO 410\r"
  "430 LET U1=INT(J*V9)\r"
  "435 IF U1<A THEN 500\r"
  "440 IF U1=A THEN 490\r"
  "450 PRINT \"YOU HAVE ONLY \"A\"RALLODS IN THE TRASURY\"\r"
  "460 GOTO 410\r"
  "490 LET K=0\r"
  "495 LET A=0\r"
  "499 GOTO 1000\r"
  "500 LET A=A-U1\r"
  "505 IF D=2000 THEN 1000\r"
  "510 PRINT \"HOW MANY RALLODS DO YOU WANT TO SPEND ON POLLUTION CONTROL\";\r"
  "520 INPUT K\r"
  "522 IF K<0 THEN 510\r"
  "530 IF K<=A THEN 1000\r"
  "540 PRINT \"THINK AGAIN, YOU HAVE ONLY\"A\"RALLODS LEFT\"\r"
  "550 GOTO 510\r"
  "600 IF H<>0 THEN 1002\r"
  "602 IF I<>0 THEN 1002\r"
  "604 IF J<>0 THEN 1002\r"
  "606 IF K<>0 THEN 1002\r"
  "608 FOR Y1=1 TO 5\r"
  "609 PRINT\r"
  "610 GOTO 1590\r"
  "612 PRINT \"GOODBYE.\"\r"
  "1000 GOTO 600\r"
  "1002 FOR Y1=1TO3:PRINT:NEXT Y1\r"
  "1010 LET A=INT(A-K)\r"
  "1020 LET A4=A\r"
  "1100 IF INT(I/100-B)>=0 THEN 1120\r"
  "1105 IF I/100<50 THEN 1700\r"
  "1110 PRINT INT(B-(I/100));\"COUNTRYMEN DIED OF STARVATION\"\r"
  "1120 LET F1=INT(RND(1))*(2000-D)\r"
  "1122 IF K<25 THEN 1130\r"
  "1125 LET F1=INT(F1/(K/25))\r"
  "1130 IF F1<=0 THEN 1150\r"
  "1140 PRINT F1\"COUNTRYMEN DIED FROM THE EFFECTS OF AIR POLLUTION\"\r"
  "1150 IF INT((I/100)-B)<0 THEN 1170\r"
  "1160 IF F1<0 THEN 1180\r"
  "1165 GOTO 1200\r"
  "1170 PRINT \"   YOU WERE FORCED TO SPEND\"INT((F1+(B-(I/100)))*9);\r"
  "1172 PRINT \"RALLODS ON FUNERAL EXPENSES.\"\r"
  "1174 LET B5=INT(F1+(B-(I/100)))\r"
  "1175 LET A=INT(A-((F1+(B-(I/100)))*9))\r"
  "1176 GOTO 1185\r"
  "1180 PRINT \"   YOU WERE FORCED TO SPEND\"INT(F1*9)\"RALLODS ON \";\r"
  "1181 PRINT \"FUNERAL EXPENSES.\"\r"
  "1182 LET B5=F1\r"
  "1183 LET A=INT(A-(F1*9))\r"
  "1185 IF A>=0 THEN 1194\r"
  "1187 PRINT \"   INSUFFICIENT RESERVES TO COVER COST -LAND WAS SOLD\"\r"
  "1189 LET D=INT(D+(A/W))\r"
  "1190 LET A=0\r"
  "1194 LET B=INT(B-5)\r"
  "1200 IF H=0 THEN 1250\r"
  "1220 LET C1=INT(H+(RND(1)*10)-(RND(1)*20))\r"
  "1224 IF C>0 THEN 1230\r"
  "1226 C1=C1+20\r"
  "1230 PRINT C1\"WORKERS CAME INTO THE COUNTRY AND\";\r"
  "1250 LET P1=INT(((I/100-B)/10)+(K/25)-((2000-D)/50)-(F1/2))\r"
  "1255 PRINT ABS(P1)\"COUNTRYMEN \";\r"
  "1260 IF P1<0 THEN 1275\r"
  "1265 PRINT \"CAME TO\";\r"
  "1270 GOTO 1280\r"
  "1275 PRINT \"LEFT\";\r"
  "1280 PRINT \"THE ISLAND.\"\r"
  "1290 LET B=INT(B+P1)\r"
  "1292 C=INT(C+C1)\r"
  "1305 U2=INT(((2000-D)*((RND(1)*1.5)/2)))\r"
  "1310 IF C=0 THEN 1324\r"
  "1320 PRINT \" OF\"INT(J)\"SQ. MILES PLANTED,\";\r"
  "1324 IF J>U2 THEN 1330\r"
  "1326 U2=J\r"
  "1330 PRINT \" YOU HARVESTED\"INT(J-U2)\"SQ. MILES OF CROPS.\"\r"
  "1340 IF U2=0 THEN 1370\r"
  "1344 IF T1>=2 THEN 1370\r"
  "1350 PRINT \"   (DUE TO \";\r"
  "1355 IF T1=0 THEN 1365\r"
  "1360 PRINT \"INCREASED \";\r"
  "1365 PRINT \"AIR AND WATER POLLUTION FROM FORIEGN INDUSTRY.)\"\r"
  "1367 LET T1=T1+1\r"
  "1370 Q=INT((J-U2)*(W/2))\r"
  "1380 PRINT \" MAKING\"INT(Q)\"RALLODS.\"\r"
  "1390 LET A=INT(A+Q)\r"
  "1400 V1=INT(((B-P1)*22)+(RND(1)*500))\r"
  "1405 V2=INT((2000-D)*15)\r"
  "1410 PRINT \" YOU MADE\"ABS(INT(V1-V2))\"RALLODS FROM TOURIST TRADE.\"\r"
  "1420 IF V2=0 THEN 1450\r"
  "1425 IF V1-V2>=V3 THEN 1450\r"
  "1430 PRINT \"   DECREASE BECAUSE \";\r"
  "1435 G1=RND(1)*10\r"
  "1440 IF G1<=2 THEN 1460\r"
  "1442 IF G1<=4 THEN 1465\r"
  "1444 IF G1<=6 THEN 1470\r"
  "1446 IF G1<=8 THEN 1475\r"
  "1448 IF G1<=10 THEN 1480\r"
  "1450 V3=INT(V1-V2)\r"
  "1451 A=INT(A+V3)\r"
  "1452 GOTO 1500\r"
  "1460 PRINT \"FISH POPULATION DWINDLED DUE TO WATER POLLUTION.\"\r"
  "1462 GOTO 1450\r"
  "1465 PRINT \"AIR POLLUTION IS KILLING GAME BIRD POPULATION.\"\r"
  "1467 GOTO 1450\r"
  "1470 PRINT \"MINERAL BATHS RUINED BY WATER POLLUTION.\"\r"
  "1472 GOTO 1450\r"
  "1475 PRINT \"UNPLESANT SMOG IS DISCOURAGING SUNBATHERS.\"\r"
  "1477 GOTO 1450\r"
  "1480 PRINT \"HOTELS ARE LOOKING SHABBY DUE TO SMOG GRIT.\"\r"
  "1482 GOTO 1450\r"
  "1500 IF B5>200 THEN 1600\r"
  "1505 IF B<343 THEN 1700\r"
  "1510 IF (A4/100)>5 THEN 1800\r"
  "1515 IF C>B THEN 1550\r"
  "1520 IF N5-1=X5 THEN 1900\r"
  "1545 GOTO 2000\r"
  "1550 FOR Y1=1 TO 8\r"
  "1552 PRINT\r"
  "1555 NEXT Y1\r"
  "1560 PRINT \"THE FORIEGN WORKERS HAVE REVOLTED AND TAKEN OVER THE \"\r"
  "1562 PRINT \"COUNTRY.\"\r"
  "1570 IF RND(1)>.5 THEN 1580\r"
  "1574 PRINT \"YOU ARE REMOVED FROM OFFICE AND ARE NOW RESIDING IN PRISON.\r"
  "1578 GOTO 1590\r"
  "1580 PRINT \"YOU HAVE BEEN ASSASSINATED.\"\r"
  "1590 REM--------END OF JOB--------\r"
  "1596 STOP\r"
  "1600 FOR Y1=1 TO 8\r"
  "1602 PRINT\r"
  "1605 NEXT Y1\r"
  "1610 PRINT B5\"COUNTRYMEN HAVE DIED IN ONE YEAR!!!!\"\r"
  "1615 PRINT \"YENDc HAVE BEEN IMPEACHETO AND REMOVED FOR MISMANAGEMENT\"\r"
  "1622 M6=INT(RND(1)*10)\r"
  "1625 IF M6<=3 THEN 1670\r"
  "1630 IF M6<=6 THEN 1680\r"
  "1635 IF M6<=10 THEN 1690\r"
  "1670 PRINT \"ALSO HAD YOUR LEFT EYE GOUGED OUT.\"\r"
  "1672 GOTO 1590\r"
  "1680 PRINT \"HAVE ALSO GAINED A VERY BAD REPUTATION.\"\r"
  "1682 GOTO 1590\r"
  "1690 PRINT \"HAVE ALSO BEEN DECLARED NATIONAL FINK.\"\r"
  "1692 GOTO 1590\r"
  "1700 FOR Y1=1 TO 8\r"
  "1702 PRINT\r"
  "1705 NEXT Y1\r"
  "1710 PRINT \"OVER ONE THIRD OF THE POPULATION HAS DIED SINCE YOU\"\r"
  "1715 PRINT \"WERE ELECTED TO OFFICE. THE PEOPLE (REMAINED)\"\r"
  "1720 PRINT \"HATE YOUR GUTS.\"\r"
  "1730 GOTO 1570\r"
  "1800 IF B5-F1<2 THEN 1515\r"
  "1805 FOR Y1=1 TO 8\r"
  "1807 PRINT\r"
  "1810 NEXT Y1\r"
  "1815 PRINT \"MONEY WAS LEFT OVER IN THE TREASURY WHICH YOU DID\"\r"
  "1820 PRINT \"DID NOT SPEND. AS A RESULT SOME OF YOUR COUNTRY DIED\"\r"
  "1825 PRINT \"OF STARVATION. THE PUBIC IS ENRAGED AND YOU HAVE\"\r"
  "1830 PRINT \"BEEN FORCED TO EITHER RESIGN OR COMMIT SUICIDE\"\r"
  "1835 PRINT \"THE CHIOCE IS YOURS\"\r"
  "1850 GOTO 1590\r"
  "1925 PRINT \"YOU HAVE SUCCESSFULLY COMPLETED YOUR \"N5\"YEAR TERM\"\r"
  "1950 GOTO 1590\r"
  "1960 INPUT \"HOW MANY YEARS WERE YOU IN OFFICE WHEN INTERRUPTED\";X5\r"
  "1962 IF X5<0 THEN 1590\r"
  "1963 IF X5<8 THEN 1969\r"
  "1965 PRINT \"   COME ON, YOUR TERM IS ONLY\"N5\"YEARS\"\r"
  "1967 GOTO 1960\r"
  "1969 INPUT \"HOW MUCH DID YOU HAVE IN THE TREASURY\";A\r"
  "1971 IF A<0 THEN 1590\r"
  "1975 INPUT \"HOW MANY COUNTRYMEN\";B\r"
  "1977 IF B<0 THEN 1590\r"
  "1980 INPUT \"HOW MANY WORKERS\";C\r"
  "1982 IF C<0 THEN 1590\r"
  "1990 INPUT \"HOW MANY SQ. MILES OF LAND\";D\r"
  "1992 IF D<0 THEN 1590\r"
  "1993 IF D>2000 THEN 1996\r"
  "1994 IF D>1000 THEN 100\r"
  "1996 PRINT \"   COME ON, YOU ONLY STARTED WITH 1000 SQ. MILES!\"\r"
  "1998 GOTO 1990\r"
  "2000 X5=X5+1\r"
  "2040 GOTO 100\r"
  "2046 END\r";

const char basic_lander[] =
  "100 REM----------------------------------------------------\r"
  "101 REM       L  A  N  D  E  R\r"
  "102 REM----------------------------------------------------\r"
  "103 REM        JUNE 16, 1977\r"
  "104 REM THIS VERSION OF LUNAR LANDER IS COURTESY OF\r"
  "105 REM THE IMSAI COMPANY.\r"
  "106 REM\r"
  "300 S3 =0\r"
  "310 N3=0\r"
  "320 H=500\r"
  "430 IF H<=0 THEN 1560\r"
  "1010 PRINT\"LUNAR LANDING SIMULATION\"\r"
  "1020 PRINT\"----- ------- ----------\"\r"
  "1030 PRINT\"TYPE '1' FOR INSTRUCTIONS\";\r"
  "1040 INPUT A\r"
  "1050 IF A<>1 THEN 1260\r"
  "1060 PRINT\r"
  "1070 PRINT\"YOU ARE LANDING ON THE MOON, YOUR HAVE HAD TO\"\r"
  "1075 PRINT\"ABORT YOUR AUTOMATIC LANDING PLAN AND HAVE TAKEN\"\r"
  "1077 PRINT\"OVER MANUAL CONTROL 500 FT. OVER A GOOD LANDING\"\r"
  "1080 PRINT\"SPOT. YOU ARE FALLING AT 50 FT/SEC, WITH 120 LBS\"\r"
  "1090 PRINT\"OF FUEL TOTAL; DEPLETED AS FOLLOWS:\"\r"
  "1120 PRINT\"(1) AFTER EACH SECOND, THE HEIGHT,VELOCITY AND\"\r"
  "1130 PRINT\"REMAINING FUEL WILL BE REPORTED.\"\r"
  "1140 PRINT\"(2) NEXT, A/?/ WILL BE TYPED. ENTER THE NUMBER\"\r"
  "1150 PRINT\"OF LBS OF FUEL YOU WISH TO BURN DURING THE NEXT\"\r"
  "1160 PRINT\"SECOND. EACH LB BURNED WILL SLOW THE DESCENT BY\"\r"
  "1170 PRINT\"1 FT/SEC. 5 LBS OF FUEL WILL MAINTAIN YOUR CUR-\"\r"
  "1175 PRINT\"RENT VELOCITY EXACTLY.\"\r"
  "1180 PRINT\"(3) MAXIMUM THRUST YOUR ENGINE CAN SUSTAIN IS\"\r"
  "1185 PRINT\"30 FT/SEC OR 30 LBS OF FUEL/SEC.\"\r"
  "1200 PRINT \"(4) WHEN YOU CONTACT THE LUNAR SURFACE, YOUR\"\r"
  "1210 PRINT\"DESCENT ENGINE WILL AUTO-SHUT OFF AND YOU WILL\"\r"
  "1220 PRINT\"BE GIVEN A READOUT OF LANDING CONDITIONS.\"\r"
  "1230 PRINT\"(5) IF OUT OF FUEL, ONLY REPORTS UNTIL\"\r"
  "1235 PRINT\"YOU CONTACT THE LUNAR SURFACE\"\r"
  "1240 T=0\r"
  "1245 V1=-5\r"
  "1250 PRINT\r"
  "1260 PRINT\"ALERT! ALERT! DESCENT PROCEEDURE INITIATED!\"\r"
  "1265 IF T>30 THEN PRINT \"HINT; NO BURN TILL SECOND # 4\"\r"
  "1266 IF T=0 THEN 1290\r"
  "1267 IF V1=0 THEN 1290\r"
  "1268 IF T<12 THEN PRINT \"HINT; YOU BURNED LATE FOR A NOVICE\"\r"
  "1290 PRINT\"SEC  FEET   SPEED    FUEL       PLOT OF DISTANCE\"\r"
  "1300 PRINT\r"
  "1310 T=0\r"
  "1320 H=500\r"
  "1330 V=50\r"
  "1340 F=120\r"
  "1350 PRINT T;TAB(4);H;TAB(12);V;TAB(20);F;TAB(29);\r"
  "1352 PRINT \"I\";TAB(H/15+29);\"*\";TAB(67);\r"
  "1360 INPUT B\r"
  "1370 IF B<0 THEN 1500\r"
  "1380 IF B>30 THEN 1520\r"
  "1390 IF B >F THEN 1540\r"
  "1400 V1=V-B+5\r"
  "1410 F=F-B\r"
  "1420 H = H-.5*(V+V1)\r"
  "1430 IF H<=0 THEN 1560\r"
  "1440 T=T+1\r"
  "1450 V=V1\r"
  "1460 IF F>0 THEN 1350\r"
  "1470 IF B=0 THEN 1490\r"
  "1480 PRINT TAB(29);\"***** OUT OF FUEL *****\"\r"
  "1490 PRINT T;TAB(4);H;TAB(12);V;TAB(20);F;TAB(29);\r"
  "1492 PRINT \"I\";TAB(H/15+29);\".\"\r"
  "1500 B=0\r"
  "1510 GOTO 1400\r"
  "1520 B=30\r"
  "1530 GOTO 1390\r"
  "1540 B=F\r"
  "1550 GOTO 1400\r"
  "1560 PRINT \"*** CONTACT ***\";\r"
  "1562 IF V1>20 THEN PRINT TAB(29);\"0\"\r"
  "1563 IF V1>25 THEN PRINT TAB(29);\"00\"\r"
  "1564 IF V1>30 THEN PRINT TAB(29);\"000\"\r"
  "1565 IF V1>35 THEN PRINT TAB(29);\"0  .\"\r"
  "1566 IF V1>40 THEN PRINT TAB(29);\".    .\"\r"
  "1567 IF V1>45 THEN PRINT TAB(29);\".\"\r"
  "1570 H =H+.5*(V+V1)\r"
  "1580 IF B=5 THEN 1610\r"
  "1585 Z=V*V+H*(10-2*B)\r"
  "1587 IF Z<0 THEN 1770\r"
  "1588 P=SQR(Z)\r"
  "1590 D=(P-V)/(5-B)\r"
  "1600 GOTO 1620\r"
  "1610 D=H/V\r"
  "1620 V1=V+(5-B)*D\r"
  "1625 N3 =N3+1\r"
  "1630 PRINT \"TOUCHDOWN AT \"; T+D;\"SECONDS\"\r"
  "1640 PRINT\"LANDING VELOCITY=\";V1;\"FT/SEC\"\r"
  "1641 IF V1>8 THEN PRINT \"OR \";V1*.5938;\" MPH, GROUNDHOG\";\r"
  "1642 IF V1<>0 THEN 1648\r"
  "1644 PRINT \"CONGRATULATIONS! A PERFECT LANDING\"\r"
  "1645 S3=S3+8\r"
  "1646 GOTO 1710\r"
  "1648 IF V1<85 THEN 1654\r"
  "1650 PRINT:PRINT\"YOU HAD TO TRY FOR THAT! DO IT RIGHT\"\r"
  "1652 GOTO 1260\r"
  "1654 FOR I1=1 TO 7\r"
  "1656 GOTO 2000\r"
  "1657 IF S1>V1 THEN 1660\r"
  "1658 NEXT I1\r"
  "1659 GOTO 1790\r"
  "1660 PRINT\";   SCORE = \";7-I1\r"
  "1661 S3 =S3+7-I1\r"
  "1662 GOTO 3000\r"
  "1664 PRINT\"NEARLY PERFECT: YOU MUST TRY AGAIN!\"\r"
  "1666 PRINT\"                    ----\"\r"
  "1668 GOTO  1260\r"
  "1670 PRINT \"GOOD.  ( YOU COULD WALK AWAY FROM IT )\":GOTO 1710\r"
  "1672 PRINT\"ABOUT LIKE HITTING THE WALL RUNNING HARD.\":GOTO 1710\r"
  "1674 PRINT\"OUCH! THAT HURT! ( THE LANDER )\":GOTO 1710\r"
  "1676 PRINT\"PUH-LEEEZE!  MY SOUFFLE'!\":GOTO 1710\r"
  "1678 PRINT \" YOU SHOULD REREAD THIS:   FOR EACH\":GOTO 1160\r"
  "1710 PRINT \"*\"\r"
  "1720 PRINT \" TYPE 1 FOR ANOTHER MISSION.\";\r"
  "1730 INPUT A\r"
  "1740 IF A=1 THEN 1260\r"
  "1745 PRINT \"FOR\";N3;\"MISSIONS, AVERAGE SCORE =\";S3/N3\r"
  "1746 IF N3<3 THEN 1750\r"
  "1747 IF S3/N3>4.5 THEN PRINT \"GOOD WORK!\"\r"
  "1750 PRINT \" CONTROL OUT\"\r"
  "1760 STOP\r"
  "1770 PRINT \"NEGATIVE ARGUMENT, END OF MISSION.\"\r"
  "1780 GOTO 1710\r"
  "1790 PRINT \"LOOP OVERFLOW, END MISSION\"\r"
  "1800 GOTO 1710\r"
  "1810 STOP\r"
  "2000 REM POWER X^Y PATCH\r"
  "2010 S1=2\r"
  "2040 FOR I9=1 TO I1 STEP 1\r"
  "2050 S1=S1*2\r"
  "2060 NEXT I9\r"
  "2070 GOTO 1657\r"
  "3000 REM ON GOTO PATCH FOR LINE 1662\r"
  "3005 IF I1=1 THEN 1664\r"
  "3010 IF I1=2 THEN 1670\r"
  "3015 IF I1=3 THEN 1672\r"
  "3020 IF I1=4 THEN 1674\r"
  "3025 IF I1=5 THEN 1676\r"
  "3030 IF I1=6 THEN 1678\r"
  "3035 IF I1=7 THEN 1710\r"
  "";

const char basic_life[] =
  "2 PRINT TAB(33);\"LIFE2\"\r"
  "4 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "6 PRINT: PRINT: PRINT\r"
  "7 DIM N(6,6),K(18),A(16),X(2),Y(2)\r"
  "8 DATA 3,102,103,120,130,121,112,111,12\r"
  "9 DATA 21,30,1020,1030,1011,1021,1003,1002,1012\r"
  "10 FOR M=1 TO 18: READ K(M): NEXT M\r"
  "13 DATA -1,0,1,0,0,-1,0,1,-1,-1,1,-1,-1,1,1,1\r"
  "14 FOR O1= 1 TO 16: READ A(O1): NEXT O1\r"
  "20 GOTO 500\r"
  "50 FOR J=1 TO 5\r"
  "51 FOR K=1 TO 5\r"
  "55 IF N(J,K)>99 THEN GOSUB 200\r"
  "60 NEXT K\r"
  "65 NEXT J\r"
  "90 K=0: M2=0: M3=0\r"
  "99 FOR J=0 TO 6: PRINT\r"
  "100 FOR K=0 TO 6\r"
  "101 IF J<>0 THEN IF J<>6 THEN 105\r"
  "102 IF K=6 THEN PRINT 0;: GOTO 125\r"
  "103 PRINT K;: GOTO 120\r"
  "105 IF K<>0 THEN IF K<>6 THEN 110\r"
  "106 IF J=6 THEN PRINT 0: GOTO 126\r"
  "107 PRINT J;: GOTO 120\r"
  "110 GOSUB 300\r"
  "120 NEXT K\r"
  "125 NEXT J\r"
  "126 RETURN\r"
  "200 B=1: IF N(J,K)>999 THEN B=10\r"
  "220 FOR O1= 1 TO 15 STEP 2\r"
  "230 N(J+A(O1),K+A(O1+1))=N(J+A(O1),K+A(O1+1))+B\r"
  "231 NEXT O1\r"
  "239 RETURN\r"
  "300 IF N(J,K)<3 THEN 399\r"
  "305 FOR O1=1 TO 18\r"
  "310 IF N(J,K)=K(O1) THEN 350\r"
  "315 NEXT O1\r"
  "320 GOTO 399\r"
  "350 IF O1>9 THEN 360\r"
  "351 N(J,K)=100: M2=M2+1: PRINT \" * \";\r"
  "355 RETURN\r"
  "360 N(J,K)=1000: M3=M3+1: PRINT \" # \";\r"
  "365 RETURN\r"
  "399 N(J,K)=0: PRINT \"   \";: RETURN\r"
  "500 PRINT TAB(10);\"U.B. LIFE GAME\"\r"
  "505 M2=0: M3=0\r"
  "510 FOR J=1 TO 5\r"
  "511 FOR K=1 TO 5\r"
  "515 N(J,K)=0\r"
  "516 NEXT K\r"
  "517 NEXT J\r"
  "519 FOR B=1 TO 2: P1=3: IF B=2 THEN P1=30\r"
  "520 PRINT:PRINT \"PLAYER\";B;\" - 3 LIVE PIECES.\"\r"
  "535 FOR K1=1 TO 3: GOSUB 700\r"
  "540 N(X(B),Y(B))=P1: NEXT K1\r"
  "542 NEXT B\r"
  "559 GOSUB 90\r"
  "560 PRINT: GOSUB 50\r"
  "570 IF M2=0 THEN IF M3=0 THEN 574\r"
  "571 IF M3=0 THEN B=1: GOTO 575\r"
  "572 IF M2=0 THEN B=2: GOTO 575\r"
  "573 GOTO 580\r"
  "574 PRINT: PRINT \"A DRAW\":GOTO 800\r"
  "575 PRINT: PRINT \"PLAYER\";B;\"IS THE WINNER\":GOTO 800\r"
  "580 FOR B=1 TO 2: PRINT: PRINT: PRINT \"PLAYER\";B;: GOSUB 700\r"
  "581 IF B=99 THEN 560\r"
  "582 NEXT B\r"
  "586 N(X(1),Y(1))=100: N(X(2),Y(2))=1000\r"
  "596 GOTO 560\r"
  "700 PRINT \"X,Y\":PRINT\"XXXXXX\";CHR$(13);\"$$$$$$\";CHR$(13);\"&&&&&&\";\r"
  "701 PRINT CHR$(13);: INPUT Y(B),X(B)\r"
  "705 IF X(B)<=5 THEN IF X(B)>0 THEN 708\r"
  "706 GOTO 750\r"
  "708 IF Y(B)<=5 THEN IF Y(B)>0 THEN 715\r"
  "710 GOTO 750\r"
  "715 IF N(X(B),Y(B))<>0 THEN 750\r"
  "720 IF B=1 THEN RETURN\r"
  "725 IF X(1)=X(2) THEN IF Y(1)=Y(2) THEN 740\r"
  "730 RETURN\r"
  "740 PRINT \"SAME COORD.  SET TO 0\"\r"
  "741 N(X(B)+1,Y(B)+1)=0: B=99: RETURN\r"
  "750 PRINT \"ILLEGAL COORDS. RETYPE\": GOTO 700\r"
  "999 END\r"
  "";

const char basic_mastermind[] =
  "2 PRINT TAB(30);\"MASTERMIND\"\r"
  "4 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "6 PRINT: PRINT: PRINT\r"
  "10 REM\r"
  "20 REM     MASTERMIND II\r"
  "30 REM     STEVE NORTH\r"
  "40 REM     CREATIVE COMPUTING\r"
  "50 REM     PO BOX 789-M MORRISTOWN NEW JERSEY 07960\r"
  "60 REM\r"
  "70 REM\r"
  "80 INPUT \"NUMBER OF COLORS\";C9\r"
  "90 IF C9>8 THEN PRINT \"NO MORE THAN 8, PLEASE!\":GOTO 80\r"
  "100 INPUT \"NUMBER OF POSITIONS\";P9\r"
  "110 INPUT \"NUMBER OF ROUNDS\";R9\r"
  "120 P=C9^P9\r"
  "130 PRINT \"TOTAL POSSIBILITIES =\";P\r"
  "140 H=0:C=0\r"
  "150 DIM Q(P9),S(10,2),S$(10),A$(P9),G$(P9),I(P),H$(P9)\r"
  "160 L$=\"BWRGOYPT\"\r"
  "170 PRINT\r"
  "180 PRINT\r"
  "190 PRINT \"COLOR     LETTER\"\r"
  "200 PRINT \"=====     ======\"\r"
  "210 FOR X=1 TO C9\r"
  "220 READ X$\r"
  "230 PRINT X$;TAB(13);MID$(L$,X,1)\r"
  "240 NEXT X\r"
  "250 PRINT\r"
  "260 FOR R=1 TO R9\r"
  "270 PRINT \r"
  "280 PRINT \"ROUND NUMBER\";R;\"----\"\r"
  "290 PRINT\r"
  "300 PRINT \"GUESS MY COMBINATION.\":PRINT\r"
  "310 REM     GET A COMBINATION\r"
  "320 A=INT(P*RND(1)+1)\r"
  "330 GOSUB 3000\r"
  "340 FOR X=1 TO A\r"
  "350 GOSUB 3500\r"
  "360 NEXT X\r"
  "370 FOR M=1 TO 10\r"
  "380 PRINT \"MOVE # \";M;\" GUESS \";:INPUT X$\r"
  "390 IF X$=\"BOARD\" THEN 2000\r"
  "400 IF X$=\"QUIT\" THEN 2500\r"
  "410 IF LEN(X$)<>P9 THEN PRINT \"BAD NUMBER OF POSITIONS.\":GOTO 380\r"
  "420 REM     UNPACK X$ INTO G$(1-P9)\r"
  "430 FOR X=1 TO P9\r"
  "440 FOR Y=1 TO C9\r"
  "450 IF MID$(X$,X,1)=MID$(L$,Y,1) THEN 480\r"
  "460 NEXT Y\r"
  "470 PRINT \"'\"; MID$(X$,X,1); \"' IS UNRECOGNIZED.\":GOTO 380\r"
  "480 G$(X)=MID$(X$,X,1)\r"
  "490 NEXT X\r"
  "500 REM     NOW WE CONVERT Q(1-P9) INTO A$(1-P9) [ACTUAL GUESS]\r"
  "510 GOSUB 4000\r"
  "520 REM     AND GET NUMBER OF BLACKS AND WHITES\r"
  "530 GOSUB 4500\r"
  "540 IF B=P9 THEN 630\r"
  "550 REM     TELL HUMAN RESULTS\r"
  "560 PRINT \"YOU HAVE \";B;\" BLACKS AND \";W;\" WHITES.\"\r"
  "570 REM     SAVE ALL THIS STUFF FOR BOARD PRINTOUT LATER\r"
  "580 S$(M)=X$\r"
  "590 S(M,1)=B\r"
  "600 S(M,2)=W\r"
  "610 NEXT M\r"
  "620 PRINT \"YOU RAN OUT OF MOVES!  THAT'S ALL YOU GET!\":GOTO 640\r"
  "622 GOSUB 4000\r"
  "623 PRINT \"THE ACTUAL COMBINATION WAS: \";\r"
  "624 FOR X=1 TO P9\r"
  "625 PRINT A$(X);\r"
  "626 NEXT X\r"
  "627 PRINT\r"
  "630 PRINT \"YOU GUESSED IT IN \";M;\" MOVES!\"\r"
  "640 H=H+M\r"
  "650 GOSUB 5000\r"
  "660 REM\r"
  "670 REM     NOW COMPUTER GUESSES\r"
  "680 REM\r"
  "690 FOR X=1 TO P\r"
  "700 I(X)=1\r"
  "710 NEXT X\r"
  "720 PRINT \"NOW I GUESS.  THINK OF A COMBINATION.\"\r"
  "730 INPUT \"HIT RETURN WHEN READY:\";X$\r"
  "740 FOR M=1 TO 10\r"
  "750 GOSUB 3000\r"
  "760 REM     FIND A GUESS\r"
  "770 G=INT(P*RND(1)+1)\r"
  "780 IF I(G)=1 THEN 890\r"
  "790 FOR X=G TO P\r"
  "800 IF I(X)=1 THEN 880\r"
  "810 NEXT X\r"
  "820 FOR X=1 TO G\r"
  "830 IF I(X)=1 THEN 880\r"
  "840 NEXT X\r"
  "850 PRINT \"YOU HAVE GIVEN ME INCONSISTENT INFORMATION.\"\r"
  "860 PRINT \"TRY AGAIN, AND THIS TIME PLEASE BE MORE CAREFUL.\"\r"
  "870 GOTO 660\r"
  "880 G=X\r"
  "890 REM     NOW WE CONVERT GUESS #G INTO G$\r"
  "900 FOR X=1 TO G\r"
  "910 GOSUB 3500\r"
  "920 NEXT X\r"
  "930 GOSUB 6000\r"
  "940 PRINT \"MY GUESS IS: \";\r"
  "950 FOR X=1 TO P9\r"
  "960 PRINT H$(X);\r"
  "970 NEXT X\r"
  "980 INPUT \"  BLACKS, WHITES \";B1,W1\r"
  "990 IF B1=P9 THEN 1120\r"
  "1000 GOSUB 3000\r"
  "1010 FOR X=1 TO P\r"
  "1020 GOSUB 3500\r"
  "1030 IF I(X)=0 THEN 1070\r"
  "1035 GOSUB 6500\r"
  "1040 GOSUB 4000\r"
  "1050 GOSUB 4500\r"
  "1060 IF B1<>B OR W1<>W THEN I(X)=0\r"
  "1070 NEXT X\r"
  "1080 NEXT M\r"
  "1090 PRINT \"I USED UP ALL MY MOVES!\"\r"
  "1100 PRINT \"I GUESS MY CPU IS JUST HAVING AN OFF DAY.\"\r"
  "1110 GOTO 1130\r"
  "1120 PRINT \"I GOT IT IN \";M;\" MOVES!\"\r"
  "1130 C=C+M\r"
  "1140 GOSUB 5000\r"
  "1150 NEXT R\r"
  "1160 PRINT \"GAME OVER\"\r"
  "1170 PRINT \"FINAL SCORE:\"\r"
  "1180 GOSUB 5040\r"
  "1190 STOP\r"
  "2000 REM\r"
  "2010 REM     BOARD PRINTOUT ROUTINE\r"
  "2020 REM\r"
  "2025 PRINT\r"
  "2030 PRINT \"BOARD\"\r"
  "2040 PRINT \"MOVE     GUESS          BLACK     WHITE\"\r"
  "2050 FOR Z=1 TO M-1\r"
  "2060 PRINT Z;TAB(9);S$(Z);TAB(25);S(Z,1);TAB(35);S(Z,2)\r"
  "2070 NEXT Z\r"
  "2075 PRINT\r"
  "2080 GOTO 380\r"
  "2500 REM\r"
  "2510 REM     QUIT ROUTINE\r"
  "2520 REM\r"
  "2530 PRINT \"QUITTER!  MY COMBINATION WAS: \";\r"
  "2535 GOSUB 4000\r"
  "2540 FOR X=1 TO P9\r"
  "2550 PRINT A$(X);\r"
  "2560 NEXT X\r"
  "2565 PRINT\r"
  "2570 PRINT \"GOOD BYE\"\r"
  "2580 STOP\r"
  "3000 REM\r"
  "3010 REM     INITIALIZE Q(1-P9) TO ZEROS\r"
  "3020 REM\r"
  "3030 FOR S=1 TO P9\r"
  "3040 Q(S)=0\r"
  "3050 NEXT S\r"
  "3060 RETURN\r"
  "3500 REM\r"
  "3510 REM     INCREMENT Q(1-P9)\r"
  "3520 REM\r"
  "3522 IF Q(1)>0 THEN 3530\r"
  "3524 REM  IF ZERO, THIS IS OUR FIRST INCREMENT: MAKE ALL ONES\r"
  "3526 FOR S=1 TO P9\r"
  "3527 Q(S)=1\r"
  "3528 NEXT S\r"
  "3529 RETURN\r"
  "3530 Q=1\r"
  "3540 Q(Q)=Q(Q)+1\r"
  "3550 IF Q(Q)<=C9 THEN RETURN\r"
  "3560 Q(Q)=1\r"
  "3570 Q=Q+1\r"
  "3580 GOTO 3540\r"
  "4000 REM\r"
  "4010 REM     CONVERT Q(1-P9) TO A$(1-P9)\r"
  "4020 REM\r"
  "4030 FOR S=1 TO P9\r"
  "4040 A$(S)=MID$(L$,Q(S),1)\r"
  "4050 NEXT S\r"
  "4060 RETURN\r"
  "4500 REM\r"
  "4510 REM     GET NUMBER OF BLACKS (B) AND WHITES (W)\r"
  "4520 REM     MASHES G$ AND A$ IN THE PROCESS\r"
  "4530 REM\r"
  "4540 B=0:W=0:F=0\r"
  "4550 FOR S=1 TO P9\r"
  "4560 IF G$(S)<>A$(S) THEN 4620\r"
  "4570 B=B+1\r"
  "4580 G$(S)=CHR$(F)\r"
  "4590 A$(S)=CHR$(F+1)\r"
  "4600 F=F+2\r"
  "4610 GOTO 4660\r"
  "4620 FOR T=1 TO P9\r"
  "4630 IF G$(S)<>A$(T) THEN 4650\r"
  "4640 IF G$(T)=A$(T) THEN 4650\r"
  "4645 W=W+1:A$(T)=CHR$(F):G$(S)=CHR$(F+1):F=F+2:GOTO 4660\r"
  "4650 NEXT T\r"
  "4660 NEXT S\r"
  "4670 RETURN\r"
  "5000 REM\r"
  "5010 REM     PRINT SCORE\r"
  "5020 REM\r"
  "5030 PRINT \"SCORE:\"\r"
  "5040 PRINT \"     COMPUTER \";C\r"
  "5050 PRINT \"     HUMAN    \";H\r"
  "5060 PRINT\r"
  "5070 RETURN\r"
  "5500 REM\r"
  "5510 REM     CONVERT Q(1-P9) INTO G$(1-P9)\r"
  "5520 REM\r"
  "5530 FOR S=1 TO P9\r"
  "5540 G$(S)=MID$(L$,Q(S),1)\r"
  "5550 NEXT S\r"
  "5560 RETURN\r"
  "6000 REM\r"
  "6010 REM     CONVERT Q(1-P9) TO H$(1-P9)\r"
  "6020 REM\r"
  "6030 FOR S=1 TO P9\r"
  "6040 H$(S)=MID$(L$,Q(S),1)\r"
  "6050 NEXT S\r"
  "6060 RETURN\r"
  "6500 REM\r"
  "6510 REM     COPY H$ INTO G$\r"
  "6520 REM\r"
  "6530 FOR S=1 TO P9\r"
  "6540 G$(S)=H$(S)\r"
  "6550 NEXT S\r"
  "6560 RETURN\r"
  "8000 REM     PROGRAM DATA FOR COLOR NAMES\r"
  "8010 DATA BLACK,WHITE,RED,GREEN,ORANGE,YELLOW,PURPLE,TAN\r"
  "9998 REM   ...WE'RE SORRY BUT IT'S TIME TO GO...\r"
  "9999 END\r"
  "";

const char basic_orbit[] =
  "2 PRINT TAB(33);\"ORBIT\"\r"
  "4 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "6 PRINT:PRINT:PRINT\r"
  "10 PRINT \"SOMEWHERE ABOVE YOUR PLANET IS A ROMULAN SHIP.\"\r"
  "15 PRINT\r"
  "20 PRINT \"THE SHIP IS IN A CONSTANT POLAR ORBIT.  ITS\"\r"
  "25 PRINT \"DISTANCE FROM THE CENTER OF YOUR PLANET IS FROM\"\r"
  "30 PRINT \"10,000 TO 30,000 MILES AND AT ITS PRESENT VELOCITY CAN\"\r"
  "31 PRINT \"CIRCLE YOUR PLANET ONCE EVERY 12 TO 36 HOURS.\"\r"
  "35 PRINT\r"
  "40 PRINT \"UNFORTUNATELY, THEY ARE USING A CLOAKING DEVICE SO\"\r"
  "45 PRINT \"YOU ARE UNABLE TO SEE THEM, BUT WITH A SPECIAL\"\r"
  "50 PRINT \"INSTRUMENT YOU CAN TELL HOW NEAR THEIR SHIP YOUR\"\r"
  "55 PRINT \"PHOTON BOMB EXPLODED.  YOU HAVE SEVEN HOURS UNTIL THEY\"\r"
  "60 PRINT \"HAVE BUILT UP SUFFICIENT POWER IN ORDER TO ESCAPE\"\r"
  "65 PRINT \"YOUR PLANET'S GRAVITY.\"\r"
  "70 PRINT\r"
  "75 PRINT \"YOUR PLANET HAS ENOUGH POWER TO FIRE ONE BOMB AN HOUR.\"\r"
  "80 PRINT\r"
  "85 PRINT \"AT THE BEGINNING OF EACH HOUR YOU WILL BE ASKED TO GIVE AN\"\r"
  "90 PRINT \"ANGLE (BETWEEN 0 AND 360) AND A DISTANCE IN UNITS OF\"\r"
  "95 PRINT \"100 MILES (BETWEEN 100 AND 300), AFTER WHICH YOUR BOMB'S\"\r"
  "100 PRINT \"DISTANCE FROM THE ENEMY SHIP WILL BE GIVEN.\"\r"
  "105 PRINT\r"
  "110 PRINT \"AN EXPLOSION WITHIN 5,000 MILES OF THE ROMULAN SHIP\"\r"
  "111 PRINT \"WILL DESTROY IT.\"\r"
  "114 PRINT\r"
  "115 PRINT \"BELOW IS A DIAGRAM TO HELP YOU VISUALIZE YOUR PLIGHT.\"\r"
  "116 PRINT\r"
  "117 PRINT\r"
  "168 PRINT \"                          90\"\r"
  "170 PRINT \"                    0000000000000\"\r"
  "171 PRINT \"                 0000000000000000000\"\r"
  "172 PRINT \"               000000           000000\"\r"
  "173 PRINT \"             00000                 00000\"\r"
  "174 PRINT \"            00000    XXXXXXXXXXX    00000\"\r"
  "175 PRINT \"           00000    XXXXXXXXXXXXX    00000\"\r"
  "176 PRINT \"          0000     XXXXXXXXXXXXXXX     0000\"\r"
  "177 PRINT \"         0000     XXXXXXXXXXXXXXXXX     0000\"\r"
  "178 PRINT \"        0000     XXXXXXXXXXXXXXXXXXX     0000\"\r"
  "179 PRINT \"180<== 00000     XXXXXXXXXXXXXXXXXXX     00000 ==>0\"\r"
  "180 PRINT \"        0000     XXXXXXXXXXXXXXXXXXX     0000\"\r"
  "181 PRINT \"         0000     XXXXXXXXXXXXXXXXX     0000\"\r"
  "182 PRINT \"          0000     XXXXXXXXXXXXXXX     0000\"\r"
  "183 PRINT \"           00000    XXXXXXXXXXXXX    00000\"\r"
  "184 PRINT \"            00000    XXXXXXXXXXX    00000\"\r"
  "185 PRINT \"             00000                 00000\"\r"
  "186 PRINT \"               000000           000000\"\r"
  "187 PRINT \"                 0000000000000000000\"\r"
  "188 PRINT \"                    0000000000000\"\r"
  "190 PRINT \"                         270\"\r"
  "192 PRINT\r"
  "195 PRINT \"X - YOUR PLANET\"\r"
  "196 PRINT \"O - THE ORBIT OF THE ROMULAN SHIP\"\r"
  "197 PRINT\r"
  "198 PRINT \"ON THE ABOVE DIAGRAM, THE ROMULAN SHIP IS CIRCLING\"\r"
  "199 PRINT \"COUNTERCLOCKWISE AROUND YOUR PLANET.  DON'T FORGET THAT\"\r"
  "200 PRINT \"WITHOUT SUFFICIENT POWER THE ROMULAN SHIP'S ALTITUDE\"\r"
  "210 PRINT \"AND ORBITAL RATE WILL REMAIN CONSTANT.\"\r"
  "220 PRINT \r"
  "230 PRINT \"GOOD LUCK.  THE FEDERATION IS COUNTING ON YOU.\"\r"
  "270 A=INT(360*RND(1))\r"
  "280 D=INT(200*RND(1)+200)\r"
  "290 R=INT(20*RND(1)+10)\r"
  "300 H=0\r"
  "310 IF H=7 THEN 490\r"
  "320 H=H+1\r"
  "325 PRINT\r"
  "326 PRINT\r"
  "330 PRINT \"THIS IS HOUR\";H;\", AT WHAT ANGLE DO YOU WISH TO SEND\"\r"
  "335 PRINT \"YOUR PHOTON BOMB\";\r"
  "340 INPUT A1\r"
  "350 PRINT \"HOW FAR OUT DO YOU WISH TO DETONATE IT\";\r"
  "360 INPUT D1\r"
  "365 PRINT\r"
  "366 PRINT\r"
  "370 A=A+R\r"
  "380 IF A<360 THEN 400\r"
  "390 A=A-360\r"
  "400 T=ABS(A-A1)\r"
  "410 IF T<180 THEN 430\r"
  "420 T=360-T\r"
  "430 C=SQR(D*D+D1*D1-2*D*D1*COS(T*3.14159/180))\r"
  "440 PRINT \"YOUR PHOTON BOMB EXPLODED\";C;\"*10^2 MILES FROM THE\"\r"
  "445 PRINT \"ROMULAN SHIP.\"\r"
  "450 IF C<=50 THEN 470\r"
  "460 GOTO 310\r"
  "470 PRINT \"YOU HAVE SUCCESFULLY COMPLETED YOUR MISSION.\"\r"
  "480 GOTO 500\r"
  "490 PRINT \"YOU HAVE ALLOWED THE ROMULANS TO ESCAPE.\"\r"
  "500 PRINT \"ANOTHER ROMULAN SHIP HAS GONE INTO ORBIT.\"\r"
  "510 PRINT \"DO YOU WISH TO TRY TO DESTROY IT\";\r"
  "520 INPUT C$\r"
  "530 IF C$=\"YES\" THEN 270\r"
  "540 PRINT \"GOOD BYE.\"\r"
  "999 END\r"
  "";

const char basic_pizza[] =
  "5 PRINT TAB(33);\"PIZZA\"\r"
  "10 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "15 PRINT: PRINT: PRINT\r"
  "20 DIM S$(16),M$(4)\r"
  "30 PRINT \"PIZZA DELIVERY GAME\": PRINT\r"
  "50 INPUT \"WHAT IS YOUR FIRST NAME\";N$: PRINT\r"
  "80 PRINT \"HI, \";N$;\".  IN THIS GAME YOU ARE TO TAKE ORDERS\"\r"
  "90 PRINT \"FOR PIZZAS.  THEN YOU ARE TO TELL A DELIVERY BOY\"\r"
  "100 PRINT \"WHERE TO DELIVER THE ORDERED PIZZAS.\": PRINT: PRINT\r"
  "140 FOR I=1 TO 16\r"
  "150 READ S$(I)\r"
  "160 NEXT I\r"
  "170 FOR I=1 TO 4\r"
  "180 READ M$(I)\r"
  "190 NEXT I\r"
  "200 DATA \"A\",\"B\",\"C\",\"D\",\"E\",\"F\",\"G\",\"H\",\"I\",\"J\",\"K\",\"L\",\"M\",\"N\",\"O\"\r"
  "210 DATA \"P\",\"1\",\"2\",\"3\",\"4\"\r"
  "230 PRINT \"MAP OF THE CITY OF HYATTSVILLE\": PRINT\r"
  "250 PRINT \" -----1-----2-----3-----4-----\"\r"
  "260 K=4\r"
  "270 FOR I=1 TO 4\r"
  "280 PRINT \"-\": PRINT \"-\": PRINT\"-\": PRINT \"-\"\r"
  "320 PRINT M$(K);\r"
  "330 S1=16-4*I+1\r"
  "340 PRINT \"     \";S$(S1);\"     \";S$(S1+1);\"     \";S$(S1+2);\"     \";\r"
  "350 PRINT S$(S1+3);\"     \";M$(K)\r"
  "380 K=K-1\r"
  "390 NEXT I\r"
  "400 PRINT \"-\": PRINT \"-\": PRINT \"-\": PRINT \"-\"\r"
  "440 PRINT \" -----1-----2-----3-----4-----\": PRINT\r"
  "460 PRINT \"THE OUTPUT IS A MAP OF THE HOMES WHERE\"\r"
  "470 PRINT \"YOU ARE TO SEND PIZZAS.\": PRINT\r"
  "490 PRINT \"YOUR JOB IS TO GIVE A TRUCK DRIVER\"\r"
  "500 PRINT \"THE LOCATION OR COORDINATES OF THE\"\r"
  "510 PRINT \"HOME ORDERING THE PIZZA.\": PRINT\r"
  "520 INPUT \"DO YOU NEED MORE DIRECTIONS\";A$\r"
  "530 IF A$=\"YES\" THEN 590\r"
  "540 IF A$=\"NO\" THEN 750\r"
  "550 PRINT \"'YES' OR 'NO' PLEASE, NOW THEN,\": GOTO 520\r"
  "590 PRINT: PRINT \"SOMEBODY WILL ASK FOR A PIZZA TO BE\"\r"
  "600 PRINT \"DELIVERED.  THEN A DELIVERY BOY WILL\"\r"
  "610 PRINT \"ASK YOU FOR THE LOCATION.\":PRINT \"     EXAMPLE:\"\r"
  "620 PRINT \"THIS IS J.  PLEASE SEND A PIZZA.\"\r"
  "640 PRINT \"DRIVER TO \";N$;\".  WHERE DOES J LIVE?\"\r"
  "650 PRINT \"YOUR ANSWER WOULD BE 2,3\": PRINT\r"
  "660 INPUT \"UNDERSTAND\";A$\r"
  "670 IF A$=\"YES\" THEN 690\r"
  "680 PRINT \"THIS JOB IS DEFINITELY TOO DIFFICULT FOR YOU. THANKS ANYWAY\"\r"
  "685 GOTO 999\r"
  "690 PRINT \"GOOD.  YOU ARE NOW READY TO START TAKING ORDERS.\": PRINT\r"
  "700 PRINT \"GOOD LUCK!!\": PRINT\r"
  "750 FOR I=1 TO 5\r"
  "760 S=INT(RND(1)*16+1): PRINT\r"
  "770 PRINT \"HELLO \";N$;\"'S PIZZA.  THIS IS \";S$(S);\".\";\r"
  "775 PRINT \"  PLEASE SEND A PIZZA.\"\r"
  "780 PRINT \"  DRIVER TO \";N$;\":  WHERE DOES \";S$(S);\" LIVE\";\r"
  "790 INPUT A(1),A(2)\r"
  "870 T=A(1)+(A(2)-1)*4\r"
  "880 IF T=S THEN 920\r"
  "890 PRINT \"THIS IS \";S$(T);\".  I DID NOT ORDER A PIZZA.\"\r"
  "900 PRINT \"I LIVE AT \";A(1);\",\";A(2)\r"
  "910 GOTO 780\r"
  "920 PRINT \"HELLO \"N$;\".  THIS IS \";S$(S);\", THANKS FOR THE PIZZA.\"\r"
  "930 NEXT I\r"
  "940 PRINT: INPUT \"DO YOU WANT TO DELIVER MORE PIZZAS\";A$\r"
  "960 IF A$=\"YES\" THEN 750\r"
  "970 PRINT: PRINT \"O.K. \";N$;\", SEE YOU LATER!\":PRINT\r"
  "999 END\r"
  "";

const char basic_poker[] =
  "2 PRINT TAB(33);\"POKER\"\r"
  "4 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "6 PRINT: PRINT: PRINT\r"
  "10 DIM A(50),B(15)\r"
  "20 DEF FNA(X)=INT(10*RND(1))\r"
  "30 DEF FNB(X)=X-100*INT(X/100)\r"
  "40 PRINT \"WELCOME TO THE CASINO.  WE EACH HAVE $200.\"\r"
  "50 PRINT \"I WILL OPEN THE BETTING BEFORE THE DRAW; YOU OPEN AFTER.\"\r"
  "60 PRINT \"TO FOLD BET 0; TO CHECK BET .5.\"\r"
  "70 PRINT \"ENOUGH TALK -- LET'S GET DOWN TO BUSINESS.\"\r"
  "80 PRINT\r"
  "90 LET O=1\r"
  "100 LET C=200\r"
  "110 LET S=200\r"
  "120 LET P=0\r"
  "130 REM\r"
  "140 PRINT\r"
  "150 IF C<=5 THEN 3670\r"
  "160 PRINT \"THE ANTE IS $5.  I WILL DEAL:\"\r"
  "170 PRINT\r"
  "180 IF S>5 THEN 200\r"
  "190 GOSUB 3830\r"
  "200 LET P=P+10\r"
  "210 LET S=S-5\r"
  "220 LET C=C-5\r"
  "230 FOR Z=1 TO 10\r"
  "240 GOSUB 1740\r"
  "250 NEXT Z\r"
  "260 PRINT \"YOUR HAND:\"\r"
  "270 N=1\r"
  "280 GOSUB 1850\r"
  "290 N=6\r"
  "300 I=2\r"
  "310 GOSUB 2170\r"
  "320 PRINT\r"
  "330 IF I<>6 THEN 470\r"
  "340 IF FNA(0)<=7 THEN 370\r"
  "350 LET X=11100\r"
  "360 GOTO 420\r"
  "370 IF FNA(0)<=7 THEN 400\r"
  "380 LET X=11110\r"
  "390 GOTO 420\r"
  "400 IF FNA(0)>=1 THEN 450\r"
  "410 X=11111\r"
  "420 I=7\r"
  "430 Z=23\r"
  "440 GOTO 580\r"
  "450 Z=1\r"
  "460 GOTO 510\r"
  "470 IF U>=13 THEN 540\r"
  "480 IF FNA(0)>=2 THEN 500\r"
  "490 GOTO 420\r"
  "500 Z=0\r"
  "510 K=0\r"
  "520 PRINT \"I CHECK.\"\r"
  "530 GOTO 620\r"
  "540 IF U<=16 THEN 570\r"
  "550 Z=2\r"
  "560 IF FNA(0)>=1 THEN 580\r"
  "570 Z=35\r"
  "580 V=Z+FNA(0)\r"
  "590 GOSUB 3480\r"
  "600 PRINT \"I'LL OPEN WITH $\"V\r"
  "610 K=V\r"
  "620 GOSUB 3050\r"
  "630 GOSUB 650\r"
  "640 GOTO 820\r"
  "650 IF I<>3 THEN 760\r"
  "660 PRINT\r"
  "670 PRINT \"I WIN.\"\r"
  "680 C=C+P\r"
  "690 PRINT \"NOW I HAVE $\"C\"AND YOU HAVE $\"S\r"
  "700 PRINT \"DO YOU WISH TO CONTINUE\";\r"
  "710 INPUT H$\r"
  "720 IF H$=\"YES\" THEN 120\r"
  "730 IF H$=\"NO\" THEN 4100\r"
  "740 PRINT \"ANSWER YES OR NO, PLEASE.\"\r"
  "750 GOTO 700\r"
  "760 IF I<>4 THEN 810\r"
  "770 PRINT\r"
  "780 PRINT \"YOU WIN.\"\r"
  "790 S=S+P\r"
  "800 GOTO 690\r"
  "810 RETURN\r"
  "820 PRINT\r"
  "830 PRINT \"NOW WE DRAW -- HOW MANY CARDS DO YOU WANT\";\r"
  "840 INPUT T\r"
  "850 IF T=0 THEN 980\r"
  "860 Z=10\r"
  "870 IF T<4 THEN 900\r"
  "880 PRINT \"YOU CAN'T DRAW MORE THAN THREE CARDS.\"\r"
  "890 GOTO 840\r"
  "900 PRINT \"WHAT ARE THEIR NUMBERS:\"\r"
  "910 FOR Q=1 TO T\r"
  "920 INPUT U\r"
  "930 GOSUB 1730\r"
  "940 NEXT Q\r"
  "950 PRINT \"YOUR NEW HAND:\"\r"
  "960 N=1\r"
  "970 GOSUB 1850\r"
  "980 Z=10+T\r"
  "990 FOR U=6 TO 10\r"
  "1000 IF INT(X/10^(U-6))<>10*INT(X/10^(U-5)) THEN 1020\r"
  "1010 GOSUB 1730\r"
  "1020 NEXT U\r"
  "1030 PRINT\r"
  "1040 PRINT \"I AM TAKING\"Z-10-T\"CARD\";\r"
  "1050 IF Z=11+T THEN 1090\r"
  "1060 PRINT \"S\"\r"
  "1070 PRINT\r"
  "1080 GOTO 1100\r"
  "1090 PRINT\r"
  "1100 N=6\r"
  "1110 V=I\r"
  "1120 I=1\r"
  "1130 GOSUB 2170\r"
  "1140 B=U\r"
  "1150 M=D\r"
  "1160 IF V<>7 THEN 1190\r"
  "1170 Z=28\r"
  "1180 GOTO 1330\r"
  "1190 IF I<>6 THEN 1220\r"
  "1200 Z=1\r"
  "1210 GOTO 1330\r"
  "1220 IF U>=13 THEN 1270\r"
  "1230 Z=2\r"
  "1240 IF FNA(0)<>6 THEN 1260\r"
  "1250 Z=19\r"
  "1260 GOTO 1330\r"
  "1270 IF U>=16 THEN 1320\r"
  "1280 Z=19\r"
  "1290 IF FNA(0)<>8 THEN 1310\r"
  "1300 Z=11\r"
  "1310 GOTO 1330\r"
  "1320 Z=2\r"
  "1330 K=0\r"
  "1340 GOSUB 3050\r"
  "1350 IF T<>.5 THEN 1450\r"
  "1360 IF V=7 THEN 1400\r"
  "1370 IF I<>6 THEN 1400\r"
  "1380 PRINT \"I'LL CHECK\"\r"
  "1390 GOTO 1460\r"
  "1400 V=Z+FNA(0)\r"
  "1410 GOSUB 3480\r"
  "1420 PRINT \"I'LL BET $\"V\r"
  "1430 K=V\r"
  "1440 GOSUB 3060\r"
  "1450 GOSUB 650\r"
  "1460 PRINT\r"
  "1470 PRINT \"NOW WE COMPARE HANDS:\"\r"
  "1480 J$=H$\r"
  "1490 K$=I$\r"
  "1500 PRINT \"MY HAND:\"\r"
  "1510 N=6\r"
  "1520 GOSUB 1850\r"
  "1530 N=1\r"
  "1540 GOSUB 2170\r"
  "1550 PRINT\r"
  "1560 PRINT \"YOU HAVE \";\r"
  "1570 K=D\r"
  "1580 GOSUB 3690\r"
  "1590 H$=J$\r"
  "1600 I$=K$\r"
  "1610 K=M\r"
  "1620 PRINT \"AND I HAVE \";\r"
  "1630 GOSUB 3690\r"
  "1640 IF B>U THEN 670\r"
  "1650 IF U>B THEN 780\r"
  "1660 IF H$=\"A FLUS\" THEN 1700\r"
  "1662 IF FNB(M)<FNB(D) THEN 780\r"
  "1664 IF FNB(M)>FNB(D) THEN 670\r"
  "1670 PRINT \"THE HAND IS DRAWN.\"\r"
  "1680 PRINT \"ALL $\"P\"REMAINS IN THE POT.\"\r"
  "1690 GOTO 140\r"
  "1700 IF FNB(M)>FNB(D) THEN 670\r"
  "1710 IF FNB(D)>FNB(M) THEN 780\r"
  "1720 GOTO 1670\r"
  "1730 Z=Z+1\r"
  "1740 A(Z)=100*INT(4*RND(1))+INT(100*RND(1))\r"
  "1750 IF INT(A(Z)/100)>3 THEN 1740\r"
  "1760 IF A(Z)-100*INT(A(Z)/100)>12 THEN 1740\r"
  "1765 IF Z=1 THEN 1840\r"
  "1770 FOR K=1 TO Z-1\r"
  "1780 IF A(Z)=A(K) THEN 1740\r"
  "1790 NEXT K\r"
  "1800 IF Z<=10 THEN 1840\r"
  "1810 N=A(U)\r"
  "1820 A(U)=A(Z)\r"
  "1830 A(Z)=N\r"
  "1840 RETURN\r"
  "1850 FOR Z=N TO N+4\r"
  "1860 PRINT Z\"--  \";\r"
  "1870 GOSUB 1950\r"
  "1880 PRINT \" OF\";\r"
  "1890 GOSUB 2070\r"
  "1900 IF Z/2<>INT(Z/2) THEN 1920\r"
  "1910 PRINT\r"
  "1920 NEXT Z\r"
  "1930 PRINT\r"
  "1940 RETURN\r"
  "1950 K=FNB(A(Z))\r"
  "1960 IF K<>9 THEN 1980\r"
  "1970 PRINT \"JACK\";\r"
  "1980 IF K<>10 THEN 2000\r"
  "1990 PRINT \"QUEEN\";\r"
  "2000 IF K<>11 THEN 2020\r"
  "2010 PRINT \"KING\";\r"
  "2020 IF K<>12 THEN 2040\r"
  "2030 PRINT \"ACE\";\r"
  "2040 IF K>=9 THEN 2060\r"
  "2050 PRINT K+2;\r"
  "2060 RETURN\r"
  "2070 K=INT(A(Z)/100)\r"
  "2080 IF K<>0 THEN 2100\r"
  "2090 PRINT \" CLUBS\",\r"
  "2100 IF K<>1 THEN 2120\r"
  "2110 PRINT \" DIAMONDS\",\r"
  "2120 IF K<>2 THEN 2140\r"
  "2130 PRINT \" HEARTS\",\r"
  "2140 IF K<>3 THEN 2160\r"
  "2150 PRINT \" SPADES\",\r"
  "2160 RETURN\r"
  "2170 U=0\r"
  "2180 FOR Z=N TO N+4\r"
  "2190 B(Z)=FNB(A(Z))\r"
  "2200 IF Z=N+4 THEN 2230\r"
  "2210 IF INT(A(Z)/100)<>INT(A(Z+1)/100) THEN 2230\r"
  "2220 U=U+1\r"
  "2230 NEXT Z\r"
  "2240 IF U<>4 THEN 2310\r"
  "2250 X=11111\r"
  "2260 D=A(N)\r"
  "2270 H$=\"A FLUS\"\r"
  "2280 I$=\"H IN\"\r"
  "2290 U=15\r"
  "2300 RETURN\r"
  "2310 FOR Z=N TO N+3\r"
  "2320 FOR K=Z+1 TO N+4\r"
  "2330 IF B(Z)<=B(K) THEN 2390\r"
  "2340 X=A(Z)\r"
  "2350 A(Z)=A(K)\r"
  "2360 B(Z)=B(K)\r"
  "2370 A(K)=X\r"
  "2380 B(K)=A(K)-100*INT(A(K)/100)\r"
  "2390 NEXT K\r"
  "2400 NEXT Z\r"
  "2410 X=0\r"
  "2420 FOR Z=N TO N+3\r"
  "2430 IF B(Z)<>B(Z+1) THEN 2470\r"
  "2440 X=X+11*10^(Z-N)\r"
  "2450 D=A(Z)\r"
  "2460 GOSUB 2760\r"
  "2470 NEXT Z\r"
  "2480 IF X<>0 THEN 2620\r"
  "2490 IF B(N)+3<>B(N+3) THEN 2520\r"
  "2500 X=1111\r"
  "2510 U=10\r"
  "2520 IF B(N+1)+3<>B(N+4) THEN 2620\r"
  "2530 IF U<>10 THEN 2600\r"
  "2540 U=14\r"
  "2550 H$=\"STRAIG\"\r"
  "2560 I$=\"HT\"\r"
  "2570 X=11111\r"
  "2580 D=A(N+4)\r"
  "2590 RETURN\r"
  "2600 U=10\r"
  "2610 X=11110\r"
  "2620 IF U>=10 THEN 2690\r"
  "2630 D=A(N+4)\r"
  "2640 H$=\"SCHMAL\"\r"
  "2650 I$=\"TZ, \"\r"
  "2660 U=9\r"
  "2670 X=11000\r"
  "2680 GOTO 2740\r"
  "2690 IF U<>10 THEN 2720\r"
  "2700 IF I=1 THEN 2740\r"
  "2710 GOTO 2750\r"
  "2720 IF U>12 THEN 2750\r"
  "2730 IF FNB(D)>6 THEN 2750\r"
  "2740 I=6\r"
  "2750 RETURN\r"
  "2760 IF U>=11 THEN 2810\r"
  "2770 U=11\r"
  "2780 H$=\"A PAIR\"\r"
  "2790 I$=\" OF \"\r"
  "2800 RETURN\r"
  "2810 IF U<>11 THEN 2910\r"
  "2820 IF B(Z)<>B(Z-1) THEN 2870\r"
  "2830 H$=\"THREE\"\r"
  "2840 I$=\" \"\r"
  "2850 U=13\r"
  "2860 RETURN\r"
  "2870 H$=\"TWO P\"\r"
  "2880 I$=\"AIR, \"\r"
  "2890 U=12\r"
  "2900 RETURN\r"
  "2910 IF U>12 THEN 2960\r"
  "2920 U=16\r"
  "2930 H$=\"FULL H\"\r"
  "2940 I$=\"OUSE, \"\r"
  "2950 RETURN\r"
  "2960 IF B(Z)<>B(Z-1) THEN 3010\r"
  "2970 U=17\r"
  "2980 H$=\"FOUR\"\r"
  "2990 I$=\" \"\r"
  "3000 RETURN\r"
  "3010 U=16\r"
  "3020 H$=\"FULL H\"\r"
  "3030 I$=\"OUSE, \"\r"
  "3040 RETURN\r"
  "3050 G=0\r"
  "3060 PRINT:PRINT \"WHAT IS YOUR BET\";\r"
  "3070 INPUT T\r"
  "3080 IF T-INT(T)=0 THEN 3140\r"
  "3090 IF K<>0 THEN 3120\r"
  "3100 IF G<>0 THEN 3120\r"
  "3110 IF T=.5 THEN 3410\r"
  "3120 PRINT \"NO SMALL CHANGE, PLEASE.\"\r"
  "3130 GOTO 3060\r"
  "3140 IF S-G-T>=0 THEN 3170\r"
  "3150 GOSUB 3830\r"
  "3160 GOTO 3060\r"
  "3170 IF T<>0 THEN 3200\r"
  "3180 I=3\r"
  "3190 GOTO 3380\r"
  "3200 IF G+T>=K THEN 3230\r"
  "3210 PRINT \"IF YOU CAN'T SEE MY BET, THEN FOLD.\"\r"
  "3220 GOTO 3060\r"
  "3230 G=G+T\r"
  "3240 IF G=K THEN 3380\r"
  "3250 IF Z<>1 THEN 3420\r"
  "3260 IF G>5 THEN 3300\r"
  "3270 IF Z>=2 THEN 3350\r"
  "3280 V=5\r"
  "3290 GOTO 3420\r"
  "3300 IF Z=1 THEN 3320\r"
  "3310 IF T<=25 THEN 3350\r"
  "3320 I=4\r"
  "3330 PRINT \"I FOLD.\"\r"
  "3340 RETURN\r"
  "3350 IF Z=2 THEN 3430\r"
  "3360 PRINT \"I'LL SEE YOU.\"\r"
  "3370 K=G\r"
  "3380 S=S-G\r"
  "3390 C=C-K\r"
  "3400 P=P+G+K\r"
  "3410 RETURN\r"
  "3420 IF G>3*Z THEN 3350\r"
  "3430 V=G-K+FNA(0)\r"
  "3440 GOSUB 3480\r"
  "3450 PRINT \"I'LL SEE YOU, AND RAISE YOU\"V\r"
  "3460 K=G+V\r"
  "3470 GOTO 3060\r"
  "3480 IF C-G-V>=0 THEN 3660\r"
  "3490 IF G<>0 THEN 3520\r"
  "3500 V=C\r"
  "3510 RETURN\r"
  "3520 IF C-G>=0 THEN 3360\r"
  "3530 IF (O/2)<>INT(O/2) THEN 3600\r"
  "3540 PRINT \"WOULD YOU LIKE TO BUY BACK YOUR WATCH FOR $50\";\r"
  "3550 INPUT J$\r"
  "3560 IF LEFT$(J$,1)=\"N\" THEN 3600\r"
  "3570 C=C+50\r"
  "3580 O=O/2\r"
  "3590 RETURN\r"
  "3600 IF O/3<>INT(O/3) THEN 3670\r"
  "3610 PRINT \"WOULD YOU LIKE TO BUY BACK YOUR TIE TACK FOR $50\";\r"
  "3620 INPUT J$\r"
  "3630 IF LEFT$(J$,1)=\"N\" THEN 3670\r"
  "3640 C=C+50\r"
  "3650 O=O/3\r"
  "3660 RETURN\r"
  "3670 PRINT \"I'M BUSTED.  CONGRATULATIONS!\"\r"
  "3680 STOP\r"
  "3690 PRINT H$;I$;\r"
  "3700 IF H$<>\"A FLUS\" THEN 3750\r"
  "3710 K=INT(K/100)\r"
  "3720 GOSUB 2080\r"
  "3730 PRINT\r"
  "3740 RETURN\r"
  "3750 K=FNB(K)\r"
  "3760 GOSUB 1960\r"
  "3770 IF H$=\"SCHMAL\" THEN 3790\r"
  "3780 IF H$<>\"STRAIG\" THEN 3810\r"
  "3790 PRINT \" HIGH\"\r"
  "3800 RETURN\r"
  "3810 PRINT \"'S\"\r"
  "3820 RETURN\r"
  "3830 PRINT\r"
  "3840 PRINT \"YOU CAN'T BET WITH WHAT YOU HAVEN'T GOT.\"\r"
  "3850 IF O/2=INT(O/2) THEN 3970\r"
  "3860 PRINT \"WOULD YOU LIKE TO SELL YOUR WATCH\";\r"
  "3870 INPUT J$\r"
  "3880 IF LEFT$(J$,1)=\"N\" THEN 3970\r"
  "3890 IF FNA(0)>=7 THEN 3930\r"
  "3900 PRINT \"I'LL GIVE YOU $75 FOR IT.\"\r"
  "3910 S=S+75\r"
  "3920 GOTO 3950\r"
  "3930 PRINT \"THAT'S A PRETTY CRUMMY WATCH - I'LL GIVE YOU $25.\"\r"
  "3940 S=S+25\r"
  "3950 O=O*2\r"
  "3960 RETURN\r"
  "3970 IF O/3<>INT(O/3) THEN 4090\r"
  "3980 PRINT \"WILL YOU PART WITH THAT DIAMOND TIE TACK\":\r"
  "3990 INPUT J$\r"
  "4000 IF LEFT$(J$,1)=\"N\" THEN 4080\r"
  "4010 IF FNA(0)>=6 THEN 4050\r"
  "4020 PRINT \"YOU ARE NOW $100 RICHER.\"\r"
  "4030 S=S+100\r"
  "4040 GOTO 4070\r"
  "4050 PRINT \"IT'S PASTE.  $25.\"\r"
  "4060 S=S+25\r"
  "4070 O=O*3\r"
  "4080 RETURN\r"
  "4090 PRINT \"YOUR WAD IS SHOT.  SO LONG, SUCKER!\"\r"
  "4100 END\r"
  "";

const char basic_power[] =
  "10 REM RECURSIVE INTEGERAL POWER\r"
  "20 PRINT \"ENTER A NUMBER TO RAISE TO A POWER:\";\r"
  "30 INPUT X\r"
  "40 PRINT \"ENTER A POWER (INTEGER > 0):\";\r"
  "50 INPUT Y\r"
  "60 A=1\r"
  "70 GOSUB 100\r"
  "80 PRINT \"ANSWER=\"A\r"
  "90 END\r"
  "100 REM POWER ROUTINE\r"
  "110 A=A*X\r"
  "120 Y=Y-1\r"
  "130 IF Y > 0 THEN GOSUB 100\r"
  "140 RETURN\r"
  "";

const char basic_powers[] =
  "10 REM :GENERATE LOTS OF POWERS OF X.\r"
  "20 REM :\"X\" IS GIVEN BY THE USER.\r"
  "30 REM :THE ARRAY -N\" STORES LARGE NUMBERS, ONE \r"
  "40 REM :DECIMAL DIGIT PER MEMORY CELL.\r"
  "50 REM :THE ARRAY -TS\" IS USED TO GET PROPER SPACING \r"
  "60 REM :WHEN PRINTING THE RESULTS.\r"
  "70 REM :\"P\" IS THE CURRENT POWER OF \"X\"\r"
  "80 REM :\"C\" IS THE CARRY OUT OF EACH LOCATION. \r"
  "90 DIM N (50), T$(9)\r"
  "100 REM :INITIALIZE.\r"
  "105 WIDTH 85\r"
  "110 GOSUB 2000\r"
  "120 PRINT \"POWERS OF\";\r"
  "130 INPUT X\r"
  "140 PRINT\r"
  "150 PRINT\r"
  "200 REM :MAIN LOOP. FIRST PRINT LATEST POWER OF \r"
  "210 GOSUB 3000\r"
  "220 LET P= P +1\r"
  "230 REM :NOW MULTIPLY LATEST VALUE BY -X- \r"
  "240 GOSUB 4000\r"
  "250 REM IF CARRY OUT OF LEFT-MOST DIGIT, QUIT. ELSE GO ON \r"
  "260 IF C=0 THEN 200\r"
  "270 END\r"
  "2000 REM :SUBROUTINE TO INITIALIZE RELEVANT VARIABLES \r"
  "2010 LET P=0\r"
  "2020 REM :HANDLE \"NO\" DIGITS IN ALL.\r"
  "2030 LET NO= 50\r"
  "2040 REM :START \"N\" AT 000 ... 0001\r"
  "2050 LET N(1)=1\r"
  "2060 FOR D=2 TO NO\r"
  "2070   LET N(D)=0\r"
  "2080 NEXT D\r"
  "2090 LET C=0\r"
  "2100 REM INITIALIZE \"T\" TO STORE STRING VERSION OF\r"
  "2110 REM :DIGITS (USED TO GET SPACING RIGHT).\r"
  "2120 FOR D=0 TO 9\r"
  "2130   READ T$(D)\r"
  "2140 NEXT D\r"
  "2150 DATA \"0\",\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\"\r"
  "2160 RETURN\r"
  "3000 REM :SUBROUTINE TO PRINT LARGE NUMBERS \r"
  "3010 PRINT P,\r"
  "3020 REM :SKIP LEADING ZEROS.\r"
  "3030 FOR D=NO TO 1 STEP -1\r"
  "3040   IF N(D)>0 THEN 3060\r"
  "3050 NEXT D\r"
  "3060 REM :PRINT VALUE, LEAVING A BLANK EVERY 3 DIGITS \r"
  "3070 LET V$=T$(N(D))\r"
  "3080 LET D=D-1\r"
  "3090 IF D=INT(D/3)*3 THEN 3200\r"
  "3100 LET V$ = V$ + T$(N(D))\r"
  "3110 LET D=D-1\r"
  "3120 GOTO 3090\r"
  "3200 REM :GOT A BLOCK OF 3-PRINT 'EM.\r"
  "3210 PRINT V$ + \" \";\r"
  "3220 REM :DONE WITH THE WHOLE NUMBER?\r"
  "3230 IF D > 0 THEN 3060\r"
  "3240 PRINT\r"
  "3250 RETURN\r"
  "4000 REM :SUBROUTINE TO MULTIPLY LARGE NUMBERS BY \"X\" \r"
  "4010 FOR D=1 TO NO\r"
  "4020 LET N(D)=N(D) * X + C\r"
  "4030 REM :HAVE A CARRY?\r"
  "4040 IF N(D) > 9 THEN 4080\r"
  "4050 REM :NO CARRY-CONTINUE.\r"
  "4060 LET C=0\r"
  "4070 GOTO 4110\r"
  "4080 REM :DO HAVE A CARRY.\r"
  "4090 LET C= INT(N(D)/ 10)\r"
  "4100 LET N(D)= N(D)-C*10\r"
  "4110 NEXT D\r"
  "4120 RETURN \r"
  "";

const char basic_qubic[] =
  "50 PRINT CHR$(26):WIDTH 80\r"
  "100 PRINT TAB(33);\"QUBIC\":PRINT\r"
  "110 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "120 PRINT:PRINT:PRINT\r"
  "210 PRINT \"DO YOU WANT INSTRUCTIONS\";\r"
  "220 INPUT C$\r"
  "230 IF LEFT$(C$,1)=\"N\" THEN 315\r"
  "240 IF LEFT$(C$,1)=\"Y\" THEN 265\r"
  "250 PRINT \"INCORRECT ANSWER.  PLEASE TYPE 'YES' OR 'NO'\";\r"
  "260 GOTO 220\r"
  "265 PRINT\r"
  "270 PRINT \"THE GAME IS TIC-TAC-TOE IN A 4 X 4 X 4 CUBE.\"\r"
  "280 PRINT \"EACH MOVE IS INDICATED BY A 3 DIGIT NUMBER, WITH EACH\"\r"
  "290 PRINT \"DIGIT BETWEEN 1 AND 4 INCLUSIVE.  THE DIGITS INDICATE THE\"\r"
  "300 PRINT \"LEVEL, ROW, AND COLUMN, RESPECTIVELY, OF THE OCCUPIED\"\r"
  "305 PRINT \"PLACE.  \"\r"
  "306 PRINT\r"
  "307 PRINT \"TO PRINT THE PLAYING BOARD, TYPE 0 (ZERO) AS YOUR MOVE.\"\r"
  "308 PRINT \"THE PROGRAM WILL PRINT THE BOARD WITH YOUR MOVES INDI-\"\r"
  "309 PRINT \"CATED WITH A (Y), THE MACHINE'S MOVES WITH AN (M), AND\"\r"
  "310 PRINT \"UNUSED SQUARES WITH A ( ).  OUTPUT IS ON PAPER.\"\r"
  "311 PRINT\r"
  "312 PRINT \"TO STOP THE PROGRAM RUN, TYPE 1 AS YOUR MOVE.\"\r"
  "313 PRINT:PRINT\r"
  "315 DIM X(64),L(76),M(76,4),Y(16)\r"
  "320 FOR I = 1 TO 16\r"
  "330 READ Y(I)\r"
  "340 NEXT I\r"
  "350 FOR I=1 TO 76\r"
  "360 FOR J = 1 TO 4\r"
  "370 READ M(I,J)\r"
  "380 NEXT J\r"
  "390 NEXT I\r"
  "400 FOR I = 1 TO 64\r"
  "410 LET X (I) =0\r"
  "420 NEXT I\r"
  "430 LET Z=1\r"
  "440 PRINT \"DO YOU WANT TO MOVE FIRST\";\r"
  "450 INPUT S$\r"
  "460 IF LEFT$(S$,1)=\"N\" THEN 630\r"
  "470 IF LEFT$(S$,1)=\"Y\" THEN 500\r"
  "480 PRINT \"INCORRECT ANSWER.  PLEASE TYPE 'YES' OR 'NO'.\";\r"
  "490 GOTO 450\r"
  "500 PRINT \" \"\r"
  "510 PRINT \"YOUR MOVE\";\r"
  "520 INPUT J1\r"
  "521 IF J1=1 THEN 2770\r"
  "522 IF J1<>0 THEN 525\r"
  "523 GOSUB 2550\r"
  "524 GOTO 500\r"
  "525 IF J1<111 THEN 2750\r"
  "526 IF J1>444 THEN 2750\r"
  "530 GOSUB 2500\r"
  "540 LET K1=INT(J1/100)\r"
  "550 LET J2=(J1-K1*100)\r"
  "560 LET K2=INT(J2/10)\r"
  "570 LET K3= J1 - K1*100 -K2*10\r"
  "580 LET M=16*K1+4*K2+K3-20\r"
  "590 IF X(M)=0 THEN 620\r"
  "600 PRINT \"THAT SQUARE IS USED, TRY AGAIN.\"\r"
  "610 GOTO 500\r"
  "620 LET X(M)=1\r"
  "630 GOSUB 1640\r"
  "640 J=1\r"
  "650 I=1\r"
  "660 IF J=1 THEN 720\r"
  "670 IF J=2 THEN 790\r"
  "680 IF J=3 THEN 930\r"
  "690 I=I+1: IF I<=76 THEN 660\r"
  "700 J=J+1: IF J<=3 THEN 650\r"
  "710 GOTO 1300\r"
  "720 IF L(I)<>4 THEN 690\r"
  "730 PRINT \"YOU WIN AS FOLLOWS\";\r"
  "740 FOR J=1 TO 4\r"
  "750 LET M=M(I,J)\r"
  "760 GOSUB 1570\r"
  "770 NEXT J\r"
  "780 GOTO 1490\r"
  "790 IF L(I)<>15 THEN 690\r"
  "800 FOR J=1 TO 4\r"
  "810 LET M=M(I,J)\r"
  "820 IF X(M)<>0 THEN 860\r"
  "830 LET X(M)=5\r"
  "840 PRINT \"MACHINE MOVES TO\";\r"
  "850 GOSUB 1570\r"
  "860 NEXT J\r"
  "870 PRINT \", AND WINS AS FOLLOWS\"\r"
  "880 FOR J=1 TO 4\r"
  "890 LET M=M(I,J)\r"
  "900 GOSUB 1570\r"
  "910 NEXT J\r"
  "920 GOTO 1490\r"
  "930 IF L(I)<>3 THEN 690\r"
  "940 PRINT \"NICE TRY. MACHINE MOVES TO\";\r"
  "950 FOR J=1 TO 4 \r"
  "960 LET M=M(I,J)\r"
  "970 IF X(M)<>0 THEN 1010\r"
  "980 LET X(M)=5\r"
  "990 GOSUB 1570\r"
  "1000 GOTO 500\r"
  "1010 NEXT J\r"
  "1020 GOTO 1300\r"
  "1030 I=1\r"
  "1040 LET L(I)=X(M(I,1))+X(M(I,2))+X(M(I,3))+X(M(I,4))\r"
  "1050 LET L = L(I)\r"
  "1060 IF L <2 THEN 1130\r"
  "1070 IF L>=3 THEN 1130\r"
  "1080 IF L>2 THEN 2230\r"
  "1090 FOR J = 1 TO 4\r"
  "1100 IF X(M(I,J))<>0 THEN 1120\r"
  "1110 LET X(M(I,J))=1/8\r"
  "1120 NEXT J\r"
  "1130 I=I+1: IF I<=76 THEN 1040\r"
  "1140 GOSUB 1640\r"
  "1150 I=1\r"
  "1160 IF L(I)=1/2 THEN 2360\r"
  "1170 IF L(I)=1+3/8 THEN 2360\r"
  "1180 I=I+1: IF I<=76 THEN 1160\r"
  "1190 GOTO 1830\r"
  "1200 LET Z = 1\r"
  "1210 IF X(Y(Z))=0 THEN 1250\r"
  "1220 LET Z=Z+1\r"
  "1230 IF Z<>17 THEN 1210\r"
  "1240 GOTO 1720\r"
  "1250 LET M=Y(Z)\r"
  "1260 LET X(M)=5\r"
  "1270 PRINT \"MACHINE MOVES TO\";\r"
  "1280 GOSUB 1570\r"
  "1290 GOTO 500\r"
  "1300 LET X=X\r"
  "1310 I=1\r"
  "1320 LET L(I)=X(M(I,1))+X(M(I,2))+X(M(I,3))+X(M(I,4))\r"
  "1330 LET L=L(I)\r"
  "1340 IF L<10 THEN 1410\r"
  "1350 IF L>=11 THEN 1410\r"
  "1360 IF L>10 THEN 2230\r"
  "1370 FOR J=1 TO 4\r"
  "1380 IF X(M(I,J))<>0 THEN 1400\r"
  "1390 LET X(M(I,J))=1/8\r"
  "1400 NEXT J\r"
  "1410 I=I+1: IF I<=76 THEN 1320\r"
  "1420 GOSUB 1640\r"
  "1430 I=1\r"
  "1440 IF L(I)=.5 THEN 2360\r"
  "1450 IF L(I)=5+3/8 THEN 2360\r"
  "1460 I=I+1: IF I<=76 THEN 1440\r"
  "1470 GOSUB 2500\r"
  "1480 GOTO 1030\r"
  "1490 PRINT \" \"\r"
  "1500 PRINT \"DO YOU WANT TO TRY ANOTHER GAME\";\r"
  "1510 INPUT X$\r"
  "1520 IF LEFT$(X$,1)=\"Y\" THEN 400\r"
  "1530 IF LEFT$(X$,1)=\"N\" THEN 1560\r"
  "1540 PRINT \"INCORRECT ANSWER. PLEASE TYPE 'YES' OR 'NO'\";\r"
  "1550 GOTO 1510\r"
  "1560 STOP: REM RUN \"MENU\"\r"
  "1570 LET K1=INT((M-1)/16)+1\r"
  "1580 LET J2=M-16*(K1-1)\r"
  "1590 LET K2=INT((J2-1)/4)+1\r"
  "1600 LET K3=M-(K1-1)*16-(K2-1)*4\r"
  "1610 LET M=K1*100+K2*10+K3\r"
  "1620 PRINT M;\r"
  "1630 RETURN\r"
  "1640 FOR S=1 TO 76\r"
  "1650 LET J1 = M(S,1)\r"
  "1660 LET J2=M(S,2)\r"
  "1670 LET J3=M(S,3)\r"
  "1680 LET J4=M(S,4)\r"
  "1690 LET L(S)=X(J1)+X(J2)+X(J3)+X(J4)\r"
  "1700 NEXT S\r"
  "1710 RETURN\r"
  "1720 FOR I=1 TO 64\r"
  "1730 IF X(I)<>0 THEN 1800\r"
  "1740 LET X(I)=5\r"
  "1750 LET M=I\r"
  "1760 PRINT \"MACHINE LIKES\";\r"
  "1770 GOSUB 1570\r"
  "1780 PRINT \" \"\r"
  "1790 GOTO 500\r"
  "1800 NEXT I\r"
  "1810 PRINT \"THE GAME IS A DRAW.\"\r"
  "1820 GOTO 1490\r"
  "1830 FOR K=1 TO 18\r"
  "1840 LET P=0\r"
  "1850 FOR I=4*K-3 TO 4*K\r"
  "1860 FOR J=1 TO 4\r"
  "1870 LET P=P+X(M(I,J))\r"
  "1880 NEXT J\r"
  "1890 NEXT I\r"
  "1900 IF P<4 THEN 1940\r"
  "1910 IF P<5 THEN 1970\r"
  "1920 IF P<9 THEN 1940\r"
  "1930 IF P<10 THEN 1970\r"
  "1940 NEXT K\r"
  "1950 GOSUB 2500\r"
  "1960 GOTO 1200\r"
  "1970 LET S=1/8\r"
  "1980 FOR I=4*K-3 TO 4*K\r"
  "1990 GOTO 2370\r"
  "2000 NEXT I\r"
  "2010 LET S=0\r"
  "2020 GOTO 1980\r"
  "2030 DATA 1,49,52,4,13,61,64,16,22,39,23,38,26,42,27,43\r"
  "2040 DATA 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20\r"
  "2050 DATA 21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38\r"
  "2060 DATA 39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56\r"
  "2070 DATA 57,58,59,60,61,62,63,64\r"
  "2080 DATA 1,17,33,49,5,21,37,53,9,25,41,57,13,29,45,61\r"
  "2090 DATA 2,18,34,50,6,22,38,54,10,26,42,58,14,30,46,62\r"
  "2100 DATA 3,19,35,51,7,23,39,55,11,27,43,59,15,31,47,63\r"
  "2110 DATA 4,20,36,52,8,24,40,56,12,28,44,60,16,32,48,64\r"
  "2120 DATA 1,5,9,13,17,21,25,29,33,37,41,45,49,53,57,61\r"
  "2130 DATA 2,6,10,14,18,22,26,30,34,38,42,46,50,54,58,62\r"
  "2140 DATA 3,7,11,15,19,23,27,31,35,39,43,47,51,55,59,63\r"
  "2150 DATA 4,8,12,16,20,24,28,32,36,40,44,48,52,56,60,64\r"
  "2160 DATA 1,6,11,16,17,22,27,32,33,38,43,48,49,54,59,64\r"
  "2170 DATA 13,10,7,4,29,26,23,20,45,42,39,36,61,58,55,52\r"
  "2180 DATA 1,21,41,61,2,22,42,62,3,23,43,63,4,24,44,64\r"
  "2190 DATA 49,37,25,13,50,38,26,14,51,39,27,15,52,40,28,16\r"
  "2200 DATA 1,18,35,52,5,22,39,56,9,26,43,60,13,30,47,64\r"
  "2210 DATA 49,34,19,4,53,38,23,8,57,42,27,12,61,46,31,16\r"
  "2220 DATA 1,22,43,64,16,27,38,49,4,23,42,61,13,26,39,52\r"
  "2230 FOR J=1 TO 4\r"
  "2240 IF X(M(I,J))<>1/8 THEN 2330\r"
  "2250 LET X(M(I,J))=5\r"
  "2260 IF L(I)<5 THEN 2290\r"
  "2270 PRINT \"LET'S SEE YOU GET OUT OF THIS:  MACHINE MOVES TO\";\r"
  "2280 GOTO 2300\r"
  "2290 PRINT \"YOU FOX.  JUST IN THE NICK OF TIME, MACHINE MOVES TO\";\r"
  "2300 LET M=M(I,J)\r"
  "2310 GOSUB 1570\r"
  "2320 GOTO 500\r"
  "2330 NEXT J\r"
  "2340 PRINT \"MACHINE CONCEDES THIS GAME.\"\r"
  "2350 GOTO 1490\r"
  "2360 LET S=1/8\r"
  "2370 IF I-INT(I/4)*4>1 THEN 2400\r"
  "2380 LET A=1\r"
  "2390 GOTO 2410\r"
  "2400 LET A=2\r"
  "2410 FOR J=A TO 5-A STEP 5-2*A\r"
  "2420 IF X(M(I,J))=S THEN 2450\r"
  "2430 NEXT J\r"
  "2440 GOTO 2000\r"
  "2450 LET X(M(I,J))=5\r"
  "2460 LET M=M(I,J)\r"
  "2470 PRINT \"MACHINE TAKES\";\r"
  "2480 GOSUB 1570\r"
  "2490 GOTO 500\r"
  "2500 FOR I=1 TO 64\r"
  "2510 IF X(I)<>1/8 THEN 2530\r"
  "2520 LET X(I)=0\r"
  "2530 NEXT I\r"
  "2540 RETURN\r"
  "2550 FOR XX=1 TO 9:PRINT:NEXT:FOR I=1 TO 4\r"
  "2560 FOR J=1 TO 4\r"
  "2562 FOR I1=1 TO J\r"
  "2564 PRINT\"   \";\r"
  "2566 NEXT I1\r"
  "2570 FOR K=1 TO 4\r"
  "2600 LET Q=16*I+4*J+K-20\r"
  "2610 IF X(Q)<>O THEN 2630\r"
  "2620 PRINT\"( )      \";\r"
  "2630 IF X(Q)<>5 THEN 2650\r"
  "2640 PRINT\"(M)      \";\r"
  "2650 IF X(Q)<>1 THEN 2660\r"
  "2655 PRINT\"(Y)      \";\r"
  "2660 IF X(Q)<>1/8 THEN 2670\r"
  "2665 PRINT\"( )      \";\r"
  "2670 NEXT K\r"
  "2680 PRINT\r"
  "2690 PRINT\r"
  "2700 NEXT J\r"
  "2710 PRINT\r"
  "2720 PRINT\r"
  "2730 NEXT I\r"
  "2735 REM PRINT CHR$(12)\r"
  "2740 RETURN\r"
  "2750 PRINT\"INCORRECT MOVE, RETYPE IT--\";\r"
  "2760 GOTO 520\r"
  "2770 END\r"
  "";

const char basic_rock_paper_scissors[] =
  "1 PRINT \"THIS PROGRAM ALLOWS YOU TO PLAY THE OLD GAME OF\"\r"
  "2 PRINT \"ROCKS, PAPER, AND SISSORS AGAINST THE COMPUTER.\"\r"
  "6 PRINT \"HOW MANY GAMES DO YOU WANT \";:INPUT Q\r"
  "8 IF Q<11 THEN 11\r"
  "9 PRINT \"SORRY, BUT WE AREN'T ALLOWED TO PLAY THAT MANY.\":GOTO 6\r"
  "11 FOR G=1 TO Q\r"
  "15 PRINT:PRINT \"GAME NUMBER\"G\r"
  "20 X=INT(RND(1)*3+1)\r"
  "25 PRINT \"3=ROCK...2=SISSORS...1=PAPER\"\r"
  "30 PRINT \"1....2....3....WHAT'S YOUR CHOICE \";:INPUT K\r"
  "32 IF (K-1)*(K-2)*(K-3)<>0 THEN PRINT \"INVALID\":GOTO 25\r"
  "35 PRINT \"THIS IS MY CHOICE...\"\r"
  "41 IF X=1 THEN 50\r"
  "42 IF X=2 THEN 60\r"
  "43 IF X=3 THEN 70\r"
  "50 PRINT \"...PAPER\":GOTO 80\r"
  "60 PRINT \"...SISSORS\":GOTO 80\r"
  "70 PRINT \"...ROCK\"\r"
  "80 IF X=K THEN 155\r"
  "85 IF X>K THEN 125\r"
  "90 IF X=1 THEN 105\r"
  "95 PRINT \"YOU WIN!!!\":H=H+1:GOTO 160\r"
  "105 IF K=3 THEN 115\r"
  "110 GOTO 95\r"
  "115 PRINT \"WOW!  I WIN!!\":C=C+1:GOTO 160\r"
  "125 IF K<>1 THEN 115\r"
  "140 IF X<>3 THEN 115\r"
  "141 GOTO 95\r"
  "155 PRINT \"TIE GAME, NO WINNER.\"\r"
  "160 NEXT G\r"
  "170 PRINT:PRINT \"HERE IS THE FINAL SCORE:\"\r"
  "175 PRINT \"I HAVE WON\"C\"GAME(S).\"\r"
  "180 PRINT \"YOU HAVE WON\"H\"GAME(S).\"\r"
  "185 PRINT \"AND\"G-1-(C+H)\"GAME(S) ENDED IN A TIE.\"\r"
  "190 PRINT:PRINT \"THANKS FOR PLAYING!!\"\r"
  "200 END\r"
  "";

const char basic_rose[] =
  "1 REM CLEAR SCREEN & VERT TAB 10\r"
  "10  PRINT  TAB( 6)\"** PETALS AROUND THE ROSE **\"\r"
  "20  FOR ZZ = 1 TO 3000: NEXT \r"
  "30  PRINT : PRINT : PRINT \r"
  "40  PRINT \"DO YOU WISH INSTRUCTIONS \";\r"
  "50  INPUT A$\r"
  "60  IF	LEFT$ (A$,1) = \"N\" THEN 140\r"
  "70  PRINT \r"
  "80  PRINT \"THE NAME OF THE GAME IS 'PETALS AROUND\"\r"
  "90  PRINT \"THE ROSE.  THE NAME OF THE GAME IS\"\r"
  "95  PRINT \"IMPORTANT.  \"\r"
  "100  PRINT : PRINT \"THE COMPUTER WILL ROLL FIVE DICE\"\r"
  "105  PRINT \"AND ASK YOU FOR THE SCORE FOR THE\"\r"
  "110  PRINT \"ROLL.  THE SCORE WILL ALWAYS BE AN\"\r"
  "115  PRINT \"EVEN NUMBER.  GUESS 99 TO STOP PLAYING\"\r"
  "120  PRINT : PRINT \"     ** GOOD LUCK **\"\r"
  "125   PRINT  :	PRINT :  PRINT :  PRINT :  INPUT \"HIT RETURN TO CONTINUE\";X$\r"
  "140  DIM L(7)\r"
  "150 H = 0:G = 0:F = 0\r"
  "155 REM  CLEAR SCREEN & VERT TAB 10\r"
  "180  FOR K = 1 TO 5\r"
  "190 A =  INT (12 *  RND (8))\r"
  "200  GOSUB 720\r"
  "210 F = 8 * F + C\r"
  "220 G = 8 * G + D\r"
  "230 H = H + B\r"
  "240  NEXT K\r"
  "250  PRINT : PRINT \r"
  "270  FOR K = 1 TO 5\r"
  "280 L(K) = F - 8 *  INT (F / 8)\r"
  "290 M = L(K)\r"
  "300  GOSUB 590\r"
  "310 F =  INT (F / 8)\r"
  "320  NEXT K\r"
  "330  FOR K = 1 TO 5\r"
  "340 M = G - 8 *  INT (G / 8)\r"
  "350  GOSUB 590\r"
  "360 G =  INT (G / 8)\r"
  "370  NEXT K\r"
  "380 H = H - 12 *  INT (H / 12)\r"
  "390  FOR K = 1 TO 5\r"
  "400  IF (L(K) - 1) * (L(K) - 4) <  > 0 THEN 420\r"
  "410 L(K) = 5 - L(K)\r"
  "420 M = L(K)\r"
  "430  GOSUB 590\r"
  "440  NEXT K\r"
  "450  PRINT : PRINT \r"
  "470  PRINT \"GUESS THE SCORE\";\r"
  "480  INPUT K\r"
  "490  IF K = 99 THEN 1110\r"
  "500 H = 2 *  INT (H)\r"
  "510  IF K = H THEN 570\r"
  "515  PRINT \r"
  "520  PRINT \" NO,IT'S \";H;\r"
  "530  IF K - 2 *  INT (K / 2) = 0 THEN 550\r"
  "540  PRINT \" (THE SCORE IS ALWAYS EVEN) \";\r"
  "545  FOR ZZ = 1 TO 2000: NEXT \r"
  "550  PRINT \r"
  "555  FOR ZZ = 1 TO 2000: NEXT \r"
  "560  GOTO 150\r"
  "570  PRINT : PRINT : PRINT  TAB( 16)\"...YES...\"\r"
  "575  FOR ZZ = 1 TO 2000: NEXT \r"
  "580  GOTO 150\r"
  "590  FOR N = 0 TO 2\r"
  "600  IF M > 3 THEN 630\r"
  "610 PRINT\"  \";\r"
  "620  GOTO 650\r"
  "630 M = M - 4 *  INT (M / 4)\r"
  "640  PRINT \" O\";\r"
  "650 M = 2 * M\r"
  "660  NEXT N\r"
  "670  IF K = 5 THEN 700\r"
  "680 PRINT\"     \";\r"
  "690  RETURN \r"
  "700  PRINT \r"
  "710  RETURN \r"
  "720 B = 6 +  RND (7) / 6\r"
  "730 C = 0\r"
  "740 D = 0\r"
  "750  IF A > 3 THEN 890\r"
  "760 B = B + 3\r"
  "770  IF A > 1 THEN 810\r"
  "780 D = D + 2\r"
  "790 B = B + 3\r"
  "800  RETURN \r"
  "810 C = C + 1\r"
  "820 B = B + 1\r"
  "830  IF A > 2 THEN 780\r"
  "840 B = B + 11\r"
  "850  GOTO 790\r"
  "860 C = C + 1\r"
  "870  IF A > 2 THEN 790\r"
  "880  GOTO 780\r"
  "890 C = C + 4\r"
  "900 B = B + 2\r"
  "910  IF A > 5 THEN 970\r"
  "920 B = B + 2\r"
  "930  IF A < 5 THEN 950\r"
  "940  GOTO 780\r"
  "950 B = B + 11\r"
  "960  GOTO 790\r"
  "970 C = C + 1\r"
  "980 B = B + 8\r"
  "990  IF A > 6 THEN 1030\r"
  "1000 D = D + 3\r"
  "1010 B = B + 5\r"
  "1020  GOTO 780\r"
  "1030  IF A > 7 THEN 1070\r"
  "1040 B = B + 5\r"
  "1050 C = C + 1\r"
  "1060  GOTO 860\r"
  "1070 B = B + 7\r"
  "1080  IF A < 10 THEN 780\r"
  "1090 B = B + 10\r"
  "1100  GOTO 790\r"
  "1110  PRINT \"  THE SCORE WAS \";2 *  INT (H)\r"
  "";

const char basic_seawar[] =
  "5 REM *** DEBUGGED AND CONVERTED TO BASIC-PLUS (PDP-11) BY DAVE AHL\r"
  "6 REM *** CONVERTED TO 4K BASIC BY D GILLIS\r"
  "10 PRINT \"YOU COMMAND A FLEET OF SHIPS OPERATING IN ENEMY TERRITORY!!!\"\r"
  "20 PRINT \"DO YOU NEED INSTRUCTIONS (0=NO 1=YES)\";\r"
  "40 INPUT Q0\r"
  "50 IF Q0=1THEN90\r"
  "60 IF Q0=0THEN170\r"
  "70 PRINT \"INPUT 1='YES' OR 0='NO'\"\r"
  "80 GOTO 40\r"
  "90 PRINT \"YOU TELL YOUR GUN CREWS THE ELEVATION TO SET THIER GUNS.\"\r"
  "100 PRINT \"ELEVATION IS IN DEGREES FROM 0 TO 360.\"\r"
  "110 PRINT \"YOUR TASK FORCE CONSISTS OF 3 DESTROYERS,2 CRUSERS\"\r"
  "120 PRINT \"2 BATTLESHIPS, AND 2 HEAVY AIRCRAFT CARRIERS.\"\r"
  "130 PRINT \"THE ENEMY HAS 9 SHIPS FOR HIS DEFENSE.\"\r"
  "140 PRINT \"IF YOU SUCCEED IN SINKING ALL HIS SHIPS BEFORE HE SINKS\"\r"
  "150 PRINT \"YOURS, YOU HAVE WON. HOWEVER, IF HE SINKS ALL YOUR SHIPS\"\r"
  "160 PRINT \"BEFORE YOU HAVE DEFEATED HIM, YOU HAVE LOST!!\"\r"
  "170 PRINT \"LET US BEGIN !!!\"\r"
  "190 A=0:O=0:P5=0:S1=0:S2=0:C=0:P2=0:P1=0:S=0:P4=0:G=0:R=0\r"
  "200 M=0\r"
  "210 PRINT:FOR Z5=1 TO 5\r"
  "220 READ Z0\r"
  "230 A=A+1\r"
  "240 GOTO 320\r"
  "250 RESTORE \r"
  "260 IF R=9THEN840\r"
  "261 IF G=9THEN840\r"
  "270 FOR X=1 TO A\r"
  "280 READ Z0\r"
  "290 NEXT X\r"
  "300 READ Z0\r"
  "310 A=A+1\r"
  "320 IF Z0=9THEN390\r"
  "330 IF Z0=1THEN2000\r"
  "340 IF Z0=5THEN360\r"
  "350 GOTO 1460\r"
  "360 IF P5=1THEN840\r"
  "370 P5=1\r"
  "380 GOTO 400\r"
  "390 RESTORE \r"
  "400 PRINT \"YOUR FLAGSHIP REPORTS THE SIGHTING OF AN ENEMY \";\r"
  "401 P0=Z0:GOSUB 3000:PRINT\".\"\r"
  "410 T=43000.-30000*RND(0)+(RND(0)*10)*.987654+102\r"
  "420 IF T<10000THEN410\r"
  "430 S=0:P2=0\r"
  "440 T=INT(T)\r"
  "450 IF Z0=1THEN2030\r"
  "460 PRINT \"YOUR INSTRUMENTS READ THE RANGE TO THE TARGET AS\"T\"YARDS.\"\r"
  "480 IF P=1THEN1480\r"
  "490 IF S>4THEN510\r"
  "500 GOTO 540\r"
  "510 PRINT:PRINT \"ALL RIGHT, BAD SHOT, THE TARGET HAS MOVED OUT OF\"\r"
  "520 PRINT \"RANGE !!!  LETS TRY IT AGAIN !!!\":PRINT\r"
  "530 GOTO 250\r"
  "540 PRINT \"WHAT ELEVATION ** \";\r"
  "550 REM ON ERROR GOTO 560\r"
  "552 REM WAIT 10\r"
  "554 INPUT B\r"
  "556 GOTO 590\r"
  "560 REM IF ERR<>15THENON ERROR GOTO 0\r"
  "565 REM RESUME 570\r"
  "570 PRINT:PRINT \"   ADMIRAL !! YOU HAVE TO BE FAST IN THIS GAME !!\"\r"
  "580 GOTO 1590\r"
  "590 PRINT \"FIRE !!\"\r"
  "600 S=S+1\r"
  "610 IF B=999THEN1850\r"
  "620 IF B>360THEN1410\r"
  "630 IF B<0THEN750\r"
  "640 IF B=0THEN770\r"
  "650 IF B=90THEN980\r"
  "660 IF B>330THEN770\r"
  "670 IF B>180THEN1370\r"
  "680 IF B>150THEN1300\r"
  "690 IF B>90THEN1020\r"
  "700 E1=INT(T-(46500.*SIN(2*B/57.3)))\r"
  "710 E2=ABS(E1)\r"
  "711 IF E2<100THEN1050\r"
  "720 IF E1>100THEN1200\r"
  "730 IF E1<-100THEN1250\r"
  "740 GOTO 1050\r"
  "750 PRINT \"GUN BACKFIRED, KILLING CREW!\"\r"
  "760 GOTO 820\r"
  "770 PRINT \"WHAT ARE YOU TRYING TO DO ? KILL SOME FISH ? THE SHELL\"\r"
  "780 PRINT \"EXPLODED UNDER WATER FIFTY FEET FROM YOUR SHIP!!!\"\r"
  "790 IF P=1THEN1590\r"
  "800 IF P3=1THEN830\r"
  "810 IF P=1THEN830\r"
  "820 PRINT \"    ADMIRAL PLEASE !!!!\"\r"
  "830 GOTO 490\r"
  "840 PRINT \"    ******** PEACE ********\"\r"
  "850 PRINT \r"
  "860 PRINT \r"
  "870 PRINT \r"
  "880 PRINT \"YOU FIRED\"S1\"ROUNDS. THE ENEMY FIRED\"S2\"ROUNDS.\"\r"
  "900 IF R=9THEN920\r"
  "910 IF G=9THEN950\r"
  "920 PRINT \"ALL OF YOUR SHIPS HAVE BEEN SUNK.  SO SORRY\"\r"
  "930 PRINT \"THE BATTLE IS OVER..........THE ENEMY WINS.\"\r"
  "940 GOTO 2220\r"
  "950 PRINT \"YOU HAVE DECIMATED THE ENEMY.........THAT'S NICE\"\r"
  "960 PRINT \"THE BATTLE IS OVER.........YOU WIN!!!!\"\r"
  "970 GOTO 2220\r"
  "980 PRINT \"YOU IDIOT !! YOU SHOT STRAIGHT UP!!, AND THE SHELL\"\r"
  "990 PRINT \"LANDED ON YOUR OWN GUN POSITION, DESTROYING IT!!!\"\r"
  "1000 IF P=1THEN1590\r"
  "1010 GOTO 800\r"
  "1020 PRINT \"HEY STUPID, YOU'RE FIRING ON YOUR OWN SHIPS!!!\"\r"
  "1030 IF P=1THEN1590\r"
  "1040 GOTO 800\r"
  "1050 IF Z0=1THEN1070\r"
  "1060 GOTO 1090\r"
  "1070 PRINT \"DEPTH CHARGE EXPLODED RIGHT ON TOP OF THAT BABY !!!\"\r"
  "1080 GOTO 1100\r"
  "1090 PRINT:PRINT \" ** BOOM **\"\r"
  "1100 PRINT:FOR Z5=1 TO 5\r"
  "1110 PRINT \"TARGET DESTROYED !!!\",S\"ROUNDS EXPENDED.\":PRINT\r"
  "1150 S1=S1+S\r"
  "1160 P=0\r"
  "1170 P3=0\r"
  "1180 G=G+1\r"
  "1190 GOTO 250\r"
  "1200 IF Z0=1THEN2130\r"
  "1210 PRINT \"SHOT FELL\"ABS(E1)\"YARDS SHORT OF TARGET.\"\r"
  "1230 IF P=1THEN1590\r"
  "1240 GOTO 490\r"
  "1250 IF Z0=1THEN2160\r"
  "1260 PRINT \"SHELL OVERSHOT TARGET BY\"ABS(E1)\"YARDS.\"\r"
  "1280 IF P=1THEN1590\r"
  "1290 GOTO 490\r"
  "1300 PRINT \r"
  "1310 PRINT \"  YOU SHOT A PROJECTILE, INTO THE AIR,\"\r"
  "1320 PRINT \"  IT FELL TO THE WATER, YOU KNOW NOT WHERE.\"\r"
  "1330 PRINT \"BUT I DO, YOU IDIOT, YOU JUST SANK YOUR OWN FLEET TANKER!!\"\r"
  "1340 S1=S1+1\r"
  "1350 IF P=1THEN1590\r"
  "1360 GOTO 490\r"
  "1370 PRINT \"WHAT ARE YOU TRYING TO DO ?? DRILL A NEW HATCH ?? THE \"\r"
  "1380 PRINT \"SHELL EXPLODED IN YOUR SHIP, DESTROYING IT!!!\"\r"
  "1390 IF P=1THEN1590\r"
  "1400 GOTO 800\r"
  "1410 PRINT \"WHERE DID U LEARN TO TYPE? \";B;\"DEGREES EXCEEDS 360 BY\"\r"
  "1420 PRINT B-360;\" DEGREES.\"\r"
  "1430 S1=S1+1\r"
  "1440 IF P=1THEN1580\r"
  "1450 GOTO 490\r"
  "1460 LET P=1\r"
  "1470 GOTO 400\r"
  "1480 PRINT \"THE ENEMY \";:P0=Z0:GOSUB 3000\r"
  "1481 PRINT \" IS FIRING ON YOUR SHIPS!\"\r"
  "1490 P4=1234*RND(RND(0))+(RND(0)*10)\r"
  "1500 IF P4>500THEN1490\r"
  "1510 IF P2=1THEN1600\r"
  "1520 IF INT(P4)<100THEN1800\r"
  "1530 IF Z0=1THEN2100\r"
  "1540 PRINT \"HIS FIRST ROUND FELL\"INT(P4)\"YARDS SHORT.\"\r"
  "1560 LET S2=S2+1\r"
  "1570 GOTO 490\r"
  "1580 REM\r"
  "1590 IF P2=1THEN1490\r"
  "1600 P1=1250*RND(RND(0))+(RND(0)*10)\r"
  "1610 IF P1>P4THEN1600\r"
  "1620 IF P1<(P4-400)THEN1600\r"
  "1630 IF P1<100THEN1710\r"
  "1640 LET P4=P1\r"
  "1650 S2=S2+1\r"
  "1660 IF Z0=1THEN2190\r"
  "1670 PRINT \"THE ENEMY ROUND FELL\"INT(P1)\"YARDS SHORT.\"\r"
  "1690 M=2\r"
  "1700 GOTO 490\r"
  "1710 S2=S2+1\r"
  "1720 LET P2=1\r"
  "1730 GOSUB 1850\r"
  "1740 IF M=1THEN1490\r"
  "1750 PRINT \"THE ENEMY \";:P0=Z0:GOSUB 3000\r"
  "1751 PRINT \" SANK \";:P0=D0:GOSUB 3000:PRINT\r"
  "1760 R=R+1\r"
  "1770 IF R=9THEN840\r"
  "1780 IF D0=18THEN840\r"
  "1790 GOTO 830\r"
  "1800 P2=1\r"
  "1810 GOSUB 1850\r"
  "1820 PRINT \"IN FACT, HE JUST SANK \";:P0=D0:GOSUB 3000:PRINT\r"
  "1830 R=R+1\r"
  "1840 GOTO 830\r"
  "1850 RESTORE \r"
  "1860 FOR C=1 TO (9+O)\r"
  "1870 READ D0\r"
  "1880 NEXT C\r"
  "1890 READ D0\r"
  "1900 O=O+1\r"
  "1910 R=R+1\r"
  "1920 DATA 1,2,3\r"
  "1930 DATA 4,5,6\r"
  "1940 DATA 7,8,9\r"
  "1950 DATA 10,11\r"
  "1960 DATA 12,13\r"
  "1970 DATA 14,15,16\r"
  "1980 DATA 17,18\r"
  "1990 RETURN \r"
  "2000 PRINT \"YOUR FLAGSHIP HAS DETECTED A U-BOAT APPROCHING AT 5\";\r"
  "2001 PRINT \" FATHOMS.\"\r"
  "2010 P=1\r"
  "2020 GOTO 410\r"
  "2030 PRINT \"YOUR SUBMARINE DETECTION EQUIPMENT READS THE RANGE TO THE\";\r"
  "2031 PRINT \" TARGET\"\r"
  "2040 T=INT(T-1500)\r"
  "2050 IF T<0THEN410\r"
  "2060 PRINT \"AS\"T\"METERS.\"\r"
  "2080 PRINT \"THE U-BOAT HAS COMMENCED FIRING TORPEDOES AT YOUR SHIPS.\"\r"
  "2090 GOTO 1490\r"
  "2100 PRINT \"HIS FIRST TORPEDO EXPLODED\"INT(P4)-50;\r"
  "2101 PRINT \"METERS BEHIND YOUR SHIP.\"\r"
  "2120 GOTO 1560\r"
  "2130 PRINT \"DEPTH CHARGE EXPLODED\"ABS(E1)\"METERS SHORT OF TARGET.\"\r"
  "2150 GOTO 1590\r"
  "2160 PRINT \"DEPTH CHARGE EXPLODED\"ABS(E1)\"METERS AFT OF TARGET.\"\r"
  "2180 GOTO 1590\r"
  "2190 PRINT \"THE ENEMY TORPEDO EXPLODED\"INT(P1)-50;\r"
  "2191 PRINT \"METERS IN FRONT OF YOUR SHIP.\"\r"
  "2210 GOTO 490\r"
  "2220 END\r"
  "3000 REM STRING VARIABLE PATCHES\r"
  "3010 IF P0=1THENPRINT \"U-BOAT\";\r"
  "3020 IF P0=2THENPRINT \"210 MM SHORE GUN\";\r"
  "3030 IF P0=3THENPRINT \"70,000 TON CRUISER\";\r"
  "3040 IF P0=4THENPRINT \"BATTLESHIP\";\r"
  "3050 IF P0=5THENPRINT \"TORPEDO BOAT\";\r"
  "3060 IF P0=6THENPRINT \"HEAVY FRIGATE\";\r"
  "3070 IF P0=7THENPRINT \"E-TYPE DESTROYER\";\r"
  "3080 IF P0=8THENPRINT \"GUIDED-MISSLE SHIP\";\r"
  "3090 IF P0=9THENPRINT \"AIRCRAFT CARRIER\";\r"
  "3100 IF P0=10THENPRINT \"ONE OF YOUR DESTROYERS!!\";\r"
  "3110 IF P0=11THENPRINT \"YOUR HEAVY CRUISER!!\";\r"
  "3120 IF P0=12THENPRINT \"ANOTHER OF YOUR DESTROYERS!!\";\r"
  "3130 IF P0=13THENPRINT \"ONE OF YOUR BATTLESHIPS!!\";\r"
  "3140 IF P0=14THENPRINT \"YOUR LAST DESTROYER\";\r"
  "3150 IF P0=15THENPRINT \"YOUR AIRCRAFT CARRIER\";\r"
  "3160 IF P0=16THENPRINT \"YOUR LIGHT CRUISER\";\r"
  "3170 IF P0=17THENPRINT \"YOUR LAST AIRCRAFT CARRIER\";\r"
  "3180 IF P0=18THENPRINT \"YOUR LAST BATTLESHIP!!\";\r"
  "3190 RETURN\r"
  "";

const char basic_sieve[] =
  "100 REM  NAME--SIEVE\r"
  "110 REM\r"
  "120 REM  DISCRIPTION--DEMONSTRATES SIEVE METHOD OF FINDING PRIMES.\r"
  "130 REM\r"
  "140 REM  SOURCE--UNKNOWN\r"
  "150 REM\r"
  "160 REM  INSTRUCTIONS--TYPE \"RUN\" AND FOLLOW INSTRUCTIONS.\r"
  "170 REM\r"
  "180 REM\r"
  "190 REM  *  *  *  *  *  *  MAIN PROGRAM   *  *  *  *  *  *  *  *\r"
  "200 REM\r"
  "210 READ E\r"
  "220 PRINT\r"
  "230 PRINT\r"
  "240 PRINT \"SIEVING BY \" E\r"
  "250 PRINT\r"
  "260 FOR N=2 TO 56\r"
  "270 IF N=2 THEN 350\r"
  "280 IF N/2>INT(N/2) THEN 310\r"
  "290 PRINT \"  * \";\r"
  "300 GO TO 400\r"
  "310 IF N<8 THEN 350\r"
  "320 FOR F= 3 TO E STEP 2\r"
  "330 IF N=F*INT(N/F) THEN 390\r"
  "340 NEXT F\r"
  "350 IF N>9 THEN 370\r"
  "360 PRINT \" \";\r"
  "370 PRINT N;\r"
  "380 GO TO 400\r"
  "390 PRINT \"  * \";\r"
  "400 NEXT N\r"
  "410 IF E < 7 THEN 210\r"
  "420 DATA 2,3,5,7\r"
  "430 END\r"
  "";

const char basic_sin[] =
  "10 PRINT \"Y = SIN X\"\r"
  "20 PRINT\r"
  "30 LET L=20\r"
  "40 LET M=L+(66-L)/2\r"
  "50 PRINT \"  X     Y\"\r"
  "60 FOR X1=-66 TO 66 STEP 2\r"
  "70 LET X=.1*X1\r"
  "80 LET Y=SIN(X)\r"
  "90 LET Y2=10*Y+M\r"
  "100 IF X1=0 THEN 210\r"
  "110 IF Y2<L THEN 250\r"
  "120 IF Y2>66 THEN 250\r"
  "130 IF Y2<M THEN 190\r"
  "140 IF Y2=M THEN 170\r"
  "150 PRINT X;\r"
  "151 PRINT TAB(6);Y;\r"
  "152 PRINT TAB(M);\"!\";TAB(Y2);\"*\"\r"
  "160 GOTO 220\r"
  "170 PRINT X;\r"
  "171 PRINT TAB(6);Y;\r"
  "172 PRINT TAB(Y2);\"*\";TAB(M);\"!\"\r"
  "180 GOTO 220\r"
  "190 PRINT X;\r"
  "191 PRINT TAB(6);Y;\r"
  "192 PRINT TAB(Y2);\"*\";TAB(M);\"!\"\r"
  "200 GOTO 220\r"
  "210 PRINT X;\r"
  "211 PRINT TAB(6);Y;\r"
  "212 PRINT TAB(Y2);\"*\";TAB(67);\"---Y\"\r"
  "220 NEXT X1\r"
  "230 PRINT TAB(M);\"X\"\r"
  "240 GOTO 260\r"
  "250 PRINT \"---------------------   T O   W I D E   -------------------------\"\r"
  "260 END\r";

const char basic_square[] =
  "100 REM  ** SQUARE **\r"
  "110 REM\r"
  "120 REM  WRITTEN BY MAC OGLESBY\r"
  "130 REM  AS DESCRIBED IN VOL. 1, ISSUE 3\r"
  "140 REM  OF CALCULATORS-COMPUTERS MAGAZINE\r"
  "150 REM\r"
  "160 CS$=CHR$(126)+CHR$(28)  'CURSOR CONTROL CODES TO CLEAR SCREEN\r"
  "170 DEFINT A-Z\r"
  "180 PRINTCS$;\"ENTER PASSWORD\";:INPUTA$:Z=0\r"
  "190 A=0:FORI=1TOLEN(A$):A=A+ASC(MID$(A$,I,1)):NEXT:A=RND(-A)\r"
  "200 DIM Q(50),S$(50),S(24,12),U(12),V(50)\r"
  "210 P$(1)=\"X\":P$(2)=\"O\":F=1\r"
  "220 FOR R0=0 TO 4:FOR C0=0 TO 4:D$(R0,C0)=\".\":NEXTC0:NEXTR0\r"
  "230 INPUT\"WANT INSTRUCTIONS FOR 'SQUARE'\";A$\r"
  "240 IFLEFT$(A$,1)=\"N\"THEN400\r"
  "250 PRINTCS$;  'CLEAR SCREEN\r"
  "260 PRINT\"   THE GAME OF SQUARE IS FOR 1 OR 2 PLAYERS.  THE NORMAL\"\r"
  "270 PRINT\"BOARD LOOKS LIKE THIS AT THE START:\":GOSUB2000\r"
  "280 PRINT\"   THE PLAYERS GO IN TURN AND CHOOSE ANY UNOCCUPIED POINT\"\r"
  "290 PRINT\"(SHOWN AS A DOT).  EACH PLAYER HAS 12 MARKERS (X'S OR O'S)\"\r"
  "300 PRINT\"WHICH ARE USED TO IDENTIFY CHOSEN POINTS.\":PRINT\r"
  "310 INPUT\"             ENTER 'C' TO CONTINUE\";A$:PRINT\r"
  "320 PRINT\"   THE WINNER IS THE FIRST PLAYER WHO HAS CHOSEN 4 POINTS\"\r"
  "330 PRINT\"WHICH FORM THE CORNERS OF A SQUARE.\"\r"
  "340 PRINT\"   TO CHOOSE A POINT, TYPE 2 DIGITS (0 TO 4) SEPARATED BY A\"\r"
  "350 PRINT\"COMMA.  THE FIRST DIGIT TELLS THE DISTANCE OVER (TO T\";\r"
  "360 PRINT\"HE RIGHT)\":PRINT\"FROM POINT 0,0 (THE ORIGIN).  THE SECOND\";\r"
  "370 PRINT\" DIGIT TELLS THE DISTANCE UP.\":PRINT\r"
  "380 PRINT\"REMEMBER: OVER,UP.\":PRINT\r"
  "390 INPUT\"             ENTER 'C' TO CONTINUE\";A$:PRINT\r"
  "400 PRINT:INPUT\"DO YOU WANT TO PLAY THE EXPERTS' GAME\";A$\r"
  "410 B0=1:IFLEFT$(A$,1)=\"Y\"THENB0=2\r"
  "420 IFB0=1THEN440\r"
  "430 D$(2,2)=\" \":N=38:GOTO450\r"
  "440 N=50\r"
  "450 IFZ=1THENGOTO490ELSEPRINT:INPUT\"HOW MANY PLAYERS (1 OR 2)\";P0\r"
  "460 IFP0=2THEN510\r"
  "470 IF P0=1THEN480ELSEPRINT\"PLEASE ENTER 1 OR 2\":GOTO450\r"
  "480 PRINTCS$;\"OK, I WILL PLAY THE X'S\":PRINT\r"
  "490 INPUT\"DO YOU WANT TO GO FIRST\";A$:F=1\r"
  "500 IFLEFT$(A$,1)=\"Y\"THENF=2\r"
  "510 PRINTCS$;\"OK...HERE WE GO...\"\r"
  "520 IFZ=1THEN940\r"
  "530 RESTORE:FORJ=0TO24:READS(J,0):NEXT\r"
  "540 DATA 4,7,8,7,4,7,10,11,10,7,8,11,12,11,8,7,10,11,10,7,4,7,8,7,4\r"
  "550 FORJ=0TO24:FORK=1TOS(J,0):READS(J,K):NEXTK:NEXTJ\r"
  "560 DATA 1,13,35,43\r"
  "570 DATA 1,2,15,20,28,31,36\r"
  "580 DATA 2,3,21,24,29,43,44,47\r"
  "590 DATA 3,4,16,25,30,31,35\r"
  "600 DATA 4,13,36,44\r"
  "610 DATA 1,5,15,24,30,32,37\r"
  "620 DATA 1,2,5,14,22,25,38,39,47,48\r"
  "630 DATA 2,3,15,16,17,23,26,32,33,39,40\r"
  "640 DATA 3,4,6,14,20,27,37,40,47,49\r"
  "650 DATA 4,6,16,21,28,33,38\r"
  "660 DATA 5,7,20,26,29,43,45,48\r"
  "670 DATA 5,7,15,17,18,21,27,31,34,39,41\r"
  "680 DATA 39,40,41,42,43,44,45,46,47,48,49,50\r"
  "690 DATA 6,8,16,17,19,22,24,31,34,40,42\r"
  "700 DATA 6,8,23,25,29,44,46,49\r"
  "710 DATA 7,9,18,22,28,32,35\r"
  "720 DATA 7,9,10,14,23,24,36,41,48,50\r"
  "730 DATA 10,11,17,18,19,20,25,32,33,41,42\r"
  "740 DATA 8,11,12,14,21,26,35,42,49,50\r"
  "750 DATA 8,12,19,27,30,33,36\r"
  "760 DATA 9,13,37,45\r"
  "770 DATA 9,10,18,26,30,34,38\r"
  "780 DATA 10,11,22,27,29,45,46,50\r"
  "790 DATA 11,12,19,23,28,34,37\r"
  "800 DATA 12,13,38,46\r"
  "810 FORJ=1TON:READS$(J):NEXT\r"
  "820 DATA 00011110,01021211,02031312,03041413,10112120\r"
  "830 DATA 13142423,20213130,23243433,30314140,31324241\r"
  "840 DATA 32334342,33344443,00044440,11133331\r"
  "850 DATA 01122110,03142312,12233221,21324130,23344332\r"
  "860 DATA 01133220,02143321,11234230,12244331\r"
  "870 DATA 02233110,03243211,12334120,13344221\r"
  "880 DATA 01144330,02244220,03344110\r"
  "890 DATA 01032321,10123230,12143432,21234341\r"
  "900 DATA 00033330,01043431,10134340,11144441\r"
  "910 DATA 11122221,12132322,21223231,22233332\r"
  "920 DATA 00022220,02042422,20224240,22244442\r"
  "930 DATA 02132211,11223120,13243322,22334231\r"
  "940 IFA(1)<>89THEN960\r"
  "950 IFB0=2THEN960ELSEPRINT:GOTO970\r"
  "960 GOSUB2000\r"
  "970 T=T+1\r"
  "980 REM ** MAIN MOVE LOOP: J=121212... OR J=212121...\r"
  "990 FORJ=FTO3-FSTEP3-2*F\r"
  "1000 IFP0=2THEN1730\r"
  "1010 IFJ=2THEN1730\r"
  "1020 REM ** GENERATE COMPUTER'S MOVE\r"
  "1030 IFT<>1THEN1100\r"
  "1040 IFD$(2,2)<>\".\"THEN1060\r"
  "1050 R1=2:C1=2:GOTO1710\r"
  "1060 IFF=1THEN1080\r"
  "1070 Q0=9:GOTO1130\r"
  "1080 R1=1+INT(RND(1)*3):C1=1+INT(RND(1)*3)\r"
  "1090 IFD$(R1,C1)<>\".\"THENGOTO1080ELSEGOTO1710\r"
  "1100 IFT<>2THEN1380\r"
  "1110 IFF=1THEN1130\r"
  "1120 Q0=19\r"
  "1130 K9=0\r"
  "1140 FORJ1=1TON:IFQ(J1)<>1+Q0THEN1160\r"
  "1150 K9=K9+1:U(K9)=J1\r"
  "1160 NEXTJ1\r"
  "1170 IFK9=0THEN1370\r"
  "1180 FORJ2=K9TO1STEP-1:T9=1+INT(RND(1)*J2):J1=U(T9)\r"
  "1190 FORK1=1TO8STEP2:R1=VAL(MID$(S$(J1),K1,1))\r"
  "1200 C1=VAL(MID$(S$(J1),K1+1,1))\r"
  "1210 IFD$(R1,C1)<>\".\"THEN1320\r"
  "1220 IFQ0+T<3THEN1240\r"
  "1230 GOTO1710\r"
  "1240 S0=5*R1+C1:M0=0:FORJ3=1TOS(S0,0)\r"
  "1250 IFB0=1THEN1280\r"
  "1260 IFS(S0,J3)<=38THEN1280\r"
  "1270 GOTO1310\r"
  "1280 IFQ(S(S0,J3))>1THEN1300\r"
  "1290 M0=M0+1\r"
  "1300 NEXTJ3\r"
  "1310 IFM0<8-B0THENGOTO1320ELSEGOTO1710\r"
  "1320 NEXTK1\r"
  "1330 IFJ2=T9THEN1350\r"
  "1340 T8=U(J2):U(J2)=U(T9):U(T9)=T8\r"
  "1350 NEXTJ2\r"
  "1360 REM *** AS A LAST RESORT, PICK ANY VACANT POINT\r"
  "1370 R1=RND(1)*5:C1=RND(1)*5:IFD$(R1,C1)<>\".\"THENGOTO1370ELSEGOTO1710\r"
  "1380 IFT=3THEN1430\r"
  "1390 REM ** SEE IF 'X' CAN COMPLETE A SQUARE\r"
  "1400 FORJ1=1TON:IFQ(J1)<>3THENGOTO1410ELSEGOTO1190\r"
  "1410 NEXTJ1\r"
  "1420 REM ** SEE IF 'O' CAN COMPLETE A SQUARE\r"
  "1430 FORJ1=1TON:IFQ(J1)<>30THENGOTO1440ELSEGOTO1190\r"
  "1440 NEXTJ1\r"
  "1450 REM ** CAN 'X' CHOOSE A 3RD CORNER?\r"
  "1460 K9=0:FORJ1=1TON:IFQ(J1)<>2THEN1480\r"
  "1470 K9=K9+1:U(K9)=J1\r"
  "1480 NEXTJ1\r"
  "1490 IFK9=0THEN1700\r"
  "1500 FORI0=1TO2:FORJ0=K9TO1STEP-1:M9=1+INT(RND(1)*J0):J1=U(M9):T9=0\r"
  "1510 FORK1=1TO8STEP2:R1=VAL(MID$(S$(J1),K1,1))\r"
  "1520 C1=VAL(MID$(S$(J1),K1+1,1)):IFD$(R1,C1)<>\".\"THEN1540\r"
  "1530 T9=T9+1:R(T9)=R1:C(T9)=C1\r"
  "1540 NEXTK1\r"
  "1550 FORJ2=1TO2:FORJ3=1TO50:V(J3)=Q(J3):NEXTJ3:S0=5*R(J2)+C(J2)\r"
  "1560 FORJ3=1TOS(S0,0):V(S(S0,J3))=V(S(S0,J3))+1:NEXTJ3\r"
  "1570 S0=5*R(3-J2)+C(3-J2)\r"
  "1580 FORJ3=1TOS(S0,0):V(S(S0,J3))=V(S(S0,J3))+10:NEXTJ3\r"
  "1590 FORJ3=1TON:IFV(J3)<>4-I0THEN1610\r"
  "1600 R1=R(J2):C1=C(J2):GOTO1710\r"
  "1610 NEXTJ3\r"
  "1620 NEXTJ2\r"
  "1630 IFJ0=M9THEN1650\r"
  "1640 T8=U(J0):U(J0)=U(M9):U(M9)=T8\r"
  "1650 NEXTJ0\r"
  "1660 NEXTI0\r"
  "1670 REM ** NO GOOD MOVE AVAILABLE...PICK ANY 3RD CORNER\r"
  "1680 J1=U(1+INT(RND(1)*K9)):GOTO1190\r"
  "1690 REM ** SEE IF WE CAN ANNOY THE HUMAN\r"
  "1700 Q0=I9:GOTO1130\r"
  "1710 PRINT\"THE \";P$(J);\"'S MOVE TO \";STR$(C1);\",\";STR$(R1):GOTO1780\r"
  "1720 REM ** GET PLAYER'S CHOICE\r"
  "1730 IFT>1THEN1750\r"
  "1740 PRINT\"THE \";P$(J);\"'S MOVE TO WHICH POINT\";:GOTO1760\r"
  "1750 PRINTP$(J);\"'S CHOICE\";\r"
  "1760 INPUTC1,R1\r"
  "1770 IFD$(R1,C1)<>\".\"THEN1850\r"
  "1780 D$(R1,C1)=P$(J)\r"
  "1790 REM ** Q() TELLS WHO OWNS CORNERS OF WHICH SQUARES\r"
  "1800 S0=5*R1+C1:FORJ1=1TOS(S0,0):Q(S(S0,J1))=Q(S(S0,J1))+1+(J-1)*9\r"
  "1810 IFQ(S(S0,J1))<>4+(J-1)*36THEN1830\r"
  "1820 PRINT:PRINT\"*** THE \";P$(J);\"'S WIN!! ***\":GOTO1910\r"
  "1830 NEXTJ1\r"
  "1840 GOTO1880\r"
  "1850 PRINT\"** ILLEGAL POINT! **\":GOTO1870\r"
  "1860 PRINT\"YOU MUST TYPE 2 DIGITS (0 TO 4) SEPARATED BY A COMMA!\"\r"
  "1870 PRINT\"** INPUT IGNORED! PLEASE TRY AGAIN...\":GOTO1750\r"
  "1880 NEXTJ\r"
  "1890 IFT<12THEN1970\r"
  "1900 PRINT:PRINT\"THE GAME IS A DRAW; NEITHER PLAYER MADE A SQUARE!\"\r"
  "1910 FORK1=1TO8STEP2:R1=VAL(MID$(S$(S(S0,J1)),K1,1))\r"
  "1920 C1=VAL(MID$(S$(S(S0,J1)),K1+1,1)):D$(R1,C1)=CHR$(64):NEXT:GOSUB2000\r"
  "1930 INPUT\"WANT TO PLAY AGAIN\";A$:IFLEFT$(A$,1)<>\"Y\"THENEND\r"
  "1940 Z=1:FORJ2=0TO4:FORJ3=0TO4:D$(J2,J3)=\".\":NEXTJ3:NEXTJ2\r"
  "1950 FORJ2=1TO50:Q(J2)=0:V(J2)=0:NEXTJ2:FORJ2=1TO12:U(J2)=0:NEXTJ2\r"
  "1960 T=0:K9=0:GOTO400\r"
  "1970 GOSUB2000\r"
  "1980 GOTO970\r"
  "1990 REM ** PRINT THE BOARD\r"
  "2000 PRINT:FORR0=4TO0STEP-1:PRINTSTR$(R0);\"  \";\r"
  "2010 FORC0=0TO4:PRINTD$(R0,C0);:IFC0=4THEN2030\r"
  "2020 PRINT\"     \";\r"
  "2030 NEXTC0:PRINT:IFR0=0THEN2050\r"
  "2040 PRINT:PRINT\r"
  "2050 NEXTR0:PRINT:PRINT\"    0     1     2     3     4\":PRINT:RETURN\r"
  "2060 END\r"
  "";

const char basic_swarms[] =
  "100 'SWARMS2 - YET ANOTHER GEM FROM 'ZOSO'\r"
  "110 CLEAR : CLEAR 1000\r"
  "120 PRINT CHR$(26);\"!!!!! ATTENTION: THE BEES ARE ATTACKING !!!!!!\"\r"
  "130 PRINT : PRINT\r"
  "140 PRINT \"BEGIN DEFENSE PLAN: \" : PRINT\r"
  "150 PRINT \"TIME:     1\"\r"
  "160 INPUT \"ENTER YOUR NAME FOR IDENTIFICATION CHECK\"; N$\r"
  "170 PRINT CHR$(26)\r"
  "180 INPUT \"ENTER CODE WORD FOR NUCLEAR CLEARANCE\"; C$\r"
  "190 GOSUB 5220\r"
  "200 REM CREATE TWO INITIAL SWARMS\r"
  "210 DIM E(21),S(21),A$(21),U(21),G(21),M(21),D(21),C(21)\r"
  "220 DIM K(21),V(21),R(21)\r"
  "230 A1=INT(RND(1)*21+1)\r"
  "240 A2=INT(RND(1)*21+1)\r"
  "250 IF A1=A2 THEN 230\r"
  "260 S(A1) = INT(RND(1)*5+2)\r"
  "270 S(A2) = INT(RND(1)*5+2)\r"
  "280 E(A1) = INT(RND(1)*9+6)\r"
  "290 E(A2) = INT(RND(1)*9+6)\r"
  "300 REM SUBTRACT ONE HOUR FROM ALL ETA'S\r"
  "310 FOR A=1 TO 21\r"
  "320 IF E(A)=0 THEN 340\r"
  "330 GOTO 350\r"
  "340 IF U(A) = 0 THEN 560\r"
  "350 IF S(A) = 1 THEN 560\r"
  "360 IF ABS(U(A)) = 1 THEN 470\r"
  "370 IF ABS(E(A)) = 1 THEN 410\r"
  "380 E(A)=E(A) - 1\r"
  "390 C(A)=C(A)+(17-E(A))\r"
  "400 GOTO 560\r"
  "410 IF E(A) = -1 THEN 450\r"
  "420 PRINT \"THE BEES HAVE ARRIVED IN THE MAJOR CITY IN SECTION \";A\r"
  "430 E(A)=-1\r"
  "440 U(A)=6\r"
  "450 U(A)=U(A)-1\r"
  "460 GOTO 560\r"
  "470 IF U(A) = -1 THEN 560\r"
  "480 PRINT \"THE BEES HAVE DESTROYED THE MAJOR CITY IN SECTION \";A\r"
  "490 U(A)=-1\r"
  "500 IF V(A)<>-1 THEN 530\r"
  "510 PRINT \"BUT THE POPULATION HAS BEEN EVACUATED\"\r"
  "520 GOTO 550\r"
  "530 K(A)=1\r"
  "540 C(A)=(1E+06*(RND(1)*A+1))+C(A)\r"
  "550 GOTO 560\r"
  "560 NEXT A\r"
  "570 REM ADD ONE UNIT TO TIME\r"
  "580 T=T+1\r"
  "590 REM CREATE NEW SWARM\r"
  "600 IF T/30<>INT(T/30) THEN 690\r"
  "610 A=INT(RND(1)*21+1)\r"
  "620 IF S(A)<>0 THEN 600\r"
  "630 IF R(A)<>0 THEN 600\r"
  "640 IF K(A)<>0 THEN 600\r"
  "650 S(A)=INT(RND(1)*5+2)\r"
  "660 E(A)=INT(RND(1)*9+16)\r"
  "670 C(A)=INT(RND(1)*10)\r"
  "680 PRINT \"A NEW SWARM IS REPORTED IN SECTION \";A\r"
  "690 REM CHECK COMBATED SWARMS\r"
  "700 FOR A=1 TO 21\r"
  "710 IF T<>G(A) THEN 870\r"
  "720 IF S(A)<> 1 THEN 810\r"
  "730 S(A)=0\r"
  "740 G(A)=0\r"
  "750 E(A)=0\r"
  "760 M(A)=0\r"
  "770 K(A)=0\r"
  "780 U(A)=0\r"
  "790 PRINT \"** THE SWARM IN SECTION \";A;\" IS TOTALLY DESTROYED.\"\r"
  "800 GOTO 870\r"
  "810 S(A)=S(A)-M(A)\r"
  "820 PRINT \"** THE PHASE ON SECTION \";A;\" WAS SUCCESSFUL.\"\r"
  "830 IF S(A)>=1 THEN 850\r"
  "840 S(A)=1\r"
  "850 G(A)=0\r"
  "860 M(A)=0\r"
  "870 NEXT A\r"
  "880 REM ADD ONE UNIT TO EACH UNCOMBATTED SWARM\r"
  "890 FOR A=1 TO 21\r"
  "900 IF E(A)=1 THEN 1150\r"
  "910 IF S(A)=1 THEN 1120\r"
  "920 IF S(A)=0 THEN 1150\r"
  "930 IF S(A)+1<9 THEN 1090\r"
  "940 IF A=1 THEN 1020\r"
  "950 IF S(A-1)>0 THEN 1010\r"
  "960 IF R(A-1)<>0 THEN 1150\r"
  "970 PRINT \"** THE SWARM IN SECTION \";A;\" HAS SPREAD TO SECTION \";A-1\r"
  "980 S(A-1)=3\r"
  "990 E(A-1)=INT(RND(1)*10+5)\r"
  "1000 GOTO 1150\r"
  "1010 IF A=21 THEN 1150\r"
  "1020 IF S(A+1)>0 THEN 1150\r"
  "1030 IF R(A+1)<>0 THEN 1150\r"
  "1040 PRINT \"** THE SWARM IN SECTION \";A;\" HAS SPREAD TO SECTION \";A+1\r"
  "1050 IF R(A+1)<>0 THEN 1150\r"
  "1060 S(A+1)=3\r"
  "1070 E(A+1)=INT(RND(1)*10+5)\r"
  "1080 GOTO 1150\r"
  "1090 S(A)=S(A)+1\r"
  "1100 C(A)=C(A)+S(A)\r"
  "1110 GOTO 1150\r"
  "1120 IF D(A)=1 THEN 1150\r"
  "1130 PRINT \"** THE SWARM IN SECTION \";A;\" IS READY TO BE DESTROYED.\"\r"
  "1140 D(A)=1\r"
  "1150 NEXT A\r"
  "1160 REM WINNER CHECK\r"
  "1170 W=0\r"
  "1180 FOR A=1 TO 21\r"
  "1190 W=S(A)+W\r"
  "1200 NEXT A\r"
  "1210 IF W>=1 THEN 1280\r"
  "1220 PRINT \"*******ALL SWARMS ARE NOW DESTROYED*******\"\r"
  "1230 PRINT \"FINAL STATISTICS ON ATTACKS AND DESTRUCTION ARE NOW \"\r"
  "1240 PRINT \"BEING COMPUTED,   ...   FINAL RESULTS FOLLOW .....\"\r"
  "1250 A=0\r"
  "1260 PRINT\r"
  "1270 GOTO 4690\r"
  "1280 REM EVACUATION CHECK\r"
  "1290 FOR A=1 TO 21\r"
  "1300 IF V(A)<>T THEN 1400\r"
  "1310 IF U(A)=-1 THEN 1370\r"
  "1320 IF K(A)>0 THEN 1370\r"
  "1330 PRINT \"** POPULATION IN SECTION \";A;\" IS EVACUATED\"\r"
  "1340 C(A)=C(A)+INT(RND(1)*17)\r"
  "1350 V(A)=-1\r"
  "1360 GOTO 1400\r"
  "1370 PRINT \"** POPULATION IN SECTION \";A;\" WAS DESTROYED BEFORE \"\r"
  "1380 PRINT \"   IT COULD BE EVACUATED\"\r"
  "1390 V(A)=0\r"
  "1400 NEXT A\r"
  "1410 REM RETURN EVACUATION CHECK\r"
  "1420 FOR A=1 TO 21\r"
  "1430 IF R(A)<>T THEN 1490\r"
  "1440 IF R(A)<1 THEN 1490\r"
  "1450 K(A)=0\r"
  "1460 R(A)=0\r"
  "1470 V(A)=0\r"
  "1480 PRINT \"** THE POPULATION HAS RETURNED TO THE CITY IN SECTION \";A\r"
  "1490 NEXT A\r"
  "1500 REM LOSER CHECK\r"
  "1510 Q=0\r"
  "1520 FOR A=1 TO 21\r"
  "1530 Q=C(A)+Q\r"
  "1540 NEXT A\r"
  "1550 IF Q<7.5E+07 THEN 1650\r"
  "1560 PRINT \"THE BEES HAVE DEVASTATED THE UNITED STATES AND \"\r"
  "1570 PRINT \"THERE ARE NOW OVER 75 MILLION CASUALTIES,  THE BEES\"\r"
  "1580 PRINT \"ARE NOW CONSIDERED TO BE THE VICTORS OVER MODERN\"\r"
  "1590 PRINT \"TECHNOLOGY.\"\r"
  "1600 A=0\r"
  "1610 Q=0\r"
  "1620 W=0\r"
  "1630 PRINT\r"
  "1640 GOTO 4690\r"
  "1650 REM COMMAND INPUT\r"
  "1660 PRINT \"TIME:   \";T+1\r"
  "1670 INPUT \"COMMAND\"; COM\r"
  "1680 IF COM>8 OR COM<1 OR COM<>INT(COM) THEN PRINT \"WRONG !!!\"; : GOTO 1670\r"
  "1690 ON COM GOTO 1700,2210,2620,3840,4060,4660,4920,5190\r"
  "1700 REM MAP PRINT OUT\r"
  "1710 PRINT CHR$(26);\"1)        ATTACK SCAN MAP\"\r"
  "1720 PRINT\r"
  "1730 FOR A=1 TO 21\r"
  "1740 IF S(A)>6 THEN 1860\r"
  "1750 IF S(A)>4 THEN 1840\r"
  "1760 IF S(A)>1 THEN 1820\r"
  "1770 IF S(A)>0 THEN 1800\r"
  "1780 A$(A)= \"?\"\r"
  "1790 GOTO 1870\r"
  "1800 A$(A)=\".\"\r"
  "1810 GOTO 1870\r"
  "1820 A$(A)=\"+\"\r"
  "1830 GOTO 1870\r"
  "1840 A$(A)=\"*\"\r"
  "1850 GOTO 1870\r"
  "1860 A$(A)=\"#\"\r"
  "1870 NEXT A\r"
  "1880 PRINT \"----------------------------------------------------\"\r"
  "1890 PRINT TAB(48);\"---\"\r"
  "1900 PRINT TAB(20);\"CANADA- NO INFORMATION     /  /\"\r"
  "1910 Z1$=\"-----------------------        / \"+A$(18)+\"/\"\r"
  "1920 PRINT TAB(15);Z1$\r"
  "1930 PRINT TAB(15);\"!   !   !   !    !    !\\-    -/  /\"\r"
  "1940 Z1$=\"! \"+A$(1)+\" ! \"+A$(3)+\" ! \"+A$(6)+\" ! \"\r"
  "1950 Z1$=Z1$+A$(9)+\"  ! \"+A$(13)+\"  !  \\--/---/\"\r"
  "1960 PRINT TAB(15);Z1$\r"
  "1970 Z1$=          \"!   !---!---!----!----! \"+A$(16)+\" !    /\"\r"
  "1980 PRINT TAB(15);Z1$\r"
  "1990 Z1$=          \"!---!   !   !    !    !   ! \"+A$(19)+\" !\"\r"
  "2000 PRINT TAB(15);Z1$\r"
  "2010 Z1$=\"!   ! \"+A$(4)+\" ! \"+A$(7)+\" ! \"+A$(10)+\"  ! \"\r"
  "2020 Z1$=Z1$+A$(14)+\"  !---!---!\"\r"
  "2030 PRINT TAB(15);Z1$\r"
  "2040 Z1$=\"! \"+A$(2)+\" !---!---!----!----!   !   !\"\r"
  "2050 PRINT TAB(15);Z1$\r"
  "2060 Z1$=\" \\  !   !   !    !    ! \"+A$(17)+\" ! \"+A$(20)+\" !\"\r"
  "2070 PRINT TAB(15);Z1$\r"
  "2080 Z1$=\"  \\ ! \"+A$(5)+\" ! \"+A$(8)+\" ! \"+A$(11)+\"  ! \"\r"
  "2090 Z1$=Z1$+A$(15)+\"  !   !   /\"\r"
  "2100 PRINT TAB(15);Z1$\r"
  "2110 Z1$=\"   \\!---!---!----!----!---! \"+A$(21)+\"!\"\r"
  "2120 PRINT TAB(15);Z1$\r"
  "2130 PRINT TAB(27);\"\\    !\";TAB(42);\"\\ !\"\r"
  "2140 Z1$=\"              \\ \"+A$(12)+\"!\"\r"
  "2150 PRINT TAB(15);Z1$;TAB(42);\"! !\"\r"
  "2160 PRINT TAB(30);\"\\-!\";TAB(42);\"!-!\"\r"
  "2170 PRINT TAB(20);\"MEXICO- NO INFORMATION\"\r"
  "2180 PRINT\r"
  "2190 PRINT \"----------------------------------------------------\"\r"
  "2200 GOTO 300\r"
  "2210 REM ETA REPORT\r"
  "2220 PRINT CHR$(12);\"2)         ETA REPORT\"\r"
  "2230 PRINT\r"
  "2240 INPUT \"ENTER SECTION #\"; A\r"
  "2250 IF A<1 OR A>21 OR A<>INT(A) THEN PRINT \"WRONG  !!!\"; : GOTO 2240\r"
  "2260 PRINT \"*************************************\"\r"
  "2270 IF A<>0 THEN 2300\r"
  "2280 D7=-1\r"
  "2290 FOR A = 1 TO 21\r"
  "2300 IF S(A)=1 THEN 2520\r"
  "2310 IF R(A)=-1 THEN 2550\r"
  "2320 IF E(A)=0 THEN 2500\r"
  "2330 IF U(A)=-1 THEN 2380\r"
  "2340 IF E(A)=-1 THEN 2410\r"
  "2350 PRINT \"THE BEES WILL ARRIVE AT THE MAJOR CITY IN\"\r"
  "2360 PRINT \"         SECTION \";A;\" AT \";E(A)+T;\" HOURS.\"\r"
  "2370 GOTO 2570\r"
  "2380 PRINT \"THE BEES HAVE ALREADY DESTROYED THE CITY IN\"\r"
  "2390 PRINT \"SECTION \";A;\" AND ARE NOW INHABITING IT.\"\r"
  "2400 GOTO 2570\r"
  "2410 PRINT \"THE BEES HAVE ARRIVED AT THE CITY IN\"\r"
  "2420 IF V(A)<>-1 THEN 2460\r"
  "2430 PRINT \"SECTION \";A;\" BUT THE POPULATION HAS BEEN\"\r"
  "2440 PRINT \"        EVACUATED\"\r"
  "2450 GOTO 2570\r"
  "2460 PRINT \"SECTION \";A;\" AND THE POPULATION OF THAT CITY\"\r"
  "2470 PRINT \"CAN ONLY SURVIVE FOR ABOUT \";U(A);\" MORE HOURS.\"\r"
  "2480 PRINT \"   USE OF URBAN DEFENSES IS RECOMMENDED.\"\r"
  "2490 GOTO 2570\r"
  "2500 PRINT \"     NO SWARMS REPORTED IN SECTION \";A\r"
  "2510 GOTO 2570\r"
  "2520 PRINT \"THE BEES IN SECTION \";A;\" ARE READY TO BE \"\r"
  "2530 PRINT \"DESTROYED.\"\r"
  "2540 GOTO 2570\r"
  "2550 PRINT \"SECTION \";A;\" IS A RADIOACTIVE WASTELAND THAT\"\r"
  "2560 PRINT \"        IS COMPLETELY UNPOPULATED\"\r"
  "2570 PRINT \"*************************************\"\r"
  "2580 IF D7<>-1 THEN 2600\r"
  "2590 NEXT A\r"
  "2600 D7=0\r"
  "2610 GOTO 300\r"
  "2620 REM BATTLE PHASE OPTIONS\r"
  "2630 PRINT CHR$(26)\r"
  "2640 PRINT \"3)        BATTLE PHASE OPTIONS\"\r"
  "2650 INPUT \"ENTER SECTION #\"; A\r"
  "2660 INPUT \"ENTER PHASE\"; P\r"
  "2670 IF V(A)<1 THEN 2700\r"
  "2680 PRINT \"SECTION \";A;\" IS BEING EVACUATED\"\r"
  "2690 GOTO 300\r"
  "2700 IF G(A)>0 THEN 2720\r"
  "2710 GOTO 2740\r"
  "2720 PRINT \"THE SWARM IN SECTION \";A;\" IS ALREADY BEING COMBATTED\"\r"
  "2730 GOTO 300\r"
  "2740 IF S(A)=0 THEN 2760\r"
  "2750 GOTO 2780\r"
  "2760 PRINT \"NO SWARM IS REPORTED IN SECTION \";A\r"
  "2770 GOTO 300\r"
  "2780 IF S(A)<>1 THEN 2820\r"
  "2790 IF P=5 THEN 2860\r"
  "2800 PRINT \"THE DESTRUCTION PHASE SHOULD BE USED IN SECTION \";A\r"
  "2810 GOTO 300\r"
  "2820 IF E(A)<>-1 THEN 2860\r"
  "2830 IF P=6 THEN 2860\r"
  "2840 PRINT \"URBAN DEFENSES SHOULD BE USED IN SECTION \";A\r"
  "2850 GOTO 300\r"
  "2860 N=RND(1)\r"
  "2870 ON P GOTO 2880,2970,3060,3120,3210,3290\r"
  "2880 REM PHASE 1\r"
  "2890 PRINT \"BEE COCKTAIL: PHASE ONE, NOW BEING ATTEMPTED.\"\r"
  "2900 IF N>.95 THEN 300\r"
  "2910 G(A)=T+INT(RND(1)*3+1)\r"
  "2920 IF S(A)>5 THEN 2950\r"
  "2930 M(A)=S(A)-2\r"
  "2940 GOTO 300\r"
  "2950 M(A)=S(A)-5\r"
  "2960 GOTO 300\r"
  "2970 REM PHASE TWO\r"
  "2980 PRINT \"PROJECT QUEEN: PHASE TWO, NOW BEING ATTEMPTED.\"\r"
  "2990 IF N>.92 THEN 300\r"
  "3000 G(A) = T+INT(RND(1)*3+4)\r"
  "3010 IF S(A)>3 THEN 3040\r"
  "3020 M(A)=1\r"
  "3030 GOTO 300\r"
  "3040 M(A)=S(A)-1\r"
  "3050 GOTO 300\r"
  "3060 REM PHASE THREE\r"
  "3070 PRINT \"PROJECT BRUSH FIRE: PHASE THREE, NOW BEING ATTEMPTED.\"\r"
  "3080 IF N>.96 THEN 300\r"
  "3090 G(A)=T+1\r"
  "3100 M(A)=2\r"
  "3110 GOTO 300\r"
  "3120 REM PHASE 4\r"
  "3130 PRINT \"PROJECT STERILE MALE: PHASE FOUR, NOW BEING ATTEMPTED.\"\r"
  "3140 IF N>.89 THEN 300\r"
  "3150 G(A)=T+INT(RND(1)*3+3)\r"
  "3160 IF S(A)>6 THEN 3190\r"
  "3170 M(A)=S(A)-1\r"
  "3180 GOTO 300\r"
  "3190 M(A)=4\r"
  "3200 GOTO 300\r"
  "3210 REM PHASE 5\r"
  "3220 IF S(A)=1 THEN 3250\r"
  "3230 PRINT \"SWARM TOO LARGE: DESTRUCTION NOT POSSIBLE\"\r"
  "3240 GOTO 300\r"
  "3250 PRINT \"DESTRUCTION: PHASE FIVE, NOW BEING ATTEMPTED.\"\r"
  "3260 IF N>.7 THEN 300\r"
  "3270 G(A)=T+INT(RND(1)*3+2)\r"
  "3280 GOTO 300\r"
  "3290 REM PHASE 6\r"
  "3300 IF E(A)<>-1 THEN 2800\r"
  "3310 INPUT \"ENTER URBAN DEFENSE CODE\"; D$\r"
  "3320 C(A)=C(A)+INT(200*RND(1))\r"
  "3330 IF RND(1) >.8 THEN 300\r"
  "3340 IF D$=\"A\" THEN 3430\r"
  "3350 IF D$=\"B\" THEN 3490\r"
  "3360 IF D$=\"C\" THEN 3550\r"
  "3370 IF D$=\"D\" THEN 3610\r"
  "3380 IF D$=\"E\" THEN 3670\r"
  "3390 IF D$=\"F\" THEN 3710\r"
  "3400 IF D$=\"G\" THEN 3750\r"
  "3410 PRINT \"INVALID URBAN DEFENSE CODE !!!\" : PRINT : GOTO 3310\r"
  "3420 GOTO 300\r"
  "3430 REM *A*\r"
  "3440 IF S(A)>5 THEN 3470\r"
  "3450 S(A)=S(A)-1\r"
  "3460 GOTO 3780\r"
  "3470 S(A)=2\r"
  "3480 GOTO 3780\r"
  "3490 REM *B*\r"
  "3500 IF S(A)>4 THEN 3530\r"
  "3510 S(A)=S(A)-3\r"
  "3520 GOTO 3780\r"
  "3530 S(A)=S(A)-2\r"
  "3540 GOTO 3780\r"
  "3550 REM *C*\r"
  "3560 IF S(A)>7 THEN 3590\r"
  "3570 S(A)=S(A)-3\r"
  "3580 GOTO 3780\r"
  "3590 S(A)=1\r"
  "3600 GOTO 3780\r"
  "3610 REM *D*\r"
  "3620 IF S(A)>3 THEN 3650\r"
  "3630 S(A)=1\r"
  "3640 GOTO 3780\r"
  "3650 S(A)=S(A)-3\r"
  "3660 GOTO 3780\r"
  "3670 REM *E*\r"
  "3680 IF RND(1)>.5 THEN 3780\r"
  "3690 S(A)=2\r"
  "3700 GOTO 3780\r"
  "3710 REM *F*\r"
  "3720 IF RND(1)>.4 THEN 3780\r"
  "3730 S(A)=1\r"
  "3740 GOTO 3780\r"
  "3750 REM *G*\r"
  "3760 IF RND(1)>.8 THEN 3780\r"
  "3770 S(A)=S(A)-4\r"
  "3780 PRINT \"THE URBAN DEFENSE IN SECTION \";A;\" WAS SUCCESSFUL\"\r"
  "3790 IF S(A)>1 THEN 300\r"
  "3800 S(A)=1\r"
  "3810 D(A)=1\r"
  "3820 PRINT \"** SWARM IN SECTION \";A;\" IS READY TO BE DESTROYED\"\r"
  "3830 GOTO 300\r"
  "3840 REM EVACUATION PROCEDURE\r"
  "3850 PRINT CHR$(26);\r"
  "3860 PRINT \"4)      EVACUATION PROCEDURE\"\r"
  "3870 INPUT \"ENTER SECTION #\"; A\r"
  "3880 IF A<1 OR A>21 OR A<>INT(A) THEN PRINT \"WRONG !!! \"; : GOTO 3870\r"
  "3890 IF S(A)=0 THEN 3950\r"
  "3900 IF V(A)>0 THEN 3970\r"
  "3910 IF V(A)=-1 THEN 3990\r"
  "3920 IF K(A)>0 THEN 4010\r"
  "3930 IF U(A)=-1 THEN 4010\r"
  "3940 GOTO 4030\r"
  "3950 PRINT \"COMPUTER FAILSAFE...NO SWARMS REPORTED IN SECTION \";A\r"
  "3960 GOTO 300\r"
  "3970 PRINT \"SECTION \";A;\" IS BEING EVACUATED ALREADY\"\r"
  "3980 GOTO 300\r"
  "3990 PRINT \"CITY IN SECTION \";A;\" IS ALREADY EVACUATED\"\r"
  "4000 GOTO 300\r"
  "4010 PRINT \"POPULATION IN SECTION \";A;\" HAS BEEN DESTROYED\"\r"
  "4020 GOTO 300\r"
  "4030 PRINT \"EVACUATION PROCEDURE NOW IN PROGRESS\"\r"
  "4040 V(A)=5+T\r"
  "4050 GOTO 300\r"
  "4060 REM ***** NUCLEAR DESTRUCTION SEQUENCE *****\r"
  "4070 PRINT CHR$(26)\r"
  "4080 PRINT \"5)       NUCLEAR DESTRUCTION SEQUENCE\"\r"
  "4090 INPUT \"PLEASE ENTER YOUR NAME\"; N1$\r"
  "4100 IF N$<>N1$ THEN 4270\r"
  "4110 INPUT \"PLEASE ENTER YOUR CODE WORD\"; C1$\r"
  "4120 IF C$<>C1$ THEN 4270\r"
  "4130 PRINT \"POSITIVE IDENTIFICATION CHECK\";CHR$(7)\r"
  "4140 PRINT \"CODE WORD CHECK IS VALID\"\r"
  "4150 PRINT \"ID SEQUENCE COMPLETED\"\r"
  "4160 INPUT \"PLEASE ENTER SECTION #\"; A\r"
  "4170 IF A<1 OR A>21 OR A<>INT(A) THEN PRINT \"WRONG !!! \"; : GOTO 4160\r"
  "4180 IF E(A)<>-1 THEN 4220\r"
  "4190 IF S(A)=0 THEN 4250\r"
  "4200 PRINT\r"
  "4210 GOTO 4310\r"
  "4220 PRINT \"COMPUTER FAILSAFE: BEES NOT ARRIVED IN THE MAJOR\"\r"
  "4230 PRINT \"CITY IN SECTION \";A\r"
  "4240 GOTO 300\r"
  "4250 PRINT \"COMPUTER FAILSAFE: NO SWARM REPORTED IN SECTION \";A\r"
  "4260 GOTO 300\r"
  "4270 PRINT \"ID SEQUENCE DEFAULT....IGNORED\"\r"
  "4280 GOTO 300\r"
  "4290 PRINT \"NUCLEAR DESTRUCTION ABORTED.\"\r"
  "4300 GOTO 300\r"
  "4310 PRINT \"BOMB IN SECTION \";A;\" IS NOW ACTIVE\"\r"
  "4320 IF K(A)=1 THEN 4370\r"
  "4330 IF V(A)=-1 THEN 4370\r"
  "4340 PRINT \"SECTION \";A;\" HAS NOT BEEN EVACUATED\"\r"
  "4350 INPUT \"DO YOU WISH TO CONTINUE\"; K$\r"
  "4360 IF LEFT$(K$,1)=\"Y\" THEN 4370 ELSE 4290\r"
  "4370 INPUT \"TYPE 'X' FOR BOMB DETONATION\"; F$\r"
  "4380 IF F$<>\"X\" THEN 4290\r"
  "4390 PRINT CHR$(26)\r"
  "4400 PRINT \"!!!!!!!!!!!!!!!! BOMB DETONATED !!!!!!!!!!!!!!!!\"\r"
  "4410 PRINT \"SWARM HAS BEEN DESTROYED!!!!!!!!!\"\r"
  "4420 PRINT \"CITY HAS BEEN DESTROYED!!!!!!!!!!\"\r"
  "4430 C(A)=2413\r"
  "4440 S(A)=0\r"
  "4450 E(A)=0\r"
  "4460 U(A)=0\r"
  "4470 D(A)=0\r"
  "4480 G(A)=0\r"
  "4490 M(A)=0\r"
  "4500 IF K(A)=1 THEN 4590\r"
  "4510 IF V(A)<>-1 THEN 4580\r"
  "4520 PRINT \"THE POPULATION WILL MOVE BACK TO THE CITY\"\r"
  "4530 PRINT \"IN SECTION \";A;\" WHEN THE RADIATION LEVEL\"\r"
  "4540 PRINT \"HAS DECREASED.\"\r"
  "4550 K(A)=2\r"
  "4560 R(A)=T+7\r"
  "4570 GOTO 300\r"
  "4580 C(A)=INT(2E+06*(RND(1)*A+1))+C(A)\r"
  "4590 PRINT \"** NO SURVIVORS ARE REPORTED IN SECTION \";A\r"
  "4600 PRINT \"** THE BEES WILL NOT ENTER A SECTION WITH\"\r"
  "4610 PRINT \"** NO HUMAN INHABITANTS, SO SECTION \";A\r"
  "4620 PRINT \"** IS COMPLETELY LACKING LIFE OF ANY KIND.\"\r"
  "4630 K(A)=2\r"
  "4640 R(A)=-1\r"
  "4650 GOTO 300\r"
  "4660 REM CASUALTY REPORT\r"
  "4670 PRINT CHR$(26);\"6)      CASUALTY REPORT\"\r"
  "4680 INPUT \"ENTER SECTION #\"; A\r"
  "4690 PRINT \"************************************\"\r"
  "4700 IF A<>0 THEN 4750\r"
  "4710 D7=-1\r"
  "4720 FOR A=1 TO 21\r"
  "4730 IF C(A)=0 THEN 4770\r"
  "4740 IF C(A)>=1E+06 THEN 4790\r"
  "4750 PRINT \"SECTION \";A;\":    \";C(A);\" CASUALTIES REPORTED\"\r"
  "4760 GOTO 4800\r"
  "4770 PRINT \"SECTION \";A;\":      NO BEE RELATED CASUALTIES\"\r"
  "4780 GOTO 4800\r"
  "4790 PRINT \"SECTION \";A;\":    \";C(A)/1E+06;\" MILLION CASUALTIES\"\r"
  "4800 PRINT \"************************************\"\r"
  "4810 F=C(A)+F\r"
  "4820 IF D7<>-1 THEN 4890\r"
  "4830 NEXT A\r"
  "4840 D7=0\r"
  "4850 IF F<1E+06 THEN 4880\r"
  "4860 PRINT \"TOTAL CASUALTIES REPORTED: \";F/1E+06;\" MILLION CASUALTIES\"\r"
  "4870 GOTO 4890\r"
  "4880 PRINT \"TOTAL CASUALTIES REPORTED: \";F\r"
  "4890 IF W=0 THEN 5200\r"
  "4900 F=0\r"
  "4910 GOTO 300\r"
  "4920 REM PRINT COMMANDS IN SHORT\r"
  "4930 PRINT CHR$(26)\r"
  "4940 PRINT \"************************COMMANDS*********************\"\r"
  "4950 PRINT\r"
  "4960 PRINT \"             1) ATTACK SCAN MAP\"\r"
  "4970 PRINT \"             2) ETA REPORT\"\r"
  "4980 PRINT \"             3) BATTLE PHASE OPTIONS\"\r"
  "4990 PRINT \"                   1. BEE COCKTAIL\"\r"
  "5000 PRINT \"                   2. PROJECT QUEEN\"\r"
  "5010 PRINT \"                   3. PROJECT BRUSH FIRE\"\r"
  "5020 PRINT \"                   4. PROJECT STERILE MALE\"\r"
  "5030 PRINT \"                   5. DESTRUCTION\"\r"
  "5040 PRINT \"                   6. URBAN DEFENSES\"\r"
  "5050 PRINT \"                        A) FLIGHT PATTERNS\"\r"
  "5060 PRINT \"                        B) SONIC BOOM\"\r"
  "5070 PRINT \"                        C) SUPER-SONIC BEAMS\"\r"
  "5080 PRINT \"                        D) POLLUTION\"\r"
  "5090 PRINT \"                        E) METHYL PARATHION\"\r"
  "5100 PRINT \"                        F) FIRE WALL\"\r"
  "5110 PRINT \"                        G) STROBE LIGHT\"\r"
  "5120 PRINT \"             4) EVACUATION PROCEDURES\"\r"
  "5130 PRINT \"             5) NUCLEAR DESTRUCTION\"\r"
  "5140 PRINT \"             6) CASUALTY REPORT\"\r"
  "5150 PRINT \"             7) COMMANDS (SHORT)\"\r"
  "5160 PRINT \"             8) CANCEL GAME\"\r"
  "5170 GOTO 300\r"
  "5180 REM GAME CANCELLED\r"
  "5190 REM\r"
  "5200 REM\r"
  "5210 RESET : END\r"
  "5220 X9=LEN(N$) : X8=LEN(C$)\r"
  "5230 X7=RND(-X9) : X7=X9+X8\r"
  "5240 FOR X9=1 TO X7+1 : X8=RND(1) : NEXT\r"
  "5250 RETURN\r"
  "";

const char basic_tic_tac_toe[] =
  "1 DATA 2,3,4,9,1,5,8,7,6 \r"
  "2 DATA 2,3,4,9,1,5,8,7,6,2,9,8,3,1,7 \r"
  "3 DATA 4,5,6,2,1,6,4,1,8 \r"
  "4 DATA 0,1,-1,1,-1,1,-1,1,-1 \r"
  "5 DIM A(9) \r"
  "6 DIM B(9) \r"
  "7 DIM C(24)\r"
  "8 DIM D(24)\r"
  "9 DIM F(9) \r"
  "10 FOR I=1 TO 9 \r"
  "11 READ A(I)\r"
  "12 NEXT I \r"
  "13 FOR I=1 TO 24\r"
  "14 READ C(I)\r"
  "15 NEXT I \r"
  "16 FOR I=1 TO 9 \r"
  "17 READ F(I)\r"
  "18 NEXT I \r"
  "19 PRINT \"TIC-TAC-TOE\"\r"
  "20 PRINT\r"
  "21 PRINT \"THE MOVE POSITIONS ARE:\"\r"
  "22 PRINT\r"
  "23 PRINT \"1 2 3\"\r"
  "24 PRINT \"4 5 6\"\r"
  "25 PRINT \"7 8 9\"\r"
  "26 GOSUB 133\r"
  "27 GOSUB 133\r"
  "32 LET E=0\r"
  "33 LET G=2\r"
  "34 LET K=0\r"
  "35 FOR I=1 TO 9 \r"
  "36 LET B(I)=0 \r"
  "37 NEXT I \r"
  "38 FOR I=1 TO 24\r"
  "39 LET D(I)=0 \r"
  "40 NEXT I \r"
  "41 PRINT\r"
  "42 PRINT\r"
  "43 PRINT \"--BEGIN GAME--\" \r"
  "44 PRINT \"YOU WILL BE 'X', I WILL BE 'O'\" \r"
  "47 PRINT \"TYPE 0 IF YOU WANT ME TO GO FIRST\"; \r"
  "48 INPUT I\r"
  "49 IF I=0 THEN 65 \r"
  "50 LET L=-1 \r"
  "51 PRINT \"YOUR MOVE\"; \r"
  "52 INPUT I\r"
  "53 PRINT\r"
  "54 PRINT\r"
  "55 LET H=INT(ABS(I))\r"
  "56 IF H<>I THEN 50\r"
  "57 IF H < 1 THEN 50 \r"
  "58 IF H>9 THEN 50 \r"
  "59 LET H=A(H) \r"
  "60 IF B(H) <> 0 THEN 50 \r"
  "61 IF K=1 THEN 64 \r"
  "62 LET G=F(H) \r"
  "63 LET K=1\r"
  "64 GOSUB 111\r"
  "65 LET L=1\r"
  "66 FOR I=1 TO 22 STEP 3 \r"
  "67 IF D(I) + D(I+1) + D(I+2) = -3 THEN 92 \r"
  "68 NEXT I \r"
  "69 FOR I=1 TO 22 STEP 3 \r"
  "70 IF D(I) + D(I+1) + D(I+2) = 2 THEN 90\r"
  "71 NEXT I \r"
  "72 FOR I=1 TO 22 STEP 3 \r"
  "73 IF D(I) + D(I+1) + D(I+2) = -2 THEN 106\r"
  "74 NEXT I \r"
  "75 IF E=1 THEN 77 \r"
  "76 IF G = -1 THEN 78\r"
  "77 IF B(1)=0 THEN 100 \r"
  "78 IF G <> 0 THEN 82\r"
  "79 FOR I=2 TO 8 STEP 2\r"
  "80 IF B(I)=0 THEN 101 \r"
  "81 NEXT I \r"
  "82 IF H>=8 THEN 86 \r"
  "83 FOR I=H+1 TO 8 \r"
  "84 IF B(I)=0 THEN 101 \r"
  "85 NEXT I \r"
  "86 FOR I=2 TO 9 \r"
  "87 IF B(I)=0 THEN 101 \r"
  "88 NEXT I \r"
  "89 GO TO 98 \r"
  "90 PRINT \"I WIN\"\r"
  "91 GOTO 900 \r"
  "92 PRINT \"YOU ARE NOT ALLOWED TO WIN\" \r"
  "93 FOR I=1 TO 9 \r"
  "94 LET B(I)=1 \r"
  "95 NEXT I \r"
  "96 GOSUB 117\r"
  "97 GOTO 900 \r"
  "98 PRINT \"DRAW\" \r"
  "99 GOTO 900 \r"
  "100 LET I=1\r"
  "101 LET H=I\r"
  "102 GOSUB 111\r"
  "103 LET E=1\r"
  "104 GOSUB 117\r"
  "105 GO TO 50 \r"
  "106 FOR J=I TO I+2 \r"
  "107 IF D(J)=0 THEN 109 \r"
  "108 NEXT J \r"
  "109 LET I=C(J) \r"
  "110 GO TO 101\r"
  "111 LET B(H)=L \r"
  "112 FOR M=1 TO 24\r"
  "113 IF C(M) <> H THEN 115\r"
  "114 LET D(M)=L \r"
  "115 NEXT M \r"
  "116 RETURN \r"
  "117 FOR N=1 TO 9 \r"
  "118 IF B(N)=0 THEN 200 \r"
  "119 NEXT N \r"
  "120 IF N<100 THEN 98 \r"
  "121 FOR N=1 TO 9 STEP 3\r"
  "122 FOR O= 0 TO 2\r"
  "123 IF B(A(O+N))=0 THEN 127\r"
  "124 IF B(A(O+N))=1 THEN 129\r"
  "125 PRINT \"X \";\r"
  "126 GO TO 130\r"
  "127 PRINT \"- \";\r"
  "128 GO TO 130\r"
  "129 PRINT \"O \";\r"
  "130 NEXT O \r"
  "131 PRINT\r"
  "132 NEXT N \r"
  "133 PRINT\r"
  "136 RETURN \r"
  "137 STOP \r"
  "200 LET N=1000 \r"
  "210 GOTO 119 \r"
  "900 GOTO 910\r"
  "910 PRINT \"TRY AGAIN (IF SO TYPE 0)\";\r"
  "920 INPUT I\r"
  "930 IF I<>0 THEN 999 \r"
  "940 GOTO 27\r"
  "999 END\r"
  "";

const char basic_towers[] =
  "10 PRINT TAB(33);\"TOWERS\"\r"
  "20 PRINT TAB(15);\"CREATIVE COMPUTING  MORRISTOWN, NEW JERSEY\"\r"
  "30 PRINT:PRINT:PRINT\r"
  "90 PRINT\r"
  "100 REM*** INITIALIZE\r"
  "110 DIM T(7,3)\r"
  "120 E=0\r"
  "130 FOR D=1 TO 7\r"
  "140 FOR N=1 TO 3\r"
  "150 T(D,N)=0\r"
  "160 NEXT N\r"
  "170 NEXT D\r"
  "180 PRINT \"TOWERS OF HANOI PUZZLE.\": PRINT\r"
  "200 PRINT \"YOU MUST TRANSFER THE DISKS FROM THE LEFT TO THE RIGHT\"\r"
  "205 PRINT \"TOWER, ONE AT A TIME, NEVER PUTTING A LARGER DISK ON A\"\r"
  "210 PRINT \"SMALLER DISK.\": PRINT\r"
  "215 INPUT \"HOW MANY DISKS DO YOU WANT TO MOVE (7 IS MAX)\";S\r"
  "220 PRINT\r"
  "230 M=0\r"
  "240 FOR Q=1 TO 7\r"
  "250 IF Q=S THEN 350\r"
  "260 NEXT Q\r"
  "270 E=E+1\r"
  "280 IF E>2 THEN 310\r"
  "290 PRINT \"SORRY, BUT I CAN'T DO THAT JOB FOR YOU.\": GOTO 215\r"
  "310 PRINT \"ALL RIGHT, WISE GUY, IF YOU CAN'T PLAY THE GAME RIGHT, I'LL\"\r"
  "320 PRINT \"JUST TAKE MY PUZZLE AND GO HOME.  SO LONG.\": STOP\r"
  "340 REM *** STORE DISKS FROM SMALLEST TO LARGEST\r"
  "350 PRINT \"IN THIS PROGRAM, WE SHALL REFER TO DISKS BY NUMERICAL CODE.\"\r"
  "355 PRINT \"3 WILL REPRESENT THE SMALLEST DISK, 5 THE NEXT SIZE,\"\r"
  "360 PRINT \"7 THE NEXT, AND SO ON, UP TO 15.  IF YOU DO THE PUZZLE WITH\"\r"
  "365 PRINT \"2 DISKS, THEIR CODE NAMES WOULD BE 13 AND 15.  WITH 3 DISKS\"\r"
  "370 PRINT \"THE CODE NAMES WOULD BE 11, 13 AND 15, ETC.  THE NEEDLES\"\r"
  "375 PRINT \"ARE NUMBERED FROM LEFT TO RIGHT, 1 TO 3.  WE WILL\"\r"
  "380 PRINT \"START WITH THE DISKS ON NEEDLE 1, AND ATTEMPT TO MOVE THEM\"\r"
  "385 PRINT \"TO NEEDLE 3.\"\r"
  "390 PRINT: PRINT \"GOOD LUCK!\": PRINT\r"
  "400 Y=7: D=15\r"
  "420 FOR X=S TO 1 STEP -1\r"
  "430 T(Y,1)=D: D=D-2: Y=Y-1\r"
  "460 NEXT X\r"
  "470 GOSUB 1230\r"
  "480 PRINT:PRINT:PRINT \"WHICH DISK WOULD YOU LIKE TO MOVE\";:E=0\r"
  "500 INPUT D\r"
  "510 IF (D-3)*(D-5)*(D-7)*(D-9)*(D-11)*(D-13)*(D-15)=0 THEN 580\r"
  "520 PRINT \"ILLEGAL ENTRY... YOU MAY ONLY TYPE 3,5,7,9,11,13, OR 15.\"\r"
  "530 E=E+1: IF E>1 THEN 560\r"
  "550 GOTO 500\r"
  "560 PRINT \"STOP WASTING MY TIME.  GO BOTHER SOMEONE ELSE.\": STOP\r"
  "580 REM *** CHECK IF REQUESTED DISK IS BELOW ANOTHER\r"
  "590 FOR R=1 TO 7\r"
  "600 FOR C=1 TO 3\r"
  "610 IF T(R,C)=D THEN 640\r"
  "620 NEXT C: NEXT R\r"
  "640 FOR Q=R TO 1 STEP -1\r"
  "645 IF T(Q,C)=0 THEN 660\r"
  "650 IF T(Q,C)<D THEN 680\r"
  "660 NEXT Q\r"
  "670 GOTO 700\r"
  "680 PRINT \"THAT DISK IS BELOW ANOTHER ONE.  MAKE ANOTHER CHOICE.\"\r"
  "690 GOTO 480\r"
  "700 E=0\r"
  "705 INPUT \"PLACE DISK ON WHICH NEEDLE\";N\r"
  "730 IF (N-1)*(N-2)*(N-3)=0 THEN 800\r"
  "735 E=E+1\r"
  "740 IF E>1 THEN 780\r"
  "750 PRINT \"I'LL ASSUME YOU HIT THE WRONG KEY THIS TIME.  BUT WATCH IT,\"\r"
  "760 PRINT \"I ONLY ALLOW ONE MISTAKE.\": GOTO 705\r"
  "780 PRINT \"I TRIED TO WARN YOU, BUT YOU WOULDN'T LISTEN.\"\r"
  "790 PRINT \"BYE BYE, BIG SHOT.\":STOP\r"
  "800 FOR R=1 TO 7\r"
  "810 IF T(R,N)<>0 THEN 840\r"
  "820 NEXT R\r"
  "830 GOTO 880\r"
  "835 REM *** CHECK IF DISK TO BE PLACED ON A LARGER ONE\r"
  "840 IF D<T(R,N) THEN 880\r"
  "850 PRINT \"YOU CAN'T PLACE A LARGER DISK ON TOP OF A SMALLER ONE,\"\r"
  "860 PRINT \"IT MIGHT CRUSH IT!\": PRINT \"NOW THEN, \";:GOTO 480\r"
  "875 REM *** MOVE RELOCATED DISK\r"
  "880 FOR V=1 TO 7: FOR W=1 TO 3\r"
  "900 IF T(V,W)=D THEN 930\r"
  "910 NEXT W: NEXT V\r"
  "925 REM *** LOCATE EMPTY SPACE ON NEEDLE N\r"
  "930 FOR U=1 TO 7\r"
  "940 IF T(U,N)<>0 THEN 970\r"
  "950 NEXT U\r"
  "960 U=7: GOTO 980\r"
  "965 REM *** MOVE DISK AND SET OLD LOCATION TO 0\r"
  "970 U=U-1\r"
  "980 T(U,N)=T(V,W): T(V,W)=0\r"
  "995 REM *** PRINT OUT CURRENT STATUS\r"
  "1000 GOSUB 1230\r"
  "1018 REM *** CHECK IF DONE\r"
  "1020 M=M+1\r"
  "1030 FOR R=1 TO 7: FOR C=1 TO 2\r"
  "1050 IF T(R,C)<>0 THEN 1090\r"
  "1060 NEXT C: NEXT R\r"
  "1080 GOTO 1120\r"
  "1090 IF M<=128 THEN 480\r"
  "1100 PRINT \"SORRY, BUT I HAVE ORDERS TO STOP IF YOU MAKE MORE THAN\"\r"
  "1110 PRINT \"128 MOVES.\":RUN \"MENU\"\r"
  "1120 IF M<>2^S-1 THEN 1140\r"
  "1130 PRINT:PRINT \"CONGRATULATIONS!!\":PRINT\r"
  "1140 PRINT \"YOU HAVE PERFORMED THE TASK IN\";M;\"MOVES.\"\r"
  "1150 PRINT: PRINT \"TRY AGAIN (YES OR NO)\";: INPUT A$\r"
  "1160 IF A$=\"NO\" THEN 1390\r"
  "1170 IF A$=\"YES\" THEN 90\r"
  "1180 PRINT: PRINT \"'YES' OR 'NO' PLEASE\";: INPUT A$: GOTO 1160\r"
  "1230 REM *** PRINT SUBROUTINE\r"
  "1240 FOR K=1 TO 7\r"
  "1250 Z=10\r"
  "1260 FOR J=1 TO 3\r"
  "1270 IF T(K,J)=0 THEN 1330\r"
  "1280 PRINT TAB(Z-INT(T(K,J)/2));\r"
  "1290 FOR V=1 TO T(K,J)\r"
  "1300 PRINT \"*\";\r"
  "1310 NEXT V\r"
  "1320 GOTO 1340\r"
  "1330 PRINT TAB(Z);\"*\";\r"
  "1340 Z=Z+21\r"
  "1350 NEXT J\r"
  "1360 PRINT\r"
  "1370 NEXT K\r"
  "1380 RETURN\r"
  "1390 PRINT: PRINT \"THANKS FOR THE GAME!\": PRINT: END\r"
  "";

const char basic_weather[] =
  "100 DIM S$(10)\r"
  "110 PRINT\"THIS PROGRAM WILL ATTEMPT TO PREDICT TOMORROWS WEATHER IF\"   \r"
  "120 PRINT\"GIVEN THE WEATHER STATISTICS FROM THE PAST TWO DAYS.\"\r"
  "130 PRINT TAB(5);\"SEASON\"\r"
  "140 INPUT S$(1)\r"
  "150 GOSUB 1500 \r"
  "160 GOTO 130 \r"
  "170 PRINT\"AFTER THE FOLLOWING QUESTION MARKS YOU WILL BE REQUIRED\"   \r"
  "180 PRINT\"TO INPUT TWO VALUES, ONE FOR YESTERDAY'S READING AND ONE\"  \r"
  "190 PRINT\"FOR TODAY'S READING.  SEPERATE THESE READINGS BY A COMMA.\" \r"
  "200 PRINT TAB(5);\"TEMPERATURE\"   \r"
  "210 INPUT T1,T2\r"
  "220 GOSUB 1570 \r"
  "230 GOTO 200   \r"
  "240 PRINT TAB(5);\"BAROMETER\"\r"
  "250 INPUT B1,B2\r"
  "260 GOSUB 1640 \r"
  "270 GOTO 240  \r"
  "280 PRINT TAB(5);\"BAROMETER TENDENCY(1=RISING,2=FALLING,3=STEADY):\" \r"
  "290 INPUT T3,T4\r"
  "300 GOSUB 1710 \r"
  "310 GOTO 280  \r"
  "320 PRINT TAB(5);\"RELATIVE HUMIDITY\"\r"
  "330 INPUT H1,H2\r"
  "340 GOSUB 1780 \r"
  "350 GOTO 320  \r"
  "360 PRINT TAB(5);\"CLOUDS(1=STRATUS,2=CUMULUS,3=CIRRUS)\" \r"
  "370 INPUT C1,C2\r"
  "380 GOSUB 1850 \r"
  "390 GOTO 360  \r"
  "400 PRINT TAB(5);\"CLOUD COVER(PERCENTAGE)\"  \r"
  "410 INPUT C4,C5\r"
  "420 GOSUB 1920 \r"
  "430 GOTO 400  \r"
  "440 PRINT TAB(5);\"WIND DIRECTION (1=NORTH,2=SOUTH,3=EAST,4=WEST)\"   \r"
  "450 INPUTD1,D2 \r"
  "460 GOSUB 1990 \r"
  "470 GOTO 440  \r"
  "480 PRINT TAB(5);\"WIND SPEED\"   \r"
  "490 INPUT S2,S3\r"
  "500 GOSUB 2060 \r"
  "510 GOTO 480  \r"
  "520 PRINT   \r"
  "530 PRINT   \r"
  "540 PRINT   \r"
  "550 PRINT\"------------------------------------------------------\"  \r"
  "560 PRINT\"PRESENT SEASON IS \";S$(1)\r"
  "570 PRINT   \r"
  "580 PRINT \"FORECAST FOR TOMORROW:\"  \r"
  "590 PRINT   \r"
  "600 PRINT   \r"
  "610 PRINT\"TEMPERATURES:\"\r"
  "620 LET T7=((T1+T2)/2)-30  \r"
  "630 LET T6=T7+10   \r"
  "640 PRINT \"LOWS TONIGHT BETWEEN\";T7;\"AND\";T6;\"DEGREES\"  \r"
  "650 LET T9=((T1+T2)/2)+5   \r"
  "660 LET T8=T9-5\r"
  "670 PRINT \"HIGHS TOMORROW NIGHT BETWEEN\";T8;\"AND\";T9;\"DEGREES\"  \r"
  "680 LET T0=T7-5\r"
  "690 PRINT \"LOWS TOMORROW NIGHT BETWEEN \";T0;\"AND\";T7;\"DEGREES\"  \r"
  "700 LET B4=(B1+B2)/2   \r"
  "710 B0=INT(ABS(B1-B2))  \r"
  "720 LET T9=(T3+T4)/2   \r"
  "730 LET T9=INT(T9) \r"
  "740 IF T9=2 THEN 780   \r"
  "750 IF T9=3 THEN 800   \r"
  "760 PRINT\"BAROMETER\";B4;\" AND RISING.\" \r"
  "770 GOTO 810  \r"
  "780 PRINT\"BAROMETER\";B4;\" AND FALLING.\"\r"
  "790 GOTO 810  \r"
  "800 PRINT\"BAROMETER\";B4;\" AND STEADY.\" \r"
  "810 LET H3=((H1+H2)/2)+5   \r"
  "820 LET H4=H3-5\r"
  "830 PRINT \"HUMIDITY BETWEEN \";H4;\"AND \";H3;\"PERCENT\"\r"
  "840 LET C3=(C1+C2)/2   \r"
  "850 LET C3=INT(C3) \r"
  "860 LET C9=((C4+C5)/2)+5   \r"
  "870 LET C8=C9-5\r"
  "880 PRINT\"CLOUD COVER BETWEEN\";C8;\"AND\";C9;\"PERCENT\"\r"
  "890 IF C3=2 THEN 940   \r"
  "900 IF C3=3 THEN 970   \r"
  "910 PRINT\"CLOUD HEIGHT BETWEEN  500 TO  580 FEET.\" \r"
  "920 PRINT\"MAJOR CLOUD TYPE WILL BE STRATUS.\"   \r"
  "930 GOTO 990  \r"
  "940 PRINT\"CLOUD HEIGHT BETWEEN  1550 TO  1800 FEET.\"   \r"
  "950 PRINT\"MAJOR CLOUD TYPE WILL BE CUMULUS.\"   \r"
  "960 GOTO 990  \r"
  "970 PRINT\"CLOUD HEIGHT BETWEEN  16500 TO 17000 FEET.\"  \r"
  "980 PRINT\"MAJOR CLOUD TYPE WILL BE CIRRUS.\"\r"
  "990 LET D5=(D1+D2)/2   \r"
  "1000 LET D5=INT(D5) \r"
  "1010 LET S5=((S2+S3)/2)+5   \r"
  "1020 LET S6=S5-5\r"
  "1030 IF D5=2 THEN 1080   \r"
  "1040 IF D5=3 THEN 1100   \r"
  "1050 IF D5=4 THEN 1120   \r"
  "1060 PRINT\"WIND FROM THE NORTH FROM\";S6;\"TO\";S5;\"MPH\"\r"
  "1070 GOTO 1130  \r"
  "1080 PRINT\"WIND FROM THE SOUTH FROM\";S6;\"TO\";S5;\"MPH\"\r"
  "1090 GOTO 1130  \r"
  "1100 PRINT \"WIND FORM THE EAST FROM\";S6;\"TO\";S5;\"MPH\"\r"
  "1110 GOTO 1130  \r"
  "1120 PRINT\"WIND FROM THE WEST FROM\";S6;\"TO\";S5;\"MPH\" \r"
  "1130 PRINT\"CHANCE OF PRECIPITATION:\"\r"
  "1140 LET P1=INT((((C5/2)+B2)+C2)/.5)\r"
  "1150 IF P1>100 THEN 2170\r"
  "1160 PRINT \"TONIGHT\";P1;\"%\"  \r"
  "1170 LET P2=INT(((C9/2)+B4)+C3) \r"
  "1180 IF P2>100 THEN 2190\r"
  "1190 PRINT\"TOMORROW\";P2;\"%\" \r"
  "1200 IF P3>100 THEN 2210\r"
  "1210 PRINT\"TOMORROW NIGHT\";P3;\"%\"   \r"
  "1220 PRINT  \r"
  "1230 IF C2=2 THEN 1340  \r"
  "1240 IF C2=3 THEN 1420  \r"
  "1250 PRINT\"FORECAST FOR TOMORROWS WEATHER:\" \r"
  "1260 PRINT  \r"
  "1270 PRINT\"IT SHOULD BE FAIR TOMORROW.\" \r"
  "1280 IF S$(1)=\"SPRING\"THEN 1320 \r"
  "1290 IF S$(1)=\"SUMMER\"THEN 1320 \r"
  "1300 PRINT\"IT SHOULD BE COOLER TOMORROW WITH NO PRECIPITATION LIKELY.\"  \r"
  "1310 GOTO 1490 \r"
  "1320 PRINT\"IT SHOULD BE WARMER TOMORROW WITH NO PRECIPITATION LIKELY.\"  \r"
  "1330 GOTO 1490 \r"
  "1340 PRINT\"FORECAST FOR TOMORROWS WEATHER.\" \r"
  "1350 PRINT  \r"
  "1360 IF S$(1)=\"SUMMER\"THEN 1390 \r"
  "1370 PRINT\"IT SHOULD BE FAIR TOMORROW.\" \r"
  "1380 GOTO 1280 \r"
  "1390 PRINT\"IF THEY ARE HEAVY CLOUDS--BE READY FOR RAIN.\"\r"
  "1400 PRINT\"IF THE CLOUDS ARE LIGHT--IT WILL BE FAIR.\"   \r"
  "1410 GOTO 1490 \r"
  "1420 IF S$(1)=\"FALL\" THEN 1490  \r"
  "1430 PRINT  \r"
  "1440 IF S$(1)=\"SPRING\"THEN 1480 \r"
  "1450 IF S$(1)=\"SUMMER\"THEN 1480 \r"
  "1460 PRINT\"TOMORROW,EXPECT SNOW TO FALL FOLLOWED BY HIGHER TEMPERATURES.\"   \r"
  "1470 GOTO 1490 \r"
  "1480 PRINT\"TOMORROW,EXPECT RAIN TO FALL FOLLOWED BY HIGHER TEMPERATURES.\"   \r"
  "1490 GOTO 2130 \r"
  "1500 IF S$(1)=\"WINTER\"THEN 170   \r"
  "1510 IF S$(1)=\"FALL\"THEN 170 \r"
  "1520 IF S$(1)=\"SPRING\"THEN 170   \r"
  "1530 IF S$(1)=\"SUMMER\" THEN 170  \r"
  "1540 PRINT TAB(5);\"LETS TRY THAT ONE AGAIN(SEASONS:WINTER,SPRING\";  \r"
  "1550 PRINT\"FALL,SUMMER)...\" \r"
  "1560 RETURN \r"
  "1570 IF T1>135 THEN 1620\r"
  "1580 IF T1<-80 THEN 1620\r"
  "1590 IF T2>135 THEN 1620\r"
  "1600 IF T2<-80 THEN 1620\r"
  "1610 GOTO 240  \r"
  "1620 PRINT TAB(5);\"LETS TRY THAT ONE AGAIN(NORMALS-80-135)...\"  \r"
  "1630 RETURN \r"
  "1640 IF B1>31.5 THEN 1690   \r"
  "1650 IF B1<28.5 THEN 1690   \r"
  "1660 IF B2>31.5 THEN 1690   \r"
  "1670 IF B2<28.5 THEN 1690   \r"
  "1680 GOTO 280  \r"
  "1690 PRINT TAB(5);\"LETS TRY THAT ONE AGAIN(NORMALS:28.5-31.5)...\"   \r"
  "1700 RETURN \r"
  "1710 IF T3<1 THEN 1760  \r"
  "1720 IF T3>3 THEN 1760  \r"
  "1730 IF T4<1 THEN 1760  \r"
  "1740 IF T4>3 THEN 1760  \r"
  "1750 GOTO 320  \r"
  "1760 PRINT TAB(5);\"LETS TRY THAT ONE AGAIN...\"  \r"
  "1770 RETURN \r"
  "1780 IF H1<0 THEN 1830  \r"
  "1790 IF H1>100 THEN 1830\r"
  "1800 IF H2<0 THEN 1830  \r"
  "1810 IF H2>100 THEN 1830\r"
  "1820 GOTO 360  \r"
  "1830 PRINT TAB(5);\"LETS TRY THAT ONE AGAIN(HUMIDITY:0-100)...\"  \r"
  "1840 RETURN \r"
  "1850 IF C1<1 THEN 1900  \r"
  "1860 IF C1>3 THEN 1900  \r"
  "1870 IF C2<1 THEN 1900  \r"
  "1880 IF C2>3 THEN 1900  \r"
  "1890 GOTO 400  \r"
  "1900 PRINT TAB(5);\"LETS TRY THAT ONE AGAIN...\"  \r"
  "1910 RETURN \r"
  "1920 IF C4<0 THEN 1970  \r"
  "1930 IF C4>100 THEN 1970\r"
  "1940 IF C5<0 THEN 1970  \r"
  "1950 IF C5>100 THEN 1970\r"
  "1960 GOTO 440  \r"
  "1970 PRINT TAB(5);\"LETS TRY THAT ONE AGAIN(COVER:0-100)...\" \r"
  "1980 RETURN \r"
  "1990 IF D1<1 THEN 2040  \r"
  "2000 IF D1>4 THEN 2040  \r"
  "2010 IF D2<1 THEN 2040  \r"
  "2020 IF D2>4 THEN 2040  \r"
  "2030 GOTO 480  \r"
  "2040 PRINT TAB(5);\"LETS TRY THAT ONE AGAIN...\"  \r"
  "2050 RETURN \r"
  "2060 IF S2<0 THEN 2110  \r"
  "2070 IF S2>75 THEN 2110 \r"
  "2080 IF S3<0 THEN 2110  \r"
  "2090 IF S3>75 THEN 2110 \r"
  "2100 GOTO 520  \r"
  "2110 PRINT TAB(5);\"LETS TRY THAT ON E AGAIN(NORMAL:0-75)...\"\r"
  "2120 RETURN \r"
  "2130 GOSUB 2230\r"
  "2140 PRINT\"THE END\" \r"
  "2150 PRINT\"---------------------------------------------------\" \r"
  "2160 STOP   \r"
  "2170 LET P1=100 \r"
  "2180 GOTO 1160  \r"
  "2190 LET P2=100 \r"
  "2200 GOTO 1190 \r"
  "2210 LET P3=100 \r"
  "2220 GOTO 1210 \r"
  "2230 IF D2=2 THEN 2390\r"
  "2240 IF D2=3 THEN 2480\r"
  "2250 IF D2=1 THEN 2580\r"
  "2260 IF B2=>30.2 THEN 2340\r"
  "2270 IF B2=>30.1 THEN 2300\r"
  "2280 PRINT\"IT WILL BE CLEARING AND COLDER TOMORROW.\"   \r"
  "2290 GOTO 2620   \r"
  "2300 IF T2=3 THEN 2330\r"
  "2310 PRINT\"IT WILL BE FAIR TOMORROW, FOLLOWED BY WINDS AND PRECIPITATION.\" \r"
  "2320 GOTO 2620   \r"
  "2330 PRINT\"IT WILL BE FAIR TOMORROW, WITH LITTLE TEMPERATURE CHANGE.\"  \r"
  "2340 IF T2=3 THEN 2370\r"
  "2350 PRINT\"IT WILL BE FAIR TOMORROW WITH SLOWLY RISING TEMPERATURES.\"  \r"
  "2360 GOTO 2620   \r"
  "2370 PRINT \"IT WILL BE CONTINUED FAIR TOMORROW.\"   \r"
  "2380 GOTO 2620   \r"
  "2390 IF B2<=29.8 THEN 2450\r"
  "2400 IF B2<=30! THEN 2430\r"
  "2410 PRINT\"IT WILL BE WINDY WITH RAIN IN 12-24 HOURS.\" \r"
  "2420 GOTO 2620   \r"
  "2430 PRINT\"IT WILL BE CLEARING AND FAIR FOR SEVERAL DAYS FOLLOWING.\"   \r"
  "2440 GOTO 2620   \r"
  "2450 PRINT\"THERE WILL BE A SEVERE STORM IN 24 HOURS FOLLOWED BY \"; \r"
  "2460 PRINT\"CLEARING.\"  \r"
  "2470 GOTO 2620   \r"
  "2480 IF B2<=29.8 THEN 2530\r"
  "2490 IF B2=> 30.1 THEN 2550   \r"
  "2500 PRINT\"IN WINTER, EXPECT SNOW WITH WINDS.\" \r"
  "2510 PRINT\"IN SUMMER, EXPECT A LONG DRY SPELL.\"\r"
  "2520 GOTO 2620   \r"
  "2530 PRINT\"THERE WILL BE A NORTHEAST WIND WITH HEAVY PRECIPITATION.\"   \r"
  "2540 GOTO 2620   \r"
  "2550 PRINT\"IN WINTER, EXPECT SNOW IN 24 HOURS.\"\r"
  "2560 PRINT\"IN SUMMER, EXPECT A DRY SPELL.\" \r"
  "2570 GOTO 2620   \r"
  "2580 IF B2<=30! THEN 2610\r"
  "2590 PRINT\"RAIN WILL CONTINUE WITH WINDS FOR 36 HOURS, THEN CLEARING.\" \r"
  "2600 GOTO 2620   \r"
  "2610 PRINT \"RAIN WILL FALL IN 12 TO 18 HOURS.\" \r"
  "2620 RETURN\r"
  "";

const char basic_word_puzzle[] =
  "100 CLEAR 1200\r"
  "110 B$=\".\"\r"
  "120 INPUT\"INPUT X AND Y DIMENSIONS \";X,Y\r"
  "130 IF X>30 OR Y>30 THEN 120\r"
  "140 IF X>Y THEN U0=X:GOTO 180\r"
  "150 U0=Y\r"
  "160 INPUT\"NUMBER OF WORDS \";N\r"
  "170 C1=100*INT(N/10):IF C1<100 THEN C1=100\r"
  "180 DIM W$(50),A$(X,Y),N$(N),L(N,4)\r"
  "190 W$(1)=\"DUMMEY ARGUMENT\"\r"
  "200 GOTO2150\r"
  "210 GOSUB 1960\r"
  "220 GOTO2020\r"
  "230 INPUT\"PUNCH LIST ON TAPE\";T$:IF LEFT$(T$,1)=\"Y\" THEN GOTO 2220\r"
  "240 Q8=1\r"
  "250 GOSUB 1940\r"
  "260 PRINT:PRINT Q8\r"
  "270 FOR I1=1 TO N\r"
  "280 GOTO 360\r"
  "290 PRINT:PRINT\"FIRST CHAR. CHANGED ON PASS\";C0;\" OF THE\";I1;\"TH WORD\"\r"
  "300 A$(L(1,1),L(1,2))=LEFT$(N$(1),1)\r"
  "310 GOTO430\r"
  "320 REM\r"
  "330 L(I1,1)=A:L(I1,2)=B:L(I1,3)=D\r"
  "340 L(I1,4)=C0\r"
  "350 GOTO 1580\r"
  "360 C0=0\r"
  "370 S$=N$(I1)\r"
  "380 Z=LEN(S$)-1\r"
  "390 GOSUB 1540\r"
  "400 C0=C0+1\r"
  "410 IF I1=1 THEN GOTO 430\r"
  "420 IF A$(L(1,1),L(1,2))<>LEFT$(N$(1),1) THEN GOTO 290\r"
  "430 IF C0/C1<>INT(C0/C1) THEN 450\r"
  "440 PRINT S$;\" TRY#\";C0\r"
  "450 IF C0<C1*10 THEN490\r"
  "460 Q8=Q8+1:IF Q8=100 THEN STOP\r"
  "470 GOTO 250\r"
  "480 PRINT Q8: GOTO250\r"
  "490 ON D GOTO 500,630,760,890,1020,1150,1280,1410\r"
  "500 IF B+Z>Y THEN 390\r"
  "510 FOR I=1 TO LEN(S$)\r"
  "520 A1=A:B1=B+I-1\r"
  "530 GOSUB 1910\r"
  "540 GOSUB 1930\r"
  "550 IF L$=B$ OR L$=N1$ THEN 570\r"
  "560 GOTO 390\r"
  "570 NEXT I\r"
  "580 FOR I=1 TO LEN(S$)\r"
  "590 GOSUB 1910\r"
  "600 A$(A,B+I-1)=N1$\r"
  "610 NEXT I\r"
  "620 GOTO 320\r"
  "630 IF B+Z>Y OR A-Z<1 THEN390\r"
  "640 FOR I=1 TO LEN(S$)\r"
  "650 A1=A-(I-1):B1=B+I-1\r"
  "660 GOSUB 1910\r"
  "670 GOSUB 1930\r"
  "680 IF L$=B$ OR L$=N1$ THEN 700\r"
  "690 GOTO 390\r"
  "700 NEXT I\r"
  "710 FOR I=1 TO LEN(S$)\r"
  "720 GOSUB 1910\r"
  "730 A$(A-(I-1),B+I-1)=N1$\r"
  "740 NEXT I\r"
  "750 GOTO 320\r"
  "760 IF A-Z<1 THEN 390\r"
  "770 FOR I=1 TO LEN(S$)\r"
  "780 A1=A-(I-1):B1=B\r"
  "790 GOSUB 1910\r"
  "800 GOSUB 1930\r"
  "810 IF L$=B$ OR L$=N1$ THEN 830\r"
  "820 GOTO 390\r"
  "830 NEXT I\r"
  "840 FOR I=1 TO LEN(S$)\r"
  "850 GOSUB 1910\r"
  "860 A$(A-(I-1),B)=N1$\r"
  "870 NEXT I\r"
  "880 GOTO320\r"
  "890 IF A-Z<1 OR B-Z<1 THEN390\r"
  "900 FOR I=1 TO LEN(S$)\r"
  "910 A1=A-(I-1):B1=B-(I-1)\r"
  "920 GOSUB 1910\r"
  "930 GOSUB 1930\r"
  "940 IF L$=B$ OR L$=N1$ THEN960\r"
  "950 GOTO 390\r"
  "960 NEXT I\r"
  "970 FOR I=1 TO LEN(S$)\r"
  "980 GOSUB 1910\r"
  "990 A$(A-(I-1),B-(I-1))=N1$\r"
  "1000 NEXT I\r"
  "1010 GOTO 320\r"
  "1020 IF B-Z<1 THEN 390\r"
  "1030 FOR I=1 TO LEN(S$)\r"
  "1040 A1=A:B1=B-(I-1)\r"
  "1050 GOSUB 1910\r"
  "1060 GOSUB 1930\r"
  "1070 IF L$=B$ OR L$=N1$ THEN 1090\r"
  "1080 GOTO 390\r"
  "1090 NEXT I\r"
  "1100 FOR I=1 TO LEN(S$)\r"
  "1110 GOSUB 1910\r"
  "1120 A$(A,B-(I-1))=N1$\r"
  "1130 NEXT I\r"
  "1140 GOTO 320\r"
  "1150 IF A+Z>X OR B-Z<1 THEN390\r"
  "1160 FOR I=1 TO LEN(S$)\r"
  "1170 A1=A+I-1:B1=B-(I-1)\r"
  "1180 GOSUB 1910\r"
  "1190 GOSUB 1930\r"
  "1200 IF L$=N1$ OR L$=B$ THEN1220\r"
  "1210 GOTO390\r"
  "1220 NEXT I\r"
  "1230 FOR I=1 TO LEN(S$)\r"
  "1240 GOSUB 1910\r"
  "1250 A$(A+I-1,B-(I-1))=N1$\r"
  "1260 NEXT I\r"
  "1270 GOTO320\r"
  "1280 IF A+Z>X THEN 390\r"
  "1290 FOR I=1 TO LEN(S$)\r"
  "1300 A1=A+I-1:B1=B\r"
  "1310 GOSUB 1910\r"
  "1320 GOSUB 1930\r"
  "1330 IF L$=N1$ OR L$=B$ THEN1350\r"
  "1340 GOTO 390\r"
  "1350 NEXT I\r"
  "1360 FOR I=1 TO LEN(S$)\r"
  "1370 GOSUB 1910\r"
  "1380 A$(A+I-1,B)=N1$\r"
  "1390 NEXT I\r"
  "1400 GOTO 320\r"
  "1410 IF A+Z>X OR B+Z>Y THEN390\r"
  "1420 FOR I=1 TO LEN(S$)\r"
  "1430 A1=A+I-1:B1=B+I-1\r"
  "1440 GOSUB 1910\r"
  "1450 GOSUB 1930\r"
  "1460 IF L$=B$ OR L$=N1$ THEN 1480\r"
  "1470 GOTO 390\r"
  "1480 NEXT I\r"
  "1490 FOR I=1 TO LEN(S$)\r"
  "1500 GOSUB 1910\r"
  "1510 A$(A+I-1,B+I-1)=N1$\r"
  "1520 NEXT I\r"
  "1530 GOTO320\r"
  "1540 A=INT(X*RND(8)+1)\r"
  "1550 B=INT(Y*RND(8)+1)\r"
  "1560 D=INT(8*RND(5)+1)\r"
  "1570 RETURN\r"
  "1580 NEXT I1\r"
  "1590 GOTO 1610\r"
  "1600 FOR I=1TOX:FORJ=1TOY:PRINTA$(I,J);\" \";:NEXTJ:PRINT:NEXTI\r"
  "1610 FOR I=1 TO 5:PRINT:NEXT I\r"
  "1620 PRINT\"THE\";N;\"HIDDEN WORDS ARE\":PRINT\r"
  "1630 Z=2:FORI=1TON:PRINTTAB(Z);N$(I);:Z=Z+18:IFZ>60 THENZ=2:PRINT\r"
  "1640 NEXT I:PRINT:PRINT:PRINT\r"
  "1650 FOR I=1 TO X\r"
  "1660 FOR J=1 TO Y\r"
  "1670 IF A$(I,J)=B$ THEN 1770\r"
  "1680 PRINT A$(I,J);\"  \";\r"
  "1690 NEXT J\r"
  "1700 PRINT\r"
  "1710 NEXT I\r"
  "1720 PRINT\r"
  "1730 GOSUB 1800\r"
  "1740 PRINT\r"
  "1750 GOTO 240\r"
  "1760 END\r"
  "1770 A$(I,J)=CHR$(INT(26*RND(1)+65))\r"
  "1780 GOTO 1680\r"
  "1790 PRINT\r"
  "1800 REM\r"
  "1810 AN=1\r"
  "1820 PRINT \"THE HIDDEN WORDS ARE LOCATED AT\"\r"
  "1830 FOR K=1 TO N\r"
  "1840 PRINT N$(K);\r"
  "1850 IF AN=0 THEN PRINT: GOTO 1880\r"
  "1860 PRINT TAB(30);L(K,1);\",\";L(K,2);\",\";L(K,3);\r"
  "1870 PRINT \",\";L(K,4)\r"
  "1880 NEXT K\r"
  "1890 RETURN\r"
  "1900 END\r"
  "1910 N1$=MID$(S$,I,1)\r"
  "1920 RETURN\r"
  "1930 L$=A$(A1,B1):RETURN\r"
  "1940 FORI=1TOX:FORJ=1TOY:A$(I,J)=B$:NEXT J,I\r"
  "1950 RETURN\r"
  "1960 FOR I=1 TO N\r"
  "1970 PRINT\"WORD #\";I;\r"
  "1980 INPUT N$(I)\r"
  "1990 IF LEN(N$(I))>U0 THEN1970\r"
  "2000 NEXT I\r"
  "2010 RETURN\r"
  "2020 IF N<3 THEN GOTO240\r"
  "2030 FOR J=2 TO (N-1)\r"
  "2040 L=0:M=0\r"
  "2050 FOR I=J TO N\r"
  "2060 IF LEN(N$(I))>L THEN L=LEN(N$(I)):M=I\r"
  "2070 NEXT I\r"
  "2080 T$=N$(M)\r"
  "2090 FOR I=(M-1)TO J STEP -1\r"
  "2100 N$(I+1)=N$(I)\r"
  "2110 NEXT I\r"
  "2120 N$(J)=T$\r"
  "2130 NEXT J\r"
  "2140 GOTO  230\r"
  "2150 INPUT\"INPUT FROM TAPE\";T$:IF LEFT$(T$,1)=\"N\" THEN GOTO210\r"
  "2160 PRINT CHR$(17):REM TAPE READER ON\r"
  "2170 FOR I=1 TO N\r"
  "2180 INPUT N$(I)\r"
  "2190 NEXT I\r"
  "2200 PRINT CHR$(19):REM TAPE READER OFF\r"
  "2210 GOTO 2020\r"
  "2220 NULL6\r"
  "2230 PRINT CHR$(18);:REM TAPE PUNCH ON\r"
  "2240 FOR I=1TO75:PRINT CHR$(0);:NEXT I:REM LEADER\r"
  "2250 FOR I=1TON:PRINTN$(I):NEXT I\r"
  "2260 FOR I=1TO75:PRINT CHR$(0);:NEXT I:PRINT CHR$(20)\r"
  "2270 NULL0:GOTO240\r"
  "";

const char basic_wumpus[] =
  ""
  "1 REM WUMPUS 1/28/77\r"
  "2 REM MODIFIED FOR ALTAIR 4K BASIC 10/01\r"
  "3 REM RECODED -> CHARACTERS, COMPUTED GOTOS, \"OR\" STATEMENTS, 2-D ARRAY\r"
  "4 REM            COMPUTED LOGICAL STATEMENTS\r"
  "10 PRINT\"WMP23-HUNT THE WUMPUS\"\r"
  "15 PRINT\r"
  "20 PRINT \"INSTRUCTIONS(1=YES OR 0=NO)\";\r"
  "30 INPUT I\r"
  "35 REM RANDOMIZE\r"
  "40 IF I<>1 THEN 70\r"
  "50 GOSUB 7000\r"
  "70 REM SET UP CAVE\r"
  "75 DIM M(8)\r"
  "77 REM DIM S(20,3) - S() CONVERTED TO 1-D AND PROGRAM MODIFIED\r"
  "80 DIM S(60)\r"
  "90 FOR J=1 TO 60\r"
  "100 READ S(J)\r"
  "120 NEXT J\r"
  "130 DATA 2,5,8,1,3,10,2,4,12,3,5,14,1,4,6\r"
  "140 DATA 5,7,15,6,8,17,1,7,9,8,10,18,2,9,11\r"
  "150 DATA 10,12,19,3,11,13,12,14,20,4,13,15,6,14,16\r"
  "160 DATA 15,17,20,7,16,18,9,17,19,11,18,20,13,16,19\r"
  "200 REM LOCATE M(J) ARRAY ITEMS\r"
  "210 REM 1,YOU 2,WUMPUS 3&4,PITS 5&6,BATS 7,BLOCKAGE8,EXIT\r"
  "240 LET W=0\r"
  "245 LET M1=W\r"
  "246 LET F=M1\r"
  "250 FOR J=1 TO 7\r"
  "260 LET M(J)=INT(1+RND(1)*20)\r"
  "270 NEXT J\r"
  "279 REM CHECK FOR CROSSOVERS (IE M(1)=M(2)ETC)\r"
  "280 FOR J=1 TO 7\r"
  "290 FOR K=J TO 7\r"
  "300 IF J=K THEN 330\r"
  "320 IF M(J)=M(K) THEN 240\r"
  "330 NEXT K\r"
  "340 NEXT J\r"
  "350 LET A=5\r"
  "360 LET M(8)=M(1)\r"
  "370 PRINT\r"
  "380 PRINT \"ENTRANCE IS IN CAVE \";M(8)\r"
  "389 REM MAIN LOOP\r"
  "390 IF RND(1)<=0.4 THEN 485\r"
  "400 GOSUB 3370\r"
  "485 IF RND(1)>=0.08 THEN 2000\r"
  "490 GOSUB 5000\r"
  "1999 REM PRINT LOCATION AND HAZARD WARNINGS\r"
  "2000 PRINT\r"
  "2010 FOR K=1 TO 3\r"
  "2020 FOR J=2 TO 6\r"
  "2025 S0=M(1)+20*(K-1)\r"
  "2030 IF S(S0) <>M(J) THEN 2110\r"
  "2050 REM ON J-1 GOTO  2060,2080,2080,2100,2100,2060\r"
  "2051 J0=J-1\r"
  "2052 IF J0=1 THEN 2060\r"
  "2053 IF J0=2 THEN 2080\r"
  "2054 IF J0=3 THEN 2080\r"
  "2055 IF J0=4 THEN 2100\r"
  "2056 IF J0=5 THEN 2100\r"
  "2057 IF J0=6 THEN 2060\r"
  "2060 PRINT\"I SMELL A WUMPUS\"\r"
  "2070 GOTO 2110\r"
  "2080 PRINT\"I FEEL A DRAFT\"\r"
  "2090 GOTO 2110\r"
  "2100 PRINT\"BATS NEARBY\"\r"
  "2110 NEXT J\r"
  "2120 NEXT K\r"
  "2130 PRINT\"YOU ARE IN CAVE \";M(1)\r"
  "2139 REM RINGER SUBROUTINES\r"
  "2140 LET J=INT(RND(1)*40)\r"
  "2145 IF J=0 THEN 2440\r"
  "2146 IF J>7 THEN 2440\r"
  "2150 REM ON J GOTO 2200,2200,2210,2220,2220,2230,2240,2250\r"
  "2151 IF J=1 THEN 2200\r"
  "2152 IF J=2 THEN 2200\r"
  "2153 IF J=3 THEN 2210\r"
  "2154 IF J=4 THEN 2220\r"
  "2155 IF J=5 THEN 2220\r"
  "2156 IF J=6 THEN 2230\r"
  "2157 IF J=7 THEN 2240\r"
  "2158 IF J=8 THEN 2250\r"
  "2160 GOTO 2440\r"
  "2200 PRINT\"AHA!.WUMPUS TRACKS\"\r"
  "2205 GOTO 2440\r"
  "2210 PRINT\"AHA!..FOUND OLD ARROW, LUCKY YOU\"\r"
  "2213 LET A=A+1\r"
  "2215 GOTO 2440\r"
  "2220 PRINT\"OOPS, SLIPPED ON SOME LOOSE GRAVEL\"\r"
  "2225 GOSUB 5900\r"
  "2227 GOTO 2440\r"
  "2230 PRINT\"OOPS, YOU JUST FELL INTO AN UNDERGROUND POOL\"\r"
  "2235 GOSUB 5900\r"
  "2237 GOTO 2440\r"
  "2240 PRINT\"THIS LOOKS LIKE A NICE CAVE,WHY NOT STOP FOR LUNCH\"\r"
  "2245 GOTO 2440\r"
  "2250 PRINT\"TAKE CARE WITH THAT FLASHLIGHT\"\r"
  "2255 GOTO  2440\r"
  "2440 PRINT \"TUNNELS LEAD TO CAVES \";S(M(1));S(M(1)+20);S(M(1)+40)\r"
  "2445 PRINT\r"
  "2449 REM FEARLESS FREDDY STRIKES HERE\r"
  "2450 IF J<>38 THEN 2500\r"
  "2460 LET L=M(5)\r"
  "2470 GOTO 4260\r"
  "2499 REM CHOOSE OPTION\r"
  "2500 LET M1=M1+1\r"
  "2510 PRINT\"DO SOMETHING (1=MOVE 2=SHOOT 3=CHECK ARROWS 4=EXIT 5=HELP)\";\r"
  "2520 INPUT I\r"
  "2530 IF I=2 THEN 3000\r"
  "2550 IF I=3 THEN 3220\r"
  "2560 IF I=1 THEN 4000\r"
  "2570 REM IF (I$=\"E\")*(M(1)=M(8))=1 THEN 8800\r"
  "2571 IF I<>4 THEN 2580\r"
  "2572 IF M(1)=M(8) THEN 8800\r"
  "2580 IF I=5 THEN 2595\r"
  "2590 GOTO 2500\r"
  "2595 GOSUB 7600\r"
  "2597 GOTO 2000\r"
  "2999 REM ARROW ROUTINE\r"
  "3000 IF A>=1 THEN 3010\r"
  "3003 PRINT\"WHAT WITH?  DUMMY\"\r"
  "3005 GOTO 390\r"
  "3010 PRINT \"CAVE #\";\r"
  "3012 INPUT L\r"
  "3015 FOR K=1 TO 3\r"
  "3016 S0=M(1)+20*(K-1)\r"
  "3018 IF S(S0)=L THEN 3130\r"
  "3020 NEXT K\r"
  "3025 PRINT\"NOT POSSIBLE\"\r"
  "3027 GOTO 3010\r"
  "3129 REM SHOOT ARROW\r"
  "3130 LET A=A-1\r"
  "3132 IF A>=0 THEN 3135\r"
  "3133 LET A=0\r"
  "3134 GOTO 3220\r"
  "3135 IF L=M(2) THEN 3140\r"
  "3137 PRINT \"MISSED\"\r"
  "3138 GOTO 3215\r"
  "3140 IF RND(1)>=0.8 THEN 3150\r"
  "3142 PRINT \"YOU GOT THE WUMPUS\"\r"
  "3144 LET F=F+1\r"
  "3146 LET M(2)=0\r"
  "3148 GOTO 4400\r"
  "3150 PRINT\"YOU WOUNDED THE WUMPUS\"\r"
  "3215 GOSUB 3370\r"
  "3220 PRINT A;\"ARROWS LEFT\"\r"
  "3230 GOTO 390\r"
  "3369 REM MOVE WUMPUS ROUTINE\r"
  "3370 IF W<>1 THEN 3380\r"
  "3373 LET M(2)=0\r"
  "3375 RETURN\r"
  "3380 REM LET M(2)=S(M(2),(INT(3*RND+1)))\r"
  "3381 S0=M(2)+20*(INT(3*RND(1)))\r"
  "3382 M(2)=S(S0)\r"
  "3385 REM IF (M(1)=M(2))+(L=M(2))+(M(2)=M(7))<>0 THEN 3380\r"
  "3386 IF M(1)=M(2) THEN 3380\r"
  "3387 IF L=M(2) THEN 3380\r"
  "3388 IF M(2)=M(7) THEN 3380\r"
  "3425 RETURN\r"
  "3999 REM MOVE ROUTINE\r"
  "4000 PRINT \"WHERE TO\";\r"
  "4010 INPUT L\r"
  "4020 FOR K=1 TO 3\r"
  "4025 S0=M(1)+20*(K-1)\r"
  "4030 IF S(S0)=L THEN 4120\r"
  "4080 NEXT K\r"
  "4090 IF L=M(1) THEN 4120\r"
  "4100 PRINT \"NOT POSSIBLE\"\r"
  "4110 GOTO 4000\r"
  "4119 REM CHECK FOR HAZARDS\r"
  "4120 IF L<>M(2) THEN 4210\r"
  "4130 PRINT \"OOPS! BUMPED A WUMPUS!\"\r"
  "4140 GOTO 4500\r"
  "4210 REM IF (L=M(3))+(L=M(4))=0 THEN 4220\r"
  "4211 IF L=M(3) THEN 4214\r"
  "4212 IF L=M(4) THEN 4214\r"
  "4213 GOTO 4220\r"
  "4214 PRINT\"YYYIIIIEEEE...FELL IN PIT\"\r"
  "4216 GOTO 4520\r"
  "4220 IF L<>M(7) THEN 4257\r"
  "4230 PRINT \"CAVE ENTRANCE IS BLOCKED\"\r"
  "4240 GOSUB 5900\r"
  "4250 GOTO 390\r"
  "4256 REM IF (L=M(5))+(L=M(6))=0 THEN 4265\r"
  "4257 IF L=M(5) THEN 4261\r"
  "4258 IF L=M(6) THEN 4261\r"
  "4259 GOTO 4265\r"
  "4261 PRINT \"ZAP..SUPERBAT SNATCH!\"\r"
  "4263 GOTO 4280\r"
  "4265 IF L<>M(8) THEN 4270\r"
  "4267 PRINT \"EXIT NEARBY\"\r"
  "4270 LET M(1)=L\r"
  "4275 GOTO 390\r"
  "4280 LET L=INT(1+RND(1)*20)\r"
  "4285 REM IF (L=M(1))+(L=M(6))+(L=M(7))<>0 THEN 4280\r"
  "4286 IF L=M(1) THEN 4280\r"
  "4287 IF L=M(6) THEN 4280\r"
  "4288 IF L=M(7) THEN 4280\r"
  "4290 GOSUB 5900\r"
  "4300 GOTO 4120\r"
  "4400 IF RND(1)>=.75 THEN 4410\r"
  "4402 PRINT \"BEWARE OF ITS MATE\"\r"
  "4404 LET J=2\r"
  "4406 GOSUB 6100\r"
  "4408 GOTO 3220\r"
  "4410 LET W=1\r"
  "4420 PRINT \"HEE HEE HEE--THE WUMPUS'L GET YOU NEXT TIME\"\r"
  "4430 GOTO 390\r"
  "4499 REM EATEN SUBROUTINE\r"
  "4500 IF RND(1)>=.75 THEN 4510\r"
  "4502 GOSUB 3370\r"
  "4504 GOSUB 5900\r"
  "4506 GOTO 4270\r"
  "4510 PRINT\"TSK TSK TSK--THE WUMPUS GOT YOU\"\r"
  "4520 PRINT \"HA HA HA--YOU LOSE!\"\r"
  "4530 GOTO 8810\r"
  "4999 REM MOVE EVERYTHING\r"
  "5000 PRINT\"**EARTHQUAKE**\"\r"
  "5001 FOR J=3 TO 7\r"
  "5002 GOSUB 6100\r"
  "5003 NEXT J\r"
  "5004 GOSUB 5900\r"
  "5005 LET M(2)=INT(RND(1)*20+1)\r"
  "5006 REM IF (M(1)=M(2))+(M(2)=M(7))<>0 THEN 5005\r"
  "5007 IF M(1)=M(2) THEN 5005\r"
  "5008 IF M(2)=M(7) THEN 5005\r"
  "5009 REM MOVE CAVE ENTRANCE\r"
  "5010 IF RND(1)<=.1 THEN 5020\r"
  "5015 RETURN\r"
  "5020 LET M(8)=INT(RND(1)*20+1)\r"
  "5025 FOR J=3 TO 7\r"
  "5030 IF M(8)<>M(J) THEN 5040\r"
  "5033 LET M(8)=INT(RND(1)*20+1)\r"
  "5036 GOTO 5030\r"
  "5040 NEXT J\r"
  "5050 RETURN\r"
  "5899 REM DROPPED ARROWS SUBROUTINE\r"
  "5900 LET J=INT(RND(1)*10)\r"
  "5901 REM IF (J>A)+(A=0)=0 THEN 5910\r"
  "5902 IF J>A THEN 5905\r"
  "5903 IF A=0 THEN 5905\r"
  "5904 GOTO 5910\r"
  "5905 RETURN\r"
  "5910 PRINT \"DROPPED ARROWS\"\r"
  "5915 IF J<>0 THEN 5930\r"
  "5920 PRINT \"ALL ARROWS FOUND\"\r"
  "5925 RETURN\r"
  "5930 LET A=A-J\r"
  "5940 PRINT J;\"ARROWS LOST\";TAB(20);A;\"ARROWS LEFT\"\r"
  "5950 RETURN\r"
  "6099 REM RANDOM CAVE REARRANGEMENT SUBROUTINE\r"
  "6100 LET M(J)=INT(RND(1)*20)+1\r"
  "6110 REM IF (M(J)=M(1))+(M(J)=M(8))<>0 THEN 6100\r"
  "6111 IF M(J)=M(1) THEN 6100\r"
  "6112 IF M(J)=M(8) THEN 6100\r"
  "6200 RETURN\r"
  "6999 REM INSTRUCTIONS\r"
  "7000 PRINT \"WELCOME TO HUNT THE WUMPUS\"\r"
  "7005 PRINT\r"
  "7010 PRINT \"THE WUMPUS COLONY INHABIT A BURROW OF 20 CAVES\"\r"
  "7020 PRINT \"EACH CAVE HAS THREE TUNNELS LEADING TO OTHER CAVES.\"\r"
  "7030 PRINT \"THE OBJECTIVE IS TO DESCEND INTO THE BURROW AND HUNT WUMPI.\r"
  "7040 PRINT \"AFTER YOU HAVE KILLED AT LEAST ONE, YOU MUST RETURN TO THE\"\r"
  "7050 PRINT\"EXIT AND LEAVE THE BURROW. NOTE THAT THERE MAY BE MORE THAN\"\r"
  "7060 PRINT \"ONE WUMPUS IN THE BURROW. \"\r"
  "7061 PRINT \"YOU HAVE 5 ARROWS.\"\r"
  "7062 PRINT\"UNDER CONDITIONS OF STRESS, YOU MAY DROP YOUR ARROWS.\"\r"
  "7065 PRINT\"YOUR RATING IS A FUNCTION OF THE NUMBER OF WUMPI SHOT & THE\"\r"
  "7067 PRINT \"TIME SPENT IN THE BURROW\"\r"
  "7070 PRINT\r"
  "7072 GOSUB 7990\r"
  "7074 PRINT\"HAZARDS\"\r"
  "7076 PRINT\r"
  "7080 PRINT\"1---BOTTOMLESS PITS\"\r"
  "7090 PRINT\"TWO ROOMS CONTAIN BOTTOMLESS PITS. IF YOU FALL IN A PIT\"\r"
  "7100 PRINT\"YOU LOSE.\"\r"
  "7110 PRINT\r"
  "7112 PRINT\r"
  "7114 PRINT\"2---SUPERBATS\"\r"
  "7120 PRINT \"TWO ROOMS CONTAIN NESTS OF SUPERBATS. THEY ARE PEACEFUL\"\r"
  "7130 PRINT\"CREATURES WHEN LEFT ALONE. SHOULD YOU INADVERTENTLY\"\r"
  "7140 PRINT\"STUMBLE ACROSS THEIR NEST YOU WILL BE PICKED UP AND\"\r"
  "7150 PRINT \"BE DEPOSITED IN ANOTHER CAVE AT RANDOM.\"\r"
  "7160 PRINT \"TOO BAD IF IT CONTAINS ANOTHER HAZARD.\"\r"
  "7162 PRINT\r"
  "7164 GOSUB 7990\r"
  "7170 PRINT\r"
  "7175 PRINT\"3---**EARTHQUAKES**\"\r"
  "7180 PRINT\"EARTHQUAKES ARE A COMMON OCCURRENCE. SHOULD ONE OCCUR, THE\"\r"
  "7185 PRINT \"BURROW ENTRANCE MAY BE BLOCKED AND A NEW ONE OPEN UP. THE\"\r"
  "7190 PRINT\"GEOGRAPHY OF THE CAVES WILL BE CHANGED. THE PITS MAY FILL\"\r"
  "7200 PRINT \"UP AND A CAVE MAY BE BLOCKED BY A ROCKFALL. THE BATS WILL\"\r"
  "7210 PRINT \"BE DISTURBED AND MAY SEEK OUT A NEW CAVE. THE WUMPUS\"\r"
  "7220 PRINT \"WILL ALSO BECOME ALARMED AND MAY MOVE TO A NEW CAVE.\"\r"
  "7230 PRINT\r"
  "7235 PRINT\"4---WUMPUS\"\r"
  "7240 PRINT \"THE WUMPUS IS NOT BOTHERED BY ANY HAZARDS (IT HAS SUCKERS\"\r"
  "7250 PRINT \"ON ITS FEET AND IS TOO BIG FOR A BAT TO LIFT).\"\r"
  "7260 PRINT \"THE WUMPUS IS MOVING IN THE CAVES LOOKING FOR FOOD. IT\"\r"
  "7270 PRINT \"NORMALLY EATS A SPECIES OF MUSHROOM, BUT MAY EAT YOU SHOULD\r"
  "7280 PRINT \"YOU ENTER THE CAVE IN WHICH IT IS FEEDING\"\r"
  "7290 PRINT\r"
  "7300 GOSUB 7990\r"
  "7600 PRINT\r"
  "7605 PRINT \"EACH TURN YOU MAY:\"\r"
  "7610 PRINT \" (1) MOVE TO AN ADJACENT CAVE THROUGH A CONNECTING TUNNEL\"\r"
  "7620 PRINT \" (2) SHOOT AN ARROW THROUGH A TUNNEL TO TRY HIT THE WUMPUS\"\r"
  "7630 PRINT \"     IT IS BIG ENOUGH SO THAT AN ARROW ENTERING THE CAVE\"\r"
  "7640 PRINT \"     THAT IT IS OCCUPYING, WILL HIT IT.\"\r"
  "7645 PRINT \" (3) CHECK ON NUMBER OF ARROWS LEFT\"\r"
  "7650 PRINT \" (4) EXIT FROM THE CAVES IF YOU ARE IN THE ENTRANCE CAVE\"\r"
  "7660 PRINT \" (5) ASK FOR INSTRUCTIONS\"\r"
  "7662 PRINT\r"
  "7664 GOSUB 7990\r"
  "7666 PRINT \"WARNINGS\"\r"
  "7670 PRINT \"WHEN YOU ARE ONE CAVE AWAY FROM A HAZARD YOU WILL BE WARNED\r"
  "7680 PRINT \"AS FOLLOWS:\"\r"
  "7685 PRINT\r"
  "7690 PRINT \" WUMPUS.....I SMELL A WUMPUS\"\r"
  "7700 PRINT \" BATS.....BATS NEARBY\"\r"
  "7710 PRINT \" PIT.....I FEEL A DRAFT\"\r"
  "7715 PRINT\r"
  "7720 PRINT \"IF YOU TRY TO ENTER A CAVE BLOCKED BY A FALL OR IF YOU\"\r"
  "7730 PRINT \"RETURN TO THE ENTRANCE CAVE, YOU WILL BE NOTIFIED\"\r"
  "7740 PRINT\r"
  "7750 RETURN\r"
  "7990 PRINT \"TO CONTINUE, ENTER ANY NUMBER\"\r"
  "7992 INPUT I\r"
  "7994 PRINT\r"
  "7996 PRINT\r"
  "7998 RETURN\r"
  "8799 REM END GAME\r"
  "8800 PRINT \"OUT OF THE CAVES\"\r"
  "8801 IF F<=0 THEN 8805\r"
  "8803 PRINT \"GOOD HUNTING\"\r"
  "8805 LET W=INT((F*1000)/M1)\r"
  "8807 PRINT \"YOUR RATING IS \";W\r"
  "8810 IF F<>0 THEN 8830\r"
  "8820 PRINT\"BETTER LUCK NEXT TIME\"\r"
  "8830 PRINT\r"
  "8840 PRINT \"WANT TO TRY AGAIN, IN SPITE OF YOUR INABILITY (1=YES 0=NO)\"\r"
  "8850 INPUT I\r"
  "8860 IF I=1 THEN 240\r"
  "9000 END\r";


struct entry_struct { const char *name, *data; };


// if both I8080 and Z80 cpu cores are included then we need to sacrifice
// some examples here to make space in FLASH.

const entry_struct basic_programs[]  = {
  {"[this directory]", NULL}
#ifdef USE_SHORT_EXAMPLE_LIST
  ,{"prime numbers",    basic_isprime}
#else
  ,{"23-match",         basic_23_match}
  ,{"amazing",          basic_amazing}
  ,{"baccarat",         basic_baccarat}
#if USE_Z80 != 2
  ,{"baseball",         basic_baseball}
  ,{"basketball",       basic_basketbl}
#endif
  ,{"battle",           basic_battle}
  ,{"birthday",         basic_birthday}
  ,{"blackjack",        basic_blackjack}
  ,{"bombardment",      basic_bombard}
#if USE_Z80 != 2
  ,{"budget",           basic_budget}
#endif
  ,{"chase",            basic_chase}
  ,{"checkers",         basic_checkers}
  ,{"chess",            basic_chess}
#if USE_Z80 != 2
  ,{"climates",         basic_climates}
  ,{"cloud 9",          basic_cloud_9}
#endif
  ,{"craps",            basic_craps}
  ,{"crazy 8",          basic_crazy_8}
  ,{"cube",             basic_cube}
  ,{"even wins",        basic_evenwin}
  ,{"flip-flop",        basic_flipflop}
#if USE_Z80 != 2
  ,{"football",         basic_football}
#endif
  ,{"galaxy",           basic_galaxy}
  ,{"hamurabi",         basic_hamurabi}
  ,{"hangman",          basic_hangman}
  ,{"histogram",        basic_histogram}
  ,{"prime numbers",    basic_isprime}
  ,{"king",             basic_king}
  ,{"lunar lander",     basic_lander}
  ,{"life",             basic_life}
  ,{"mastermind",       basic_mastermind}
  ,{"orbit",            basic_orbit}
  ,{"pizza",            basic_pizza}
  ,{"poker",            basic_poker}
  ,{"power",            basic_power}
  ,{"powers",           basic_powers}
  ,{"qubic",            basic_qubic}
  ,{"rock paper scissors", basic_rock_paper_scissors}
  ,{"rose",             basic_rose}
  ,{"seawar",           basic_seawar}
  ,{"sieve",            basic_sieve}
  ,{"sine",             basic_sin}
  ,{"square",           basic_square}
#if USE_Z80 != 2
  ,{"swarms",           basic_swarms}
#endif
  ,{"tic-tac-toe",      basic_tic_tac_toe}
  ,{"towers",           basic_towers}
  ,{"word puzzle",      basic_word_puzzle}
  ,{"wumpus",           basic_wumpus}
#endif
  };



#define NUM_BASIC_PROGRAMS (sizeof(basic_programs)/sizeof(entry_struct))

byte read_basic_example(int n, int i)
{
  if( n==0 )
    {
      // construct directory line-by-line
      static int entry = 0, offset = 0;
      static char line[50];
      if( i==0 || line[i-offset]==0 )
        {
          byte b;
          entry = i==0 ? 0 : entry+1;
          if( entry<NUM_BASIC_PROGRAMS )
            {
              offset = i;
              sprintf(line, "%2i \"        ) %s\"\r", entry, basic_programs[entry].name);
              b = entry;
              for(int j=0; j<8; j++) {line[4+j] = b & 0x80 ? '1' : '0'; b <<= 1; }
              return line[0];
            }
          else
            return 0;
        }
      else
        return line[i-offset];
    }
  else
    {
      // read example
      return basic_programs[n].data[i];
    }
}
